﻿(function() {
	'use strict';
	var $asm = {};
	global.B2BProject = global.B2BProject || {};
	global.B2BProject.Business = global.B2BProject.Business || {};
	global.B2BProject.Business.Plugin = global.B2BProject.Business.Plugin || {};
	global.JSLib = global.JSLib || {};
	global.JSLib.Extension = global.JSLib.Extension || {};
	global.USOProject = global.USOProject || {};
	global.USOProject.Business = global.USOProject.Business || {};
	global.USOProject.Business.Model = global.USOProject.Business.Model || {};
	global.USOProject.Business.Retail = global.USOProject.Business.Retail || {};
	global.USOProject.Business.ToCompletion = global.USOProject.Business.ToCompletion || {};
	global.USOProject.Pages = global.USOProject.Pages || {};
	global.USOProject.Pages.ApplyAudit = global.USOProject.Pages.ApplyAudit || {};
	global.USOProject.Pages.ApplyAudit.Adjust = global.USOProject.Pages.ApplyAudit.Adjust || {};
	global.USOProject.Pages.ApplyAudit.EngineerOrder = global.USOProject.Pages.ApplyAudit.EngineerOrder || {};
	global.USOProject.Pages.ApplyAudit.OrderAudit = global.USOProject.Pages.ApplyAudit.OrderAudit || {};
	global.USOProject.Pages.ApplyAudit.OtherOrder = global.USOProject.Pages.ApplyAudit.OtherOrder || {};
	global.USOProject.Pages.Common = global.USOProject.Pages.Common || {};
	global.USOProject.Pages.Control = global.USOProject.Pages.Control || {};
	global.USOProject.Pages.NewRetailInputStatistics = global.USOProject.Pages.NewRetailInputStatistics || {};
	global.USOProject.Pages.Product = global.USOProject.Pages.Product || {};
	global.USOProject.Pages.Retail = global.USOProject.Pages.Retail || {};
	global.USOProject.Pages.Retail.Add = global.USOProject.Pages.Retail.Add || {};
	global.USOProject.Pages.Retail.Return = global.USOProject.Pages.Retail.Return || {};
	global.USOProject.Pages.Spec = global.USOProject.Pages.Spec || {};
	global.USOProject.Pages.SystemModule = global.USOProject.Pages.SystemModule || {};
	global.USOProject.Pages.Test = global.USOProject.Pages.Test || {};
	ss.initAssembly($asm, 'USOProject');
	////////////////////////////////////////////////////////////////////////////////
	// App
	var $App = function() {
		this.AppVersion = '';
		this.baseHandlerObj = null;
		this.channel = null;
		this.userInfo = null;
		this.permissions = null;
		this.defaultAjaxTimeout = 60000;
		this.activeAjaxRequestMap = null;
		this.config = null;
	};
	$App.__typeName = 'App';
	$App.RecoredTimeDiff = function() {
		var serverDate = DateTimeEx.ToDateTimeForce($App.LoginResult.PersistentDate);
		var curDate = new Date();
		$App.TimeDiff = new ss.TimeSpan((serverDate - curDate) * 10000);
	};
	$App.GetCurrentServerDate = function() {
		return new Date((new Date()).valueOf() + Math.round($App.TimeDiff.ticks / 10000000 * 1000));
	};
	$App.get_DeviceInfo = function() {
		if (JSLib.Mobile.Application.IsBrowser) {
			var deviceInfo = { available: true, platform: 'borwser', version: '1.0', uuid: '', cordova: '', model: '' };
			return deviceInfo;
		}
		else {
			return device;
		}
	};
	$App.initCurrentOrgID = function() {
		var currentOrganizationId = window.localStorage.getItem('currentStockOrganizationId|' + $App.app.userInfo.User.Id);
		if (ss.isNullOrUndefined(currentOrganizationId)) {
			window.localStorage.setItem('currentStockOrganizationId|' + $App.app.userInfo.User.Id, $App.app.userInfo.User.CurrentStockOrganizationId.toString());
		}
		else {
			$App.app.userInfo.User.CurrentStockOrganizationId = CoreEx.ToInt(currentOrganizationId, 0);
		}
	};
	$App.GetUserID = function() {
		if (ss.isValue($App.app.userInfo) && ss.isValue($App.app.userInfo.User)) {
			return $App.app.userInfo.User.Id;
		}
		return 0;
	};
	$App.GetStoredCurrentOrgID = function(userID) {
		if (userID === 0) {
			return 0;
		}
		var currentOrganizationId = window.localStorage.getItem('currentStockOrganizationId|' + userID);
		if (ss.isNullOrUndefined(currentOrganizationId)) {
			return 0;
		}
		return CoreEx.ToInt(currentOrganizationId, 0);
	};
	$App.GetDeviceInfo = function() {
		var deviceInfo = '';
		if (!JSLib.Mobile.Application.IsBrowser) {
			deviceInfo = JSON.stringify({ mobileDeviceInfo: { deviceavailable: $App.get_DeviceInfo().available, deviceplatform: $App.get_DeviceInfo().platform, deviceversion: $App.get_DeviceInfo().version, deviceuuid: $App.get_DeviceInfo().uuid, cordova: $App.get_DeviceInfo().cordova, devicemodel: $App.get_DeviceInfo().model, connectionType: navigator.network.connection.type, clientVersion: $App.app.AppVersion } });
		}
		else {
			var device = { available: true, platform: 'ios', version: '1.0', uuid: '', cordova: '', model: '' };
			deviceInfo = JSON.stringify({ mobileDeviceInfo: { deviceavailable: device.available, deviceplatform: device.platform, deviceversion: device.version, deviceuuid: device.uuid, cordova: device.cordova, devicemodel: device.model, connectionType: 'internet', clientVersion: $App.app.AppVersion } });
		}
		return deviceInfo;
	};
	$App.GetProductImageUrl = function(imageInfo) {
		var size = '';
		switch (imageInfo.type) {
			case 1: {
				size = '168';
				break;
			}
			case 2: {
				size = '640';
				break;
			}
			case 3: {
				size = '104';
				break;
			}
		}
		var imageUrl = ss.formatString('{0}m_{1}/{2}_{3}.jpg', $App.app.config.MobileImgUrl, imageInfo.id, imageInfo.index, size);
		return imageUrl;
	};
	$App.GetSetupTypeText = function(value) {
		var type = Enumerable.from($App.SetupTypes).firstOrDefault(function(n) {
			return n.Value === value;
		}, ss.getDefaultValue($USOProject_SetupType));
		if (ss.isNullOrUndefined(type)) {
			return '';
		}
		else {
			return type.Name;
		}
	};
	$App.GetNetWorkTypesText = function(value) {
		var type = Enumerable.from($App.NetWorkTypes).firstOrDefault(function(n) {
			return n.Value === value;
		}, ss.getDefaultValue($USOProject_NetWorkType));
		if (ss.isNullOrUndefined(type)) {
			return '';
		}
		else {
			return type.Name;
		}
	};
	$App.RegisterShowMessage = function() {
		var pnlInformationPanel = $("<div id='pnlInformationPanel' class='InformationPanel'></div>").prependTo(document.body);
		pnlInformationPanel.on('click', '.informationItem', ss.thisFix(function(elem, event) {
			$(elem).remove();
			if (pnlInformationPanel.children().length === 0) {
				pnlInformationPanel.hide();
			}
		}));
		JSLib.Mobile.MessageBox.AlertHandler = function(message) {
			var $state = 0, messageItem, $t1;
			var $sm = function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							messageItem = $("<div class='informationItem'>" + message + '</div>');
							pnlInformationPanel.append(messageItem).show();
							$t1 = ss.Task.delay(5000);
							$state = 1;
							$t1.continueWith($sm);
							return;
						}
						case 1: {
							$state = -1;
							$t1.getAwaitedResult();
							messageItem.remove();
							if (pnlInformationPanel.children().length === 0) {
								pnlInformationPanel.hide();
							}
							$state = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			};
			$sm();
		};
	};
	$App.RegisterInputModal = function() {
		$(document).on('click', 'input[data-modal-number], input[data-modal][type=text],input[data-modal][type=number],input[data-modal][type=email],input[data-modal][type=search],input[data-modal][type=tel],input[data-modal][type=url],input[data-modal][type=password]', ss.thisFix(function(elem, event) {
			var target = elem;
			if (target.readOnly) {
				return;
			}
			target.blur();
			var rootContainer = $('body');
			var inputDialog = rootContainer.find('.inputDialog');
			if (inputDialog.length <= 0) {
				inputDialog = $("<div class='inputDialog modal'>\n                                        <div class='content'>\n                                            <div class='title'>请输入:</div>\n                                            <div class='inputArea'>\n                                                <input class='inputControl' type='text' placeholder='' />\n                                            </div>\n                                            <div class='toolBarArea'>\n                                                <div class='modalButton OK' >确认</div>\n                                                <div class='modalButton Cancel'>取消</div>\n                                            </div>\n                                        </div>\n                                      </div>");
				inputDialog.prependTo(rootContainer);
				var inputControl = inputDialog.find('.inputControl');
				var placeHolder = target.getAttribute('placeholder');
				if (!ss.isNullOrEmptyString(placeHolder)) {
					inputControl.attr('placeHolder', placeHolder);
				}
				var typevalue = target.getAttribute('type');
				inputControl.attr('type', typevalue);
				if (target.hasAttribute('data-modal-number')) {
					inputControl.attr('type', 'number');
				}
				inputControl.val(target.value);
				inputDialog.on('click', '.Cancel,.OK', ss.thisFix(function(ele, event1) {
					inputControl.blur();
					inputDialog.off().remove();
					if ($(ele).hasClass('OK')) {
						$(target).val(inputControl.val());
					}
				}));
				inputDialog.click(function(event11) {
					if (ss.referenceEquals(event11.target, inputDialog[0])) {
						inputControl.blur();
						inputDialog.off().remove();
					}
				});
				inputControl.focus();
			}
		}));
	};
	$App.RemoveGlobalInputModal = function() {
		var inputDialog = $(document).find('.inputDialog');
		if (inputDialog.length > 0) {
			inputDialog.off().remove();
			return true;
		}
		return false;
	};
	$App.RegisterGlobalEvent = function() {
		$(document).on('click', 'input[data-date]', ss.thisFix(function(elem, event) {
			//android调用插件来处理
			if (!JSLib.Mobile.Application.IsBrowser && JSLib.Mobile.Application.DeviceType === 10) {
				if (!elem.readOnly) {
					$(elem).attr('readonly', 'readonly');
				}
				var curDate = new Date();
				var dateValueString = elem.value;
				var date = new Date(Date.parse(dateValueString));
				if (date.toString().indexOf('NaN') === -1) {
					curDate = date;
				}
				(new DatePicker()).show({ date: curDate, mode: 'date' }, function(time) {
					if (time.toString().indexOf('NaN') === -1) {
						$(elem).val(ss.formatDate(time, 'yyyy-MM-dd'));
					}
				});
			}
			else {
				var type = elem.getAttribute('type');
				if (type.toUpperCase().indexOf('DATE') === -1) {
					$(elem).attr('type', 'date');
				}
			}
		}));
		//开关按钮
		$(document).on('click', '.chkBox', ss.thisFix(function(elem1, event1) {
			if ($(elem1).closest('.radioPanel').length > 0) {
				return;
			}
			if (!jQueryObjectEx.IsEnable($(elem1))) {
				return;
			}
			$(elem1).toggleClass('active').trigger('change');
		}));
		//单选组件
		$(document).on('click', '.radioPanel>.chkBox', ss.thisFix(function(elem2, event2) {
			$(elem2).toggleClass('active', true).siblings().removeClass('active');
			$(elem2).parent('.radioPanel').trigger('change');
		}));
		//开关按钮
		$(document).on('click', '.toggleButton', ss.thisFix(function(elem3, event3) {
			$(elem3).toggleClass('active').trigger('change');
		}));
		//注册选择用户事件
		$(document).on('click', '.chooseCustomer,.chooseUser', ss.thisFix(function(elem4, event4) {
			var customerSelectorMode = 0;
			if ($(elem4).hasClass('chooseUser')) {
				customerSelectorMode = 1;
			}
			var $t1 = new $USOProject_Pages_Common_CustomerSelectorData();
			$t1.Mode = customerSelectorMode;
			JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Common_CustomerSelector).call(null, $t1, function(selector) {
				selector.OnUserSelected = function(customer) {
					if (elem4.tagName.toUpperCase() === 'DIV') {
						$(elem4).text(customer.Name);
					}
					else if (elem4.tagName.toUpperCase() === 'INPUT') {
						$(elem4).val(customer.Name);
					}
					$(elem4).data('customer', customer);
					JSLib.Mobile.Application.Back(1);
				};
			});
		}));
	};
	global.App = $App;
	////////////////////////////////////////////////////////////////////////////////
	// AppData
	var $AppData = function() {
	};
	$AppData.__typeName = 'AppData';
	$AppData.GetUserInfo = function() {
		return $AppData.$_userData;
	};
	$AppData.SetUserData = function(userdata) {
		$AppData.$_userData = userdata;
	};
	global.AppData = $AppData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.Retail.CustomerSalesRestDTO
	var $CustomerSalesRestDTO = function() {
	};
	$CustomerSalesRestDTO.__typeName = 'CustomerSalesRestDTO';
	$CustomerSalesRestDTO.createInstance = function() {
		return $CustomerSalesRestDTO.$ctor();
	};
	$CustomerSalesRestDTO.$ctor = function() {
		var $this = {};
		$this.Id = 0;
		$this.SourceType = null;
		$this.SaleType = 0;
		$this.SaleLegalId = null;
		$this.SaleLegalName = null;
		$this.ClientName = null;
		$this.ClientPhone = null;
		$this.ClientCardNo = null;
		$this.ClientAddress = null;
		$this.SaleOn = null;
		$this.SaleBy = null;
		$this.SaleByName = null;
		$this.SalesAmount = null;
		$this.SalesStatus = 0;
		$this.AuditBy = null;
		$this.AuditByName = null;
		$this.AuditOn = null;
		$this.ConfirmBy = null;
		$this.ConfirmByName = null;
		$this.ConfirmOn = null;
		$this.CustomerSaleTypeString = null;
		$this.CustomerSalesStatusString = null;
		$this.Items = null;
		$this.CustomerStoreId = null;
		$this.CustomerStoreName = null;
		$this.SOMasterId = null;
		$this.IsExpiredData = 0;
		$this.Memo = null;
		$this.PayStatus = 0;
		$this.ProvinceCode = null;
		$this.CityCode = null;
		$this.CountyCode = null;
		$this.ExactAddress = null;
		$this.FixedLineTelephone = null;
		$this.Sex = '0';
		$this.FromSystem = null;
		$this.CreateBy = null;
		$this.CreateByName = null;
		$this.CreateOn = null;
		$this.CustomerUserId = 0;
		$this.OrderType = 0;
		$this.SourceRetailInputID = 0;
		$this.PurchaseDate = ss.formatDate(new Date(), 'yyyy-MM-dd');
		return $this;
	};
	$CustomerSalesRestDTO.isInstanceOfType = function() {
		return true;
	};
	global.CustomerSalesRestDTO = $CustomerSalesRestDTO;
	////////////////////////////////////////////////////////////////////////////////
	// JuqeryObjectEx
	var $JuqeryObjectEx = function() {
	};
	$JuqeryObjectEx.__typeName = 'JuqeryObjectEx';
	$JuqeryObjectEx.GetCustomerLegalId = function(target) {
		var customer = target.data('customer');
		if (ss.isNullOrUndefined(customer)) {
			return null;
		}
		else {
			return customer.Id;
		}
	};
	$JuqeryObjectEx.UpdateState = function(target, prefix, typeName) {
		if (target.length === 0) {
			return target;
		}
		var classLists = target[0].classList;
		Enumerable.from(classLists).where(function(n) {
			return ss.startsWithString(n, prefix);
		}).forEach(function(className) {
			target[0].classList.remove(className);
		});
		target.addClass(prefix + typeName);
		return target;
	};
	global.JuqeryObjectEx = $JuqeryObjectEx;
	////////////////////////////////////////////////////////////////////////////////
	// NullableExtenion
	var $NullableExtenion = function() {
	};
	$NullableExtenion.__typeName = 'NullableExtenion';
	$NullableExtenion.WithDefault$1 = function(target, defaultValue) {
		return (ss.isValue(target) ? ss.unbox(target) : defaultValue);
	};
	$NullableExtenion.ForamtInt = function(target, defaultValue) {
		return (ss.isValue(target) ? ss.unbox(target).toString() : defaultValue);
	};
	$NullableExtenion.WithDefault = function(target, defaultValue) {
		return (ss.isValue(target) ? ss.unbox(target) : defaultValue);
	};
	$NullableExtenion.FormatMoney = function(target, defaultValue) {
		return (ss.isValue(target) ? ss.unbox(target).toFixed(2) : defaultValue);
	};
	$NullableExtenion.FormatMoney$1 = function(target, defaultValue) {
		return (ss.isValue(target) ? ss.unbox(target).toFixed(2) : defaultValue);
	};
	global.NullableExtenion = $NullableExtenion;
	////////////////////////////////////////////////////////////////////////////////
	// RetailStatisticsCurrentUser
	var $RetailStatisticsCurrentUser = function() {
	};
	$RetailStatisticsCurrentUser.__typeName = 'RetailStatisticsCurrentUser';
	$RetailStatisticsCurrentUser.get_ViewOrgTypes = function() {
		var orgTypes = Enumerable.from(ss.Enum.getValues($RetailStatisticsOrgType)).where(function(n) {
			return n > $RetailStatisticsCurrentUser.OwnOrgType;
		}).toArray();
		return orgTypes;
	};
	$RetailStatisticsCurrentUser.GetNextOrgType = function(orgType) {
		var result = Enumerable.from($RetailStatisticsCurrentUser.SelectedOrgTypes).firstOrDefault(function(n) {
			return n > orgType;
		}, ss.getDefaultValue($RetailStatisticsOrgType));
		if (result === 0) {
			return null;
		}
		else {
			return result;
		}
	};
	$RetailStatisticsCurrentUser.GetPreOrgType = function(orgType) {
		var result = Enumerable.from($RetailStatisticsCurrentUser.SelectedOrgTypes).firstOrDefault(function(n) {
			return n < orgType;
		}, ss.getDefaultValue($RetailStatisticsOrgType));
		if (result === 0) {
			return null;
		}
		else {
			return result;
		}
	};
	global.RetailStatisticsCurrentUser = $RetailStatisticsCurrentUser;
	////////////////////////////////////////////////////////////////////////////////
	// RetailStatisticsOrgType
	var $RetailStatisticsOrgType = function() {
	};
	$RetailStatisticsOrgType.__typeName = 'RetailStatisticsOrgType';
	global.RetailStatisticsOrgType = $RetailStatisticsOrgType;
	////////////////////////////////////////////////////////////////////////////////
	// RetailStatisticsPageData
	var $RetailStatisticsPageData = function() {
		this.CurrentOrgType = null;
		this.CurrentDrillToOrgType = null;
		this.QueryReportViewType = 1;
		this.CurrentOrgName = null;
		this.CurrentOrgId = 0;
		this.IsModel = false;
		this.CurModelId = null;
		this.CurModelName = null;
		this.CustomerManagerId = null;
		this.CustomerLegalId = null;
		this.CustomerStoreId = null;
		this.QueryDateType = 2;
		this.QueryDateRange = null;
		this.IsMarkedStore = null;
		this.OrganizationId = 0;
		this.OriDateType = null;
	};
	$RetailStatisticsPageData.__typeName = 'RetailStatisticsPageData';
	global.RetailStatisticsPageData = $RetailStatisticsPageData;
	////////////////////////////////////////////////////////////////////////////////
	// B2BProject.Business.Plugin.AppVersion
	var $B2BProject_Business_Plugin_AppVersion = function() {
	};
	$B2BProject_Business_Plugin_AppVersion.__typeName = 'B2BProject.Business.Plugin.AppVersion';
	$B2BProject_Business_Plugin_AppVersion.GetAppVersion = function() {
		var tsk = new ss.TaskCompletionSource();
		cordova.exec(function(o) {
			tsk.setResult(o);
		}, function(o1) {
			console.error(o1);
		}, 'AppVersion', 'getVersionNumber', []);
		return tsk.task;
	};
	global.B2BProject.Business.Plugin.AppVersion = $B2BProject_Business_Plugin_AppVersion;
	////////////////////////////////////////////////////////////////////////////////
	// JSLib.Extension.ArrayExtension
	var $JSLib_Extension_ArrayExtension = function() {
	};
	$JSLib_Extension_ArrayExtension.__typeName = 'JSLib.Extension.ArrayExtension';
	global.JSLib.Extension.ArrayExtension = $JSLib_Extension_ArrayExtension;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.BytesBuilder
	var $USOProject_BytesBuilder = function() {
		this.$dataArray = null;
		this.$count = 0;
		this.OnAddString = null;
		this.OnAddInt = null;
		this.$dataArray = new Array();
		this.$count = 0;
	};
	$USOProject_BytesBuilder.__typeName = 'USOProject.BytesBuilder';
	global.USOProject.BytesBuilder = $USOProject_BytesBuilder;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.BytesReader
	var $USOProject_BytesReader = function(pArray) {
		this.$btArray = null;
		this.$readI = 0;
		this.$btArray = pArray;
		this.$readI = 0;
	};
	$USOProject_BytesReader.__typeName = 'USOProject.BytesReader';
	global.USOProject.BytesReader = $USOProject_BytesReader;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.LoginInfo
	var $USOProject_LoginInfo = function() {
		this.UserName = null;
		this.Password = null;
		this.ValidationCode = null;
		this.IsRemberLogin = false;
	};
	$USOProject_LoginInfo.__typeName = 'USOProject.LoginInfo';
	global.USOProject.LoginInfo = $USOProject_LoginInfo;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.MainEntry
	var $USOProject_MainEntry = function() {
	};
	$USOProject_MainEntry.__typeName = 'USOProject.MainEntry';
	global.USOProject.MainEntry = $USOProject_MainEntry;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.NetWorkType
	var $USOProject_NetWorkType = function() {
	};
	$USOProject_NetWorkType.__typeName = 'USOProject.NetWorkType';
	$USOProject_NetWorkType.$ctor = function(name, value) {
		var $this = {};
		$this.Name = null;
		$this.Value = 0;
		$this.Name = name;
		$this.Value = value;
		return $this;
	};
	$USOProject_NetWorkType.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.NetWorkType = $USOProject_NetWorkType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.SecurityChannel
	var $USOProject_SecurityChannel = function() {
		this.$ajaxCallIndex = 0;
	};
	$USOProject_SecurityChannel.__typeName = 'USOProject.SecurityChannel';
	$USOProject_SecurityChannel.GetValidateTokens = function() {
		var currentDate = new Date();
		var MAXDiffMS = 28797000;
		var validateTokens = [];
		for (var aI = 0; aI < $USOProject_SecurityChannel.tokenArray.length; aI++) {
			var tokenObj = $USOProject_SecurityChannel.tokenArray[aI];
			if (currentDate - tokenObj.createDate >= MAXDiffMS) {
				continue;
			}
			validateTokens.push(tokenObj.token);
		}
		return validateTokens;
	};
	$USOProject_SecurityChannel.getDebugToken = function() {
		if ($USOProject_SecurityChannel.tokenArray.length > 0) {
			var tokenObj = $USOProject_SecurityChannel.tokenArray[0];
			return tokenObj;
		}
		else {
			return null;
		}
	};
	$USOProject_SecurityChannel.GetTokenObject = function() {
		//undo:60 * 30
		var currentDate = new Date();
		var MAXDiffMS = 28797000;
		while ($USOProject_SecurityChannel.tokenArray.length > 0) {
			//Console.Info("现有token:", tokenArray.Count);
			var tokenObject = $USOProject_SecurityChannel.tokenArray.shift();
			//Console.Info("移除token:", tokenObject);
			if (currentDate - tokenObject.createDate >= MAXDiffMS) {
				continue;
			}
			return tokenObject;
		}
		return null;
	};
	$USOProject_SecurityChannel.AddTokenArray = function(target) {
		if (ss.isNullOrUndefined($USOProject_SecurityChannel.tokenArray)) {
			$USOProject_SecurityChannel.tokenArray = [];
		}
		$USOProject_SecurityChannel.tokenArray.push(target);
		window.localStorage['tokenData'] = JSON.stringify($USOProject_SecurityChannel.tokenArray);
	};
	$USOProject_SecurityChannel.IsEqual = function(btArray1, btArray2) {
		if (ss.referenceEquals(btArray1, btArray2)) {
			return true;
		}
		if (ss.isNullOrUndefined(btArray1) || ss.isNullOrUndefined(btArray2)) {
			return false;
		}
		if (btArray1.length !== btArray2.length) {
			return false;
		}
		for (var i1 = 0; i1 < btArray1.length; i1++) {
			if (!ss.referenceEquals(btArray1[i1], btArray2[i1])) {
				return false;
			}
		}
		return true;
	};
	$USOProject_SecurityChannel.getServerInfo = function(resultReader) {
		var result = { weakV: { version: resultReader.ReadString(), url: resultReader.ReadString(), iosUrl: resultReader.ReadString() }, strongV: { version: resultReader.ReadString(), url: resultReader.ReadString(), iosUrl: resultReader.ReadString() } };
		var btArray = System.Convert.FromBase64String(resultReader.ReadString());
		var base64Json = System.Text.Encoding.UTF8.GetString(btArray);
		var extentionObj = $.parseJSON(base64Json);
		result.upgradeTip = ss.cast(extentionObj.upgradeTip, String);
		console.log('...........new version 1 result.upgradeTip is:' + result.upgradeTip);
		return result;
	};
	$USOProject_SecurityChannel.readEncodingTokensCore = function(resultReader) {
		var tokenCount = resultReader.ReadBytes(1);
		var tempArray = [];
		for (var tokenI = 0; tokenI < tokenCount; tokenI++) {
			var tokenObject = {};
			tempArray.push(tokenObject);
			tokenObject.oldKey = resultReader.ReadBytes(32);
			tokenObject.oldIV = resultReader.ReadBytes(16);
			tokenObject.newKey = resultReader.ReadBytes(32);
			tokenObject.newIV = resultReader.ReadBytes(16);
			tokenObject.nextKey = resultReader.ReadBytes(32);
			tokenObject.nextIV = resultReader.ReadBytes(16);
			tokenObject.token = resultReader.ReadString();
			tokenObject.createDate = new Date();
		}
		return tempArray;
	};
	global.USOProject.SecurityChannel = $USOProject_SecurityChannel;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.SecurityLayerJS
	var $USOProject_SecurityLayerJS = function() {
	};
	$USOProject_SecurityLayerJS.__typeName = 'USOProject.SecurityLayerJS';
	$USOProject_SecurityLayerJS.SavePersistentToken = function(userInfo) {
		var token = userInfo.token;
		var userID = userInfo.userID;
		var serverDate = userInfo.serverDate;
		var cipher = new System.Security.Cryptography.RijndaelManaged();
		cipher.GenerateKey();
		cipher.GenerateIV();
		var oldKey = cipher.Key;
		var oldKeyIV = cipher.IV;
		var array = new System.Byte(48);
		System.Array.Copy(oldKey, 0, array, 0, 32);
		System.Array.Copy(oldKeyIV, 0, array, 32, 16);
		var base64key = System.Convert.ToBase64String(array);
		var newIVArray = new System.Byte(16);
		System.Array.Copy(oldKey, 8, newIVArray, 0, 12);
		System.Array.Copy(oldKeyIV, 2, newIVArray, 12, 4);
		var aesKeyBuilder = new $USOProject_BytesBuilder();
		aesKeyBuilder.AddBytes(array);
		aesKeyBuilder.AddString($App.get_DeviceInfo().model);
		aesKeyBuilder.AddString($App.get_DeviceInfo().uuid);
		aesKeyBuilder.AddString($App.get_DeviceInfo().version);
		aesKeyBuilder.AddString($App.get_DeviceInfo().platform);
		aesKeyBuilder.AddString($App.get_DeviceInfo().cordova);
		aesKeyBuilder.AddString($App.app.AppVersion);
		var md5 = new System.Security.Cryptography.MD5();
		var md5EncodingKey = md5.ComputeHash(aesKeyBuilder.ToArray());
		var tokenBuilder = new $USOProject_BytesBuilder();
		tokenBuilder.AddString(token);
		tokenBuilder.AddString(userID.toString());
		tokenBuilder.AddString(serverDate);
		md5 = new System.Security.Cryptography.MD5();
		var tokenInfoMD5 = md5.ComputeHash(tokenBuilder.ToArray());
		var tokenInfoAndMD5 = tokenBuilder.ToArray().concat(tokenInfoMD5);
		var secretKey = new System.Security.Cryptography.Rfc2898DeriveBytes(md5EncodingKey, newIVArray, 10);
		var createKey = secretKey.GetBytes(32);
		var createIV = secretKey.GetBytes(16);
		var aesTokenInfo = $USOProject_SecurityLayerJS.Encrypt(createKey, createIV, tokenInfoAndMD5);
		var base64TokenInfo = System.Convert.ToBase64String(aesTokenInfo);
		var storeToken = base64key.substring(0, 32) + base64TokenInfo + base64key.substring(32, 64);
		window.localStorage.setItem('USOAPPDATA', storeToken);
		return storeToken;
	};
	$USOProject_SecurityLayerJS.ReadPersistentToken = function() {
		try {
			var storeToken = window.localStorage.getItem('USOAPPDATA');
			if (ss.isNullOrUndefined(storeToken)) {
				return null;
			}
			var base64key = storeToken.substring(0, 32) + storeToken.substring(storeToken.length - 32, storeToken.length);
			var base64TokenInfo = storeToken.substring(32, storeToken.length - 32);
			var aesTokenInfo = System.Convert.FromBase64String(base64TokenInfo);
			var array = System.Convert.FromBase64String(base64key);
			var oldKey = new System.Byte(32);
			var oldKeyIV = new System.Byte(16);
			System.Array.Copy(array, 0, oldKey, 0, 32);
			System.Array.Copy(array, 32, oldKeyIV, 0, 16);
			var newIVArray = new System.Byte(16);
			System.Array.Copy(oldKey, 8, newIVArray, 0, 12);
			System.Array.Copy(oldKeyIV, 2, newIVArray, 12, 4);
			var aesKeyBuilder = new $USOProject_BytesBuilder();
			aesKeyBuilder.AddBytes(array);
			aesKeyBuilder.AddString($App.get_DeviceInfo().model);
			aesKeyBuilder.AddString($App.get_DeviceInfo().uuid);
			aesKeyBuilder.AddString($App.get_DeviceInfo().version);
			aesKeyBuilder.AddString($App.get_DeviceInfo().platform);
			aesKeyBuilder.AddString($App.get_DeviceInfo().cordova);
			aesKeyBuilder.AddString($App.app.AppVersion);
			var md5 = new System.Security.Cryptography.MD5();
			var md5EncodingKey = md5.ComputeHash(aesKeyBuilder.ToArray());
			var secretKey = new System.Security.Cryptography.Rfc2898DeriveBytes(md5EncodingKey, newIVArray, 10);
			var createKey = secretKey.GetBytes(32);
			var createIV = secretKey.GetBytes(16);
			var tokenInfoAndMD5 = $USOProject_SecurityLayerJS.Decrypt(createKey, createIV, aesTokenInfo);
			var tokenBuilder = new System.Byte(tokenInfoAndMD5.length - 16);
			var tokenInfoMD5 = new System.Byte(16);
			System.Array.Copy(tokenInfoAndMD5, 0, tokenBuilder, 0, tokenBuilder.length);
			System.Array.Copy(tokenInfoAndMD5, tokenBuilder.length, tokenInfoMD5, 0, tokenInfoMD5.length);
			var storeTokenInfoMD5 = md5.ComputeHash(tokenBuilder);
			if (!$USOProject_SecurityChannel.IsEqual(tokenInfoMD5, storeTokenInfoMD5)) {
				return null;
			}
			var bytesReader = new $USOProject_BytesReader(tokenBuilder);
			var token = bytesReader.ReadString();
			var userID = bytesReader.ReadString();
			var serverDate = bytesReader.ReadString();
			return new $USOProject_SecurityLayerJS$PersistenceData.$ctor1(token, CoreEx.ToInt(userID, 0), serverDate);
		}
		catch ($t1) {
			var ex = ss.Exception.wrap($t1);
			return null;
		}
	};
	$USOProject_SecurityLayerJS.RemovePersistentToken = function() {
		window.localStorage.removeItem('USOAPPDATA');
	};
	$USOProject_SecurityLayerJS.RsaEncryptByPublicCore = function(decryptedBytes, xmlParams) {
		var rsa = new System.Security.Cryptography.RSACryptoServiceProvider();
		rsa.FromXmlString(xmlParams);
		var encryptedBytes = rsa.Encrypt(decryptedBytes, false);
		return encryptedBytes;
	};
	$USOProject_SecurityLayerJS.RsaEncryptByDonetPublic = function(decryptedBytes) {
		return $USOProject_SecurityLayerJS.RsaEncryptByPublicCore(decryptedBytes, $USOProject_SecurityLayerJS.xmlParams);
	};
	$USOProject_SecurityLayerJS.RsaDecryptByPublicCore = function(encryptedBytes, xmlParams) {
		var rsa = new System.Security.Cryptography.RSACryptoServiceProvider();
		rsa.FromXmlString(xmlParams);
		var decryptedBytes = rsa.Decrypt(encryptedBytes, false);
		return decryptedBytes;
	};
	$USOProject_SecurityLayerJS.Encrypt = function(key, iv, bytes) {
		var encryptor = $USOProject_SecurityLayerJS.GetTransform(key, iv, true);
		return $USOProject_SecurityLayerJS.$CipherStreamWrite(encryptor, bytes);
	};
	$USOProject_SecurityLayerJS.Decrypt = function(key, iv, bytes) {
		var decryptor = $USOProject_SecurityLayerJS.GetTransform(key, iv, false);
		return $USOProject_SecurityLayerJS.$CipherStreamWrite(decryptor, bytes);
	};
	$USOProject_SecurityLayerJS.$CipherStreamWrite = function(cryptor, input) {
		var inputBuffer = new System.Byte(input.length);
		System.Buffer.BlockCopy(input, 0, inputBuffer, 0, inputBuffer.length);
		var stream = new System.IO.MemoryStream();
		var mode = System.Security.Cryptography.CryptoStreamMode.Write;
		var cryptoStream = new System.Security.Cryptography.CryptoStream(stream, cryptor, mode);
		cryptoStream.Write(inputBuffer, 0, inputBuffer.length);
		cryptoStream.FlushFinalBlock();
		var outputBuffer = stream.ToArray();
		stream.Close();
		cryptoStream.Close();
		return outputBuffer;
	};
	$USOProject_SecurityLayerJS.GetTransform = function(key, iv, isEncrypt) {
		var cipher = new System.Security.Cryptography.RijndaelManaged();
		var cryptor = null;
		if (isEncrypt) {
			cryptor = cipher.CreateEncryptor(key, iv);
		}
		else {
			cryptor = cipher.CreateDecryptor(key, iv);
		}
		return cryptor;
	};
	global.USOProject.SecurityLayerJS = $USOProject_SecurityLayerJS;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.SecurityLayerJS.PersistenceData
	var $USOProject_SecurityLayerJS$PersistenceData = function() {
		this.token = null;
		this.userID = 0;
		this.serverDate = null;
	};
	$USOProject_SecurityLayerJS$PersistenceData.__typeName = 'USOProject.SecurityLayerJS$PersistenceData';
	$USOProject_SecurityLayerJS$PersistenceData.$ctor1 = function(token, userId, serverDate) {
		this.token = null;
		this.userID = 0;
		this.serverDate = null;
		this.token = token;
		this.userID = userId;
		this.serverDate = serverDate;
	};
	global.USOProject.SecurityLayerJS$PersistenceData = $USOProject_SecurityLayerJS$PersistenceData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.SetupType
	var $USOProject_SetupType = function() {
	};
	$USOProject_SetupType.__typeName = 'USOProject.SetupType';
	$USOProject_SetupType.$ctor = function(name, value) {
		var $this = {};
		$this.Name = null;
		$this.Value = 0;
		$this.Name = name;
		$this.Value = value;
		return $this;
	};
	$USOProject_SetupType.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.SetupType = $USOProject_SetupType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.TokenObject
	var $USOProject_TokenObject = function() {
	};
	$USOProject_TokenObject.__typeName = 'USOProject.TokenObject';
	$USOProject_TokenObject.createInstance = function() {
		return {};
	};
	$USOProject_TokenObject.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.TokenObject = $USOProject_TokenObject;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.ActionTypeEnum
	var $USOProject_Business_ActionTypeEnum = function() {
	};
	$USOProject_Business_ActionTypeEnum.__typeName = 'USOProject.Business.ActionTypeEnum';
	global.USOProject.Business.ActionTypeEnum = $USOProject_Business_ActionTypeEnum;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.BusinessAction
	var $USOProject_Business_BusinessAction = function() {
	};
	$USOProject_Business_BusinessAction.__typeName = 'USOProject.Business.BusinessAction';
	$USOProject_Business_BusinessAction.WaitConfirmOrder_SearchWaitAudit = function(query, page, showLoading) {
		var serviceName = 'MobileRest.Service.WaitConfirmOrderAuditService';
		var methodName = 'SearchWaitAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, query, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.WaitConfirmOrder_SearchAudited = function(query, page, showLoading) {
		var serviceName = 'MobileRest.Service.WaitConfirmOrderAuditService';
		var methodName = 'SearchAudited';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, query, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.WaitConfirmOrder_Get = function(request, page, showLoading) {
		var serviceName = 'MobileRest.Service.WaitConfirmOrderAuditService';
		var methodName = 'Get';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, request, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.WaitConfirmOrder_DoReturnBack = function(model, page, showLoading) {
		var serviceName = 'MobileRest.Service.WaitConfirmOrderAuditService';
		var methodName = 'DoReturnBack';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, model, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.WaitConfirmOrderAuditService_DoAudit = function(request, page, showLoading) {
		var serviceName = 'MobileRest.Service.WaitConfirmOrderAuditService';
		var methodName = 'DoAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, request, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.SpecificSaleOrder_SearchWaitAudit = function(query, page, showLoading) {
		var serviceName = 'MobileRest.Service.SpecificSaleOrderAuditService';
		var methodName = 'SearchWaitAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, query, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.SpecificSaleOrder_SearchAudited = function(query, page, showLoading) {
		var serviceName = 'MobileRest.Service.SpecificSaleOrderAuditService';
		var methodName = 'SearchAudited';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, query, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.SpecificSaleOrder_Get = function(applyId, page, showLoading) {
		var serviceName = 'MobileRest.Service.SpecificSaleOrderAuditService';
		var methodName = 'Get';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, applyId, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.SpecificSaleOrder_GetFlow = function(soId, page, showLoading) {
		var serviceName = 'MobileRest.Service.SpecificSaleOrderAuditService';
		var methodName = 'GetFlow';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, soId, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.SpecificSaleOrder_InitAudit = function(soId, page, showLoading) {
		var serviceName = 'MobileRest.Service.SpecificSaleOrderAuditService';
		var methodName = 'InitAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, soId, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.SpecificSaleOrderAuditService_DoAudit = function(model, page, showLoading) {
		var serviceName = 'MobileRest.Service.SpecificSaleOrderAuditService';
		var methodName = 'DoAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, model, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.ReturnOrderWeiHuo_SearchWaitAudit = function(query, page, showLoading) {
		var serviceName = 'MobileRest.Service.ReturnOrderWeiHuoAuditService';
		var methodName = 'SearchWaitAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, query, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.ReturnOrderWeiHuo_SearchAudited = function(query, page, showLoading) {
		var serviceName = 'MobileRest.Service.ReturnOrderWeiHuoAuditService';
		var methodName = 'SearchAudited';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, query, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.ReturnOrderWeiHuo_Get = function(applyId, page, showLoading) {
		var serviceName = 'MobileRest.Service.ReturnOrderWeiHuoAuditService';
		var methodName = 'Get';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, applyId, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.ReturnOrderWeiHuo_GetFlow = function(soId, page, showLoading) {
		var serviceName = 'MobileRest.Service.ReturnOrderWeiHuoAuditService';
		var methodName = 'GetFlow';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, soId, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.ReturnOrderWeiHuo_InitAudit = function(soId, page, showLoading) {
		var serviceName = 'MobileRest.Service.ReturnOrderWeiHuoAuditService';
		var methodName = 'InitAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, soId, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.ReturnOrderWeiHuoAuditService_DoAudit = function(model, page, showLoading) {
		var serviceName = 'MobileRest.Service.ReturnOrderWeiHuoAuditService';
		var methodName = 'DoAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, model, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.QueryCustomerLegal = function(name, pageIndex, pageSize, page) {
		var result = $USOProject_Business_DataService.PostCommonRequest(Object).call(null, 'MobileRest.Service.RetailInputNewService', 'QueryCustomerLegal', { Name: name, PageIndex: pageIndex, PageSize: pageSize }, page, true);
		return ss.cast(result, ss.Task);
	};
	$USOProject_Business_BusinessAction.QueryUser = function(name, pageIndex, pageSize, page) {
		var result = $USOProject_Business_DataService.PostCommonRequest(Object).call(null, 'MobileRest.Service.RetailInputNewService', 'QueryUser', { Name: name, PageIndex: pageIndex, PageSize: pageSize }, page, true);
		return ss.cast(result, ss.Task);
	};
	$USOProject_Business_BusinessAction.Login = function(userName, password, validateCode, isRemberLogin, page) {
		var $state = 0, $tcs = new ss.TaskCompletionSource(), $t1, result;
		var $sm = function() {
			try {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							$t1 = $USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
								builder.AddString(userName);
								builder.AddString(password);
								builder.AddString(validateCode);
								builder.AddString((isRemberLogin ? '1' : '0'));
								//ogrId;
								builder.AddString('');
								var deviceInfo = $App.GetDeviceInfo();
								builder.AddString(deviceInfo);
							}, 2, true, page, false);
							$state = 1;
							$t1.continueWith($sm);
							return;
						}
						case 1: {
							$state = -1;
							result = $t1.getAwaitedResult();
							$tcs.setResult(result);
							return;
						}
						default: {
							break $sm1;
						}
					}
				}
			}
			catch ($t2) {
				$tcs.setException(ss.Exception.wrap($t2));
			}
		};
		$sm();
		return $tcs.task;
	};
	$USOProject_Business_BusinessAction.AutoLogin = function(data, page) {
		return $USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
			builder.AddString(data.userID.toString());
			builder.AddString(data.token);
			builder.AddString('');
			var deviceInfo = $App.GetDeviceInfo();
			builder.AddString(deviceInfo);
		}, 14, true, page, false);
	};
	$USOProject_Business_BusinessAction.QeuryProductFavorite = function(query, page) {
		var result = $USOProject_Business_DataService.PostRequest(Array).call(null, function(builder) {
			builder.AddString(JSON.stringify(query));
		}, 32, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.DelteFavorite = function(favId, page) {
		var result = $USOProject_Business_DataService.PostRequest(ss.Int32).call(null, function(builder) {
			builder.AddString(JSON.stringify({ Id: favId }));
		}, 31, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.QuerySpecList = function(condtion, page) {
		var result = $USOProject_Business_DataService.PostRequest(Array).call(null, function(builder) {
			builder.AddString(JSON.stringify(condtion));
		}, 7, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetSpecDetail = function(specId, page) {
		var result = $USOProject_Business_DataService.PostRequest($USOProject_Business_SpecialAuditViewModel).call(null, function(builder) {
			builder.AddString(specId.toString());
		}, 10, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetSpecialAuditProcTrack = function(query, page) {
		var result = $USOProject_Business_DataService.PostRequest($USOProject_Business_WorkFlowProcTrackDTO).call(null, function(builder) {
			builder.AddString(JSON.stringify(query));
		}, 28, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetSpecialApproveInitData = function(specialId, page) {
		var result = $USOProject_Business_DataService.PostRequest($USOProject_Business_SpecialAuditActionViewModel).call(null, function(builder) {
			builder.AddString(specialId.toString());
		}, 9, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.SpecialApprove = function(data, page) {
		var result = $USOProject_Business_DataService.PostRequest(String).call(null, function(builder) {
			builder.AddString(JSON.stringify(data));
		}, 8, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetIndexWorkTodoData = function(query, page) {
		var result = $USOProject_Business_DataService.PostRequest($USOProject_Business_TodoWorkDtoModel).call(null, function(builder) {
			builder.AddString(JSON.stringify(query));
		}, 11, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.QueryCurrentTopLevelOrg = function(UserMinOrgType, CurrentStockOrgId, page) {
		var result = $USOProject_Business_DataService.PostCommonRequest(Object).call(null, 'MobileRest.Service.RetailInputNewService', 'QueryCurrentTopLevelOrg', { UserMinOrgType: UserMinOrgType, CurrentStockOrgId: CurrentStockOrgId }, page, true);
		return ss.cast(result, ss.Task);
	};
	$USOProject_Business_BusinessAction.QueryStatisticsRetailReport = function(query, page) {
		query.RetailInputStatRoleType = $App.LoginResult.RetailInputStatRoleType;
		if (query.DateType === 6 || query.DateType === 7 || query.DateType === 8) {
			query.CustomizeDateRange = new $USOProject_Pages_NewRetailInputStatistics_CustomizeDateRange();
			query.CustomizeDateRange.To = ss.formatDate(new Date(), 'yyyy-MM-dd');
			if (query.DateType === 6) {
				var quater = ss.Int32.div((new Date()).getMonth() + 1 - 1, 3) + 1;
				var quaterBeginMonth = (quater - 1) * 3 + 1;
				query.CustomizeDateRange.From = ss.formatDate(new Date(), ss.formatString('yyyy-{0}-01', ss.formatNumber(quaterBeginMonth, 'd2')));
			}
			else if (query.DateType === 7) {
				var beginMonth = 1;
				if ((new Date()).getMonth() + 1 >= 7) {
					beginMonth = 7;
				}
				query.CustomizeDateRange.From = ss.formatDate(new Date(), ss.formatString('yyyy-{0}-01', ss.formatNumber(beginMonth, 'd2')));
			}
			else if (query.DateType === 8) {
				query.CustomizeDateRange.From = ss.formatDate(new Date(), 'yyyy-01-01');
			}
			query.DateType = 5;
		}
		var result = $USOProject_Business_DataService.PostCommonRequest(Object).call(null, 'MobileRest.Service.RetailInputNewService', 'QueryStatisticsRetailReport', query, page, true);
		return ss.cast(result, ss.Task);
	};
	$USOProject_Business_BusinessAction.GetLastLogDate = function(page) {
		var result = $USOProject_Business_DataService.PostCommonRequest(Object).call(null, 'MobileRest.Service.RetailInputNewService', 'GetLastLogDate', {}, page, true);
		return ss.cast(result, ss.Task);
	};
	$USOProject_Business_BusinessAction.GetProductDetail = function(productId) {
		var result = $USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
			builder.AddInt(productId);
		}, 39, true, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetProductOrg = function(R3ProductGroupId) {
		var result = $USOProject_Business_DataService.PostRequest(Array).call(null, function(builder) {
			builder.AddInt(R3ProductGroupId);
		}, 47, true, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetCustomerLegalAction = function(orgId) {
		var result = $USOProject_Business_DataService.PostRequest(Array).call(null, function(builder) {
			builder.AddInt(orgId);
		}, 42, true, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetWarehouseAcction = function(orgId) {
		var result = $USOProject_Business_DataService.PostRequest(Array).call(null, function(builder) {
			builder.AddInt(orgId);
		}, 43, true, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetProductQuantity = function(orgId, stockId, productId) {
		var result = $USOProject_Business_DataService.PostRequest(ss.Int32).call(null, function(builder) {
			builder.AddInt(orgId);
			builder.AddInt(stockId);
			builder.AddInt(productId);
		}, 44, true, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetPriceAction = function(productId, orgId, customerLegalId) {
		var result = $USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
			builder.AddInt(productId);
			builder.AddInt(orgId);
			builder.AddInt(customerLegalId);
		}, 41, true, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetProductDiscount = function(customerId, orgId) {
		var result = $USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
			builder.AddInt(customerId);
			builder.AddInt(orgId);
		}, 45, true, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.AddProductFavorite = function(productId, productFavoriteType) {
		var result = $USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
			builder.AddString(JSON.stringify({ ProductId: productId, ProductFavoriteType: productFavoriteType }));
		}, 30, true, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetAllCategory = function() {
		var result = $USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
		}, 29, true, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetProductList = function(dto) {
		var result = $USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
			builder.AddString(JSON.stringify(dto));
		}, 25, true, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetProductNameList = function(keyword) {
		var result = $USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
			builder.AddString(keyword);
		}, 24, false, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.RetailListQuery = function(query, page) {
		var result = $USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
			builder.AddString(JSON.stringify(query));
		}, 13, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.RetailInputDetailQuery = function(saleId, page) {
		var result = $USOProject_Business_DataService.PostRequest($CustomerSalesRestDTO).call(null, function(builder) {
			builder.AddString(JSON.stringify({ saleId: saleId }));
		}, 16, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.RetailInputAddOrUpdate = function(entity, page) {
		var result = $USOProject_Business_DataService.PostRequest($CustomerSalesRestDTO).call(null, function(builder) {
			builder.AddString(JSON.stringify(entity));
		}, 17, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.RetailInputUpdateStatus = function(saleId, status, page) {
		var result = $USOProject_Business_DataService.PostRequest(Boolean).call(null, function(builder) {
			builder.AddString(JSON.stringify({ saleId: saleId, status: status }));
		}, 18, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.RetailInputProductListAction = function(query, page) {
		var result = $USOProject_Business_DataService.PostRequest(Array).call(null, function(builder) {
			builder.AddString(JSON.stringify(query));
		}, 19, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.RetailInputInit = function(sid, page) {
		var result = $USOProject_Business_DataService.PostRequest(ss.Int32).call(null, function(builder) {
			builder.AddString(sid.toString());
		}, 20, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.RetailInputStatistic = function(query, page) {
		var result = $USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
			builder.AddString(JSON.stringify(query));
		}, 22, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.RetailInputStatisticProduct = function(query, page) {
		var result = $USOProject_Business_DataService.PostRequest(Array).call(null, function(builder) {
			builder.AddString(JSON.stringify(query));
		}, 23, true, page, false);
		return result;
	};
	$USOProject_Business_BusinessAction.GetFeeList = function(page, showLoading) {
		var serviceName = 'MobileRest.Service.ProductNewService';
		var methodName = 'GetRetailFeeCategoryList';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, new Object(), page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.GetRetailInputProductOrgs = function(page, showLoading) {
		var serviceName = 'MobileRest.Service.ProductNewService';
		var methodName = 'GetProductGroupOrgs';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, new Object(), page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.GetStoreAddress = function(storeId, page, showLoading) {
		var serviceName = 'MobileRest.Service.StoreAddressService';
		var methodName = 'GetAddress';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, { Value: storeId }, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.BlankOut = function(SaleId, page, showLoading) {
		var serviceName = 'MobileRest.Service.RetailInputNewService';
		var methodName = 'BlankOut';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, { SaleId: SaleId }, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.IsProductAllReturn = function(CustomerSalesId, page, showLoading) {
		var serviceName = 'MobileRest.Service.RetailInputNewService';
		var methodName = 'IsProductAllReturn';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, { CustomerSalesId: CustomerSalesId }, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.GetRetailReturnProductCount = function(SaleId, page, showLoading) {
		var serviceName = 'MobileRest.Service.RetailInputNewService';
		var methodName = 'GetRetailReturnProductCount';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, { SaleId: SaleId }, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.ReturnGoods = function(SaleId, data, page, showLoading) {
		var serviceName = 'MobileRest.Service.RetailInputNewService';
		var methodName = 'ReturnGoods';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, { SaleId: SaleId, Data: data }, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.BlankOutReturnSale = function(SaleId, page, showLoading) {
		var serviceName = 'MobileRest.Service.RetailInputNewService';
		var methodName = 'BlankOutReturnSale';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, { SaleId: SaleId }, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.GetInternalAccountPriceForApp = function(ProductId, OrganizationId, R3DistributionId, CustomerId, page, showLoading) {
		var serviceName = 'MobileRest.Service.RetailInputNewService';
		var methodName = 'GetInternalAccountPriceForApp';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, { ProductId: ProductId, OrganizationId: OrganizationId, R3DistributionId: R3DistributionId, CustomerId: CustomerId }, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.ModifyPassword = function(oldPassword, newPassword) {
		var result = $USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
			builder.AddString(oldPassword);
			builder.AddString(newPassword);
		}, 3, true, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.ManualUpgrade = function() {
		var $state = 0, $tcs = new ss.TaskCompletionSource(), result, data;
		var $sm = function() {
			try {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							result = $USOProject_Business_DataService.PostRequest(String).call(null, function(builder) {
							}, 4, true, null, false);
							//结果返回的是字符串，这个地方为了让代码编译通过，强制改为了UpgradeInfo;
							$state = 1;
							result.continueWith($sm);
							return;
						}
						case 1: {
							$state = -1;
							data = result.getAwaitedResult();
							if (ss.isValue(data) && data.IsSuccess) {
								data.Result = $.parseJSON(data.Result);
							}
							$tcs.setResult(data);
							return;
						}
						default: {
							break $sm1;
						}
					}
				}
			}
			catch ($t1) {
				$tcs.setException(ss.Exception.wrap($t1));
			}
		};
		$sm();
		return $tcs.task;
	};
	$USOProject_Business_BusinessAction.GetCustomerStoreAction = function() {
		var result = $USOProject_Business_DataService.PostRequest(Array).call(null, function(builder) {
		}, 15, true, null, false);
		return result;
	};
	$USOProject_Business_BusinessAction.AdjustApply_SearchWaitAudit = function(query, page, showLoading) {
		var serviceName = 'MobileRest.Service.AdjustApplyAuditService';
		var methodName = 'SearchWaitAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, query, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.AdjustApply_SearchAudited = function(query, page, showLoading) {
		var serviceName = 'MobileRest.Service.AdjustApplyAuditService';
		var methodName = 'SearchAudited';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, query, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.AdjustApply_Get = function(applyId, page, showLoading) {
		var serviceName = 'MobileRest.Service.AdjustApplyAuditService';
		var methodName = 'Get';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, applyId, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.AdjustApply_GetFlow = function(applyId, page, showLoading) {
		var serviceName = 'MobileRest.Service.AdjustApplyAuditService';
		var methodName = 'GetFlow';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, applyId, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.AdjustApply_InitAudit = function(applyId, page, showLoading) {
		var serviceName = 'MobileRest.Service.AdjustApplyAuditService';
		var methodName = 'InitAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, applyId, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.AdjustApply_DoAudit = function(data, page, showLoading) {
		var serviceName = 'MobileRest.Service.AdjustApplyAuditService';
		var methodName = 'DoAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, data, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.EngineerOrder_SearchWaitAudit = function(query, page, showLoading) {
		var serviceName = 'MobileRest.Service.EngineerOrderAuditService';
		var methodName = 'SearchWaitAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, query, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.EngineerOrder_SearchAudited = function(query, page, showLoading) {
		var serviceName = 'MobileRest.Service.EngineerOrderAuditService';
		var methodName = 'SearchAudited';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, query, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.EngineerOrder_Get = function(projectFileId, page, showLoading) {
		var serviceName = 'MobileRest.Service.EngineerOrderAuditService';
		var methodName = 'Get';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, projectFileId, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.EngineerOrder_DoAudit = function(applyId, page, showLoading) {
		var serviceName = 'MobileRest.Service.EngineerOrderAuditService';
		var methodName = 'DoAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, applyId, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.EngineerOrder_DoReturnBack = function(model, page, showLoading) {
		var serviceName = 'MobileRest.Service.EngineerOrderAuditService';
		var methodName = 'DoReturnBack';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, model, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.OtherOrder_SearchWaitAudit = function(query, page, showLoading) {
		var serviceName = 'MobileRest.Service.OtherOrderAuditService';
		var methodName = 'SearchWaitAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, query, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.OtherOrder_SearchAudited = function(query, page, showLoading) {
		var serviceName = 'MobileRest.Service.OtherOrderAuditService';
		var methodName = 'SearchAudited';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, query, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.OtherOrder_Get = function(request, page, showLoading) {
		var serviceName = 'MobileRest.Service.OtherOrderAuditService';
		var methodName = 'Get';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, request, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.OtherOrder_DoAudit = function(soMasterId, page, showLoading) {
		var serviceName = 'MobileRest.Service.OtherOrderAuditService';
		var methodName = 'DoAudit';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, soMasterId, page, showLoading), ss.Task);
	};
	$USOProject_Business_BusinessAction.OtherOrder_DoReturnBack = function(model, page, showLoading) {
		var serviceName = 'MobileRest.Service.OtherOrderAuditService';
		var methodName = 'DoReturnBack';
		return ss.cast($USOProject_Business_DataService.PostCommonRequest(Object).call(null, serviceName, methodName, model, page, showLoading), ss.Task);
	};
	global.USOProject.Business.BusinessAction = $USOProject_Business_BusinessAction;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.CustomerLegalOrgList
	var $USOProject_Business_CustomerLegalOrgList = function() {
		this.CustomerLegalId = 0;
		this.CustomerLegalName = null;
		this.OrganizationId = 0;
	};
	$USOProject_Business_CustomerLegalOrgList.__typeName = 'USOProject.Business.CustomerLegalOrgList';
	global.USOProject.Business.CustomerLegalOrgList = $USOProject_Business_CustomerLegalOrgList;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.CustomerLegalStoreOrgDTO
	var $USOProject_Business_CustomerLegalStoreOrgDTO = function() {
	};
	$USOProject_Business_CustomerLegalStoreOrgDTO.__typeName = 'USOProject.Business.CustomerLegalStoreOrgDTO';
	$USOProject_Business_CustomerLegalStoreOrgDTO.createInstance = function() {
		return $USOProject_Business_CustomerLegalStoreOrgDTO.$ctor();
	};
	$USOProject_Business_CustomerLegalStoreOrgDTO.$ctor = function() {
		var $this = {};
		$this.CustomerStoreId = 0;
		$this.CustomerStoreName = null;
		$this.CustomerLegalOrgList = null;
		return $this;
	};
	$USOProject_Business_CustomerLegalStoreOrgDTO.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.CustomerLegalStoreOrgDTO = $USOProject_Business_CustomerLegalStoreOrgDTO;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.CustomerWorkFlowlRangeStatusEnum
	var $USOProject_Business_CustomerWorkFlowlRangeStatusEnum = function() {
	};
	$USOProject_Business_CustomerWorkFlowlRangeStatusEnum.__typeName = 'USOProject.Business.CustomerWorkFlowlRangeStatusEnum';
	global.USOProject.Business.CustomerWorkFlowlRangeStatusEnum = $USOProject_Business_CustomerWorkFlowlRangeStatusEnum;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.DataResult
	var $USOProject_Business_DataResult$1 = function(T) {
		var $type = function() {
		};
		$type.createInstance = function() {
			return $type.$ctor();
		};
		$type.$ctor = function() {
			var $this = {};
			$this.IsSuccess = false;
			$this.ErrorMessage = false;
			return $this;
		};
		$type.isInstanceOfType = function() {
			return true;
		};
		ss.registerGenericClassInstance($type, $USOProject_Business_DataResult$1, [T], {}, function() {
			return null;
		}, function() {
			return [];
		});
		return $type;
	};
	$USOProject_Business_DataResult$1.__typeName = 'USOProject.Business.DataResult$1';
	ss.initGenericClass($USOProject_Business_DataResult$1, $asm, 1);
	global.USOProject.Business.DataResult$1 = $USOProject_Business_DataResult$1;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.DataService
	var $USOProject_Business_DataService = function() {
	};
	$USOProject_Business_DataService.__typeName = 'USOProject.Business.DataService';
	$USOProject_Business_DataService.PostRequest = function(T) {
		return function(BuildRequest, actionID, showMask, page, isPlainSession) {
			var tsk = new ss.TaskCompletionSource();
			var tokenObj = $USOProject_SecurityChannel.GetTokenObject();
			if (ss.isNullOrUndefined(tokenObj)) {
				JSLib.Mobile.MessageBox.Alert('当前会话超时，请重新登陆！');
				JSLib.Mobile.Application.BackTo($USOProject_Pages_LoginPage).call(null);
				return null;
			}
			var body = '';
			console.info('-------------------------------------------------------------------------------------------');
			console.info('Ajax Call:', ss.Enum.toString($USOProject_Business_ActionTypeEnum, actionID), actionID);
			if (!ss.staticEquals(BuildRequest, null)) {
				var builder = new $USOProject_BytesBuilder();
				builder.OnAddInt = function(i) {
					console.info('ajax parameter:', i);
				};
				builder.OnAddString = function(s) {
					console.info('ajax parameter:', s);
				};
				BuildRequest(builder);
				body = System.Convert.ToBase64String(builder.ToArray());
			}
			var isImage = [0];
			var keyInfo1 = { Key: tokenObj.oldKey, IV: tokenObj.oldIV };
			var keyInfo2 = { Key: tokenObj.newKey, IV: tokenObj.newIV };
			var currentOrgID = $App.GetStoredCurrentOrgID($App.GetUserID());
			var md5 = new System.Security.Cryptography.MD5();
			var md5Builder = new $USOProject_BytesBuilder();
			var serviceAction = [actionID, 0];
			md5Builder.AddBytes(serviceAction);
			md5Builder.AddBytes(isImage);
			md5Builder.AddString(tokenObj.token);
			md5Builder.AddString(body);
			md5Builder.AddString(currentOrgID.toString());
			var md5Value = md5.ComputeHash(md5Builder.ToArray());
			var contentBuilder = new $USOProject_BytesBuilder();
			contentBuilder.AddBytes(md5Value).AddString(body).AddString(currentOrgID.toString());
			var encoding1Builder = new $USOProject_BytesBuilder();
			var encrypted1 = $USOProject_SecurityLayerJS.Encrypt(keyInfo1.Key, keyInfo1.IV, contentBuilder.ToArray());
			var encoding1 = encoding1Builder.AddBytes(serviceAction).AddBytes(encrypted1).ToArray();
			var encrypted2 = $USOProject_SecurityLayerJS.Encrypt(keyInfo2.Key, keyInfo2.IV, encoding1);
			var encoding2Builder = new $USOProject_BytesBuilder();
			var sendArray = encoding2Builder.AddString(tokenObj.token).AddBytes(isImage).AddBytes(encrypted2).ToArray();
			window.setTimeout(function() {
				var $state = 0, loadingDialog, $t1, isPageDestory, currentAjaxRequest;
				var $sm = function() {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								loadingDialog = null;
								if (showMask) {
									if (ss.isValue(page)) {
										$t1 = page.ShowLoading(0);
										$state = 2;
										$t1.continueWith($sm);
										return;
									}
									else {
										JSLib.Mobile.Application.ShowLoading();
										$state = 1;
										continue $sm1;
									}
								}
								$state = 1;
								continue $sm1;
							}
							case 2: {
								$state = -1;
								loadingDialog = $t1.getAwaitedResult();
								$state = 1;
								continue $sm1;
							}
							case 1: {
								$state = -1;
								isPageDestory = false;
								currentAjaxRequest = $.ajax({
									async: true,
									cache: false,
									type: 'post',
									url: $App.app.get_ServiceBase() + (isPlainSession ? 'PlainSession' : 'Session'),
									success: function(result, status, request) {
										if (ss.isValue(loadingDialog)) {
											loadingDialog.Destroy();
										}
										var base64Result = result.toString();
										if (ss.isNullOrEmptyString(base64Result) || base64Result === '0' || base64Result === '') {
											tsk.setResult($USOProject_Business_DataService.$GetErrorData(T).call(null, 1));
											JSLib.Mobile.MessageBox.Alert('当前会话超时，请重新登陆！');
											return;
										}
										if (base64Result === '-1') {
											tsk.setResult($USOProject_Business_DataService.$GetErrorData(T).call(null, 2));
											JSLib.Mobile.MessageBox.Alert('当前会话超时，请重新登陆！');
											return;
										}
										if (base64Result === '-2') {
											tsk.setResult($USOProject_Business_DataService.$GetErrorData(T).call(null, 3));
											JSLib.Mobile.MessageBox.Alert('当前会话超时，请重新登陆！');
											JSLib.Mobile.Application.BackTo($USOProject_Pages_LoginPage).call(null);
											return;
										}
										//undo:if base64Result == null or 0 mean exception....
										var dataArray = System.Convert.FromBase64String(base64Result);
										var decodeArray = null;
										try {
											var decodeArray1 = $USOProject_SecurityLayerJS.Decrypt(tokenObj.nextKey, tokenObj.nextIV, dataArray);
											decodeArray = $USOProject_SecurityLayerJS.Decrypt(tokenObj.newKey, tokenObj.newIV, decodeArray1);
										}
										catch ($t2) {
											var ex = ss.Exception.wrap($t2);
											tsk.setResult($USOProject_Business_DataService.$GetErrorData(T).call(null, 6));
											return;
										}
										var resultReader = new $USOProject_BytesReader(decodeArray);
										var successArray = resultReader.ReadBytes(1);
										if (successArray[0] !== 1) {
											tsk.setResult($USOProject_Business_DataService.$GetErrorData(T).call(null, 4));
											return;
										}
										var tempArray = $USOProject_SecurityChannel.readEncodingTokensCore(resultReader);
										for (var tI = 0; tI < tempArray.length; tI++) {
											$USOProject_SecurityChannel.tokenArray.push(tempArray[tI]);
										}
										var actionBody = resultReader.ReadString();
										var position = resultReader.GetPosition();
										var infoArray = decodeArray.slice(0, position);
										var calMd5 = (new System.Security.Cryptography.MD5()).ComputeHash(infoArray);
										var returnMD5 = resultReader.ReadBytes(16);
										if (!$USOProject_SecurityChannel.IsEqual(calMd5, returnMD5)) {
											tsk.setResult($USOProject_Business_DataService.$GetErrorData(T).call(null, 5));
											return;
										}
										var objResult = $.parseJSON(System.Text.Encoding.UTF8.GetString(System.Convert.FromBase64String(actionBody)));
										console.info('ajax result:', objResult);
										tsk.setResult(objResult);
									},
									error: function() {
										if (showMask) {
											if (ss.isValue(loadingDialog)) {
												loadingDialog.Destroy();
											}
											else {
												JSLib.Mobile.Application.HideLoading();
											}
										}
										if (isPageDestory) {
											return;
										}
										var data = new (ss.makeGenericType($USOProject_Business_DataServiceResult$1, [T]))();
										data.IsSuccess = false;
										data.ErrorMessage = '网络连接出现错误!';
										tsk.setResult(data);
									},
									complete: function() {
										if (showMask) {
											if (ss.isValue(loadingDialog)) {
												loadingDialog.Destroy();
											}
											else {
												JSLib.Mobile.Application.HideLoading();
											}
										}
									},
									data: ss.mkdict(['', System.Convert.ToBase64String(sendArray)]),
									dataType: 'text',
									timeout: $App.app.defaultAjaxTimeout,
									headers: ss.mkdict(['appVersion', $App.app.AppVersion])
								});
								if (ss.isValue(page)) {
									page.add_OnDestroy(function(sender, args) {
										isPageDestory = true;
										currentAjaxRequest.abort();
									});
								}
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				};
				$sm();
			}, 0);
			return tsk.task;
		};
	};
	$USOProject_Business_DataService.PostCommonRequest = function(T) {
		return function(typeName, methodName, postData, page, showLoading) {
			var loadingDialog = null;
			var tsk = new ss.TaskCompletionSource();
			window.setTimeout(function() {
				var $state = 0, $t1, service, param, bodyEncoding, currentStockOrganizationId, req, isPageDestory, ajaxRequest;
				var $sm = function() {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								if (showLoading) {
									if (ss.isValue(page) && ss.isValue(page.pageObject)) {
										$t1 = page.ShowLoading(0);
										$state = 2;
										$t1.continueWith($sm);
										return;
									}
									$state = 1;
									continue $sm1;
								}
								$state = 1;
								continue $sm1;
							}
							case 2: {
								$state = -1;
								loadingDialog = $t1.getAwaitedResult();
								$state = 1;
								continue $sm1;
							}
							case 1: {
								$state = -1;
								service = { ServiceName: typeName, MethodName: methodName };
								param = null;
								if (ss.isNullOrUndefined(postData)) {
									param = '';
								}
								else {
									param = JSON.stringify(postData);
								}
								bodyEncoding = { ServiceName: service.ServiceName, MethodName: service.MethodName, Param: param };
								currentStockOrganizationId = $App.app.userInfo.User.CurrentStockOrganizationId;
								req = { Token: $USOProject_SecurityChannel.getDebugToken().token, BodyEncoding: bodyEncoding, CurrentStockOrgID: currentStockOrganizationId };
								isPageDestory = false;
								ajaxRequest = $.ajax({
									cache: false,
									type: 'post',
									url: $App.app.get_ServiceBase() + 'PlainSession',
									success: function(data, status, request) {
										if (showLoading && ss.isValue(loadingDialog)) {
											loadingDialog.Destroy();
										}
										tsk.setResult(JSON.parse(data));
									},
									error: function(request1, status1, error) {
										if (showLoading && ss.isValue(loadingDialog)) {
											loadingDialog.Destroy();
										}
										if (isPageDestory) {
											return;
										}
										var data1 = new (ss.makeGenericType($USOProject_Business_DataServiceResult$1, [T]))();
										data1.IsSuccess = false;
										data1.ErrorMessage = '网络连接出现错误!';
										tsk.setResult(data1);
									},
									data: ss.mkdict(['', JSON.stringify(req)]),
									timeout: $App.app.defaultAjaxTimeout,
									headers: ss.mkdict(['appVersion', $App.app.AppVersion])
								});
								if (ss.isValue(page)) {
									page.add_OnDestroy(function(sender, args) {
										isPageDestory = true;
										ajaxRequest.abort();
									});
								}
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				};
				$sm();
			}, 0);
			return tsk.task;
		};
	};
	$USOProject_Business_DataService.$GetErrorData = function(T) {
		return function(errorType) {
			var $t1 = new (ss.makeGenericType($USOProject_Business_DataServiceResult$1, [T]))();
			$t1.ErrorType = 5;
			$t1.IsSuccess = false;
			return $t1;
		};
	};
	global.USOProject.Business.DataService = $USOProject_Business_DataService;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.DataServiceErrorType
	var $USOProject_Business_DataServiceErrorType = function() {
	};
	$USOProject_Business_DataServiceErrorType.__typeName = 'USOProject.Business.DataServiceErrorType';
	global.USOProject.Business.DataServiceErrorType = $USOProject_Business_DataServiceErrorType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.DataServiceResult
	var $USOProject_Business_DataServiceResult$1 = function(T) {
		var $type = function() {
			this.IsSuccess = false;
			this.ErrorType = 0;
			this.Result = ss.getDefaultValue(T);
			this.ErrorMessage = null;
			this.IsSuccess = false;
			this.ErrorMessage = '';
		};
		ss.registerGenericClassInstance($type, $USOProject_Business_DataServiceResult$1, [T], {}, function() {
			return null;
		}, function() {
			return [];
		});
		return $type;
	};
	$USOProject_Business_DataServiceResult$1.__typeName = 'USOProject.Business.DataServiceResult$1';
	ss.initGenericClass($USOProject_Business_DataServiceResult$1, $asm, 1);
	global.USOProject.Business.DataServiceResult$1 = $USOProject_Business_DataServiceResult$1;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.DescriptionAttribute
	var $USOProject_Business_DescriptionAttribute = function(description) {
	};
	$USOProject_Business_DescriptionAttribute.__typeName = 'USOProject.Business.DescriptionAttribute';
	global.USOProject.Business.DescriptionAttribute = $USOProject_Business_DescriptionAttribute;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.FileTransferPlugin
	var $USOProject_Business_FileTransferPlugin = function() {
	};
	$USOProject_Business_FileTransferPlugin.__typeName = 'USOProject.Business.FileTransferPlugin';
	$USOProject_Business_FileTransferPlugin.DownloadFile = function(source, target, onProgress) {
		var tsk = new ss.TaskCompletionSource();
		var fileTransfer = new FileTransfer();
		fileTransfer.download(source, target, function(entry) {
			tsk.setResult(true);
		}, function(error) {
			tsk.setResult(false);
			console.error(error);
		});
		fileTransfer.onprogress = onProgress;
		return tsk.task;
	};
	global.USOProject.Business.FileTransferPlugin = $USOProject_Business_FileTransferPlugin;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.InAppUpdater
	var $USOProject_Business_InAppUpdater = function() {
		this.$checkUrl = ss.cast(window.InAppVersionCheckUrl, String);
	};
	$USOProject_Business_InAppUpdater.__typeName = 'USOProject.Business.InAppUpdater';
	$USOProject_Business_InAppUpdater.IsExistFile = function(fileName) {
		return $USOProject_Business_InAppUpdater.DownloadString(fileName).continueWith(function(task) {
			return ss.isValue(task.getResult());
		});
	};
	$USOProject_Business_InAppUpdater.DownloadData = function(T) {
		return function(url) {
			return $USOProject_Business_InAppUpdater.DownloadString(url).continueWith(function(task) {
				if (!ss.isNullOrEmptyString(task.getResult())) {
					return JSON.parse(task.getResult());
				}
				else {
					return ss.getDefaultValue(T);
				}
			});
		};
	};
	$USOProject_Business_InAppUpdater.DownloadString = function(fileUrl) {
		var tsk = new ss.TaskCompletionSource();
		var ajaxOption = {
			url: fileUrl,
			success: function(data, status, request) {
				tsk.setResult(request.responseText);
			},
			error: function(request1, status1, error) {
				tsk.setResult(null);
			}
		};
		$.ajax(ajaxOption);
		return tsk.task;
	};
	$USOProject_Business_InAppUpdater.GetFileURI = function(fileUrI) {
		var tsk = new ss.TaskCompletionSource();
		window.resolveLocalFileSystemURI(fileUrI, function(entry) {
			var url = entry.toURL();
			tsk.setResult(url);
		}, function(o) {
			tsk.setResult(null);
		});
		return tsk.task;
	};
	global.USOProject.Business.InAppUpdater = $USOProject_Business_InAppUpdater;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.IndexWorkTodoQuery
	var $USOProject_Business_IndexWorkTodoQuery = function() {
	};
	$USOProject_Business_IndexWorkTodoQuery.__typeName = 'USOProject.Business.IndexWorkTodoQuery';
	$USOProject_Business_IndexWorkTodoQuery.createInstance = function() {
		return $USOProject_Business_IndexWorkTodoQuery.$ctor();
	};
	$USOProject_Business_IndexWorkTodoQuery.$ctor = function() {
		var $this = {};
		$this.Page = 0;
		$this.PageSize = 0;
		$this.LastWorkStepId = null;
		$this.IsOrderByLastWorkStepId = false;
		$this.FirstWorkStepId = null;
		$this.LoadedSpecialIds = null;
		return $this;
	};
	$USOProject_Business_IndexWorkTodoQuery.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.IndexWorkTodoQuery = $USOProject_Business_IndexWorkTodoQuery;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.JPush
	var $USOProject_Business_JPush = function() {
	};
	$USOProject_Business_JPush.__typeName = 'USOProject.Business.JPush';
	$USOProject_Business_JPush.SetAlias = function(alias) {
		if (!JSLib.Mobile.Application.IsBrowser) {
			plugins.jPushPlugin.setAlias(alias);
		}
	};
	global.USOProject.Business.JPush = $USOProject_Business_JPush;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.JPushPlugin
	var $USOProject_Business_JPushPlugin = function() {
	};
	$USOProject_Business_JPushPlugin.__typeName = 'USOProject.Business.JPushPlugin';
	global.USOProject.Business.JPushPlugin = $USOProject_Business_JPushPlugin;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.LoadedSpecials
	var $USOProject_Business_LoadedSpecials = function() {
	};
	$USOProject_Business_LoadedSpecials.__typeName = 'USOProject.Business.LoadedSpecials';
	$USOProject_Business_LoadedSpecials.createInstance = function() {
		return $USOProject_Business_LoadedSpecials.$ctor();
	};
	$USOProject_Business_LoadedSpecials.$ctor = function() {
		var $this = {};
		$this.SpecialId = 0;
		$this.IsInProcess = false;
		return $this;
	};
	$USOProject_Business_LoadedSpecials.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.LoadedSpecials = $USOProject_Business_LoadedSpecials;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.OrganizationDTO
	var $USOProject_Business_OrganizationDTO = function() {
	};
	$USOProject_Business_OrganizationDTO.__typeName = 'USOProject.Business.OrganizationDTO';
	$USOProject_Business_OrganizationDTO.createInstance = function() {
		return $USOProject_Business_OrganizationDTO.$ctor();
	};
	$USOProject_Business_OrganizationDTO.$ctor = function() {
		var $this = {};
		$this.Id = 0;
		$this.Name = null;
		$this.SortOrder = 0;
		$this.HtmlDescription = null;
		$this.CreatedOn = new Date(0);
		$this.CreatedBy = 0;
		$this.DomainName = null;
		$this.ModifiedOn = new Date(0);
		$this.ModifiedBy = 0;
		$this.OrganizationType = 0;
		$this.NodeId = ss.getDefaultValue(ss.Guid);
		$this.ParentId = 0;
		$this.ParentName = null;
		$this.ParentDomainName = null;
		$this.R3SalesOrg = null;
		$this.R3SalesOffice = null;
		$this.R3SalesGroup = null;
		$this.R3SalesCompany = null;
		$this.ScpOrgId = null;
		$this.ScpOrgName = null;
		$this.StockOrganizationId = null;
		$this.CustomerCode = null;
		$this.SystemProductCompanyId = null;
		$this.BusinessScope = null;
		$this.Status = 0;
		$this.R3FinanceCompanyCode = null;
		$this.R3FinanceCompanyCodeName = null;
		$this.SystemProductCompany = null;
		$this.IsUseRebate = null;
		$this.Children = null;
		$this.AncestorIds = null;
		$this.DescendantIds = null;
		$this.IsCheck = false;
		return $this;
	};
	$USOProject_Business_OrganizationDTO.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.OrganizationDTO = $USOProject_Business_OrganizationDTO;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.OrganizationList
	var $USOProject_Business_OrganizationList = function() {
	};
	$USOProject_Business_OrganizationList.__typeName = 'USOProject.Business.OrganizationList';
	$USOProject_Business_OrganizationList.createInstance = function() {
		return $USOProject_Business_OrganizationList.$ctor();
	};
	$USOProject_Business_OrganizationList.$ctor = function() {
		var $this = {};
		$this.Id = 0;
		$this.Name = null;
		$this.Description = null;
		$this.DomainName = null;
		$this.SortOrder = 0;
		$this.OrganizationType = 0;
		$this.NodeId = null;
		$this.CreatedOn = null;
		$this.CreatedBy = 0;
		$this.ModifiedOn = null;
		$this.ModifiedBy = 0;
		$this.Status = 0;
		$this.Children = null;
		$this.Ancestors = null;
		$this.Descendants = null;
		$this.ParentId = null;
		$this.R3SalesCompany = null;
		$this.StockOrganizationId = null;
		$this.CustomerCode = null;
		$this.SystemProductCompanyId = null;
		$this.ScpOrgId = null;
		$this.ScpOrgName = null;
		$this.BusinessScope = null;
		$this.R3FinanceCompanyCode = null;
		$this.R3FinanceCompanyCodeName = null;
		$this.R3SalesOrg = null;
		$this.R3SalesOffice = null;
		$this.R3SalesGroup = null;
		return $this;
	};
	$USOProject_Business_OrganizationList.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.OrganizationList = $USOProject_Business_OrganizationList;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.OrganizationStatus
	var $USOProject_Business_OrganizationStatus = function() {
	};
	$USOProject_Business_OrganizationStatus.__typeName = 'USOProject.Business.OrganizationStatus';
	global.USOProject.Business.OrganizationStatus = $USOProject_Business_OrganizationStatus;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.OrganizationType
	var $USOProject_Business_OrganizationType = function() {
	};
	$USOProject_Business_OrganizationType.__typeName = 'USOProject.Business.OrganizationType';
	global.USOProject.Business.OrganizationType = $USOProject_Business_OrganizationType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.PageCombineService
	var $USOProject_Business_PageCombineService$1 = function(T) {
		var $type = function(pageSerivces) {
			this.PrepareDataFuncs = null;
			this.$data = [];
			this.PrepareDataFuncs = pageSerivces;
		};
		ss.registerGenericClassInstance($type, $USOProject_Business_PageCombineService$1, [T], {
			GetPageData: function(pageIndex, pageSize) {
				var tsk = new ss.TaskCompletionSource();
				window.setTimeout(ss.mkdel(this, function() {
					var $state = 0, takeData, existDataPageServices, $t1, item, $t2, result;
					var $sm = ss.mkdel(this, function() {
						var $doFinally = true;
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									if (!true) {
										$state = -1;
										break $sm1;
									}
									takeData = Enumerable.from(this.$data).skip((pageIndex - JSLib.Mobile.Application.get_PageIndexStart()) * pageSize).take(pageSize);
									if (takeData.count() === pageSize || Enumerable.from(this.PrepareDataFuncs).all(function(n) {
										return n.IsComplete;
									})) {
										tsk.setResult(takeData.toArray());
										$state = -1;
										break $sm1;
									}
									else {
										existDataPageServices = Enumerable.from(this.PrepareDataFuncs).where(function(n1) {
											return !n1.IsComplete;
										});
										$t1 = existDataPageServices.getEnumerator();
										$state = 1;
										continue $sm1;
									}
								}
								case 1:
								case 2:
								case 3: {
									if ($state === 1) {
										$state = 2;
									}
									try {
										$sm2:
										for (;;) {
											switch ($state) {
												case 2: {
													$state = -1;
													if (!$t1.moveNext()) {
														$state = -1;
														break $sm2;
													}
													item = $t1.current();
													$t2 = item.FetechNext();
													$state = 3;
													$t2.continueWith($sm);
													$doFinally = false;
													return;
												}
												case 3: {
													$state = -1;
													result = $t2.getAwaitedResult();
													if (ss.isValue(result)) {
														ss.arrayAddRange(this.$data, result);
													}
													$state = 2;
													continue $sm2;
												}
												default: {
													break $sm2;
												}
											}
										}
									}
									finally {
										if ($doFinally) {
											$t1.dispose();
										}
									}
									$state = 0;
									continue $sm1;
								}
								default: {
									break $sm1;
								}
							}
						}
					});
					$sm();
				}), 0);
				return tsk.task;
			},
			Reset: function() {
				this.$data = [];
				this.PrepareDataFuncs.forEach(function(service) {
					service.Reset();
				});
			}
		}, function() {
			return null;
		}, function() {
			return [];
		});
		return $type;
	};
	$USOProject_Business_PageCombineService$1.__typeName = 'USOProject.Business.PageCombineService$1';
	ss.initGenericClass($USOProject_Business_PageCombineService$1, $asm, 1);
	global.USOProject.Business.PageCombineService$1 = $USOProject_Business_PageCombineService$1;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.ProjectFileStatus
	var $USOProject_Business_ProjectFileStatus = function() {
	};
	$USOProject_Business_ProjectFileStatus.__typeName = 'USOProject.Business.ProjectFileStatus';
	global.USOProject.Business.ProjectFileStatus = $USOProject_Business_ProjectFileStatus;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.R3CustomerStoreDTO
	var $USOProject_Business_R3CustomerStoreDTO = function() {
	};
	$USOProject_Business_R3CustomerStoreDTO.__typeName = 'USOProject.Business.R3CustomerStoreDTO';
	$USOProject_Business_R3CustomerStoreDTO.createInstance = function() {
		return $USOProject_Business_R3CustomerStoreDTO.$ctor();
	};
	$USOProject_Business_R3CustomerStoreDTO.ToLogString = function($this) {
		return ss.formatString('门店ID:{0},组织机构Id:{1},R3门店客户代码:{2},法人集团关系ID:{3},法人名称:{4},法人ID:{5}, 年销售额:{6},区域:{7}, 是否免费样机:{8},合作开始时间:{9}, 合作结束时间:{10},创建者Id:{11},创建时间:{12},修改者ID:{13},修改者名称:{14},修改时间:{15}', $this.CustomerStoreId, $this.OrganizationId, $this.R3CustomerCode, $this.R3CustomerLegalId, $this.CustomerLegalName, $this.CustomerLegalId, $this.YearSellingAmount, $this.Area, $this.IsFreeSampleId, $this.StartTime, $this.EndTime, $this.CreatedById, $this.CreatedOn, $this.ModifiedById, $this.ModifiedByName, $this.ModifiedOn);
	};
	$USOProject_Business_R3CustomerStoreDTO.$ctor = function() {
		var $this = {};
		$this.Name = null;
		$this.CustomerStoreId = 0;
		$this.StoreName = null;
		$this.OrganizationId = 0;
		$this.OrganizationName = null;
		$this.R3CustomerCode = null;
		$this.R3CustomerLegalId = 0;
		$this.CustomerLegalName = null;
		$this.CustomerLegalId = 0;
		$this.YearSellingAmount = 0;
		$this.Area = 0;
		$this.IsFreeSampleId = null;
		$this.IsFreeSample = null;
		$this.StartTime = null;
		$this.EndTime = null;
		$this.CreatedById = 0;
		$this.CreatedByName = null;
		$this.CreatedOn = null;
		$this.ModifiedById = 0;
		$this.ModifiedByName = null;
		$this.ModifiedOn = null;
		return $this;
	};
	$USOProject_Business_R3CustomerStoreDTO.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.R3CustomerStoreDTO = $USOProject_Business_R3CustomerStoreDTO;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.R3DistributionStatus
	var $USOProject_Business_R3DistributionStatus = function() {
	};
	$USOProject_Business_R3DistributionStatus.__typeName = 'USOProject.Business.R3DistributionStatus';
	global.USOProject.Business.R3DistributionStatus = $USOProject_Business_R3DistributionStatus;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.RegularExpressionAttribute
	var $USOProject_Business_RegularExpressionAttribute = function(regex) {
		this.ErrorMessage = null;
	};
	$USOProject_Business_RegularExpressionAttribute.__typeName = 'USOProject.Business.RegularExpressionAttribute';
	global.USOProject.Business.RegularExpressionAttribute = $USOProject_Business_RegularExpressionAttribute;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.RequiredAttribute
	var $USOProject_Business_RequiredAttribute = function() {
		this.ErrorMessage = null;
	};
	$USOProject_Business_RequiredAttribute.__typeName = 'USOProject.Business.RequiredAttribute';
	global.USOProject.Business.RequiredAttribute = $USOProject_Business_RequiredAttribute;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.RetailInputStatRoleType
	var $USOProject_Business_RetailInputStatRoleType = function() {
	};
	$USOProject_Business_RetailInputStatRoleType.__typeName = 'USOProject.Business.RetailInputStatRoleType';
	global.USOProject.Business.RetailInputStatRoleType = $USOProject_Business_RetailInputStatRoleType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.RetailStatisticsExtension
	var $USOProject_Business_RetailStatisticsExtension = function() {
	};
	$USOProject_Business_RetailStatisticsExtension.__typeName = 'USOProject.Business.RetailStatisticsExtension';
	$USOProject_Business_RetailStatisticsExtension.GetTotalQuantity = function(target) {
		if (ss.isNullOrUndefined(target)) {
			return 0;
		}
		return Enumerable.from(target).sum(function(n) {
			return ss.coalesce(n.Quantity, 0);
		});
	};
	$USOProject_Business_RetailStatisticsExtension.GetTotalAmount = function(target) {
		if (ss.isNullOrUndefined(target)) {
			return 0;
		}
		return Enumerable.from(target).sum(function(n) {
			return n.Amount;
		});
	};
	$USOProject_Business_RetailStatisticsExtension.GetTotalAvg = function(target) {
		if (ss.isNullOrUndefined(target)) {
			return 0;
		}
		var totalQuantity = $USOProject_Business_RetailStatisticsExtension.GetTotalQuantity(target);
		if (totalQuantity === 0) {
			return 0;
		}
		else {
			return $USOProject_Business_RetailStatisticsExtension.GetTotalAmount(target) / totalQuantity;
		}
	};
	$USOProject_Business_RetailStatisticsExtension.ToMoney = function(target) {
		if (target > 10000) {
			return (target / 10000).toFixed(1) + '万';
		}
		else {
			return target.toFixed();
		}
	};
	$USOProject_Business_RetailStatisticsExtension.GetAmountRatioIn = function(target, totalAmount) {
		var data = ((totalAmount <= 0) ? 0 : (target.Amount * 100 / totalAmount));
		return data.toFixed(1) + '%';
	};
	$USOProject_Business_RetailStatisticsExtension.GetQuantityRatioIn = function(target, totalQuantity) {
		var data = ((totalQuantity <= 0) ? 0 : (ss.coalesce(target.Quantity, 0) * 100 / totalQuantity));
		return data.toFixed(1) + '%';
	};
	global.USOProject.Business.RetailStatisticsExtension = $USOProject_Business_RetailStatisticsExtension;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SelectListItem
	var $USOProject_Business_SelectListItem = function() {
	};
	$USOProject_Business_SelectListItem.__typeName = 'USOProject.Business.SelectListItem';
	$USOProject_Business_SelectListItem.createInstance = function() {
		return $USOProject_Business_SelectListItem.$ctor();
	};
	$USOProject_Business_SelectListItem.$ctor = function() {
		var $this = {};
		$this.Selected = false;
		$this.Text = null;
		$this.Value = null;
		return $this;
	};
	$USOProject_Business_SelectListItem.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.SelectListItem = $USOProject_Business_SelectListItem;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SinglePageService
	var $USOProject_Business_SinglePageService$1 = function(T) {
		var $type = function() {
			this.IsComplete = false;
			this.CurrentPageIndex = JSLib.Mobile.Application.get_PageIndexStart();
			this.PageSize = 20;
			this.$1$GetSinglePageDataField = null;
		};
		ss.registerGenericClassInstance($type, $USOProject_Business_SinglePageService$1, [T], {
			get_GetSinglePageData: function() {
				return this.$1$GetSinglePageDataField;
			},
			set_GetSinglePageData: function(value) {
				this.$1$GetSinglePageDataField = value;
			},
			FetechNext: function() {
				var $state = 0, $tcs = new ss.TaskCompletionSource(), $t1, result;
				var $sm = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									$t1 = this.get_GetSinglePageData()(this.CurrentPageIndex++);
									$state = 1;
									$t1.continueWith($sm);
									return;
								}
								case 1: {
									$state = -1;
									result = $t1.getAwaitedResult();
									if (ss.isNullOrUndefined(result) || result.length < this.PageSize) {
										this.IsComplete = true;
									}
									$tcs.setResult(result);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t2) {
						$tcs.setException(ss.Exception.wrap($t2));
					}
				});
				$sm();
				return $tcs.task;
			},
			Reset: function() {
				this.IsComplete = false;
				this.CurrentPageIndex = JSLib.Mobile.Application.get_PageIndexStart();
			}
		}, function() {
			return null;
		}, function() {
			return [];
		});
		return $type;
	};
	$USOProject_Business_SinglePageService$1.__typeName = 'USOProject.Business.SinglePageService$1';
	ss.initGenericClass($USOProject_Business_SinglePageService$1, $asm, 1);
	global.USOProject.Business.SinglePageService$1 = $USOProject_Business_SinglePageService$1;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SlideDirectionDetect
	var $USOProject_Business_SlideDirectionDetect = function() {
		this.$startX = 0;
		this.$startY = 0;
		this.IsInHorizontal = false;
		this.OnScrollHorizontal = null;
	};
	$USOProject_Business_SlideDirectionDetect.__typeName = 'USOProject.Business.SlideDirectionDetect';
	global.USOProject.Business.SlideDirectionDetect = $USOProject_Business_SlideDirectionDetect;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SlideList
	var $USOProject_Business_SlideList = function(container, listItemSelector, itemContentSelector, slideActionSelector) {
		this.$container = null;
		this.$listItemSelector = null;
		this.$slideActionSelector = null;
		this.itemContentSelector = null;
		this.$curListItem = null;
		this.$lastExpandListitem = null;
		this.$startX = 0;
		this.$curX = 0;
		this.$endX = 0;
		this.$slidMaxWidth = 0;
		this.$_detector = null;
		this.$container = container;
		this.$listItemSelector = listItemSelector;
		this.$slideActionSelector = slideActionSelector;
		this.itemContentSelector = itemContentSelector;
		this.$BindEvent();
	};
	$USOProject_Business_SlideList.__typeName = 'USOProject.Business.SlideList';
	global.USOProject.Business.SlideList = $USOProject_Business_SlideList;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SlideList.CurListItem
	var $USOProject_Business_SlideList$CurListItem = function(target, curItemContentSelector, slideActionSelector) {
		this.$curListItemDom = null;
		this.$curItemContentDom = null;
		this.MaxSlideWidth = 0;
		this.$curListItemDom = target;
		this.$curItemContentDom = target.find(curItemContentSelector);
		this.MaxSlideWidth = target.find(slideActionSelector).width();
	};
	$USOProject_Business_SlideList$CurListItem.__typeName = 'USOProject.Business.SlideList$CurListItem';
	global.USOProject.Business.SlideList$CurListItem = $USOProject_Business_SlideList$CurListItem;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SpecialAuditActionViewModel
	var $USOProject_Business_SpecialAuditActionViewModel = function() {
	};
	$USOProject_Business_SpecialAuditActionViewModel.__typeName = 'USOProject.Business.SpecialAuditActionViewModel';
	$USOProject_Business_SpecialAuditActionViewModel.createInstance = function() {
		return $USOProject_Business_SpecialAuditActionViewModel.$ctor();
	};
	$USOProject_Business_SpecialAuditActionViewModel.$ctor = function() {
		var $this = {};
		$this.ApportionOrgId = 0;
		$this.NextUserId = 0;
		$this.SpecialId = 0;
		$this.Status = 0;
		$this.Note = null;
		$this.ProductTypeId = 0;
		$this.IsFirst = 0;
		$this.IsLast = 0;
		$this.NextUsers = null;
		$this.ActionStatus = null;
		$this.ApportionOrg = null;
		$this.ProductType = null;
		$this.SpecialName = null;
		$this.SpecialNum = null;
		$this.CreateName = null;
		$this.SpecialItems = null;
		return $this;
	};
	$USOProject_Business_SpecialAuditActionViewModel.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.SpecialAuditActionViewModel = $USOProject_Business_SpecialAuditActionViewModel;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SpecialAuditItemViewModel
	var $USOProject_Business_SpecialAuditItemViewModel = function() {
	};
	$USOProject_Business_SpecialAuditItemViewModel.__typeName = 'USOProject.Business.SpecialAuditItemViewModel';
	$USOProject_Business_SpecialAuditItemViewModel.createInstance = function() {
		return $USOProject_Business_SpecialAuditItemViewModel.$ctor();
	};
	$USOProject_Business_SpecialAuditItemViewModel.$ctor = function() {
		var $this = {};
		$this.ProductId = null;
		$this.ProductBirefName = null;
		$this.ApplyNum = null;
		$this.ApplyPrice = null;
		$this.AgreeNum = null;
		$this.AgreePrice = null;
		$this.Note = null;
		$this.NowPrice = null;
		$this.AuditNum = null;
		$this.AuditPrice = null;
		$this.SpecialNum = null;
		$this.OrganizationId = null;
		$this.CustomerId = null;
		$this.SpecialId = 0;
		$this.ItemId = 0;
		$this.UsedNum = null;
		$this.Status = 0;
		$this.ProductR3Code = null;
		$this.ProductMode = null;
		$this.HaveRoyalties = null;
		$this.HaveGrossProfit = null;
		$this.AuditStatus = 0;
		$this.ApplyCorePrice = null;
		$this.AuditCorePrice = null;
		$this.DiscountAmt = null;
		$this.CostPrice = null;
		$this.InternalAccountPrice = null;
		$this.RedLinPriceOfSubCompay = null;
		$this.RedLinePriceOfBizDepartment = null;
		$this.MinContractPrice = 0;
		$this.CustomerPrice = null;
		$this.AgreeCorePrice = null;
		return $this;
	};
	$USOProject_Business_SpecialAuditItemViewModel.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.SpecialAuditItemViewModel = $USOProject_Business_SpecialAuditItemViewModel;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SpecialAuditResult
	var $USOProject_Business_SpecialAuditResult = function() {
	};
	$USOProject_Business_SpecialAuditResult.__typeName = 'USOProject.Business.SpecialAuditResult';
	global.USOProject.Business.SpecialAuditResult = $USOProject_Business_SpecialAuditResult;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SpecialAuditViewModel
	var $USOProject_Business_SpecialAuditViewModel = function() {
	};
	$USOProject_Business_SpecialAuditViewModel.__typeName = 'USOProject.Business.SpecialAuditViewModel';
	$USOProject_Business_SpecialAuditViewModel.createInstance = function() {
		return $USOProject_Business_SpecialAuditViewModel.$ctor();
	};
	$USOProject_Business_SpecialAuditViewModel.$ctor = function() {
		var $this = {};
		$this.SpecialId = 0;
		$this.Items = null;
		$this.SpecialTypeId = 0;
		$this.ApportionOrgId = 0;
		$this.SpecialTypeName = null;
		$this.SpecialNum = null;
		$this.SpecialName = null;
		$this.ProjectFileId = null;
		$this.OrganizationId = null;
		$this.OrganizationName = null;
		$this.CustomerId = null;
		$this.CustomerName = null;
		$this.VaildTimeFormTime = null;
		$this.VaildTimeForm = null;
		$this.VaildTimeFormmart = null;
		$this.VaildTimeToTime = null;
		$this.VaildTimeTo = null;
		$this.VaildTimeToFormart = null;
		$this.CreateOnTime = null;
		$this.CreateOn = null;
		$this.CreateOnFormart = null;
		$this.Memo = null;
		$this.WorkStatus = 0;
		$this.Status = null;
		$this.StatusString = null;
		$this.CreateName = null;
		$this.AduitAction = null;
		$this.SaleChannelName = null;
		$this.ApportionOrgName = null;
		$this.WorkFlowSteps = null;
		$this.WorkFlowAllStep = null;
		$this.OrderId = null;
		$this.IsAllowModifyPrice = false;
		$this.Items = [];
		return $this;
	};
	$USOProject_Business_SpecialAuditViewModel.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.SpecialAuditViewModel = $USOProject_Business_SpecialAuditViewModel;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SpecialListDto
	var $USOProject_Business_SpecialListDto = function() {
	};
	$USOProject_Business_SpecialListDto.__typeName = 'USOProject.Business.SpecialListDto';
	$USOProject_Business_SpecialListDto.createInstance = function() {
		return $USOProject_Business_SpecialListDto.$ctor();
	};
	$USOProject_Business_SpecialListDto.$ctor = function() {
		var $this = {};
		$this.Id = 0;
		$this.SpecialNum = null;
		$this.SpecialStatusString = null;
		$this.CustomerName = null;
		$this.SpecialName = null;
		$this.SpecialTypeString = null;
		$this.SpecialType = 0;
		$this.SpecialStatus = 0;
		$this.LastStepId = 0;
		$this.CreateOn = new Date(0);
		return $this;
	};
	$USOProject_Business_SpecialListDto.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.SpecialListDto = $USOProject_Business_SpecialListDto;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SpecialType
	var $USOProject_Business_SpecialType = function() {
	};
	$USOProject_Business_SpecialType.__typeName = 'USOProject.Business.SpecialType';
	global.USOProject.Business.SpecialType = $USOProject_Business_SpecialType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SpecialWorkFlowStatus
	var $USOProject_Business_SpecialWorkFlowStatus = function() {
	};
	$USOProject_Business_SpecialWorkFlowStatus.__typeName = 'USOProject.Business.SpecialWorkFlowStatus';
	global.USOProject.Business.SpecialWorkFlowStatus = $USOProject_Business_SpecialWorkFlowStatus;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SpecQueryCondtion
	var $USOProject_Business_SpecQueryCondtion = function() {
	};
	$USOProject_Business_SpecQueryCondtion.__typeName = 'USOProject.Business.SpecQueryCondtion';
	$USOProject_Business_SpecQueryCondtion.createInstance = function() {
		return $USOProject_Business_SpecQueryCondtion.$ctor();
	};
	$USOProject_Business_SpecQueryCondtion.$ctor = function() {
		var $this = {};
		$this.SpecialNum = null;
		$this.SpecialName = null;
		$this.CustomerId = null;
		$this.ProductID = null;
		$this.CustomerWorkFlowlRangeStatus = 0;
		$this.SpecialType = null;
		$this.Page = 0;
		$this.PageSize = 0;
		$this.FromDate = null;
		$this.ToDate = null;
		$this.SpecialStatus = 0;
		$this.CustomerName = null;
		return $this;
	};
	$USOProject_Business_SpecQueryCondtion.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.SpecQueryCondtion = $USOProject_Business_SpecQueryCondtion;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.SystemProductCompanyDTO
	var $USOProject_Business_SystemProductCompanyDTO = function() {
	};
	$USOProject_Business_SystemProductCompanyDTO.__typeName = 'USOProject.Business.SystemProductCompanyDTO';
	$USOProject_Business_SystemProductCompanyDTO.createInstance = function() {
		return $USOProject_Business_SystemProductCompanyDTO.$ctor();
	};
	$USOProject_Business_SystemProductCompanyDTO.$ctor = function() {
		var $this = {};
		$this.Id = 0;
		$this.Name = null;
		return $this;
	};
	$USOProject_Business_SystemProductCompanyDTO.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.SystemProductCompanyDTO = $USOProject_Business_SystemProductCompanyDTO;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.ToDoWorkDto
	var $USOProject_Business_ToDoWorkDto = function() {
	};
	$USOProject_Business_ToDoWorkDto.__typeName = 'USOProject.Business.ToDoWorkDto';
	$USOProject_Business_ToDoWorkDto.createInstance = function() {
		return $USOProject_Business_ToDoWorkDto.$ctor();
	};
	$USOProject_Business_ToDoWorkDto.$ctor = function() {
		var $this = {};
		$this.TaskName = null;
		$this.TaskType = null;
		$this.TaskId = null;
		$this.TaskInfo = null;
		$this.TaskCreateTime = null;
		$this.LastStepID = null;
		$this.TotalCount = 0;
		$this.DetailPageType = null;
		$this.StockOrganizationName = null;
		return $this;
	};
	$USOProject_Business_ToDoWorkDto.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.ToDoWorkDto = $USOProject_Business_ToDoWorkDto;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.TodoWorkDtoModel
	var $USOProject_Business_TodoWorkDtoModel = function() {
	};
	$USOProject_Business_TodoWorkDtoModel.__typeName = 'USOProject.Business.TodoWorkDtoModel';
	$USOProject_Business_TodoWorkDtoModel.createInstance = function() {
		return $USOProject_Business_TodoWorkDtoModel.$ctor();
	};
	$USOProject_Business_TodoWorkDtoModel.$ctor = function() {
		var $this = {};
		$this.TotalCount = 0;
		$this.WorkList = null;
		$this.LoadedSpecials = null;
		return $this;
	};
	$USOProject_Business_TodoWorkDtoModel.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.TodoWorkDtoModel = $USOProject_Business_TodoWorkDtoModel;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.UnZipPlugin
	var $USOProject_Business_UnZipPlugin = function() {
	};
	$USOProject_Business_UnZipPlugin.__typeName = 'USOProject.Business.UnZipPlugin';
	$USOProject_Business_UnZipPlugin.UnZipFile = function(filePath, targetDir, onProgress) {
		var tsk = new ss.TaskCompletionSource();
		var $t2 = function(o) {
			var target = o;
			if (ss.isValue(target) && ss.isValue(target.loaded)) {
				if (!ss.staticEquals(onProgress, null)) {
					onProgress(new ProgressEvent('UnZip', { lengthComputable: false, loaded: target.loaded, total: target.total }));
				}
			}
			else {
				tsk.setResult(true);
			}
		};
		var $t3 = function(o1) {
			tsk.setResult(false);
		};
		var $t1 = [];
		$t1.push(filePath);
		$t1.push(targetDir);
		cordova.exec($t2, $t3, 'Zip', 'unzip', $t1);
		return tsk.task;
	};
	global.USOProject.Business.UnZipPlugin = $USOProject_Business_UnZipPlugin;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.UpgradeInfo
	var $USOProject_Business_UpgradeInfo = function() {
	};
	$USOProject_Business_UpgradeInfo.__typeName = 'USOProject.Business.UpgradeInfo';
	$USOProject_Business_UpgradeInfo.createInstance = function() {
		return $USOProject_Business_UpgradeInfo.$ctor();
	};
	$USOProject_Business_UpgradeInfo.$ctor = function() {
		var $this = {};
		$this.weekAppVersion = null;
		$this.weekAppUrl = null;
		$this.weekAppUrl_IOS = null;
		$this.strongAppUrl = null;
		$this.strongAppUrl_IOS = null;
		$this.strongAppVersion = null;
		$this.upgradeTip = null;
		return $this;
	};
	$USOProject_Business_UpgradeInfo.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.UpgradeInfo = $USOProject_Business_UpgradeInfo;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.UserData
	var $USOProject_Business_UserData = function() {
	};
	$USOProject_Business_UserData.__typeName = 'USOProject.Business.UserData';
	$USOProject_Business_UserData.createInstance = function() {
		return $USOProject_Business_UserData.$ctor();
	};
	$USOProject_Business_UserData.$ctor = function() {
		var $this = {};
		$this.User = null;
		$this.StockOrganizationList = null;
		$this.Config = null;
		$this.UserMinOrgType = 0;
		return $this;
	};
	$USOProject_Business_UserData.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.UserData = $USOProject_Business_UserData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.UserInfo
	var $USOProject_Business_UserInfo = function() {
	};
	$USOProject_Business_UserInfo.__typeName = 'USOProject.Business.UserInfo';
	$USOProject_Business_UserInfo.createInstance = function() {
		return $USOProject_Business_UserInfo.$ctor();
	};
	$USOProject_Business_UserInfo.$ctor = function() {
		var $this = {};
		$this.Id = 0;
		$this.EmployeeNumber = null;
		$this.IdentityNumber = null;
		$this.Name = null;
		$this.Email = null;
		$this.CreatedOn = null;
		$this.CreatedBy = 0;
		$this.ModifiedOn = null;
		$this.ModifiedBy = 0;
		$this.ValidFrom = null;
		$this.IsValid = false;
		$this.Status = 0;
		$this.CurrentStockOrganizationId = 0;
		$this.Roles = null;
		$this.Positions = null;
		$this.OrgIds = null;
		return $this;
	};
	$USOProject_Business_UserInfo.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.UserInfo = $USOProject_Business_UserInfo;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.WorkFlowActionProcessType
	var $USOProject_Business_WorkFlowActionProcessType = function() {
	};
	$USOProject_Business_WorkFlowActionProcessType.__typeName = 'USOProject.Business.WorkFlowActionProcessType';
	global.USOProject.Business.WorkFlowActionProcessType = $USOProject_Business_WorkFlowActionProcessType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.WorkFlowProcTrackDTO
	var $USOProject_Business_WorkFlowProcTrackDTO = function() {
	};
	$USOProject_Business_WorkFlowProcTrackDTO.__typeName = 'USOProject.Business.WorkFlowProcTrackDTO';
	$USOProject_Business_WorkFlowProcTrackDTO.createInstance = function() {
		return $USOProject_Business_WorkFlowProcTrackDTO.$ctor();
	};
	$USOProject_Business_WorkFlowProcTrackDTO.$ctor = function() {
		var $this = {};
		$this.WorkFlowSteps = null;
		$this.WorkFlowAllStep = null;
		return $this;
	};
	$USOProject_Business_WorkFlowProcTrackDTO.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.WorkFlowProcTrackDTO = $USOProject_Business_WorkFlowProcTrackDTO;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.WorkFlowStep
	var $USOProject_Business_WorkFlowStep = function() {
	};
	$USOProject_Business_WorkFlowStep.__typeName = 'USOProject.Business.WorkFlowStep';
	$USOProject_Business_WorkFlowStep.createInstance = function() {
		return $USOProject_Business_WorkFlowStep.$ctor();
	};
	$USOProject_Business_WorkFlowStep.$ctor = function() {
		var $this = {};
		$this.StepNo = 0;
		$this.StepName = null;
		$this.StepStatus = null;
		$this.ProPersonId = 0;
		$this.ProPersonName = null;
		$this.ProcessedOn = null;
		$this.Note = null;
		$this.TimeSpanStep = null;
		$this.ThisPersonId = 0;
		$this.ThisPersonName = null;
		$this.ProcessType = null;
		$this.ProcessTypeString = null;
		return $this;
	};
	$USOProject_Business_WorkFlowStep.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.WorkFlowStep = $USOProject_Business_WorkFlowStep;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.Model.ImageInfo
	var $USOProject_Business_Model_ImageInfo = function() {
		this.id = null;
		this.index = 0;
		this.type = 0;
	};
	$USOProject_Business_Model_ImageInfo.__typeName = 'USOProject.Business.Model.ImageInfo';
	global.USOProject.Business.Model.ImageInfo = $USOProject_Business_Model_ImageInfo;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.Model.ImageInfoType
	var $USOProject_Business_Model_ImageInfoType = function() {
	};
	$USOProject_Business_Model_ImageInfoType.__typeName = 'USOProject.Business.Model.ImageInfoType';
	global.USOProject.Business.Model.ImageInfoType = $USOProject_Business_Model_ImageInfoType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.Retail.CustomerSalesStatus
	var $USOProject_Business_Retail_CustomerSalesStatus = function() {
	};
	$USOProject_Business_Retail_CustomerSalesStatus.__typeName = 'USOProject.Business.Retail.CustomerSalesStatus';
	global.USOProject.Business.Retail.CustomerSalesStatus = $USOProject_Business_Retail_CustomerSalesStatus;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.Retail.CustomerSaleType
	var $USOProject_Business_Retail_CustomerSaleType = function() {
	};
	$USOProject_Business_Retail_CustomerSaleType.__typeName = 'USOProject.Business.Retail.CustomerSaleType';
	global.USOProject.Business.Retail.CustomerSaleType = $USOProject_Business_Retail_CustomerSaleType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.Retail.ProductBomVaild
	var $USOProject_Business_Retail_ProductBomVaild = function() {
	};
	$USOProject_Business_Retail_ProductBomVaild.__typeName = 'USOProject.Business.Retail.ProductBomVaild';
	global.USOProject.Business.Retail.ProductBomVaild = $USOProject_Business_Retail_ProductBomVaild;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.Retail.RetailInputSimpleQuery
	var $USOProject_Business_Retail_RetailInputSimpleQuery = function() {
	};
	$USOProject_Business_Retail_RetailInputSimpleQuery.__typeName = 'USOProject.Business.Retail.RetailInputSimpleQuery';
	$USOProject_Business_Retail_RetailInputSimpleQuery.createInstance = function() {
		return $USOProject_Business_Retail_RetailInputSimpleQuery.$ctor();
	};
	$USOProject_Business_Retail_RetailInputSimpleQuery.$ctor = function() {
		var $this = {};
		$this.isYear = false;
		$this.fromDate = null;
		$this.toDate = null;
		$this.satGroupId = -1;
		return $this;
	};
	$USOProject_Business_Retail_RetailInputSimpleQuery.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.Retail.RetailInputSimpleQuery = $USOProject_Business_Retail_RetailInputSimpleQuery;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.Retail.RetailInputStatisticQuery
	var $USOProject_Business_Retail_RetailInputStatisticQuery = function() {
	};
	$USOProject_Business_Retail_RetailInputStatisticQuery.__typeName = 'USOProject.Business.Retail.RetailInputStatisticQuery';
	$USOProject_Business_Retail_RetailInputStatisticQuery.createInstance = function() {
		return $USOProject_Business_Retail_RetailInputStatisticQuery.$ctor();
	};
	$USOProject_Business_Retail_RetailInputStatisticQuery.$ctor = function() {
		var $this = {};
		$this.Page = 0;
		$this.PageSize = 0;
		$this.FromDate = null;
		$this.ToDate = null;
		$this.CustomerStoreId = null;
		$this.CustomerLegalId = null;
		$this.satGroupId = -1;
		$this.CurrentUserId = 0;
		$this.PageSize = 6;
		$this.Page = 1;
		return $this;
	};
	$USOProject_Business_Retail_RetailInputStatisticQuery.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Business.Retail.RetailInputStatisticQuery = $USOProject_Business_Retail_RetailInputStatisticQuery;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.ToCompletion.PermissionManager
	var $USOProject_Business_ToCompletion_PermissionManager = function() {
	};
	$USOProject_Business_ToCompletion_PermissionManager.__typeName = 'USOProject.Business.ToCompletion.PermissionManager';
	$USOProject_Business_ToCompletion_PermissionManager.GetAvaiableModulePermission = function() {
		var disabledPermissions = $USOProject_Business_ToCompletion_PermissionManager.LoadDisabledPermission();
		var avaiablePermission = $USOProject_Business_ToCompletion_PermissionManager.LocalPermissionDefine.filter(function(module) {
			return ss.contains($App.app.permissions, module.PermissionName) && !ss.contains(disabledPermissions, module.PermissionName);
		});
		return avaiablePermission;
	};
	$USOProject_Business_ToCompletion_PermissionManager.LoadDisabledPermission = function() {
		var result = window.localStorage['disableModule_' + $App.GetUserID()];
		var data = [];
		if (ss.isValue(result)) {
			data = JSON.parse(result);
		}
		return data;
	};
	$USOProject_Business_ToCompletion_PermissionManager.SetLocalPermision = function(permissionName, enable) {
		var disabledPermissions = $USOProject_Business_ToCompletion_PermissionManager.LoadDisabledPermission();
		if (enable) {
			ss.remove(disabledPermissions, permissionName);
		}
		else {
			disabledPermissions.push(permissionName);
		}
		window.localStorage['disableModule_' + $App.GetUserID()] = JSON.stringify(disabledPermissions);
		if (!ss.staticEquals($USOProject_Business_ToCompletion_PermissionManager.$1$OnPermissionChangedField, null)) {
			$USOProject_Business_ToCompletion_PermissionManager.$1$OnPermissionChangedField(null, null);
		}
	};
	$USOProject_Business_ToCompletion_PermissionManager.add_OnPermissionChanged = function(value) {
		$USOProject_Business_ToCompletion_PermissionManager.$1$OnPermissionChangedField = ss.delegateCombine($USOProject_Business_ToCompletion_PermissionManager.$1$OnPermissionChangedField, value);
	};
	$USOProject_Business_ToCompletion_PermissionManager.remove_OnPermissionChanged = function(value) {
		$USOProject_Business_ToCompletion_PermissionManager.$1$OnPermissionChangedField = ss.delegateRemove($USOProject_Business_ToCompletion_PermissionManager.$1$OnPermissionChangedField, value);
	};
	$USOProject_Business_ToCompletion_PermissionManager.Have_ShowSpecialWorkFlowBasic = function() {
		return ss.contains($App.app.permissions, 'ShowSpecialWorkFlowBasic');
	};
	$USOProject_Business_ToCompletion_PermissionManager.Have_ShowApplyCorePriceBasic = function() {
		return ss.contains($App.app.permissions, 'ShowApplyCorePriceBasic');
	};
	$USOProject_Business_ToCompletion_PermissionManager.HavePerssion = function(permission) {
		return ss.contains($App.app.permissions, ss.Enum.toString($USOProject_Business_ToCompletion_PermissionType, permission));
	};
	global.USOProject.Business.ToCompletion.PermissionManager = $USOProject_Business_ToCompletion_PermissionManager;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.ToCompletion.PermissionType
	var $USOProject_Business_ToCompletion_PermissionType = function() {
	};
	$USOProject_Business_ToCompletion_PermissionType.__typeName = 'USOProject.Business.ToCompletion.PermissionType';
	global.USOProject.Business.ToCompletion.PermissionType = $USOProject_Business_ToCompletion_PermissionType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.ToCompletion.PermissionTypeEx
	var $USOProject_Business_ToCompletion_PermissionTypeEx = function() {
	};
	$USOProject_Business_ToCompletion_PermissionTypeEx.__typeName = 'USOProject.Business.ToCompletion.PermissionTypeEx';
	$USOProject_Business_ToCompletion_PermissionTypeEx.ToEnumString = function(enumValue) {
		return ss.Enum.toString($USOProject_Business_ToCompletion_PermissionType, enumValue);
	};
	global.USOProject.Business.ToCompletion.PermissionTypeEx = $USOProject_Business_ToCompletion_PermissionTypeEx;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Business.ToCompletion.PermmissionModule
	var $USOProject_Business_ToCompletion_PermmissionModule = function(moduleName, permissionName, iconUrl, pageType) {
		this.PermissionName = null;
		this.ModuleName = null;
		this.iconUrl = null;
		this.PageType = null;
		this.PermissionName = permissionName;
		this.ModuleName = moduleName;
		this.iconUrl = iconUrl;
		this.PageType = pageType;
	};
	$USOProject_Business_ToCompletion_PermmissionModule.__typeName = 'USOProject.Business.ToCompletion.PermmissionModule';
	global.USOProject.Business.ToCompletion.PermmissionModule = $USOProject_Business_ToCompletion_PermmissionModule;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.HomePage
	var $USOProject_Pages_HomePage = function() {
		this.$_scroller = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.navbar = null;
		this.defaultNav = null;
		this.a_work = null;
		this.nav_work = null;
		this.spanWorksCount = null;
		this.a_appcenter = null;
		this.nav_appcenter = null;
		this.a_pers = null;
		this.nav_pers = null;
		this.a_more = null;
		this.nav_more = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$HomePage_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$HomePage_OnPageShow));
	};
	$USOProject_Pages_HomePage.__typeName = 'USOProject.Pages.HomePage';
	global.USOProject.Pages.HomePage = $USOProject_Pages_HomePage;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.LoginPage
	var $USOProject_Pages_LoginPage = function() {
		this.$showValidationCode = false;
		this.img_title = null;
		this.sanjiaoxing = null;
		this.div_login = null;
		this.divLoginName = null;
		this.loginUserName = null;
		this.divLoginPassword = null;
		this.loginPassword = null;
		this.divLoginValidationCode = null;
		this.loginValidationCode = null;
		this.validationCodeImg = null;
		this.divRemberLogin = null;
		this.cbRemberLogin = null;
		this.btn_log = null;
		this.divLoginContent_Detail = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$LoginPage_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$LoginPage_OnPageShow));
	};
	$USOProject_Pages_LoginPage.__typeName = 'USOProject.Pages.LoginPage';
	$USOProject_Pages_LoginPage.AutoLogin = function() {
		var $state = 0, $tcs = new ss.TaskCompletionSource(), autoLoginResult, savedTokenInfo, $t1, result, $t2;
		var $sm = function() {
			try {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							autoLoginResult = null;
							//执行后台登陆
							savedTokenInfo = $USOProject_SecurityLayerJS.ReadPersistentToken();
							if (ss.isValue(savedTokenInfo)) {
								$t1 = $USOProject_Business_BusinessAction.AutoLogin(savedTokenInfo, null);
								$state = 2;
								$t1.continueWith($sm);
								return;
							}
							$state = 1;
							continue $sm1;
						}
						case 2: {
							$state = -1;
							result = $t1.getAwaitedResult();
							console.info('自动登录结果', result);
							autoLoginResult = result;
							if (!autoLoginResult.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(autoLoginResult.Error);
								$USOProject_SecurityLayerJS.RemovePersistentToken();
								$tcs.setResult(false);
								return;
							}
							else {
								$App.app.userInfo = autoLoginResult.User;
								$App.app.permissions = autoLoginResult.Permissions;
								$App.app.config = autoLoginResult.Config;
								$App.LoginResult = autoLoginResult;
								$App.initCurrentOrgID();
								window.setTimeout(function() {
									$USOProject_Business_JPush.SetAlias('');
									var messageSwitchValue = window.localStorage.getItem('messageSwich');
									if (ss.isValue(messageSwitchValue) && messageSwitchValue === 'on') {
										if (ss.isValue($App.app.userInfo)) {
											$USOProject_Business_JPush.SetAlias('userid_' + $App.app.userInfo.User.Id);
										}
									}
								}, 0);
								$t2 = ss.Task.delay(500);
								$state = 3;
								$t2.continueWith($sm);
								return;
							}
						}
						case 1: {
							$state = -1;
							$tcs.setResult(false);
							return;
						}
						case 3: {
							$state = -1;
							$t2.getAwaitedResult();
							$tcs.setResult(true);
							return;
						}
						default: {
							break $sm1;
						}
					}
				}
			}
			catch ($t3) {
				$tcs.setException(ss.Exception.wrap($t3));
			}
		};
		$sm();
		return $tcs.task;
	};
	global.USOProject.Pages.LoginPage = $USOProject_Pages_LoginPage;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.TokenInitilzer
	var $USOProject_Pages_TokenInitilzer = function() {
	};
	$USOProject_Pages_TokenInitilzer.__typeName = 'USOProject.Pages.TokenInitilzer';
	$USOProject_Pages_TokenInitilzer.TokenInit = function() {
		$USOProject_SecurityChannel.tokenArray = [];
		var tsk = new ss.TaskCompletionSource();
		$USOProject_Pages_TokenInitilzer.Seq = Math.floor(Math.random() * 128 + 1);
		JSLib.Mobile.Application.ShowLoading();
		$.ajax({
			type: 'get',
			url: $App.app.get_ServiceBase() + 'Connect/' + $USOProject_Pages_TokenInitilzer.Seq,
			success: function(data, status1, httpRequest) {
				var $state = 0, result, token, $t1, $t2, secondResult;
				var $sm = function() {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								result = $.parseJSON(data.toString());
								token = result.B;
								$t1 = ss.Task.delay(100);
								$state = 1;
								$t1.continueWith($sm);
								return;
							}
							case 1: {
								$state = -1;
								$t1.getAwaitedResult();
								$t2 = $USOProject_Pages_TokenInitilzer.$SecondRequest(token);
								$state = 2;
								$t2.continueWith($sm);
								return;
							}
							case 2: {
								$state = -1;
								secondResult = $t2.getAwaitedResult();
								if (ss.isValue(secondResult)) {
									tsk.setResult(secondResult);
								}
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				};
				$sm();
			},
			error: function(httpRequest1, status2, error1) {
				tsk.setResult(null);
				JSLib.Mobile.Application.HideLoading();
			},
			complete: function() {
				JSLib.Mobile.Application.HideLoading();
			},
			dataType: 'text',
			timeout: $App.app.defaultAjaxTimeout,
			headers: ss.mkdict(['appVersion', $App.app.AppVersion])
		});
		return tsk.task;
	};
	$USOProject_Pages_TokenInitilzer.$SecondRequest = function(token) {
		var tsk = new ss.TaskCompletionSource();
		$USOProject_Pages_TokenInitilzer.Seq += 2;
		var cipher = new System.Security.Cryptography.RijndaelManaged();
		cipher.GenerateKey();
		cipher.GenerateIV();
		var oldKey = cipher.Key;
		var oldKeyIV = cipher.IV;
		var initKeyInfo = { Key: oldKey, IV: oldKeyIV };
		var array = new System.Byte(48);
		System.Array.Copy(oldKey, 0, array, 0, 32);
		System.Array.Copy(oldKeyIV, 0, array, 32, 16);
		var rsaEncoding = $USOProject_SecurityLayerJS.RsaEncryptByDonetPublic(array);
		var tokenBytes = System.Text.Encoding.UTF8.GetBytes(token);
		var tokenSeqBuilder = new $USOProject_BytesBuilder();
		var tokenSeqArray = tokenSeqBuilder.AddBytes(tokenBytes).AddBytes(System.BitConverter.GetBytes($USOProject_Pages_TokenInitilzer.Seq)).ToArray();
		var builder = new $USOProject_BytesBuilder();
		var md5 = new System.Security.Cryptography.MD5();
		var md5Value = md5.ComputeHash($USOProject_SecurityLayerJS.Encrypt(oldKey, oldKeyIV, tokenSeqArray));
		console.info('md5 value:' + md5Value);
		builder.AddBytes(tokenBytes).AddBytes(md5Value).AddBytes(rsaEncoding);
		var sendArray = builder.ToArray();
		var requestContext = { tokenObj: { nextKey: initKeyInfo.Key, nextIV: initKeyInfo.IV } };
		var base64String = System.Convert.ToBase64String(sendArray);
		JSLib.Mobile.Application.ShowLoading();
		$.ajax({
			cache: false,
			type: 'post',
			url: $App.app.get_ServiceBase() + 'Connect?clientVersion=' + $App.app.AppVersion,
			success: function(base64Result, status, request1) {
				var textResult = base64Result;
				if (ss.isNullOrUndefined(textResult) || textResult.toString() === '0' || textResult.toString() === '') {
					tsk.setResult(null);
					$App.app.error('Connection error!');
					return;
				}
				var btArray = System.Convert.FromBase64String(textResult);
				var decodeArray = $USOProject_SecurityLayerJS.Decrypt(requestContext.tokenObj.nextKey, requestContext.tokenObj.nextIV, btArray);
				var resultReader = new $USOProject_BytesReader(decodeArray);
				var successArray = resultReader.ReadBytes(1);
				if (successArray[0] !== 1) {
					//undo:all those need to relogin?
					//handler.handleException("call error!", requestContext);
					tsk.setResult(null);
					return;
				}
				var tempArray = $USOProject_SecurityChannel.readEncodingTokensCore(resultReader);
				//Console.Info("添加token:", tempArray);
				for (var tI = 0; tI < tempArray.length; tI++) {
					$USOProject_SecurityChannel.tokenArray.push(tempArray[tI]);
				}
				//Console.Info("现有token:", SecurityChannel.tokenArray.Count);
				var serverInfo = $USOProject_SecurityChannel.getServerInfo(resultReader);
				var position = resultReader.GetPosition();
				var infoArray = decodeArray.slice(0, position);
				var calMd5 = (new System.Security.Cryptography.MD5()).ComputeHash(infoArray);
				var returnMD5 = resultReader.ReadBytes(16);
				if (!$USOProject_SecurityChannel.IsEqual(calMd5, returnMD5)) {
					//handler.handleException("Md5 not equal!", requestContext);
					tsk.setResult(null);
					return;
				}
				console.info(serverInfo);
				tsk.setResult(serverInfo);
			},
			error: function(request2, status1, error) {
				tsk.setResult(null);
			},
			complete: function(request, status2) {
				JSLib.Mobile.Application.HideLoading();
			},
			data: ss.mkdict(['', base64String]),
			dataType: 'text',
			timeout: $App.app.defaultAjaxTimeout,
			headers: ss.mkdict(['appVersion', $App.app.AppVersion])
		});
		return tsk.task;
	};
	global.USOProject.Pages.TokenInitilzer = $USOProject_Pages_TokenInitilzer;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.ApplyAuditBasePage
	var $USOProject_Pages_ApplyAudit_ApplyAuditBasePage = function() {
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$ApplyAuditBasePage_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_ApplyAuditBasePage.__typeName = 'USOProject.Pages.ApplyAudit.ApplyAuditBasePage';
	global.USOProject.Pages.ApplyAudit.ApplyAuditBasePage = $USOProject_Pages_ApplyAudit_ApplyAuditBasePage;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.Adjust.AdjustAuditAction
	var $USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction = function() {
		this.AuditData = null;
		this.ApplyId = 0;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.pnlNextUser = null;
		this.selNextStepUser = null;
		this.pnlAuditOptions = null;
		this.chkBack = null;
		this.txtRemark = null;
		this.txtReturnRemark = null;
		this.txtAdjustRemark = null;
		this.btnAudit = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$AdjustAuditAction_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction.__typeName = 'USOProject.Pages.ApplyAudit.Adjust.AdjustAuditAction';
	global.USOProject.Pages.ApplyAudit.Adjust.AdjustAuditAction = $USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.Adjust.AdjustAuditAction.AdjustAuditParam
	var $USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction$AdjustAuditParam = function() {
		this.id = 0;
		this.data = null;
	};
	$USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction$AdjustAuditParam.__typeName = 'USOProject.Pages.ApplyAudit.Adjust.AdjustAuditAction$AdjustAuditParam';
	global.USOProject.Pages.ApplyAudit.Adjust.AdjustAuditAction$AdjustAuditParam = $USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction$AdjustAuditParam;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.Adjust.AdjustDetail
	var $USOProject_Pages_ApplyAudit_Adjust_AdjustDetail = function() {
		this.DataID = 0;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.btnAudit = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$AdjustDetail_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_Adjust_AdjustDetail.__typeName = 'USOProject.Pages.ApplyAudit.Adjust.AdjustDetail';
	global.USOProject.Pages.ApplyAudit.Adjust.AdjustDetail = $USOProject_Pages_ApplyAudit_Adjust_AdjustDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.Adjust.AdjustList
	var $USOProject_Pages_ApplyAudit_Adjust_AdjustList = function() {
		this.$_iscrollList = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.btnQuery = null;
		this.pnlContent = null;
		this.pnlDataList = null;
		$USOProject_Pages_ApplyAudit_ApplyAuditBasePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$AdjustList_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$AdjustList_OnPageShow));
	};
	$USOProject_Pages_ApplyAudit_Adjust_AdjustList.__typeName = 'USOProject.Pages.ApplyAudit.Adjust.AdjustList';
	global.USOProject.Pages.ApplyAudit.Adjust.AdjustList = $USOProject_Pages_ApplyAudit_Adjust_AdjustList;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.Adjust.AdjustProductDetail
	var $USOProject_Pages_ApplyAudit_Adjust_AdjustProductDetail = function() {
		this.ProductData = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$AdjustProductDetail_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_Adjust_AdjustProductDetail.__typeName = 'USOProject.Pages.ApplyAudit.Adjust.AdjustProductDetail';
	global.USOProject.Pages.ApplyAudit.Adjust.AdjustProductDetail = $USOProject_Pages_ApplyAudit_Adjust_AdjustProductDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.Adjust.AdjustQueryPage
	var $USOProject_Pages_ApplyAudit_Adjust_AdjustQueryPage = function() {
		this.QueryData = null;
		this.OnQueryComplete = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.txtId = null;
		this.selOrderType = null;
		this.txtReturnCustomer = null;
		this.txtAdjustCustomer = null;
		this.txtCreator = null;
		this.txtBeginDate = null;
		this.txtEndDate = null;
		this.btnQuery = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$AdjustQueryPage_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_Adjust_AdjustQueryPage.__typeName = 'USOProject.Pages.ApplyAudit.Adjust.AdjustQueryPage';
	global.USOProject.Pages.ApplyAudit.Adjust.AdjustQueryPage = $USOProject_Pages_ApplyAudit_Adjust_AdjustQueryPage;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.Adjust.PictureViewer
	var $USOProject_Pages_ApplyAudit_Adjust_PictureViewer = function() {
		this.files = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.pnlCarousel = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$PictureViewer_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_Adjust_PictureViewer.__typeName = 'USOProject.Pages.ApplyAudit.Adjust.PictureViewer';
	global.USOProject.Pages.ApplyAudit.Adjust.PictureViewer = $USOProject_Pages_ApplyAudit_Adjust_PictureViewer;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderAuditAction
	var $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderAuditAction = function() {
		this.$MasterId = 0;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.pnlAuditOptions = null;
		this.chkBack = null;
		this.pnlBackReason = null;
		this.txtRemark = null;
		this.btnAudit = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$AdjustAuditAction_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderAuditAction.__typeName = 'USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderAuditAction';
	global.USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderAuditAction = $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderAuditAction;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderDetail
	var $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderDetail = function() {
		this.Data = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.btnAudit = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$EngineerOrderDetail_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderDetail.__typeName = 'USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderDetail';
	global.USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderDetail = $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderDetailData
	var $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderDetailData = function() {
		this.Id = 0;
		this.IsToAudit = false;
		this.StockOrganizationName = null;
	};
	$USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderDetailData.__typeName = 'USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderDetailData';
	global.USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderDetailData = $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderDetailData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderList
	var $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderList = function() {
		this.$_iscrollList = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.btnQuery = null;
		this.pnlContent = null;
		this.pnlDataList = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$EngineerOrderList_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$EngineerOrderList_OnPageShow));
	};
	$USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderList.__typeName = 'USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderList';
	global.USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderList = $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderList;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderProductDetail
	var $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderProductDetail = function() {
		this.ProductData = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$EngineerOrderProductDetail_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderProductDetail.__typeName = 'USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderProductDetail';
	global.USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderProductDetail = $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderProductDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderQueryPage
	var $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderQueryPage = function() {
		this.QueryData = null;
		this.OnQueryComplete = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.txtId = null;
		this.selOrg = null;
		this.txtCustomerName = null;
		this.txtCreator = null;
		this.txtBeginDate = null;
		this.txtEndDate = null;
		this.btnQuery = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$EngineerOrderQueryPage_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderQueryPage.__typeName = 'USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderQueryPage';
	global.USOProject.Pages.ApplyAudit.EngineerOrder.EngineerOrderQueryPage = $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderQueryPage;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OrderAudit.OrderAuditAction
	var $USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditAction = function() {
		this.Data = null;
		this.InitData = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.btnAudit = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$OrderAuditAction_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditAction.__typeName = 'USOProject.Pages.ApplyAudit.OrderAudit.OrderAuditAction';
	global.USOProject.Pages.ApplyAudit.OrderAudit.OrderAuditAction = $USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditAction;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OrderAudit.OrderAuditAction.OrderAuditActionData
	var $USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditAction$OrderAuditActionData = function() {
		this.OrderId = 0;
		this.OrderAuditType = 0;
	};
	$USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditAction$OrderAuditActionData.__typeName = 'USOProject.Pages.ApplyAudit.OrderAudit.OrderAuditAction$OrderAuditActionData';
	global.USOProject.Pages.ApplyAudit.OrderAudit.OrderAuditAction$OrderAuditActionData = $USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditAction$OrderAuditActionData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OrderAudit.OrderAuditType
	var $USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditType = function() {
	};
	$USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditType.__typeName = 'USOProject.Pages.ApplyAudit.OrderAudit.OrderAuditType';
	global.USOProject.Pages.ApplyAudit.OrderAudit.OrderAuditType = $USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OrderAudit.OrderDetail
	var $USOProject_Pages_ApplyAudit_OrderAudit_OrderDetail = function() {
		this.Data = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.btnAudit = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$OrderDetail_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_OrderAudit_OrderDetail.__typeName = 'USOProject.Pages.ApplyAudit.OrderAudit.OrderDetail';
	global.USOProject.Pages.ApplyAudit.OrderAudit.OrderDetail = $USOProject_Pages_ApplyAudit_OrderAudit_OrderDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OrderAudit.OrderDetailData
	var $USOProject_Pages_ApplyAudit_OrderAudit_OrderDetailData = function() {
		this.OrderId = 0;
		this.IsToAudit = false;
		this.StockOrganizationName = null;
		this.OrderAuditType = 0;
	};
	$USOProject_Pages_ApplyAudit_OrderAudit_OrderDetailData.__typeName = 'USOProject.Pages.ApplyAudit.OrderAudit.OrderDetailData';
	global.USOProject.Pages.ApplyAudit.OrderAudit.OrderDetailData = $USOProject_Pages_ApplyAudit_OrderAudit_OrderDetailData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OrderAudit.OrderList
	var $USOProject_Pages_ApplyAudit_OrderAudit_OrderList = function() {
		this.$_iscrollList = null;
		this.$CurStatus = 1;
		this.btnBack = null;
		this.lblHeadText = null;
		this.btnQuery = null;
		this.pnlContent = null;
		this.pnlDataList = null;
		$USOProject_Pages_ApplyAudit_ApplyAuditBasePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$OrderList_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$OrderList_OnPageShow));
	};
	$USOProject_Pages_ApplyAudit_OrderAudit_OrderList.__typeName = 'USOProject.Pages.ApplyAudit.OrderAudit.OrderList';
	global.USOProject.Pages.ApplyAudit.OrderAudit.OrderList = $USOProject_Pages_ApplyAudit_OrderAudit_OrderList;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OrderAudit.OrderProductDetail
	var $USOProject_Pages_ApplyAudit_OrderAudit_OrderProductDetail = function() {
		this.ProductData = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$OrderProductDetail_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_OrderAudit_OrderProductDetail.__typeName = 'USOProject.Pages.ApplyAudit.OrderAudit.OrderProductDetail';
	global.USOProject.Pages.ApplyAudit.OrderAudit.OrderProductDetail = $USOProject_Pages_ApplyAudit_OrderAudit_OrderProductDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OrderAudit.OrderQueryPage
	var $USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage = function() {
		this.QueryData = null;
		this.OnQueryComplete = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.txtId = null;
		this.selStockOrg = null;
		this.txtCustomerLegalName = null;
		this.selSaleChannels = null;
		this.selProductGroup = null;
		this.txtCreator = null;
		this.txtBeginDate = null;
		this.txtEndDate = null;
		this.btnQuery = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$OrderQueryPage_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage.__typeName = 'USOProject.Pages.ApplyAudit.OrderAudit.OrderQueryPage';
	global.USOProject.Pages.ApplyAudit.OrderAudit.OrderQueryPage = $USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderAuditAction
	var $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderAuditAction = function() {
		this.MasterId = 0;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.pnlAuditOptions = null;
		this.chkBack = null;
		this.pnlBackReason = null;
		this.txtRemark = null;
		this.btnAudit = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$OtherOrderAuditAction_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderAuditAction.__typeName = 'USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderAuditAction';
	global.USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderAuditAction = $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderAuditAction;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderDetail
	var $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderDetail = function() {
		this.Data = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.btnAudit = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$OtherOrderDetail_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderDetail.__typeName = 'USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderDetail';
	global.USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderDetail = $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderDetailData
	var $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderDetailData = function() {
		this.Id = 0;
		this.StockOrgName = null;
		this.IsToAudit = false;
	};
	$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderDetailData.__typeName = 'USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderDetailData';
	global.USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderDetailData = $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderDetailData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderList
	var $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderList = function() {
		this.$_iscrollList = null;
		this.$CurStatus = 1;
		this.btnBack = null;
		this.lblHeadText = null;
		this.btnQuery = null;
		this.pnlContent = null;
		this.pnlDataList = null;
		$USOProject_Pages_ApplyAudit_ApplyAuditBasePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$OtherOrderList_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$OtherOrderList_OnPageShow));
	};
	$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderList.__typeName = 'USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderList';
	global.USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderList = $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderList;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderProductDetail
	var $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderProductDetail = function() {
		this.ProductData = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$OtherOrderProductDetail_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderProductDetail.__typeName = 'USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderProductDetail';
	global.USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderProductDetail = $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderProductDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderQueryPage
	var $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage = function() {
		this.QueryData = null;
		this.OnQueryComplete = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.txtId = null;
		this.selStockOrg = null;
		this.txtCustomerLegalName = null;
		this.selSaleChannels = null;
		this.selProductGroup = null;
		this.txtCreator = null;
		this.txtBeginDate = null;
		this.txtEndDate = null;
		this.btnQuery = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$OtherOrderQueryPage_OnPageInit));
	};
	$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.__typeName = 'USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderQueryPage';
	global.USOProject.Pages.ApplyAudit.OtherOrder.OtherOrderQueryPage = $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Common.AddressDataInfo
	var $USOProject_Pages_Common_AddressDataInfo = function() {
	};
	$USOProject_Pages_Common_AddressDataInfo.__typeName = 'USOProject.Pages.Common.AddressDataInfo';
	$USOProject_Pages_Common_AddressDataInfo.createInstance = function() {
		return $USOProject_Pages_Common_AddressDataInfo.$ctor();
	};
	$USOProject_Pages_Common_AddressDataInfo.$ctor1 = function(provinceId, cityId, countyId) {
		var $this = {};
		$this.ProvinceID = 0;
		$this.ProvinceName = null;
		$this.CityID = 0;
		$this.CityName = null;
		$this.CountyID = 0;
		$this.CountyName = null;
		$this.ProvinceID = provinceId;
		$this.CityID = cityId;
		$this.CountyID = countyId;
		var province = Enumerable.from($USOProject_Pages_Common_AddressSelector.get_AddressData()).firstOrDefault(function(n) {
			return n.Id === provinceId;
		}, ss.getDefaultValue(Object));
		if (ss.isValue(province)) {
			$this.ProvinceName = province.Name;
		}
		var city = Enumerable.from($USOProject_Pages_Common_AddressSelector.get_AddressData()).firstOrDefault(function(n1) {
			return n1.Id === cityId;
		}, ss.getDefaultValue(Object));
		if (ss.isValue(city)) {
			$this.CityName = city.Name;
		}
		var county = Enumerable.from($USOProject_Pages_Common_AddressSelector.get_AddressData()).firstOrDefault(function(n2) {
			return n2.Id === countyId;
		}, ss.getDefaultValue(Object));
		if (ss.isValue(county)) {
			$this.CountyName = county.Name;
		}
		return $this;
	};
	$USOProject_Pages_Common_AddressDataInfo.$ctor = function() {
		var $this = {};
		$this.ProvinceID = 0;
		$this.ProvinceName = null;
		$this.CityID = 0;
		$this.CityName = null;
		$this.CountyID = 0;
		$this.CountyName = null;
		return $this;
	};
	$USOProject_Pages_Common_AddressDataInfo.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Pages.Common.AddressDataInfo = $USOProject_Pages_Common_AddressDataInfo;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Common.AddressDataInfoEx
	var $USOProject_Pages_Common_AddressDataInfoEx = function() {
	};
	$USOProject_Pages_Common_AddressDataInfoEx.__typeName = 'USOProject.Pages.Common.AddressDataInfoEx';
	$USOProject_Pages_Common_AddressDataInfoEx.ToDisplayString = function(target) {
		if (ss.isNullOrEmptyString(target.ProvinceName)) {
			return '';
		}
		else {
			return ss.formatString('{0}-{1}-{2}', target.ProvinceName, target.CityName, target.CountyName);
		}
	};
	global.USOProject.Pages.Common.AddressDataInfoEx = $USOProject_Pages_Common_AddressDataInfoEx;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Common.AddressSelector
	var $USOProject_Pages_Common_AddressSelector = function() {
		this.OnAddressSelected = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.btnFinished = null;
		this.pnlContent = null;
		this.address_select_province = null;
		this.address_select_city = null;
		this.address_select_town = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$AddressSelector_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$OnOnPageShow));
	};
	$USOProject_Pages_Common_AddressSelector.__typeName = 'USOProject.Pages.Common.AddressSelector';
	$USOProject_Pages_Common_AddressSelector.get_AddressData = function() {
		if (ss.isNullOrUndefined($USOProject_Pages_Common_AddressSelector.$_addressData)) {
			var request = $.ajax({ url: 'address.json', async: false });
			$USOProject_Pages_Common_AddressSelector.$_addressData = JSON.parse(request.responseText);
		}
		return $USOProject_Pages_Common_AddressSelector.$_addressData;
	};
	global.USOProject.Pages.Common.AddressSelector = $USOProject_Pages_Common_AddressSelector;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Common.CustomerSelector
	var $USOProject_Pages_Common_CustomerSelector = function() {
		this.OnUserSelected = null;
		this.Data = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.btnClear = null;
		this.pnlContent = null;
		this.txtName = null;
		this.btnSearch = null;
		this.pnlDataList = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$CustomerSelector_OnPageInit));
	};
	$USOProject_Pages_Common_CustomerSelector.__typeName = 'USOProject.Pages.Common.CustomerSelector';
	global.USOProject.Pages.Common.CustomerSelector = $USOProject_Pages_Common_CustomerSelector;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Common.CustomerSelector.ListItem
	var $USOProject_Pages_Common_CustomerSelector$ListItem = function() {
		this.Name = null;
		this.Id = 0;
	};
	$USOProject_Pages_Common_CustomerSelector$ListItem.__typeName = 'USOProject.Pages.Common.CustomerSelector$ListItem';
	global.USOProject.Pages.Common.CustomerSelector$ListItem = $USOProject_Pages_Common_CustomerSelector$ListItem;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Common.CustomerSelectorData
	var $USOProject_Pages_Common_CustomerSelectorData = function() {
		this.Title = null;
		this.Mode = 0;
	};
	$USOProject_Pages_Common_CustomerSelectorData.__typeName = 'USOProject.Pages.Common.CustomerSelectorData';
	global.USOProject.Pages.Common.CustomerSelectorData = $USOProject_Pages_Common_CustomerSelectorData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Common.CustomerSelectorMode
	var $USOProject_Pages_Common_CustomerSelectorMode = function() {
	};
	$USOProject_Pages_Common_CustomerSelectorMode.__typeName = 'USOProject.Pages.Common.CustomerSelectorMode';
	global.USOProject.Pages.Common.CustomerSelectorMode = $USOProject_Pages_Common_CustomerSelectorMode;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Control.AppCenterControl
	var $USOProject_Pages_Control_AppCenterControl = function() {
		this.$_scroller = null;
		this.$_moduleItems = null;
		JSLib.Controller.ControllerBase.call(this);
		this.add_OnLoad(ss.mkdel(this, this.$AppCenterControl_OnLoad));
		this.add_OnShow(ss.mkdel(this, this.$OnOnShow));
	};
	$USOProject_Pages_Control_AppCenterControl.__typeName = 'USOProject.Pages.Control.AppCenterControl';
	global.USOProject.Pages.Control.AppCenterControl = $USOProject_Pages_Control_AppCenterControl;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Control.MyWorkControl
	var $USOProject_Pages_Control_MyWorkControl = function() {
		this.$LastWorkStepId = '';
		this.$FirstWorkStepId = '';
		this.$lastedFirstWorkStepId = '';
		this.$_iscrollList = null;
		this.work = null;
		this.pnlMyWorkModuls = null;
		this.ul1 = null;
		this.spanWorkTitle = null;
		this.ulWorkContainer = null;
		JSLib.Controller.ControllerBase.call(this);
		this.add_OnLoad(ss.mkdel(this, this.$MyWorkControl_OnLoad));
		this.add_OnShow(ss.mkdel(this, this.$OnOnShow));
	};
	$USOProject_Pages_Control_MyWorkControl.__typeName = 'USOProject.Pages.Control.MyWorkControl';
	$USOProject_Pages_Control_MyWorkControl.add_TodoWorkChange = function(value) {
		$USOProject_Pages_Control_MyWorkControl.$3$TodoWorkChangeField = ss.delegateCombine($USOProject_Pages_Control_MyWorkControl.$3$TodoWorkChangeField, value);
	};
	$USOProject_Pages_Control_MyWorkControl.remove_TodoWorkChange = function(value) {
		$USOProject_Pages_Control_MyWorkControl.$3$TodoWorkChangeField = ss.delegateRemove($USOProject_Pages_Control_MyWorkControl.$3$TodoWorkChangeField, value);
	};
	$USOProject_Pages_Control_MyWorkControl.TriggerTodoWorkChange = function() {
		if (!ss.staticEquals($USOProject_Pages_Control_MyWorkControl.$3$TodoWorkChangeField, null)) {
			$USOProject_Pages_Control_MyWorkControl.$3$TodoWorkChangeField(null, null);
		}
	};
	global.USOProject.Pages.Control.MyWorkControl = $USOProject_Pages_Control_MyWorkControl;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Control.PersonalCenterControl
	var $USOProject_Pages_Control_PersonalCenterControl = function() {
		this.$_iscroller = null;
		this.span_userinfo = null;
		this.span_username = null;
		this.span_dept = null;
		this.pers_myFavorite_devider = null;
		this.pers_myFavorite_li = null;
		this.pers_myFavorite = null;
		this.messageSwich_button = null;
		this.sk_ios = null;
		this.sk_iosgreen = null;
		this.btnGotoModifyPassword = null;
		this.user_logout = null;
		JSLib.Controller.ControllerBase.call(this);
		this.add_OnLoad(ss.mkdel(this, this.$PersonalCenterControl_OnLoad));
		this.add_OnShow(ss.mkdel(this, this.$OnOnShow));
	};
	$USOProject_Pages_Control_PersonalCenterControl.__typeName = 'USOProject.Pages.Control.PersonalCenterControl';
	global.USOProject.Pages.Control.PersonalCenterControl = $USOProject_Pages_Control_PersonalCenterControl;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Control.TodoWorkItem
	var $USOProject_Pages_Control_TodoWorkItem = function() {
		this.Type = null;
		this.DisplayName = null;
		this.Date = null;
	};
	$USOProject_Pages_Control_TodoWorkItem.__typeName = 'USOProject.Pages.Control.TodoWorkItem';
	global.USOProject.Pages.Control.TodoWorkItem = $USOProject_Pages_Control_TodoWorkItem;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Control.UpgradePlugin
	var $USOProject_Pages_Control_UpgradePlugin = function() {
	};
	$USOProject_Pages_Control_UpgradePlugin.__typeName = 'USOProject.Pages.Control.UpgradePlugin';
	$USOProject_Pages_Control_UpgradePlugin.download = function(url) {
		var $t2 = function(o) {
			var result = o;
			if (result === 'suc') {
				window.localStorage.setItem('isUSOInit', '0');
			}
		};
		var $t3 = function(o1) {
			JSLib.Mobile.MessageBox.Alert(JSON.stringify(o1));
		};
		var $t1 = [];
		$t1.push(url);
		cordova.exec($t2, $t3, 'CustomPlugin', 'download', $t1);
	};
	global.USOProject.Pages.Control.UpgradePlugin = $USOProject_Pages_Control_UpgradePlugin;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Control.UpgradeTipController
	var $USOProject_Pages_Control_UpgradeTipController = function(serverInfo) {
		this.ServerInfo = null;
		this.UpgradeCancel = null;
		this.splash_download = null;
		this.splash_download_title = null;
		this.dl_title = null;
		this.dl_content = null;
		this.progress_nowv = null;
		this.progress_objv = null;
		this.updateComment = null;
		this.lblUpgradeTip = null;
		this.dl_content_loading = null;
		this.progress_info = null;
		this.loading_main = null;
		this.loading_has = null;
		this.loading_not = null;
		this.progress_persent = null;
		this.btn_startdownload = null;
		this.btn_startManualDownload = null;
		this.btn_cancelUpdate = null;
		JSLib.Controller.ControllerBase.call(this);
		this.ServerInfo = serverInfo;
		this.add_OnLoad(ss.mkdel(this, this.$UpgradeTipController_OnLoad));
	};
	$USOProject_Pages_Control_UpgradeTipController.__typeName = 'USOProject.Pages.Control.UpgradeTipController';
	$USOProject_Pages_Control_UpgradeTipController.CheckShouldUpdate = function(versionCode) {
		var savs = versionCode.split('.');
		var apvs = $App.app.AppVersion.split('.');
		var isupdate = false;
		for (var i = 0; i < savs.length; i++) {
			var client = CoreEx.ToInt(apvs[i], 0);
			var server = CoreEx.ToInt(savs[i], 0);
			if (client > server) {
				break;
			}
			if (client < server) {
				isupdate = true;
				break;
			}
		}
		return isupdate;
	};
	global.USOProject.Pages.Control.UpgradeTipController = $USOProject_Pages_Control_UpgradeTipController;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Control.ViewMoreControl
	var $USOProject_Pages_Control_ViewMoreControl = function() {
		this.$_scroller = null;
		this.more_version = null;
		this.pnlCheckNew = null;
		this.btnCheckNew = null;
		this.btn_modulesetting = null;
		JSLib.Controller.ControllerBase.call(this);
		this.add_OnLoad(ss.mkdel(this, this.$ViewMoreControl_OnLoad));
		this.add_OnShow(ss.mkdel(this, this.$ViewMoreControl_OnShow));
	};
	$USOProject_Pages_Control_ViewMoreControl.__typeName = 'USOProject.Pages.Control.ViewMoreControl';
	global.USOProject.Pages.Control.ViewMoreControl = $USOProject_Pages_Control_ViewMoreControl;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.NewRetailInputStatistics.CustomizeDateRange
	var $USOProject_Pages_NewRetailInputStatistics_CustomizeDateRange = function() {
		this.From = null;
		this.To = null;
	};
	$USOProject_Pages_NewRetailInputStatistics_CustomizeDateRange.__typeName = 'USOProject.Pages.NewRetailInputStatistics.CustomizeDateRange';
	global.USOProject.Pages.NewRetailInputStatistics.CustomizeDateRange = $USOProject_Pages_NewRetailInputStatistics_CustomizeDateRange;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.NewRetailInputStatistics.QueryReportDateType
	var $USOProject_Pages_NewRetailInputStatistics_QueryReportDateType = function() {
	};
	$USOProject_Pages_NewRetailInputStatistics_QueryReportDateType.__typeName = 'USOProject.Pages.NewRetailInputStatistics.QueryReportDateType';
	global.USOProject.Pages.NewRetailInputStatistics.QueryReportDateType = $USOProject_Pages_NewRetailInputStatistics_QueryReportDateType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.NewRetailInputStatistics.QueryReportRequest
	var $USOProject_Pages_NewRetailInputStatistics_QueryReportRequest = function() {
		this.DateType = 1;
		this.OriDateType = 6;
		this.CustomizeDateRange = null;
		this.QueryReportViewType = 1;
		this.AncestorDepth = 0;
		this.LevelId = 0;
		this.IsMarkedStore = null;
		this.StockOrganizationId = 0;
		this.CustomerManagerId = null;
		this.CustomerLegalId = null;
		this.CustomerStoreId = null;
		this.ProductSeryId = null;
		this.ProductId = null;
		this.OrganizationId = null;
		this.RetailInputStatRoleType = 0;
	};
	$USOProject_Pages_NewRetailInputStatistics_QueryReportRequest.__typeName = 'USOProject.Pages.NewRetailInputStatistics.QueryReportRequest';
	global.USOProject.Pages.NewRetailInputStatistics.QueryReportRequest = $USOProject_Pages_NewRetailInputStatistics_QueryReportRequest;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.NewRetailInputStatistics.QueryReportViewType
	var $USOProject_Pages_NewRetailInputStatistics_QueryReportViewType = function() {
	};
	$USOProject_Pages_NewRetailInputStatistics_QueryReportViewType.__typeName = 'USOProject.Pages.NewRetailInputStatistics.QueryReportViewType';
	global.USOProject.Pages.NewRetailInputStatistics.QueryReportViewType = $USOProject_Pages_NewRetailInputStatistics_QueryReportViewType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.NewRetailInputStatistics.RetailInputStatistics_Configure
	var $USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Configure = function() {
		this.StoreData = null;
		this.$lastUpdateDate = '';
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.pnlConfigData = null;
		this.selOrg = null;
		this.selCustomerLegalIds = null;
		this.btnContinue = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$RetailInputStatistics_Configure_OnPageInit));
	};
	$USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Configure.__typeName = 'USOProject.Pages.NewRetailInputStatistics.RetailInputStatistics_Configure';
	global.USOProject.Pages.NewRetailInputStatistics.RetailInputStatistics_Configure = $USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Configure;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.NewRetailInputStatistics.RetailInputStatistics_Configure.LevelItemData
	var $USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Configure$LevelItemData = function() {
		this.Name = null;
		this.Level = 0;
		this.IsActive = false;
		this.OrgType = 0;
	};
	$USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Configure$LevelItemData.__typeName = 'USOProject.Pages.NewRetailInputStatistics.RetailInputStatistics_Configure$LevelItemData';
	global.USOProject.Pages.NewRetailInputStatistics.RetailInputStatistics_Configure$LevelItemData = $USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Configure$LevelItemData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.NewRetailInputStatistics.RetailInputStatistics_Detail
	var $USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Detail = function() {
		this.Data = null;
		this.ChildOrg = null;
		this.$IsByModel = false;
		this.$lastUpdateDate = '';
		this.$query = new $USOProject_Pages_NewRetailInputStatistics_QueryReportRequest();
		this.$_listData = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.pnlConditionalPanel = null;
		this.lblCurDateCondtion = null;
		this.lblCurMarkCondition = null;
		this.pnlFilterMore = null;
		this.pnlDateChoose = null;
		this.pnlStoreChoose = null;
		this.pnlGridData = null;
		this.lblVerticalLine = null;
		this.pnlList = null;
		this.lblTotalQuantity = null;
		this.lblTotalAver = null;
		this.lblTotalAmount = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$RetailInputStatistics_Detail_OnPageInit));
	};
	$USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Detail.__typeName = 'USOProject.Pages.NewRetailInputStatistics.RetailInputStatistics_Detail';
	global.USOProject.Pages.NewRetailInputStatistics.RetailInputStatistics_Detail = $USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Detail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.NewRetailInputStatistics.RetailInputStatistics_Index
	var $USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Index = function() {
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$RetailInputStatistics_Index_OnPageInit));
	};
	$USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Index.__typeName = 'USOProject.Pages.NewRetailInputStatistics.RetailInputStatistics_Index';
	global.USOProject.Pages.NewRetailInputStatistics.RetailInputStatistics_Index = $USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Index;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.CategoryDetail
	var $USOProject_Pages_Product_CategoryDetail = function() {
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.cateLeft = null;
		this.cate2List = null;
		this.cateRight = null;
		this.pnlCate3List = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$CategoryDetail_OnPageInit));
	};
	$USOProject_Pages_Product_CategoryDetail.__typeName = 'USOProject.Pages.Product.CategoryDetail';
	global.USOProject.Pages.Product.CategoryDetail = $USOProject_Pages_Product_CategoryDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.CategoryMaster
	var $USOProject_Pages_Product_CategoryMaster = function() {
		this.btnBack = null;
		this.btnGotoSearch = null;
		this.txtSearchPlaceHolder = null;
		this.pnlContent = null;
		this.ulCategory1Container = null;
		this.pnlCategoryMasterFooter = null;
		this.btnGotoFav = null;
		this.btnGotoCart = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$CategoryMaster_OnPageInit));
	};
	$USOProject_Pages_Product_CategoryMaster.__typeName = 'USOProject.Pages.Product.CategoryMaster';
	global.USOProject.Pages.Product.CategoryMaster = $USOProject_Pages_Product_CategoryMaster;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.ListSortDirection
	var $USOProject_Pages_Product_ListSortDirection = function() {
	};
	$USOProject_Pages_Product_ListSortDirection.__typeName = 'USOProject.Pages.Product.ListSortDirection';
	global.USOProject.Pages.Product.ListSortDirection = $USOProject_Pages_Product_ListSortDirection;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.MobileProductFavorite
	var $USOProject_Pages_Product_MobileProductFavorite = function() {
	};
	$USOProject_Pages_Product_MobileProductFavorite.__typeName = 'USOProject.Pages.Product.MobileProductFavorite';
	$USOProject_Pages_Product_MobileProductFavorite.createInstance = function() {
		return $USOProject_Pages_Product_MobileProductFavorite.$ctor();
	};
	$USOProject_Pages_Product_MobileProductFavorite.$ctor = function() {
		var $this = {};
		$this.Id = 0;
		$this.ProductId = 0;
		$this.UserId = 0;
		$this.ProductFavoriteType = 0;
		$this.CreateOn = new Date(0);
		$this.CreateOnString = null;
		$this.ConsultPrice = null;
		$this.ProductMode = null;
		$this.BriefName = null;
		return $this;
	};
	$USOProject_Pages_Product_MobileProductFavorite.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Pages.Product.MobileProductFavorite = $USOProject_Pages_Product_MobileProductFavorite;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.MobileProductFavoriteQuery
	var $USOProject_Pages_Product_MobileProductFavoriteQuery = function() {
		this.$1$PageField = 0;
		this.$1$PageSizeField = 0;
		this.$1$IdField = 0;
		this.$1$UserIdField = 0;
		this.$1$ProductIdField = 0;
		this.$1$OrderByColumnsField = null;
		this.set_PageSize(10);
		this.set_Page(1);
	};
	$USOProject_Pages_Product_MobileProductFavoriteQuery.__typeName = 'USOProject.Pages.Product.MobileProductFavoriteQuery';
	global.USOProject.Pages.Product.MobileProductFavoriteQuery = $USOProject_Pages_Product_MobileProductFavoriteQuery;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.OrderByColumn
	var $USOProject_Pages_Product_OrderByColumn = function() {
	};
	$USOProject_Pages_Product_OrderByColumn.__typeName = 'USOProject.Pages.Product.OrderByColumn';
	$USOProject_Pages_Product_OrderByColumn.createInstance = function() {
		return $USOProject_Pages_Product_OrderByColumn.$ctor();
	};
	$USOProject_Pages_Product_OrderByColumn.$ctor = function() {
		var $this = {};
		$this.alias = 'A';
		$this.ColumnName = null;
		$this.Alias = null;
		$this.SortDirection = 0;
		return $this;
	};
	$USOProject_Pages_Product_OrderByColumn.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Pages.Product.OrderByColumn = $USOProject_Pages_Product_OrderByColumn;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.ProductDetail
	var $USOProject_Pages_Product_ProductDetail = function() {
		this.$productId = 0;
		this.$orgId = 0;
		this.$customerLeagls = null;
		this.$curCustomerLegalId = 0;
		this.$wareHouseData = null;
		this.$curWareHouseId = 0;
		this.$quantity = 0;
		this.$curSelectType = 0;
		this.$currentBuyNumber = 0;
		this.$priceInfo = null;
		this.$discountInfo = null;
		this.$dialogIscroll = null;
		this.$pageScroller = null;
		this.$carousel = null;
		this.ProductData = null;
		this.productOrg = null;
		this.$isAutoScroll = false;
		this.$isPullLongEnough = false;
		this.$isUPPull = false;
		this.$isInpage2 = false;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlChooseDialog = null;
		this.btnClose = null;
		this.pnlChooseContent = null;
		this.pnlSep2PullTip = null;
		this.lblSep2PullTip = null;
		this.pnlTabHeads = null;
		this.pnlProductInfo = null;
		this.pnlContent = null;
		this.pnlSep1 = null;
		this.PictureArea = null;
		this.carouselWarper = null;
		this.carouselScroller = null;
		this.indicator = null;
		this.btnToggleFavIcon = null;
		this.btnChooseOrg = null;
		this.btnChooseCustomerLegal = null;
		this.btnChooseWarehouse = null;
		this.lblConsultStock = null;
		this.pnlChangeNumber = null;
		this.lblNumberText = null;
		this.pnlNav = null;
		this.pnlSep2 = null;
		this.tabPanelGroup = null;
		this.pnlTabPages = null;
		this.pnlWebView = null;
		this.pnlParameter = null;
		this.btnAddToFavToolBar = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$ProductDetail_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$ProductDetail_OnPageShow));
	};
	$USOProject_Pages_Product_ProductDetail.__typeName = 'USOProject.Pages.Product.ProductDetail';
	global.USOProject.Pages.Product.ProductDetail = $USOProject_Pages_Product_ProductDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.ProductFavorite
	var $USOProject_Pages_Product_ProductFavorite = function() {
		var $t1 = new $USOProject_Pages_Product_ProductFavorite$Point();
		$t1.x = 0;
		$t1.y = 0;
		this.$iniTouch = $t1;
		this.$deleteBtnWidth = 61;
		this.$lastMoveX = 0;
		this.$swipeLeft = false;
		this.$defaultMarginLeft = 67;
		this.$defaultImgMarginLeft = 67;
		this.$bufferContentMarginLeft = 6;
		this.$liMarginLeftBuffer = 15;
		this.$needForbindMove = true;
		this.$_scrollList = null;
		this.$_slideToDeleteList = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.ulProductFavoriteContainer = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$ProductFavorite_OnPageInit));
	};
	$USOProject_Pages_Product_ProductFavorite.__typeName = 'USOProject.Pages.Product.ProductFavorite';
	global.USOProject.Pages.Product.ProductFavorite = $USOProject_Pages_Product_ProductFavorite;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.ProductFavorite.Point
	var $USOProject_Pages_Product_ProductFavorite$Point = function() {
		this.x = 0;
		this.y = 0;
	};
	$USOProject_Pages_Product_ProductFavorite$Point.__typeName = 'USOProject.Pages.Product.ProductFavorite$Point';
	global.USOProject.Pages.Product.ProductFavorite$Point = $USOProject_Pages_Product_ProductFavorite$Point;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.ProductFavoriteType
	var $USOProject_Pages_Product_ProductFavoriteType = function() {
	};
	$USOProject_Pages_Product_ProductFavoriteType.__typeName = 'USOProject.Pages.Product.ProductFavoriteType';
	global.USOProject.Pages.Product.ProductFavoriteType = $USOProject_Pages_Product_ProductFavoriteType;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.ProductList
	var $USOProject_Pages_Product_ProductList = function() {
		this.$_productListRestDto = null;
		this.$_queryProductDto = null;
		this.$_iscrollList = null;
		this.$_queryDto = null;
		this.btnBack = null;
		this.btnGotoSearch = null;
		this.txtKeyWord = null;
		this.btnFilter = null;
		this.btnSearch = null;
		this.pnlContent = null;
		this.ulProductContainer = null;
		this.pnlCompleteList = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$ProductList_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$ProductList_OnPageShow));
	};
	$USOProject_Pages_Product_ProductList.__typeName = 'USOProject.Pages.Product.ProductList';
	global.USOProject.Pages.Product.ProductList = $USOProject_Pages_Product_ProductList;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.ProductList.ProductListData
	var $USOProject_Pages_Product_ProductList$ProductListData = function() {
		this.IsFromClickSearch = false;
		this.C3Id = '';
		this.FilterString = '';
		this.QueryType = '';
		this.KeyWords = null;
	};
	$USOProject_Pages_Product_ProductList$ProductListData.__typeName = 'USOProject.Pages.Product.ProductList$ProductListData';
	global.USOProject.Pages.Product.ProductList$ProductListData = $USOProject_Pages_Product_ProductList$ProductListData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Product.ProductListCondition
	var $USOProject_Pages_Product_ProductListCondition = function() {
		this.ProductListRestDto = null;
		this.OnConditionComplete = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.retail_sel_salesStatus = null;
		this.product_dosearch = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$ProductListCondition_OnPageInit));
	};
	$USOProject_Pages_Product_ProductListCondition.__typeName = 'USOProject.Pages.Product.ProductListCondition';
	global.USOProject.Pages.Product.ProductListCondition = $USOProject_Pages_Product_ProductListCondition;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.RetailInput
	var $USOProject_Pages_Retail_RetailInput = function() {
		this.$queryDto = null;
		this.$_pageScroller = null;
		this.$intervalIds = [];
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.retailindex_top = null;
		this.retailindex_top_title = null;
		this.retailindex_top_title_left = null;
		this.retailindex_title_span = null;
		this.retailindex_top_title_select = null;
		this.retailindex_top_title_right = null;
		this.retailindex_top_content = null;
		this.retailindex_middle = null;
		this.retailindex_middle_left_content = null;
		this.retailindex_middle_right_content = null;
		this.retailindex_bottom = null;
		this.retailindex_bottom_list = null;
		this.navbar = null;
		this.retailInput_new = null;
		this.retailInput_list = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$RetailInput_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$OnOnPageShow));
	};
	$USOProject_Pages_Retail_RetailInput.__typeName = 'USOProject.Pages.Retail.RetailInput';
	global.USOProject.Pages.Retail.RetailInput = $USOProject_Pages_Retail_RetailInput;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.RetailInputList
	var $USOProject_Pages_Retail_RetailInputList = function() {
		this.QueryData = $USOProject_Pages_Retail_RetailInputQuery$QueryCondition.$ctor();
		this.btnBack = null;
		this.lblHeadText = null;
		this.header_search = null;
		this.pnlContent = null;
		this.btnNewRetailInput = null;
		this.pnlInfoPanel = null;
		this.lblCustomerName = null;
		this.lblStoreName = null;
		this.lblProductName = null;
		this.lblQueryDate = null;
		this.lblBeginDate = null;
		this.lblEndDate = null;
		this.ulRetailInputListContainer = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$RetailInputList_OnPageInit));
	};
	$USOProject_Pages_Retail_RetailInputList.__typeName = 'USOProject.Pages.Retail.RetailInputList';
	global.USOProject.Pages.Retail.RetailInputList = $USOProject_Pages_Retail_RetailInputList;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.RetailInputProductDetail
	var $USOProject_Pages_Retail_RetailInputProductDetail = function() {
		this.PageData = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.divRetailProductListContainer = null;
		this.div_work_content = null;
		this.div_work_pnumber_span = null;
		this.div_work_pprice_span = null;
		this.div_work_commAmount_span = null;
		this.div_work_smode_span = null;
		this.div_work_networktype_span = null;
		this.div_work_saledate_span = null;
		this.div_work_remark_span = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$RetailInputProductDetail_OnPageInit));
	};
	$USOProject_Pages_Retail_RetailInputProductDetail.__typeName = 'USOProject.Pages.Retail.RetailInputProductDetail';
	global.USOProject.Pages.Retail.RetailInputProductDetail = $USOProject_Pages_Retail_RetailInputProductDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.RetailInputProductSaleStatistics
	var $USOProject_Pages_Retail_RetailInputProductSaleStatistics = function() {
		this.Data = null;
		this.$_iscrollList = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.retail_productSaleStatistics_information = null;
		this.ulRetailInputProductSaleStatisticsContainer = null;
		this.lblCustomerName = null;
		this.lblStoreName = null;
		this.lblQueryDate = null;
		this.lblBeginDate = null;
		this.lblEndDate = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$RetailInputProductSaleStatistics_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$RetailInputProductSaleStatistics_OnPageShow));
	};
	$USOProject_Pages_Retail_RetailInputProductSaleStatistics.__typeName = 'USOProject.Pages.Retail.RetailInputProductSaleStatistics';
	global.USOProject.Pages.Retail.RetailInputProductSaleStatistics = $USOProject_Pages_Retail_RetailInputProductSaleStatistics;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.RetailInputProductSaleStatistics.StatisticsData
	var $USOProject_Pages_Retail_RetailInputProductSaleStatistics$StatisticsData = function() {
	};
	$USOProject_Pages_Retail_RetailInputProductSaleStatistics$StatisticsData.__typeName = 'USOProject.Pages.Retail.RetailInputProductSaleStatistics$StatisticsData';
	$USOProject_Pages_Retail_RetailInputProductSaleStatistics$StatisticsData.createInstance = function() {
		return $USOProject_Pages_Retail_RetailInputProductSaleStatistics$StatisticsData.$ctor();
	};
	$USOProject_Pages_Retail_RetailInputProductSaleStatistics$StatisticsData.$ctor = function() {
		var $this = {};
		$this.storeId = null;
		$this.storeName = null;
		$this.customerName = null;
		$this.CustomerLegalId = 0;
		$this.fromDate = null;
		$this.toDate = null;
		$this.satGroupId = null;
		return $this;
	};
	$USOProject_Pages_Retail_RetailInputProductSaleStatistics$StatisticsData.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Pages.Retail.RetailInputProductSaleStatistics$StatisticsData = $USOProject_Pages_Retail_RetailInputProductSaleStatistics$StatisticsData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.RetailInputQuery
	var $USOProject_Pages_Retail_RetailInputQuery = function() {
		this.PageQueryCondition = null;
		this.OnConditionComplete = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.retail_txt_legalName = null;
		this.retail_txt_clientName = null;
		this.retail_search_txt_productId = null;
		this.retail_sel_salestype = null;
		this.retail_sel_orderytype = null;
		this.retail_sel_salesStatus = null;
		this.retail_sel_customerStore = null;
		this.retail_search_date_beginDate = null;
		this.retail_search_date_endDate = null;
		this.retail_a_dosearch = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$RetailInputQuery_OnPageInit));
	};
	$USOProject_Pages_Retail_RetailInputQuery.__typeName = 'USOProject.Pages.Retail.RetailInputQuery';
	global.USOProject.Pages.Retail.RetailInputQuery = $USOProject_Pages_Retail_RetailInputQuery;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.RetailInputQuery.QueryCondition
	var $USOProject_Pages_Retail_RetailInputQuery$QueryCondition = function() {
	};
	$USOProject_Pages_Retail_RetailInputQuery$QueryCondition.__typeName = 'USOProject.Pages.Retail.RetailInputQuery$QueryCondition';
	$USOProject_Pages_Retail_RetailInputQuery$QueryCondition.createInstance = function() {
		return $USOProject_Pages_Retail_RetailInputQuery$QueryCondition.$ctor();
	};
	$USOProject_Pages_Retail_RetailInputQuery$QueryCondition.$ctor = function() {
		var $this = {};
		$this.CustomerStoreId = null;
		$this.ProductId = null;
		$this.FromDate = null;
		$this.ToDate = null;
		$this.ClientName = null;
		$this.CustomerLegalName = null;
		$this.SalesStatus = null;
		$this.Page = 0;
		$this.PageSize = 0;
		$this.CustomerUserId = 0;
		$this.customerName = null;
		$this.storeName = null;
		$this.ProductName = null;
		$this.CurrentUserId = null;
		$this.OrderType = null;
		$this.IsReturnOrder = false;
		return $this;
	};
	$USOProject_Pages_Retail_RetailInputQuery$QueryCondition.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Pages.Retail.RetailInputQuery$QueryCondition = $USOProject_Pages_Retail_RetailInputQuery$QueryCondition;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.Add.AddFeeItem
	var $USOProject_Pages_Retail_Add_AddFeeItem = function() {
		this.OnFinished = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.retail_feelist_feedata = null;
		this.retail_feelist_amount = null;
		this.retail_feelist_remark = null;
		this.btnOK = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$AddFeeItem_OnPageInit));
	};
	$USOProject_Pages_Retail_Add_AddFeeItem.__typeName = 'USOProject.Pages.Retail.Add.AddFeeItem';
	global.USOProject.Pages.Retail.Add.AddFeeItem = $USOProject_Pages_Retail_Add_AddFeeItem;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.Add.ChooseProductDetail
	var $USOProject_Pages_Retail_Add_ChooseProductDetail = function() {
		this.PageData = null;
		this.$RedLinePrice = null;
		this.OnProductSave = null;
		this.$product = {};
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.span_retail_productdetail_pid = null;
		this.span_retail_productdetail_pname = null;
		this.span_retail_productdetail_innerprice = null;
		this.span_retail_productdetail_quantity = null;
		this.divRetailProductDetail = null;
		this.retailInput_orgList = null;
		this.input_retail_productdetail_quantity = null;
		this.input_retail_productdetail_price = null;
		this.input_retail_productdetail_commAmount = null;
		this.select_retail_productdetail_smode = null;
		this.select_retail_productdetail_nwtype = null;
		this.input_retail_productdetail_saledate = null;
		this.input_retail_productdetail_memo = null;
		this.retailInput_addGiftCardItem = null;
		this.lblFeeAmount = null;
		this.pnlFeeItems = null;
		this.btnOK = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$ChooseProductDetail_OnPageInit));
	};
	$USOProject_Pages_Retail_Add_ChooseProductDetail.__typeName = 'USOProject.Pages.Retail.Add.ChooseProductDetail';
	global.USOProject.Pages.Retail.Add.ChooseProductDetail = $USOProject_Pages_Retail_Add_ChooseProductDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.Add.ChooseProductList
	var $USOProject_Pages_Retail_Add_ChooseProductList = function() {
		this.$ParamData = null;
		this.OnProductChoosed = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.retail_productlist_searcharea = null;
		this.retail_productlist_searchinput = null;
		this.retail_productlist_searchbutton = null;
		this.divRetailProductListContainer = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$ChooseProductList_OnPageInit));
	};
	$USOProject_Pages_Retail_Add_ChooseProductList.__typeName = 'USOProject.Pages.Retail.Add.ChooseProductList';
	global.USOProject.Pages.Retail.Add.ChooseProductList = $USOProject_Pages_Retail_Add_ChooseProductList;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.Add.RetailInputAdd
	var $USOProject_Pages_Retail_Add_RetailInputAdd = function() {
		this.OnBlankOut = null;
		this.StoreData = null;
		this.InData = $CustomerSalesRestDTO.$ctor();
		this.PageState = 0;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.retailInput_ShopList = null;
		this.retailInput_OrderType = null;
		this.retailInput_customerName = null;
		this.retailInput_Sex = null;
		this.retailInput_purchaseDate = null;
		this.retailInput_teleNum = null;
		this.retailInput_fixedLineTelephone = null;
		this.btnChooseAddressArea = null;
		this.retailInput_chooseAreaButton = null;
		this.retailInput_address = null;
		this.retailInput_addProductItem = null;
		this.retailInput_productValue = null;
		this.pnlProductList = null;
		this.btnSave = null;
		this.btnModify = null;
		this.btn_retailInput_return = null;
		this.btn_retailInput_delete = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$RetailInputAdd_OnPageInit));
	};
	$USOProject_Pages_Retail_Add_RetailInputAdd.__typeName = 'USOProject.Pages.Retail.Add.RetailInputAdd';
	global.USOProject.Pages.Retail.Add.RetailInputAdd = $USOProject_Pages_Retail_Add_RetailInputAdd;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.Add.RetailInputAdd.State
	var $USOProject_Pages_Retail_Add_RetailInputAdd$State = function() {
	};
	$USOProject_Pages_Retail_Add_RetailInputAdd$State.__typeName = 'USOProject.Pages.Retail.Add.RetailInputAdd$State';
	global.USOProject.Pages.Retail.Add.RetailInputAdd$State = $USOProject_Pages_Retail_Add_RetailInputAdd$State;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.Add.RetailReturnData
	var $USOProject_Pages_Retail_Add_RetailReturnData = function() {
	};
	$USOProject_Pages_Retail_Add_RetailReturnData.__typeName = 'USOProject.Pages.Retail.Add.RetailReturnData';
	$USOProject_Pages_Retail_Add_RetailReturnData.createInstance = function() {
		return $USOProject_Pages_Retail_Add_RetailReturnData.$ctor();
	};
	$USOProject_Pages_Retail_Add_RetailReturnData.$ctor = function() {
		var $this = {};
		$this.showRetailInputDetailNavLink = false;
		$this.saleId = 0;
		$this.returnId = 0;
		$this.Mode = 'View';
		return $this;
	};
	$USOProject_Pages_Retail_Add_RetailReturnData.isInstanceOfType = function() {
		return true;
	};
	global.USOProject.Pages.Retail.Add.RetailReturnData = $USOProject_Pages_Retail_Add_RetailReturnData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.Add.RetailReturnPage
	var $USOProject_Pages_Retail_Add_RetailReturnPage = function() {
		this.OnDrop = null;
		this.PageParam = null;
		this.retailData = null;
		this.returnData = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.btnModify = null;
		this.btnCancel = null;
		this.pnlContent = null;
		this.lblCustomerName = null;
		this.lblBuyDate = null;
		this.pnlReturnList = null;
		this.btnSave = null;
		this.btnDrop = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$RetailReturnPage_OnPageInit));
	};
	$USOProject_Pages_Retail_Add_RetailReturnPage.__typeName = 'USOProject.Pages.Retail.Add.RetailReturnPage';
	global.USOProject.Pages.Retail.Add.RetailReturnPage = $USOProject_Pages_Retail_Add_RetailReturnPage;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Retail.Return.RetailInputReturnDetail
	var $USOProject_Pages_Retail_Return_RetailInputReturnDetail = function() {
		this.btnSave = null;
		this.btnDrop = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$RetailInputReturnDetail_OnPageInit));
	};
	$USOProject_Pages_Retail_Return_RetailInputReturnDetail.__typeName = 'USOProject.Pages.Retail.Return.RetailInputReturnDetail';
	global.USOProject.Pages.Retail.Return.RetailInputReturnDetail = $USOProject_Pages_Retail_Return_RetailInputReturnDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Spec.SpecAuditAction
	var $USOProject_Pages_Spec_SpecAuditAction = function() {
		this.IsSpecAuditFinished = null;
		this.$Data = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.spec_audit_action_specialNum = null;
		this.spec_audit_action_specialName = null;
		this.spec_audit_action_createName = null;
		this.pnlNextUsers = null;
		this.spec_audit_action_nextUserId = null;
		this.pnlAuditOptions = null;
		this.chkBack = null;
		this.spec_audit_action_productType = null;
		this.spec_audit_action_apportionOrg = null;
		this.spec_audit_action_remark = null;
		this.btnAudit = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$SpecAuditAction_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$SpecAuditAction_OnPageShow));
	};
	$USOProject_Pages_Spec_SpecAuditAction.__typeName = 'USOProject.Pages.Spec.SpecAuditAction';
	global.USOProject.Pages.Spec.SpecAuditAction = $USOProject_Pages_Spec_SpecAuditAction;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Spec.SpecAuditAction.SpecAuditActionData
	var $USOProject_Pages_Spec_SpecAuditAction$SpecAuditActionData = function() {
		this.SpecId = 0;
		this.SpecItems = null;
	};
	$USOProject_Pages_Spec_SpecAuditAction$SpecAuditActionData.__typeName = 'USOProject.Pages.Spec.SpecAuditAction$SpecAuditActionData';
	global.USOProject.Pages.Spec.SpecAuditAction$SpecAuditActionData = $USOProject_Pages_Spec_SpecAuditAction$SpecAuditActionData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Spec.SpecDetail
	var $USOProject_Pages_Spec_SpecDetail = function() {
		this.ModelData = null;
		this.IsSpecAuditFinished = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.btn_spec_audit = null;
		this.ulSpecDetail = null;
		this.spec_detail_specialNum = null;
		this.spec_detail_specialName = null;
		this.spec_detail_specialTypeName = null;
		this.spec_detail_createName = null;
		this.spec_detail_createOnFormart = null;
		this.spec_detail_vaildTimeFormmart = null;
		this.spec_detail_vaildTimeToFormart = null;
		this.li_spec_audit_proc_track = null;
		this.spec_detail_customerName = null;
		this.spec_detail_saleChannelName = null;
		this.spec_detail_apportionOrgName = null;
		this.spec_detail_organizationName = null;
		this.spec_detail_memo = null;
		this.spec_detail_productlist = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$SpecDetail_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$SpecDetail_OnPageShow));
	};
	$USOProject_Pages_Spec_SpecDetail.__typeName = 'USOProject.Pages.Spec.SpecDetail';
	global.USOProject.Pages.Spec.SpecDetail = $USOProject_Pages_Spec_SpecDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Spec.SpecList
	var $USOProject_Pages_Spec_SpecList = function() {
		var $t1 = new $USOProject_Pages_Spec_SpecQuery$QueryCondition();
		var $t2 = new Date();
		$t1.FromDate = ss.formatDate(new Date($t2.getFullYear() + -1, $t2.getMonth(), $t2.getDate(), $t2.getHours(), $t2.getMinutes(), $t2.getSeconds(), $t2.getMilliseconds()), 'yyyy-MM-dd');
		$t1.ToDate = ss.formatDate(new Date(), 'yyyy-MM-dd');
		this.$pageQuery = $t1;
		this.btnBack = null;
		this.lblHeadText = null;
		this.header_search = null;
		this.pnlContent = null;
		this.spec_list_status_tab = null;
		this.ulSpecQueryListContainer = null;
		this.spec_list_more = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$SpecList_OnPageInit));
	};
	$USOProject_Pages_Spec_SpecList.__typeName = 'USOProject.Pages.Spec.SpecList';
	global.USOProject.Pages.Spec.SpecList = $USOProject_Pages_Spec_SpecList;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Spec.SpecProcTrack
	var $USOProject_Pages_Spec_SpecProcTrack = function() {
		this.processData = null;
		this.IsFinished = false;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$SpecProcTrack_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$SpecProcTrack_OnPageShow));
	};
	$USOProject_Pages_Spec_SpecProcTrack.__typeName = 'USOProject.Pages.Spec.SpecProcTrack';
	global.USOProject.Pages.Spec.SpecProcTrack = $USOProject_Pages_Spec_SpecProcTrack;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Spec.SpecProcTrack.SpecProcTrackData
	var $USOProject_Pages_Spec_SpecProcTrack$SpecProcTrackData = function() {
		this.SpecialId = 0;
		this.Status = 0;
	};
	$USOProject_Pages_Spec_SpecProcTrack$SpecProcTrackData.__typeName = 'USOProject.Pages.Spec.SpecProcTrack$SpecProcTrackData';
	global.USOProject.Pages.Spec.SpecProcTrack$SpecProcTrackData = $USOProject_Pages_Spec_SpecProcTrack$SpecProcTrackData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Spec.SpecProductDetail
	var $USOProject_Pages_Spec_SpecProductDetail = function() {
		this.OnModifyComplete = null;
		this.product = null;
		this.Index = 0;
		this.SpecialData = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.prod_detail_productNo = null;
		this.prod_detail_productmode = null;
		this.prod_detail_productbirefname = null;
		this.prod_detail_productr3code = null;
		this.prod_detail_applynum = null;
		this.prod_detail_agreenum = null;
		this.div_agreenum_title = null;
		this.div_agreenum_content = null;
		this.txt_prod_detail_auditnum = null;
		this.prod_detail_applyprice = null;
		this.prod_detail_agreeprice = null;
		this.div_agreeprice_title = null;
		this.div_agreeprice_content = null;
		this.txt_prod_detail_auditprice = null;
		this.prod_detail_applycoreprice = null;
		this.div_agreecoreprice_title = null;
		this.div_agreecoreprice_content = null;
		this.txt_prod_detail_auditcoreprice = null;
		this.prod_detail_nowprice = null;
		this.prod_detail_internalaccountprice = null;
		this.prod_detail_redlinpriceofsubcompay = null;
		this.prod_detail_discountamt = null;
		this.prod_detail_HaveRoyalties = null;
		this.prod_detail_havegrossprofit = null;
		this.prod_detail_status = null;
		this.prod_detail_note = null;
		this.spec_product_detail_confirm = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$SpecProductDetail_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$SpecProductDetail_OnPageShow));
	};
	$USOProject_Pages_Spec_SpecProductDetail.__typeName = 'USOProject.Pages.Spec.SpecProductDetail';
	global.USOProject.Pages.Spec.SpecProductDetail = $USOProject_Pages_Spec_SpecProductDetail;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Spec.SpecProductDetail.ResultData
	var $USOProject_Pages_Spec_SpecProductDetail$ResultData = function() {
		this.AuditCorePrice = 0;
		this.AuditNum = 0;
		this.AuditPrice = 0;
		this.HaveRoyalties = 0;
		this.HaveGrossProfit = 0;
	};
	$USOProject_Pages_Spec_SpecProductDetail$ResultData.__typeName = 'USOProject.Pages.Spec.SpecProductDetail$ResultData';
	global.USOProject.Pages.Spec.SpecProductDetail$ResultData = $USOProject_Pages_Spec_SpecProductDetail$ResultData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Spec.SpecProductDetail.SpecProductDetailData
	var $USOProject_Pages_Spec_SpecProductDetail$SpecProductDetailData = function() {
		this.Product = null;
		this.SpecialData = null;
	};
	$USOProject_Pages_Spec_SpecProductDetail$SpecProductDetailData.__typeName = 'USOProject.Pages.Spec.SpecProductDetail$SpecProductDetailData';
	global.USOProject.Pages.Spec.SpecProductDetail$SpecProductDetailData = $USOProject_Pages_Spec_SpecProductDetail$SpecProductDetailData;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Spec.SpecQuery
	var $USOProject_Pages_Spec_SpecQuery = function() {
		this.queryCondition = null;
		this.OnSearchButttonClick = null;
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.spec_txt_specid = null;
		this.spec_txt_specname = null;
		this.spec_txt_customer = null;
		this.spec_sel_spectypesearch = null;
		this.spec_search_date_beginDate = null;
		this.spec_search_date_endDate = null;
		this.spec_a_dosearch = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$SpecQuery_OnPageInit));
	};
	$USOProject_Pages_Spec_SpecQuery.__typeName = 'USOProject.Pages.Spec.SpecQuery';
	global.USOProject.Pages.Spec.SpecQuery = $USOProject_Pages_Spec_SpecQuery;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Spec.SpecQuery.QueryCondition
	var $USOProject_Pages_Spec_SpecQuery$QueryCondition = function() {
		this.SpecId = null;
		this.SpecName = null;
		this.Customer = null;
		this.Spectype = null;
		this.FromDate = null;
		this.ToDate = null;
	};
	$USOProject_Pages_Spec_SpecQuery$QueryCondition.__typeName = 'USOProject.Pages.Spec.SpecQuery$QueryCondition';
	global.USOProject.Pages.Spec.SpecQuery$QueryCondition = $USOProject_Pages_Spec_SpecQuery$QueryCondition;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.SystemModule.ModifyPassword
	var $USOProject_Pages_SystemModule_ModifyPassword = function() {
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.txtCurPassword = null;
		this.txtNewPassword = null;
		this.txtReNewPassword = null;
		this.btnSubmit = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$ModifyPassword_OnPageInit));
	};
	$USOProject_Pages_SystemModule_ModifyPassword.__typeName = 'USOProject.Pages.SystemModule.ModifyPassword';
	global.USOProject.Pages.SystemModule.ModifyPassword = $USOProject_Pages_SystemModule_ModifyPassword;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.SystemModule.ModuleSettings
	var $USOProject_Pages_SystemModule_ModuleSettings = function() {
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		this.pnlModuleItems = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$ModuleSettings_OnPageInit));
		this.add_OnPageShow(ss.mkdel(this, this.$ModuleSettings_OnPageShow));
	};
	$USOProject_Pages_SystemModule_ModuleSettings.__typeName = 'USOProject.Pages.SystemModule.ModuleSettings';
	global.USOProject.Pages.SystemModule.ModuleSettings = $USOProject_Pages_SystemModule_ModuleSettings;
	////////////////////////////////////////////////////////////////////////////////
	// USOProject.Pages.Test.TestPage
	var $USOProject_Pages_Test_TestPage = function() {
		this.btnBack = null;
		this.lblHeadText = null;
		this.pnlContent = null;
		Phone.RazorMobilePage.call(this);
		this.add_OnPageInit(ss.mkdel(this, this.$TestPage_OnPageInit));
	};
	$USOProject_Pages_Test_TestPage.__typeName = 'USOProject.Pages.Test.TestPage';
	global.USOProject.Pages.Test.TestPage = $USOProject_Pages_Test_TestPage;
	ss.initClass($App, $asm, {
		get_ServiceBase: function() {
			return ss.cast(window.ServiceAddr, String);
		},
		error$1: function(exception, context) {
		},
		error: function(message) {
			console.error(message, []);
		},
		trace: function(message) {
			console.info(message);
		},
		isForegroundTask: function(o) {
			return false;
		}
	});
	ss.initClass($AppData, $asm, {});
	ss.initClass($CustomerSalesRestDTO, $asm, {});
	ss.initClass($JuqeryObjectEx, $asm, {});
	ss.initClass($NullableExtenion, $asm, {});
	ss.initClass($RetailStatisticsCurrentUser, $asm, {});
	ss.initEnum($RetailStatisticsOrgType, $asm, { 分公司: 2, 经营部: 3, 业务经理: 4, 客户: 5, 门店: 6 });
	ss.initClass($RetailStatisticsPageData, $asm, {});
	ss.initClass($B2BProject_Business_Plugin_AppVersion, $asm, {});
	ss.initClass($JSLib_Extension_ArrayExtension, $asm, {});
	ss.initClass($USOProject_BytesBuilder, $asm, {
		AddBytes: function(byteSystemArray) {
			this.$dataArray.push(byteSystemArray);
			this.$count += byteSystemArray.length;
			return this;
		},
		AddString: function(str) {
			if (!ss.staticEquals(this.OnAddString, null)) {
				this.OnAddString(str);
			}
			if (ss.isNullOrUndefined(str)) {
				str = '';
			}
			var bytes = System.Text.Encoding.UTF8.GetBytes(str);
			bytes.push(0);
			this.AddBytes(bytes);
			return this;
		},
		AddInt: function(iv) {
			if (!ss.staticEquals(this.OnAddInt, null)) {
				this.OnAddInt(iv);
			}
			var bytes = System.BitConverter.GetBytes(iv);
			this.AddBytes(bytes);
			return this;
		},
		ToArray: function() {
			var result = new System.Byte(this.$count);
			var startI = 0;
			for (var aI = 0; aI < this.$dataArray.length; aI++) {
				System.Array.Copy(this.$dataArray[aI], 0, result, startI, this.$dataArray[aI].length);
				startI += this.$dataArray[aI].length;
			}
			return result;
		}
	});
	ss.initClass($USOProject_BytesReader, $asm, {
		GetPosition: function() {
			return this.$readI;
		},
		ReadBytes: function(n) {
			var result = this.$btArray.slice(this.$readI, this.$readI + n);
			this.$readI += n;
			return result;
		},
		ReadInt32: function() {
			var bytesResult = this.ReadBytes(4);
			var result = System.BitConverter.ToInt32(bytesResult, 0);
			return result;
		},
		getStringLength: function() {
			var startI = this.$readI;
			while (startI < this.$btArray.length) {
				if (this.$btArray[startI] === 0) {
					return startI - this.$readI;
				}
				startI++;
			}
			return startI - this.$readI;
		},
		ReadString: function() {
			var len = this.getStringLength();
			if (len === 0) {
				this.$readI++;
				return '';
			}
			else {
				var bytesResult = this.ReadBytes(len);
				var result = System.Text.Encoding.UTF8.GetString(bytesResult);
				this.$readI++;
				return result;
			}
		}
	});
	ss.initClass($USOProject_LoginInfo, $asm, {});
	ss.initClass($USOProject_MainEntry, $asm, {});
	ss.initClass($USOProject_NetWorkType, $asm, {});
	ss.initClass($USOProject_SecurityChannel, $asm, {
		handleAes2Response: function(base64Result, pRequestContext) {
			if (ss.isNullOrUndefined(base64Result) || base64Result === '0' || base64Result === '') {
				pRequestContext.handleException('Connection error!', pRequestContext);
				return;
			}
			if (base64Result === '-1') {
				pRequestContext.handleException('Api call exceed limit!', pRequestContext);
				return;
			}
			if (base64Result === '-2') {
				JSLib.Mobile.MessageBox.Alert('当前会话超时，请重新登陆！');
				try {
					//后退并释放10个页面,
					JSLib.Mobile.Application.Back(10);
				}
				catch ($t1) {
					var ex = ss.Exception.wrap($t1);
				}
				JSLib.Mobile.Application.BackTo($USOProject_Pages_LoginPage).call(null);
				return;
			}
			//undo:if base64Result == null or 0 mean exception....
			var btArray = System.Convert.FromBase64String(base64Result);
			var decodeArray1 = null;
			var decodeArray = null;
			try {
				var tokenObj = pRequestContext.tokenObj;
				decodeArray1 = ss.cast($USOProject_SecurityLayerJS.Decrypt(ss.cast(tokenObj.nextKey, Array), ss.cast(tokenObj.nextIV, Array), btArray), Array);
				decodeArray = ss.cast($USOProject_SecurityLayerJS.Decrypt(ss.cast(tokenObj.newKey, Array), ss.cast(tokenObj.newIV, Array), decodeArray1), Array);
			}
			catch ($t2) {
				var ex1 = ss.Exception.wrap($t2);
				pRequestContext.handleException(ex1, pRequestContext);
				return;
			}
			var resultReader = new $USOProject_BytesReader(decodeArray);
			var successArray = resultReader.ReadBytes(1);
			if (successArray[0] !== 1) {
				pRequestContext.handleException('call error!', pRequestContext);
				return;
			}
			var tempArray = $USOProject_SecurityChannel.readEncodingTokensCore(resultReader);
			console.info('response token Array:', tempArray);
			for (var tI = 0; tI < tempArray.length; tI++) {
				$USOProject_SecurityChannel.tokenArray.push(tempArray[tI]);
			}
			var actionBody = resultReader.ReadString();
			var position = resultReader.GetPosition();
			var infoArray = decodeArray.slice(0, position);
			var calMd5 = (new System.Security.Cryptography.MD5()).ComputeHash(infoArray);
			var returnMD5 = resultReader.ReadBytes(16);
			if (!$USOProject_SecurityChannel.IsEqual(calMd5, returnMD5)) {
				pRequestContext.handleException('Md5 not equal!', pRequestContext);
				return;
			}
			var response = { Body: actionBody };
			if (!!ss.isValue(pRequestContext.handler)) {
				pRequestContext.handler.handleResponse(response, pRequestContext);
			}
		},
		handleAes1Response: function(base64Result, requestContext) {
		},
		startTrackRequest: function(request) {
			var currentIndex = this.$ajaxCallIndex++;
			$App.app.activeAjaxRequestMap[currentIndex] = request;
			return currentIndex;
		},
		stopTrackRequest: function(index) {
			$App.app.activeAjaxRequestMap[index] = null;
		}
	});
	ss.initClass($USOProject_SecurityLayerJS, $asm, {});
	ss.initClass($USOProject_SecurityLayerJS$PersistenceData, $asm, {});
	$USOProject_SecurityLayerJS$PersistenceData.$ctor1.prototype = $USOProject_SecurityLayerJS$PersistenceData.prototype;
	ss.initClass($USOProject_SetupType, $asm, {});
	ss.initClass($USOProject_TokenObject, $asm, {});
	ss.initEnum($USOProject_Business_ActionTypeEnum, $asm, { Login: 2, ModifyPassword: 3, ManualUpgrade: 4, TestSo: 5, GeoApi: 6, CheckPersistentTokenAction: 14, QuerySpecList: 7, SpecialApprove: 8, SpecialApproveInit: 9, SpecialDetailInitAction: 10, IndexTodoWorkAction: 11, SpecialSearchInit: 46, MessageAction: 12, GetCustomerOrganizations: 21, RetailListQuery: 13, GetCustomerStoreAction: 15, RetailInputDetailQuery: 16, RetailInputAddOrUpdate: 17, RetailInputUpdateStatus: 18, RetailInputProductListAction: 19, RetailInputInit: 20, RetailInputStatistic: 22, RetailInputStatisticProduct: 23, GetProductNameList: 24, ProductQuery: 25, GetProductDetailById: 26, GetProductFilterPropertyByC3Id: 27, SpecialAuditProcTrack: 28, GetAllCategory: 29, AddProductFavorite: 30, DelProductFavorite: 31, QueryProductFavorite: 32, GetProductDetail: 39, GetPriceAction: 41, GetCustomerLegalAction: 42, GetWarehouseAcction: 43, GetProductQuantity: 44, GetProductDiscount: 45, GetProductOrg: 47, CommonMobileService: 33, DebugLogin: 32767, DebugRegisterCmd: 32766, DebugReceiveCommand: 32765, DebugSendResponse: 32764, DebugReceiveResult: 32763 });
	ss.initClass($USOProject_Business_BusinessAction, $asm, {});
	ss.initClass($USOProject_Business_CustomerLegalOrgList, $asm, {});
	ss.initClass($USOProject_Business_CustomerLegalStoreOrgDTO, $asm, {});
	ss.initEnum($USOProject_Business_CustomerWorkFlowlRangeStatusEnum, $asm, { Todo: 1, Processed: 2, All: 3 });
	ss.initClass($USOProject_Business_DataService, $asm, {});
	ss.initEnum($USOProject_Business_DataServiceErrorType, $asm, { ConnectionError: 1, ApiCallExceedLimit: 2, TokenTimeOut: 3, CallError: 4, DataMD5ValidationError: 5, DecryptError: 6 });
	ss.initClass($USOProject_Business_DescriptionAttribute, $asm, {});
	ss.initClass($USOProject_Business_FileTransferPlugin, $asm, {});
	ss.initClass($USOProject_Business_InAppUpdater, $asm, {
		Do: function() {
			var $state = 0, $t1, localAppInfo, $t2, serverVersion, $t4, $t3, $t6, $t5, downloadfileUrl, updateFileName, updateFileDir, $t7, donwnloadFile, $t8, unZipFileResult, $t10, $t9;
			var $sm = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							$t1 = this.GetLocalVersion();
							$state = 1;
							$t1.continueWith($sm);
							return;
						}
						case 1: {
							$state = -1;
							localAppInfo = $t1.getAwaitedResult();
							$t2 = this.GetServerVersion();
							$state = 2;
							$t2.continueWith($sm);
							return;
						}
						case 2: {
							$state = -1;
							serverVersion = $t2.getAwaitedResult();
							if (ss.isNullOrUndefined(serverVersion)) {
								if (localAppInfo.IsUseAppDataDir) {
									if (!(window.location.href.indexOf('update') !== -1)) {
										$t4 = window.location;
										$t3 = $USOProject_Business_InAppUpdater.GetFileURI('cdvfile://localhost/persistent/update/Resources/index.html');
										$state = 5;
										$t3.continueWith($sm);
										return;
									}
									$state = 4;
									continue $sm1;
								}
								$state = 4;
								continue $sm1;
							}
							$state = 3;
							continue $sm1;
						}
						case 5: {
							$state = -1;
							$t4.href = $t3.getAwaitedResult();
							$state = 4;
							continue $sm1;
						}
						case 4: {
							$state = -1;
							console.log('获取内部更新信息失败');
							return;
						}
						case 3: {
							$state = -1;
							if (localAppInfo.VersionCode >= serverVersion.VersionCode) {
								if (localAppInfo.IsUseAppDataDir) {
									if (!(window.location.href.indexOf('update') !== -1)) {
										$t6 = window.location;
										$t5 = $USOProject_Business_InAppUpdater.GetFileURI('cdvfile://localhost/persistent/update/Resources/index.html');
										$state = 8;
										$t5.continueWith($sm);
										return;
									}
									$state = 7;
									continue $sm1;
								}
								$state = 7;
								continue $sm1;
							}
							$state = 6;
							continue $sm1;
						}
						case 8: {
							$state = -1;
							$t6.href = $t5.getAwaitedResult();
							$state = 7;
							continue $sm1;
						}
						case 7: {
							$state = -1;
							return;
						}
						case 6: {
							$state = -1;
							downloadfileUrl = serverVersion.UpdateZipUrl;
							updateFileName = 'cdvfile://localhost/persistent/app.zip';
							updateFileDir = 'cdvfile://localhost/persistent/update/';
							JSLib.Mobile.MessageBox.Alert('正在下载数据文件!');
							$t7 = $USOProject_Business_FileTransferPlugin.DownloadFile(downloadfileUrl, updateFileName, function(event) {
								console.info(ss.formatString('下载进度:{0}/{1}', event.loaded, event.total));
							});
							$state = 9;
							$t7.continueWith($sm);
							return;
						}
						case 9: {
							$state = -1;
							donwnloadFile = $t7.getAwaitedResult();
							if (!donwnloadFile) {
								JSLib.Mobile.MessageBox.Alert('下载文件失败');
								return;
							}
							JSLib.Mobile.MessageBox.Alert('正在更新数据文件!');
							$t8 = $USOProject_Business_UnZipPlugin.UnZipFile(updateFileName, updateFileDir, function(event1) {
								console.info(ss.formatString('解压进度:{0}/{1}', event1.loaded, event1.total));
							});
							$state = 10;
							$t8.continueWith($sm);
							return;
						}
						case 10: {
							$state = -1;
							unZipFileResult = $t8.getAwaitedResult();
							if (!unZipFileResult) {
								JSLib.Mobile.MessageBox.Alert('解压文件失败');
								return;
							}
							console.log('版本更新完成!');
							$t10 = window.location;
							$t9 = $USOProject_Business_InAppUpdater.GetFileURI('cdvfile://localhost/persistent/update/Resources/index.html');
							$state = 11;
							$t9.continueWith($sm);
							return;
						}
						case 11: {
							$state = -1;
							$t10.href = $t9.getAwaitedResult();
							$state = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm();
		},
		GetServerVersion: function() {
			var tsk = new ss.TaskCompletionSource();
			var ajaxOption = {
				url: this.$checkUrl,
				success: function(data, status, request) {
					var result = data;
					tsk.setResult(result);
				},
				error: function(request1, status1, error) {
					tsk.setResult(null);
				}
			};
			$.ajax(ajaxOption);
			return tsk.task;
		},
		GetLocalVersion: function() {
			var tsk = new ss.TaskCompletionSource();
			window.setTimeout(function() {
				var $state = 0, appInfo, localVersionCode, $t1, localAppDirVersionConfigFile, $t2, $t3, localAppVersionInfo;
				var $sm = function() {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								appInfo = {};
								localVersionCode = 0;
								$t1 = $USOProject_Business_InAppUpdater.DownloadData(Object).call(null, 'VersionInfo.json');
								$state = 1;
								$t1.continueWith($sm);
								return;
							}
							case 1: {
								$state = -1;
								localVersionCode = $t1.getAwaitedResult().VersionCode;
								localAppDirVersionConfigFile = 'cdvfile://localhost/persistent/update/Resources/VersionInfo.json';
								$t2 = $USOProject_Business_InAppUpdater.GetFileURI(localAppDirVersionConfigFile);
								$state = 2;
								$t2.continueWith($sm);
								return;
							}
							case 2: {
								$state = -1;
								if (ss.isValue($t2.getAwaitedResult())) {
									appInfo.IsUseAppDataDir = true;
									$t3 = $USOProject_Business_InAppUpdater.DownloadData(Object).call(null, localAppDirVersionConfigFile);
									$state = 4;
									$t3.continueWith($sm);
									return;
								}
								$state = 3;
								continue $sm1;
							}
							case 4: {
								$state = -1;
								localAppVersionInfo = $t3.getAwaitedResult();
								if (ss.isValue(localAppVersionInfo)) {
									localVersionCode = localAppVersionInfo.VersionCode;
								}
								$state = 3;
								continue $sm1;
							}
							case 3: {
								$state = -1;
								appInfo.VersionCode = localVersionCode;
								tsk.setResult(appInfo);
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				};
				$sm();
			}, 0);
			return tsk.task;
		}
	});
	ss.initClass($USOProject_Business_IndexWorkTodoQuery, $asm, {});
	ss.initClass($USOProject_Business_JPush, $asm, {});
	ss.initClass($USOProject_Business_JPushPlugin, $asm, {});
	ss.initClass($USOProject_Business_LoadedSpecials, $asm, {});
	ss.initClass($USOProject_Business_OrganizationDTO, $asm, {});
	ss.initClass($USOProject_Business_OrganizationList, $asm, {});
	ss.initEnum($USOProject_Business_OrganizationStatus, $asm, { None: -1, Normal: 0, Invalid: 1 });
	ss.initEnum($USOProject_Business_OrganizationType, $asm, { None: -1, Parent: 0, Head: 1, Branch: 2, Department: 3, Others: 4 });
	ss.initEnum($USOProject_Business_ProjectFileStatus, $asm, { Inital: 0, 待审核: 1, 已审核: 2, SpecialAudited: 3, SpecialProcess: 5, Disuse: 9, 待订单中心审核: 6 });
	ss.initClass($USOProject_Business_R3CustomerStoreDTO, $asm, {});
	ss.initEnum($USOProject_Business_R3DistributionStatus, $asm, { None: -1, Active: 0, Freeze: 1 });
	ss.initClass($USOProject_Business_RegularExpressionAttribute, $asm, {});
	ss.initClass($USOProject_Business_RequiredAttribute, $asm, {});
	ss.initEnum($USOProject_Business_RetailInputStatRoleType, $asm, { Organization: 0, CustomerManager: 1, RetailInputor: 2 });
	ss.initClass($USOProject_Business_RetailStatisticsExtension, $asm, {});
	ss.initClass($USOProject_Business_SelectListItem, $asm, {});
	ss.initClass($USOProject_Business_SlideDirectionDetect, $asm, {
		Start: function(x, y) {
			this.$startX = x;
			this.$startY = y;
		},
		MoveDectct: function(x, y) {
			this.IsInHorizontal = Math.abs(x - this.$startX) > Math.abs(y - this.$startY);
			if (!ss.staticEquals(this.OnScrollHorizontal, null)) {
				this.OnScrollHorizontal();
			}
		},
		Stop: function() {
			this.IsInHorizontal = false;
			this.$startX = 0;
			this.$startY = 0;
		}
	});
	ss.initClass($USOProject_Business_SlideList, $asm, {
		$BindEvent: function() {
			this.$_detector = new $USOProject_Business_SlideDirectionDetect();
			this.$container.on('touchstart', ss.thisFix(ss.mkdel(this, this.$OnTouchStart)));
			this.$container.on('touchmove', ss.thisFix(ss.mkdel(this, this.$OnTouchMove)));
			this.$container.on('touchend touchcancel', ss.thisFix(ss.mkdel(this, this.$OnTouchEnd)));
		},
		$OnTouchStart: function(elem, event) {
			//点击了面板区
			if ($(event.target).is(this.$slideActionSelector)) {
				this.$lastExpandListitem.set_IsExpand(false);
				this.$lastExpandListitem = null;
				return;
			}
			//有展开项
			if (ss.isValue(this.$lastExpandListitem)) {
				this.$lastExpandListitem.set_IsExpand(false);
				this.$lastExpandListitem.PosRightWithAnimate(0);
				this.$lastExpandListitem = null;
				event.preventDefault();
				event.stopPropagation();
				return;
			}
			this.$curListItem = new $USOProject_Business_SlideList$CurListItem($(event.target).parents(this.$listItemSelector), this.itemContentSelector, this.$slideActionSelector);
			this.$startX = event.originalEvent.touches[0].clientX;
			var startY = event.originalEvent.touches[0].clientY;
			this.$_detector.Stop();
			this.$_detector.Start(this.$startX, startY);
			this.$slidMaxWidth = this.$curListItem.MaxSlideWidth;
		},
		$OnTouchMove: function(elem, event) {
			if (ss.isValue(this.$curListItem)) {
				this.$curX = event.originalEvent.touches[0].clientX;
				var curY = event.originalEvent.touches[0].clientY;
				var deltaX = this.$startX - this.$curX;
				//未展开状态
				if (!this.$curListItem.get_IsExpand()) {
					this.$_detector.MoveDectct(this.$curX, curY);
					if (this.$_detector.IsInHorizontal) {
						event.preventDefault();
						event.stopPropagation();
						event.stopImmediatePropagation();
					}
					else {
						this.$curListItem.PosRight(0);
						this.$curListItem = null;
						return;
					}
					//向右滑，则不处理
					if (deltaX < 0) {
					}
					else if (deltaX <= this.$slidMaxWidth) {
						this.$curListItem.PosRight(deltaX);
					}
					else if (deltaX > this.$slidMaxWidth) {
						this.$curListItem.PosRight(this.$slidMaxWidth + (deltaX - this.$slidMaxWidth) * 0.2);
					}
				}
				else {
					event.preventDefault();
					event.stopPropagation();
					event.stopImmediatePropagation();
					//向左滑，不处理
					if (deltaX > 0) {
					}
					else if (Math.abs(deltaX) < this.$slidMaxWidth) {
						this.$curListItem.PosRight(this.$slidMaxWidth - Math.abs(deltaX));
					}
					else {
						this.$curListItem.PosRight(0);
					}
				}
			}
		},
		$OnTouchEnd: function(elem, event) {
			this.$_detector.Stop();
			if (ss.isValue(this.$curListItem)) {
				this.$endX = event.originalEvent.changedTouches[0].clientX;
				var deltaX = this.$startX - this.$endX;
				this.$PosEnd(deltaX);
				this.$EmptyData();
			}
		},
		$PosEnd: function(deltaX) {
			//未展开状态
			if (!this.$curListItem.get_IsExpand()) {
				//向右滑 或者向左滑不足面板一半
				if (deltaX < 0 || deltaX < ss.Int32.div(this.$slidMaxWidth, 2)) {
					this.$curListItem.PosRightWithAnimate(0);
					this.$curListItem.set_IsExpand(false);
				}
				else {
					this.$curListItem.PosRightWithAnimate(this.$slidMaxWidth);
					this.$curListItem.set_IsExpand(true);
					this.$lastExpandListitem = this.$curListItem;
				}
			}
			else {
				//向左滑 或 右滑距离不足一半
				if (deltaX > 0 || Math.abs(deltaX) < ss.Int32.div(this.$slidMaxWidth, 2)) {
					this.$curListItem.PosRightWithAnimate(this.$slidMaxWidth);
					this.$curListItem.set_IsExpand(true);
					this.$lastExpandListitem = this.$curListItem;
				}
				else {
					this.$curListItem.PosRightWithAnimate(0);
					this.$curListItem.set_IsExpand(false);
				}
			}
		},
		$EmptyData: function() {
			this.$curListItem = null;
			this.$startX = 0;
			this.$curX = 0;
			this.$endX = 0;
			this.$slidMaxWidth = 0;
		},
		dispose: function() {
			this.$container.off('touchstart', ss.thisFix(ss.mkdel(this, this.$OnTouchStart)));
			this.$container.off('touchmove', ss.thisFix(ss.mkdel(this, this.$OnTouchMove)));
			this.$container.off('touchend touchcancel', ss.thisFix(ss.mkdel(this, this.$OnTouchEnd)));
			this.$_detector.Stop();
		}
	}, null, [ss.IDisposable]);
	ss.initClass($USOProject_Business_SlideList$CurListItem, $asm, {
		get_IsExpand: function() {
			return this.$curListItemDom.data('state') === 'expand';
		},
		set_IsExpand: function(value) {
			this.$curListItemDom.data('state', (value ? 'expand' : ''));
		},
		PosRight: function(posValue) {
			this.$curItemContentDom[0].style.right = posValue + 'px';
		},
		PosRightWithAnimate: function(posValue) {
			this.$curItemContentDom.animate(ss.mkdict(['right', posValue]), 100);
		},
		equals: function(o) {
			if (ss.isInstanceOfType(o, $USOProject_Business_SlideList$CurListItem)) {
				return this.$curListItemDom.index() === o.$curListItemDom.index();
			}
			return this === o;
		}
	});
	ss.initClass($USOProject_Business_SpecialAuditActionViewModel, $asm, {});
	ss.initClass($USOProject_Business_SpecialAuditItemViewModel, $asm, {});
	ss.initClass($USOProject_Business_SpecialAuditResult, $asm, {});
	ss.initClass($USOProject_Business_SpecialAuditViewModel, $asm, {});
	ss.initClass($USOProject_Business_SpecialListDto, $asm, {});
	ss.initEnum($USOProject_Business_SpecialType, $asm, { General: 0, Engineer: 1, Back: 2, NormalBuy: 3, NormalBack: 4, Buying: 5, BuyingBack: 6, MeiLingNormal: 7, MeiLingBatch: 8, MeilingPrototype: 9, MeilingConsignment: 10, MeiLingEngineer: 11, MeiLingBack: 12, MultimediaWhite: 13, Ds: 14, DsBack: 15, Relation: 16, KtEngineer: 17, KtRelationBuy: 18, DmtBuying: 19, OblRelationBuy: 20, OblEngineer: 21, OblBack: 22, MultimediaBrokenScreen: 23, KtGeneralDelivery: 25, MeilingPrototypeOutSale: 26, MeilingRelationBuy: 27 });
	ss.initEnum($USOProject_Business_SpecialWorkFlowStatus, $asm, { Cancel: -9, Initial: 0, InProcess: 1, Finish: 2 });
	ss.initClass($USOProject_Business_SpecQueryCondtion, $asm, {});
	ss.initClass($USOProject_Business_SystemProductCompanyDTO, $asm, {});
	ss.initClass($USOProject_Business_ToDoWorkDto, $asm, {});
	ss.initClass($USOProject_Business_TodoWorkDtoModel, $asm, {});
	ss.initClass($USOProject_Business_UnZipPlugin, $asm, {});
	ss.initClass($USOProject_Business_UpgradeInfo, $asm, {});
	ss.initClass($USOProject_Business_UserData, $asm, {});
	ss.initClass($USOProject_Business_UserInfo, $asm, {});
	ss.initEnum($USOProject_Business_WorkFlowActionProcessType, $asm, { None: -1, PC: 0, Mobile: 1 });
	ss.initClass($USOProject_Business_WorkFlowProcTrackDTO, $asm, {});
	ss.initClass($USOProject_Business_WorkFlowStep, $asm, {});
	ss.initClass($USOProject_Business_Model_ImageInfo, $asm, {});
	ss.initEnum($USOProject_Business_Model_ImageInfoType, $asm, { LIST: 1, DETAIL: 2, FAVORITE: 3 });
	ss.initEnum($USOProject_Business_Retail_CustomerSalesStatus, $asm, { Initial: 1, Review: 2, BlankOut: 3, Audit: 4, AuditNoPass: 5, Draft: 6 });
	ss.initEnum($USOProject_Business_Retail_CustomerSaleType, $asm, { CustomerLegal: 1, CustomerRetail: 2, MobileCustomerRetail: 3 });
	ss.initEnum($USOProject_Business_Retail_ProductBomVaild, $asm, { Yes: 1, No: 0 });
	ss.initClass($USOProject_Business_Retail_RetailInputSimpleQuery, $asm, {});
	ss.initClass($USOProject_Business_Retail_RetailInputStatisticQuery, $asm, {});
	ss.initClass($USOProject_Business_ToCompletion_PermissionManager, $asm, {});
	ss.initEnum($USOProject_Business_ToCompletion_PermissionType, $asm, { SpecialApprovalQueryListBasic: 0, CreateSpecialBasic: 1, ProductEntry: 2, RetailInputEnrty: 3, ShowSpecialWorkFlowBasic: 4, UnprocessSpecialBasic: 5, ViewRetailInputStatBasic: 6, SpecialPrewBasic: 7, SpecialApprovalEntry: 8, AddSpecialProductBasic: 9, AuditSpecialBasic: 10, SpecialListBasic: 11, ShowApplyCorePriceBasic: 12, EditSpecialBasic: 13, AdjustApplyAuditEntry: 14, ProjectFileOrderCenterAuditEntry: 15, AuditOtherOrgOrderBasic: 16, ExcludeSaleCheckSoListEntry: 17, WeiHuoAuditBasic: 18, WaitConfirmOrderListBasic: 19, WaitConfirmCreditOrderListBasic: 20, Speical_WeiHuo_WaitOrderApproveEntry: 21 });
	ss.initClass($USOProject_Business_ToCompletion_PermissionTypeEx, $asm, {});
	ss.initClass($USOProject_Business_ToCompletion_PermmissionModule, $asm, {});
	ss.initClass($USOProject_Pages_HomePage, $asm, {
		$HomePage_OnPageShow: function(sender, e) {
		},
		$HomePage_OnPageInit: function(sender, e) {
			var $state = 0, contentContainer, myWorkControl, $t1, $t2, $t3, $t4, $t5;
			var $sm = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							$App.RecoredTimeDiff();
							contentContainer = JSLib.Controller.Panel.FromElement(this.pnlContent[0]);
							myWorkControl = new $USOProject_Pages_Control_MyWorkControl();
							$t1 = contentContainer.AddChild(myWorkControl, false, true, this);
							$state = 1;
							$t1.continueWith($sm);
							return;
						}
						case 1: {
							$state = -1;
							$t1.getAwaitedResult();
							$t2 = contentContainer.AddChild(new $USOProject_Pages_Control_AppCenterControl(), false, true, this);
							$state = 2;
							$t2.continueWith($sm);
							return;
						}
						case 2: {
							$state = -1;
							$t2.getAwaitedResult();
							$t3 = contentContainer.AddChild(new $USOProject_Pages_Control_PersonalCenterControl(), false, true, this);
							$state = 3;
							$t3.continueWith($sm);
							return;
						}
						case 3: {
							$state = -1;
							$t3.getAwaitedResult();
							$t4 = contentContainer.AddChild(new $USOProject_Pages_Control_ViewMoreControl(), false, true, this);
							$state = 4;
							$t4.continueWith($sm);
							return;
						}
						case 4: {
							$state = -1;
							$t4.getAwaitedResult();
							//_scroller = this.SetScrollable(pnlContent[0], true, true, false);
							//导航点击事件
							this.defaultNav.on('click', 'a.nav_org', ss.thisFix(ss.mkdel(this, function(elem, event) {
								var target = $(elem);
								target.addClass('pressed').siblings().removeClass('pressed');
								this.pnlContent.children().hide();
								$(this.pnlContent.children()[target.index()]).show();
								contentContainer.GetChild(target.index()).Show();
								this.lblHeadText.text(target.attr('data-title'));
							})));
							$t5 = ss.Task.delay(500);
							$state = 5;
							$t5.continueWith($sm);
							return;
						}
						case 5: {
							$state = -1;
							$t5.getAwaitedResult();
							this.a_work.click();
							$state = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm();
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="HomePage">\n    <div class="head">\n        <div id="btnBack" class="backButton"></div>\n        <div id="lblHeadText" class="headText">长虹营销业务平台</div>\n    </div>\n    <div class="content" id="pnlContent">\n    </div>\n    <div style="border-width: 1px 0px 0px 0px; -webkit-border-image: url(\'img/border.png\') 2 0 stretch;">\n        <div id="navbar" style="margin-top: 1px; display: block; background-color: rgb(255, 255, 255);" class="footer">\n            <footer id="defaultNav">\n                <a id="a_work" data-id="MyWork" data-title="我的工作" data-transition="slide" class="nav_org pressed" data-ignore-pressed="true" data-resethistory="true">\n                    <div id="nav_work" class="div_org">我的工作<span id="spanWorksCount" class="af-badge lr" style="display: none;"></span></div>\n                </a>\n                <a id="a_appcenter" data-id="AppCenter" data-title="应用中心" class="nav_org">\n                    <div id="nav_appcenter" class="div_org">应用中心</div>\n                </a>\n                <a id="a_pers" data-id="PersonalCenter" data-title="个人中心" class="nav_org">\n                    <div id="nav_pers" class="div_org">个人中心</div>\n                </a>\n                <a id="a_more" data-id="ViewMore" data-title="查看更多" class="nav_org">\n                    <div id="nav_more" class="div_org">查看更多</div>\n                </a>\n            </footer>\n        </div>\n    </div>\n</div>');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.navbar = this.pageObject.find('#navbar');
			this.defaultNav = this.pageObject.find('#defaultNav');
			this.a_work = this.pageObject.find('#a_work');
			this.nav_work = this.pageObject.find('#nav_work');
			this.spanWorksCount = this.pageObject.find('#spanWorksCount');
			this.a_appcenter = this.pageObject.find('#a_appcenter');
			this.nav_appcenter = this.pageObject.find('#nav_appcenter');
			this.a_pers = this.pageObject.find('#a_pers');
			this.nav_pers = this.pageObject.find('#nav_pers');
			this.a_more = this.pageObject.find('#a_more');
			this.nav_more = this.pageObject.find('#nav_more');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.navbar)) {
				this.navbar.unbind().off();
				this.navbar = null;
			}
			if (ss.isValue(this.defaultNav)) {
				this.defaultNav.unbind().off();
				this.defaultNav = null;
			}
			if (ss.isValue(this.a_work)) {
				this.a_work.unbind().off();
				this.a_work = null;
			}
			if (ss.isValue(this.nav_work)) {
				this.nav_work.unbind().off();
				this.nav_work = null;
			}
			if (ss.isValue(this.spanWorksCount)) {
				this.spanWorksCount.unbind().off();
				this.spanWorksCount = null;
			}
			if (ss.isValue(this.a_appcenter)) {
				this.a_appcenter.unbind().off();
				this.a_appcenter = null;
			}
			if (ss.isValue(this.nav_appcenter)) {
				this.nav_appcenter.unbind().off();
				this.nav_appcenter = null;
			}
			if (ss.isValue(this.a_pers)) {
				this.a_pers.unbind().off();
				this.a_pers = null;
			}
			if (ss.isValue(this.nav_pers)) {
				this.nav_pers.unbind().off();
				this.nav_pers = null;
			}
			if (ss.isValue(this.a_more)) {
				this.a_more.unbind().off();
				this.a_more = null;
			}
			if (ss.isValue(this.nav_more)) {
				this.nav_more.unbind().off();
				this.nav_more = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_LoginPage, $asm, {
		$LoginPage_OnPageShow: function(sender, e) {
		},
		$LoginPage_OnPageInit: function(sender, e) {
			var $state2 = 0, $t6, serverInfo, bodyContainer, upgradeController, $t8, $t9, autoLoginResult;
			var $sm2 = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state2) {
						case 0: {
							$state2 = -1;
							this.btn_log.click(ss.mkdel(this, function(event) {
								var $state = 0, isRemberLogin, $t1, loginInfo, tokenObj, $t2, $t3, result, dataResult, $t4;
								var $sm = ss.mkdel(this, function() {
									$sm1:
									for (;;) {
										switch ($state) {
											case 0: {
												$state = -1;
												isRemberLogin = this.cbRemberLogin.hasClass('active');
												$t1 = new $USOProject_LoginInfo();
												$t1.UserName = this.loginUserName.val();
												$t1.Password = this.loginPassword.val();
												$t1.ValidationCode = this.loginValidationCode.val();
												$t1.IsRemberLogin = isRemberLogin;
												loginInfo = $t1;
												if (!this.checkInput(loginInfo)) {
													return;
												}
												tokenObj = $USOProject_SecurityChannel.GetTokenObject();
												if (ss.isNullOrUndefined(tokenObj)) {
													$t2 = $USOProject_Pages_TokenInitilzer.TokenInit();
													$state = 2;
													$t2.continueWith($sm);
													return;
												}
												$state = 1;
												continue $sm1;
											}
											case 2: {
												$state = -1;
												$t2.getAwaitedResult();
												$state = 1;
												continue $sm1;
											}
											case 1: {
												$state = -1;
												$t3 = $USOProject_Business_BusinessAction.Login(loginInfo.UserName, loginInfo.Password, loginInfo.ValidationCode, loginInfo.IsRemberLogin, this);
												$state = 3;
												$t3.continueWith($sm);
												return;
											}
											case 3: {
												$state = -1;
												result = $t3.getAwaitedResult();
												if (result.IsSuccess) {
													dataResult = result;
													$App.app.userInfo = dataResult.User;
													$App.app.permissions = dataResult.Permissions;
													$App.app.config = dataResult.Config;
													$App.LoginResult = dataResult;
													if (isRemberLogin) {
														$t4 = new $USOProject_SecurityLayerJS$PersistenceData();
														$t4.token = dataResult.PersistentToken;
														$t4.userID = $App.app.userInfo.User.Id;
														$t4.serverDate = dataResult.PersistentDate;
														$USOProject_SecurityLayerJS.SavePersistentToken($t4);
													}
													this.$showValidationCode = false;
													$App.initCurrentOrgID();
													$AppData.SetUserData(dataResult.User);
													//是否是弱口令
													if (result.IsPasswordValidated) {
														JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_HomePage).call(null, null, null);
													}
													else {
														JSLib.Mobile.MessageBox.Alert(result.Error);
														JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_SystemModule_ModifyPassword).call(null, null, null);
													}
												}
												else {
													JSLib.Mobile.MessageBox.Alert((ss.isNullOrEmptyString(result.Error) ? '访问超时！' : result.Error));
													if (result.IsShowValidationCode) {
														this.divLoginValidationCode.show();
														this.validationCodeImg.attr('src', $App.app.get_ServiceBase() + 'GetValidationImage/' + result.ImageToken + '_' + ss.Guid.newGuid());
													}
													$App.app.userInfo = null;
													$USOProject_SecurityLayerJS.RemovePersistentToken();
													this.initDoLogin();
												}
												$state = -1;
												break $sm1;
											}
											default: {
												break $sm1;
											}
										}
									}
								});
								$sm();
							}));
							$t6 = $USOProject_Pages_TokenInitilzer.TokenInit();
							$state2 = 1;
							$t6.continueWith($sm2);
							return;
						}
						case 1: {
							$state2 = -1;
							serverInfo = $t6.getAwaitedResult();
							if (JSLib.Mobile.Application.DeviceType === 10) {
								//检查版本更新
								if ($USOProject_Pages_Control_UpgradeTipController.CheckShouldUpdate(serverInfo.strongV.version) || $USOProject_Pages_Control_UpgradeTipController.CheckShouldUpdate(serverInfo.weakV.version)) {
									bodyContainer = JSLib.Controller.Panel.FromElement(document.body);
									upgradeController = new $USOProject_Pages_Control_UpgradeTipController(serverInfo);
									upgradeController.UpgradeCancel = function() {
										var $state1 = 0;
										var $sm1 = function() {
											$sm1:
											for (;;) {
												switch ($state1) {
													case 0: {
														$state1 = -1;
														bodyContainer.RemoveChild();
														$state1 = -1;
														break $sm1;
													}
													default: {
														break $sm1;
													}
												}
											}
										};
										$sm1();
									};
									$t8 = bodyContainer.AddChild(upgradeController, true, false, null);
									$state2 = 3;
									$t8.continueWith($sm2);
									return;
								}
								$state2 = 2;
								continue $sm1;
							}
							$state2 = 2;
							continue $sm1;
						}
						case 3: {
							$state2 = -1;
							$t8.getAwaitedResult();
							$state2 = 2;
							continue $sm1;
						}
						case 2: {
							$state2 = -1;
							$t9 = $USOProject_Pages_LoginPage.AutoLogin();
							$state2 = 4;
							$t9.continueWith($sm2);
							return;
						}
						case 4: {
							$state2 = -1;
							autoLoginResult = $t9.getAwaitedResult();
							if (autoLoginResult) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_HomePage).call(null, null, null);
							}
							this.initDoLogin();
							$state2 = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm2();
		},
		initDoLogin: function() {
			this.div_login.show();
			this.btn_log.show();
			this.sanjiaoxing.show();
			this.divRemberLogin.show();
		},
		checkInput: function(loginInfo) {
			if (ss.isNullOrUndefined(loginInfo.UserName) || loginInfo.UserName.length <= 0) {
				JSLib.Mobile.MessageBox.Alert('请输入用户名！');
				return false;
			}
			if (ss.isNullOrUndefined(loginInfo.Password) || loginInfo.Password.length <= 0) {
				JSLib.Mobile.MessageBox.Alert('请输入密码！');
				return false;
			}
			if (this.$showValidationCode) {
				if (ss.isNullOrUndefined(loginInfo.ValidationCode) || loginInfo.ValidationCode.length <= 0) {
					JSLib.Mobile.MessageBox.Alert('请输入验证码！');
					return false;
				}
			}
			return true;
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class=\'heavy LoginPage\'>\n    <div class="content chbackground ">\n        <img id="img_title" src="img/title.png" width="270" height="56" />\n        <div id="sanjiaoxing" class="sanjiaoxing"></div>\n        <div id="div_login" class="log_win">\n            <div id="divLoginName" class="InputTop">\n                账号<input id="loginUserName" class="logininput" type="text" placeholder="输入账号" />\n            </div>\n            <div class="InputMiddle" id="divLoginPassword">\n                密码<input id="loginPassword" class="logininput" type="password" placeholder="输入密码" />\n            </div>\n            <div class="InputBottom" id="divLoginValidationCode" style="display: none;">\n                验证码\n                <input id="loginValidationCode" class="logininput" type="text" style="margin-left: 3px;width: 50px;" placeholder="验证码">\n                <img id="validationCodeImg" style="width: 95px;vertical-align: middle;">\n            </div>\n        </div>\n        <div id="divRemberLogin">\n            <span class="chkBox" id="cbRemberLogin">记住登录状态</span>\n        </div>\n        <button id="btn_log" class="btn_log">登录 ');
			this.Write(window.AppNameEx);
			this.WriteLiteral('</button>\r\n        <div id="divLoginContent_Detail">COPYRIGHT2013 BY 长虹集团股份有限公司.ALL RIGHT RESERVED</div>\r\n    </div>\r\n</div>\r\n');
		},
		InitialComponent: function() {
			this.img_title = this.pageObject.find('#img_title');
			this.sanjiaoxing = this.pageObject.find('#sanjiaoxing');
			this.div_login = this.pageObject.find('#div_login');
			this.divLoginName = this.pageObject.find('#divLoginName');
			this.loginUserName = this.pageObject.find('#loginUserName');
			this.divLoginPassword = this.pageObject.find('#divLoginPassword');
			this.loginPassword = this.pageObject.find('#loginPassword');
			this.divLoginValidationCode = this.pageObject.find('#divLoginValidationCode');
			this.loginValidationCode = this.pageObject.find('#loginValidationCode');
			this.validationCodeImg = this.pageObject.find('#validationCodeImg');
			this.divRemberLogin = this.pageObject.find('#divRemberLogin');
			this.cbRemberLogin = this.pageObject.find('#cbRemberLogin');
			this.btn_log = this.pageObject.find('#btn_log');
			this.divLoginContent_Detail = this.pageObject.find('#divLoginContent_Detail');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.img_title)) {
				this.img_title.unbind().off();
				this.img_title = null;
			}
			if (ss.isValue(this.sanjiaoxing)) {
				this.sanjiaoxing.unbind().off();
				this.sanjiaoxing = null;
			}
			if (ss.isValue(this.div_login)) {
				this.div_login.unbind().off();
				this.div_login = null;
			}
			if (ss.isValue(this.divLoginName)) {
				this.divLoginName.unbind().off();
				this.divLoginName = null;
			}
			if (ss.isValue(this.loginUserName)) {
				this.loginUserName.unbind().off();
				this.loginUserName = null;
			}
			if (ss.isValue(this.divLoginPassword)) {
				this.divLoginPassword.unbind().off();
				this.divLoginPassword = null;
			}
			if (ss.isValue(this.loginPassword)) {
				this.loginPassword.unbind().off();
				this.loginPassword = null;
			}
			if (ss.isValue(this.divLoginValidationCode)) {
				this.divLoginValidationCode.unbind().off();
				this.divLoginValidationCode = null;
			}
			if (ss.isValue(this.loginValidationCode)) {
				this.loginValidationCode.unbind().off();
				this.loginValidationCode = null;
			}
			if (ss.isValue(this.validationCodeImg)) {
				this.validationCodeImg.unbind().off();
				this.validationCodeImg = null;
			}
			if (ss.isValue(this.divRemberLogin)) {
				this.divRemberLogin.unbind().off();
				this.divRemberLogin = null;
			}
			if (ss.isValue(this.cbRemberLogin)) {
				this.cbRemberLogin.unbind().off();
				this.cbRemberLogin = null;
			}
			if (ss.isValue(this.btn_log)) {
				this.btn_log.unbind().off();
				this.btn_log = null;
			}
			if (ss.isValue(this.divLoginContent_Detail)) {
				this.divLoginContent_Detail.unbind().off();
				this.divLoginContent_Detail = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_TokenInitilzer, $asm, {});
	ss.initClass($USOProject_Pages_ApplyAudit_ApplyAuditBasePage, $asm, {
		$ApplyAuditBasePage_OnPageInit: function(sender, e) {
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction, $asm, {
		$AdjustAuditAction_OnPageInit: function(sender, e) {
			jQueryObjectEx.SetVisible(this.pnlNextUser, this.AuditData.IsLast !== 1);
			this.btnAudit.click(ss.mkdel(this, function(event) {
				var $state = 0, chkStatus, $t1, result;
				var $sm = ss.mkdel(this, function() {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								chkStatus = this.pnlAuditOptions.find('.chkBox.active');
								if (chkStatus.length === 0) {
									JSLib.Mobile.MessageBox.Alert('请选择处理状态!');
									return;
								}
								this.AuditData.Status = CoreEx.ToInt(chkStatus.attr('data-value'), 0);
								this.AuditData.Note = this.txtRemark.val();
								this.AuditData.ReturnNote = this.txtReturnRemark.val();
								this.AuditData.AdjustNote = this.txtAdjustRemark.val();
								this.AuditData.NextUserId = CoreEx.ToInt(this.selNextStepUser.val(), 0);
								this.AuditData.ApplyId = this.ApplyId;
								$t1 = $USOProject_Business_BusinessAction.AdjustApply_DoAudit(this.AuditData, this, true);
								$state = 1;
								$t1.continueWith($sm);
								return;
							}
							case 1: {
								$state = -1;
								result = $t1.getAwaitedResult();
								if (!result.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
									return;
								}
								JSLib.Mobile.MessageBox.Alert('审核成功!');
								$USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction.IsAuditComplete = true;
								JSLib.Mobile.Application.BackTo($USOProject_Pages_HomePage).call(null);
								$USOProject_Pages_Control_MyWorkControl.TriggerTodoWorkChange();
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				});
				$sm();
			}));
		},
		PrepareData: function() {
			var $state = 0, $tcs = new ss.TaskCompletionSource(), param;
			var $sm = ss.mkdel(this, function() {
				try {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								// 此处不能进行耗时操作
								//DataServiceResult<AdjustAuditActionViewModel> data = await BusinessAction.AdjustApply_InitAudit(this.InitialData.As<int>(), this);
								//if (!data.IsSuccess)
								//{
								//    MessageBox.Alert(data.ErrorMessage);
								//    await Task.Delay(1000);
								//    Application.Back();
								//}
								//AuditData = data.Result;
								param = this.InitialData;
								this.AuditData = param.data;
								this.ApplyId = param.id;
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
					$tcs.setResult(null);
				}
				catch ($t1) {
					$tcs.setException(ss.Exception.wrap($t1));
				}
			});
			$sm();
			return $tcs.task;
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="AdjustAuditAction">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">调帐审核</div>\n    </div>\n    <div class="content scroll" id="pnlContent">\n        <div class="AuditDetailSeg">\n            <div class="row" id="pnlNextUser">\n                <div class="name">下步审核人:</div>\n                <div class="value">\n                    <select id="selNextStepUser">\n');
			for (var $t1 = 0; $t1 < this.AuditData.NextUsers.length; $t1++) {
				var item = this.AuditData.NextUsers[$t1];
				var selectedStr = '';
				if (item.Selected) {
					selectedStr = "selected='selected'";
				}
				this.WriteLiteral('                            <option value="');
				this.Write(item.Value);
				this.WriteLiteral('" ');
				this.Write(selectedStr);
				this.WriteLiteral('>');
				this.Write(item.Text);
				this.WriteLiteral('</option>\r\n');
			}
			this.WriteLiteral('                    </select>\n                </div>\n            </div>\n            <div class="row">\n                <div class="name">处理状态:</div>\n                <div class="value">\n                    <div class="radioPanel" id="pnlAuditOptions">\n                        <span class="chkBox" data-value="1">确认</span>\n                        <span class="chkBox" data-value="0" id="chkBack">退回</span>\n                    </div>\n                </div>\n            </div>\n\n            <div class="row">\n                <div class="name">备注:</div>\n                <div class="value">\n                    <input type="text" id="txtRemark" placeholder="备注" value="');
			this.Write(this.AuditData.Note);
			this.WriteLiteral('" />\r\n                </div>\r\n            </div>\r\n            <div class="row">\r\n                <div class="name">调出备注:</div>\r\n                <div class="value">\r\n                    <input type="text" id="txtReturnRemark" value="');
			this.Write(this.AuditData.ReturnNote);
			this.WriteLiteral('" />\r\n                </div>\r\n            </div>\r\n            <div class="row">\r\n                <div class="name">调入备注:</div>\r\n                <div class="value">\r\n                    <input type="text" id="txtAdjustRemark" value="');
			this.Write(this.AuditData.AdjustNote);
			this.WriteLiteral('" />\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n\r\n    <div class="footer">\r\n        <div class="redButton" id="btnAudit">\r\n            确认审核\r\n        </div>\r\n    </div>\r\n</div>\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.pnlNextUser = this.pageObject.find('#pnlNextUser');
			this.selNextStepUser = this.pageObject.find('#selNextStepUser');
			this.pnlAuditOptions = this.pageObject.find('#pnlAuditOptions');
			this.chkBack = this.pageObject.find('#chkBack');
			this.txtRemark = this.pageObject.find('#txtRemark');
			this.txtReturnRemark = this.pageObject.find('#txtReturnRemark');
			this.txtAdjustRemark = this.pageObject.find('#txtAdjustRemark');
			this.btnAudit = this.pageObject.find('#btnAudit');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.pnlNextUser)) {
				this.pnlNextUser.unbind().off();
				this.pnlNextUser = null;
			}
			if (ss.isValue(this.selNextStepUser)) {
				this.selNextStepUser.unbind().off();
				this.selNextStepUser = null;
			}
			if (ss.isValue(this.pnlAuditOptions)) {
				this.pnlAuditOptions.unbind().off();
				this.pnlAuditOptions = null;
			}
			if (ss.isValue(this.chkBack)) {
				this.chkBack.unbind().off();
				this.chkBack = null;
			}
			if (ss.isValue(this.txtRemark)) {
				this.txtRemark.unbind().off();
				this.txtRemark = null;
			}
			if (ss.isValue(this.txtReturnRemark)) {
				this.txtReturnRemark.unbind().off();
				this.txtReturnRemark = null;
			}
			if (ss.isValue(this.txtAdjustRemark)) {
				this.txtAdjustRemark.unbind().off();
				this.txtAdjustRemark = null;
			}
			if (ss.isValue(this.btnAudit)) {
				this.btnAudit.unbind().off();
				this.btnAudit = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction$AdjustAuditParam, $asm, {});
	ss.initClass($USOProject_Pages_ApplyAudit_Adjust_AdjustDetail, $asm, {
		$AdjustDetail_OnPageInit: function(sender, e) {
			var $state2 = 0, $t1, dataResult, DetailData;
			var $sm2 = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state2) {
						case 0: {
							$state2 = -1;
							$t1 = $USOProject_Business_BusinessAction.AdjustApply_Get(this.DataID, this, true);
							$state2 = 1;
							$t1.continueWith($sm2);
							return;
						}
						case 1: {
							$state2 = -1;
							dataResult = $t1.getAwaitedResult();
							if (!dataResult.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(dataResult.ErrorMessage);
								return;
							}
							DetailData = dataResult.Result;
							this.pnlContent.html(this.GetDetailHtml(DetailData).toString());
							jQueryObjectEx.SetVisible(this.btnAudit, dataResult.Result.SingleSo.Status === 1);
							this.pageObject.on('click', '.attachButton', ss.thisFix(function(elem, event) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_Adjust_PictureViewer).call(null, DetailData.AttachFiles, null);
							}));
							this.pageObject.on('click', '.productItem', ss.thisFix(function(elem1, event1) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_Adjust_AdjustProductDetail).call(null, UIDataEx.GetBindData$1(Object).call(null, $(elem1)), null);
							}));
							this.pageObject.on('click', '.flowTrace', ss.thisFix(ss.mkdel(this, function(elem2, event2) {
								var $state = 0, pageData, $t2, result;
								var $sm = ss.mkdel(this, function() {
									$sm1:
									for (;;) {
										switch ($state) {
											case 0: {
												$state = -1;
												pageData = $USOProject_Business_WorkFlowProcTrackDTO.$ctor();
												$t2 = $USOProject_Business_BusinessAction.AdjustApply_GetFlow(this.DataID, this, true);
												$state = 1;
												$t2.continueWith($sm);
												return;
											}
											case 1: {
												$state = -1;
												result = $t2.getAwaitedResult();
												if (!result.IsSuccess) {
													JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
													return;
												}
												JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Spec_SpecProcTrack).call(null, result.Result, null);
												$state = -1;
												break $sm1;
											}
											default: {
												break $sm1;
											}
										}
									}
								});
								$sm();
							})));
							this.btnAudit.click(ss.mkdel(this, function(event3) {
								var $state1 = 0, $t4, data, $t5;
								var $sm1 = ss.mkdel(this, function() {
									$sm1:
									for (;;) {
										switch ($state1) {
											case 0: {
												$state1 = -1;
												$t4 = $USOProject_Business_BusinessAction.AdjustApply_InitAudit(this.DataID, this, true);
												$state1 = 1;
												$t4.continueWith($sm1);
												return;
											}
											case 1: {
												$state1 = -1;
												data = $t4.getAwaitedResult();
												if (!data.IsSuccess) {
													JSLib.Mobile.MessageBox.Alert(data.ErrorMessage);
													return;
												}
												$t5 = new $USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction$AdjustAuditParam();
												$t5.id = this.DataID;
												$t5.data = data.Result;
												JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction).call(null, $t5, null);
												$state1 = -1;
												break $sm1;
											}
											default: {
												break $sm1;
											}
										}
									}
								});
								$sm1();
							}));
							$state2 = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm2();
		},
		PrepareData: function() {
			this.DataID = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		GetDetailHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				var item = data.SingleSo;
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="AuditDetailPanel ">\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegBody">\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('编号', item.Id));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('类型', item.OrderTypeStr));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('创建人', item.CreateByName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('调出客户', item.ReturnCustomerLegalName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('调入客户', item.AdjustCustomerLegalName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('调出金额', item.ReturnSOAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('调入金额', item.AdjustSOAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('审核状态', item.StatusStr));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n');
				if (ss.isValue(data.AttachFiles) && ss.count(data.AttachFiles) > 0) {
					this.WriteLiteralTo(__razor_helper_writer, '                    <div class="row toolBar">\r\n                        <div class="button attachButton" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(data.AttachFiles));
					this.WriteLiteralTo(__razor_helper_writer, '>附件</div>\r\n                    </div>\r\n');
				}
				this.WriteLiteralTo(__razor_helper_writer, '            </div>\n        </div>\n\n        <div class="AuditDetailSeg">\n            <div class="navItem endNavIcon flowTrace">\n                流程跟踪\n            </div>\n        </div>\n\n        <div class="AuditDetailSeg">\n            <div class="SegTitle">\n                调出信息\n            </div>\n            <div class="SegBody">\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('客户', item.ReturnCustomerLegalName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('客户代码', item.ReturnCustomerLegalCode));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('组织', item.ReturnOrganizationName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('门店', item.ReturnStoreName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('门店代码', item.ReturnStoreCode));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('订单类型', item.ReturnOrderTypeName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('分销渠道', item.ReturnR3SalesChannelCode));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('产品总金额', item.ReturnProductsAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('订单总金额', item.ReturnSOAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('国际贸易条件', item.ReturnInternationalName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('卸货地址', item.ReturnReceiveAddressString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('备注', item.ReturnNote));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            </div>\r\n        </div>\r\n\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegTitle">\r\n                调入信息\r\n            </div>\r\n            <div class="SegBody">\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('客户', item.AdjustCustomerLegalName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('客户代码', item.AdjustCustomerLegalCode));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('组织', item.AdjustOrganizationName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('门店', item.AdjustStoreName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('门店代码', item.AdjustStoreCode));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('订单类型', item.AdjustOrderTypeName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('分销渠道', item.AdjustR3SalesChannelCode));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('产品组', item.R3ProductGroupName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('产品总金额', item.AdjustProductsAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('订单总金额', item.AdjustSOAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('返利', item.AdjustTotalRebate));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('仓库', item.WarehouseName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('PO编号', item.AdjustOrderPoNum));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('国际贸易条件', item.AdjustInternationalName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('卸货地址', item.AdjustReceiveAddressString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('备注', item.AdjustNote));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('申请主体', item.AdjustTypeStr));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            </div>\r\n        </div>\r\n\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegTitle">\r\n                公共信息\r\n            </div>\r\n            <div class="SegBody">\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('绕过专供管控', item.IsExcludeSaleCheckString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('退回原因', item.BackReason));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('订单中心审核人', item.CenterAuditUserName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('审核时间', DateTimeEx.ToDateString(DateTimeEx.ToDateTime(item.CenterAuditDate), 'yyyy-MM-dd')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('订单中心退回原因', item.CenterBackReason));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            </div>\r\n        </div>\r\n\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegTitle">\r\n                产品列表\r\n            </div>\r\n            <div class="SegBody">\r\n');
				for (var $t1 = 0; $t1 < data.SingleSo.Items.length; $t1++) {
					var proItem = data.SingleSo.Items[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '                    <div class="productItem endNavIcon" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(proItem));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('物料代码', proItem.R3Code));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('数量', proItem.Quantity));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('调出单价', proItem.ReturnPrice));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('调入单价', proItem.AdjustPrice));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                    </div>\r\n');
				}
				this.WriteLiteralTo(__razor_helper_writer, '            </div>\r\n        </div>\r\n    </div>\r\n');
			}));
		},
		GetNameValueItem: function(name, value) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="row">\r\n        <div class="name">');
				this.WriteTo(__razor_helper_writer, name);
				this.WriteTo(__razor_helper_writer, ':');
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n        <div class="value">');
				this.WriteTo(__razor_helper_writer, value);
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n    </div>\r\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="AdjustDetail">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">调帐详情</div>\n    </div>\n    <div class="content scroll" id="pnlContent">\n\n    </div>\n    <div class="footer">\n        <div class="redButton hidden" id="btnAudit">\n            审核\n        </div>\n    </div>\n</div>\n\n');
			this.WriteLiteral('\r\n\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.btnAudit = this.pageObject.find('#btnAudit');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.btnAudit)) {
				this.btnAudit.unbind().off();
				this.btnAudit = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_Adjust_AdjustList, $asm, {
		$AdjustList_OnPageShow: function(sender, e) {
			if ($USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction.IsAuditComplete) {
				$USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction.IsAuditComplete = true;
				if (ss.isValue(this.$_iscrollList)) {
					this.$_iscrollList.ReLoad();
				}
			}
		},
		$AdjustList_OnPageInit: function(sender, e) {
			var query = {};
			query.Status = 1;
			//query.CreateOn = DateTime.Now.AddMonths(-1).ToString("yyyy-MM-dd");
			var $t1 = new Date();
			query.CreateOn = ss.formatDate(new Date($t1.getFullYear() + -1, $t1.getMonth(), $t1.getDate(), $t1.getHours(), $t1.getMinutes(), $t1.getSeconds(), $t1.getMilliseconds()), 'yyyy-MM-dd');
			query.CreatedOnEnd = ss.formatDate(new Date(), 'yyyy-MM-dd');
			this.$_iscrollList = this.SetIscrollList(this.pnlDataList[0], 20, 100, true, false, true);
			this.$_iscrollList.set_GetPageData(ss.mkdel(this, function(index) {
				var $state = 0, $tcs = new ss.TaskCompletionSource(), result, $t2, $t3, datalist, $t4;
				var $sm = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									query.OrderType = -1;
									query.R3ProductGroupId = -1;
									query.Page = index;
									query.PageSize = 20;
									if (ss.unbox(query.Status) === 1) {
										$t2 = $USOProject_Business_BusinessAction.AdjustApply_SearchWaitAudit(query, this, true);
										$state = 2;
										$t2.continueWith($sm);
										return;
									}
									else {
										$t3 = $USOProject_Business_BusinessAction.AdjustApply_SearchAudited(query, this, true);
										$state = 3;
										$t3.continueWith($sm);
										return;
									}
								}
								case 2: {
									$state = -1;
									result = $t2.getAwaitedResult();
									$state = 1;
									continue $sm1;
								}
								case 3: {
									$state = -1;
									result = $t3.getAwaitedResult();
									$state = 1;
									continue $sm1;
								}
								case 1: {
									$state = -1;
									if (!result.IsSuccess) {
										JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
										$tcs.setResult(new JSLib.IScrollWraper.PageData());
										return;
									}
									$USOProject_Pages_ApplyAudit_Adjust_AdjustQueryPage.OrderTypes = result.Result.OrderTypes;
									$USOProject_Pages_ApplyAudit_Adjust_AdjustQueryPage.SearchProductGroups = result.Result.SearchProductGroups;
									datalist = result.Result.QueryResult;
									$t4 = new JSLib.IScrollWraper.PageData();
									$t4.PageIndex = index;
									$t4.RecordCount = (ss.isNullOrUndefined(datalist) ? 0 : datalist.Total);
									$t4.ResultElement = jQueryObjectEx.ToJqueryObject$1(this.GetDataListHtml(datalist));
									$tcs.setResult($t4);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t5) {
						$tcs.setException(ss.Exception.wrap($t5));
					}
				});
				$sm();
				return $tcs.task;
			}));
			this.$_iscrollList.ReLoad();
			this.pageObject.on('click', '.workTab', ss.thisFix(ss.mkdel(this, function(elem, event) {
				$(elem).addClass('active').siblings().removeClass('active');
				query.Status = UIDataEx.GetBindData$1(Object).call(null, $(elem));
				this.$_iscrollList.ReLoad();
			})));
			this.pageObject.on('click', '.workItem', ss.thisFix(function(elem1, event1) {
				var bindData = UIDataEx.GetBindData$1(Object).call(null, $(elem1));
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_Adjust_AdjustDetail).call(null, bindData.Id, null);
			}));
			this.btnQuery.click(ss.mkdel(this, function(event2) {
				//查询条件位于首次返回的数据中
				if (ss.isNullOrUndefined($USOProject_Pages_ApplyAudit_Adjust_AdjustQueryPage.OrderTypes)) {
					JSLib.Mobile.MessageBox.Alert('请稍候!');
					return;
				}
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_Adjust_AdjustQueryPage).call(null, query, ss.mkdel(this, function(page) {
					page.OnQueryComplete = ss.mkdel(this, function(queryResult) {
						query = queryResult;
						JSLib.Mobile.Application.Back(1);
						this.$_iscrollList.ReLoad();
					});
				}));
			}));
		},
		GetDataListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || data.Total === 0) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">暂无数据</div>\r\n');
					return;
				}
				for (var $t1 = 0; $t1 < data.Result.length; $t1++) {
					var item = data.Result[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="workItem endNavIcon" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(item));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n            <div class="title">\r\n                <div class="number">');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n                <div class="status">');
					this.WriteTo(__razor_helper_writer, item.StatusStr);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n            </div>\r\n            <div class="detail">\r\n                ');
					this.WriteTo(__razor_helper_writer, item.CreatedOn);
					this.WriteLiteralTo(__razor_helper_writer, '  ');
					this.WriteTo(__razor_helper_writer, item.AdjustCustomerLegalName);
					this.WriteLiteralTo(__razor_helper_writer, '\r\n            </div>\r\n        </div>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="AdjustList">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">调帐审核列表</div>\n        <div class="queryButton" id="btnQuery"></div>\n\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="workTabs">\n            <div class="workTab active" ');
			this.Write(this.DataBind(1));
			this.WriteLiteral(' >审核中</div>\r\n            <div class="workTab" ');
			this.Write(this.DataBind(2));
			this.WriteLiteral('>已审核</div>\r\n        </div>\r\n        <div class="workList" id="pnlDataList"></div>\r\n    </div>\r\n\r\n</div>\r\n\r\n');
			this.WriteLiteral('\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.btnQuery = this.pageObject.find('#btnQuery');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.pnlDataList = this.pageObject.find('#pnlDataList');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.btnQuery)) {
				this.btnQuery.unbind().off();
				this.btnQuery = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.pnlDataList)) {
				this.pnlDataList.unbind().off();
				this.pnlDataList = null;
			}
		}
	}, $USOProject_Pages_ApplyAudit_ApplyAuditBasePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_Adjust_AdjustProductDetail, $asm, {
		$AdjustProductDetail_OnPageInit: function(sender, e) {
			this.ProductData = this.InitialData;
			this.pnlContent.html(this.GetProductDetailsHtml(this.ProductData).toString());
		},
		GetProductDetailsHtml: function(item) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="AuditDetailSeg">\r\n\r\n        <div class="SegBody">\r\n\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('物料代码', item.R3Code));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('物料名称', item.ProductName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('对应标准单号', item.SelectedMasterId));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('数量', item.Quantity));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('调出单价', item.ReturnPrice));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('调出折扣金额', item.ReturnDiscountAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('调出折扣比例', item.ReturnDiscountRateString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('调入单价', item.AdjustPrice));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('调入折扣金额', item.AdjustDiscountAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('调入折扣比例', item.AdjustDiscountRateString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n');
				var totalRebate = '';
				if (ss.Nullable$1.gt(item.AdjustRebateAmt, 0) && (ss.isNullOrUndefined(item.UseRebateItems) || item.UseRebateItems.length === 0)) {
					totalRebate = '老订单，只使用了一个返利,无法查看明细';
				}
				else if (ss.isValue(item.UseRebateItems) && item.UseRebateItems.length > 0) {
					totalRebate = Enumerable.from(item.UseRebateItems).sum(function(i) {
						return i.OrderMoney;
					}).toString();
				}
				else {
					totalRebate = '0.00';
				}
				this.WriteLiteralTo(__razor_helper_writer, '            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('返利总金额', totalRebate));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n        </div>\r\n    </div>\r\n');
			}));
		},
		GetNameValueItem: function(name, value) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="row">\r\n        <div class="name">');
				this.WriteTo(__razor_helper_writer, name);
				this.WriteTo(__razor_helper_writer, ':');
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n        <div class="value">');
				this.WriteTo(__razor_helper_writer, value);
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n    </div>\r\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="AdjustProductDetail">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">调帐产品详情</div>\n    </div>\n    <div class="content" id="pnlContent">\n\n    </div>\n\n</div>\n\n');
			this.WriteLiteral('\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_Adjust_AdjustQueryPage, $asm, {
		$AdjustQueryPage_OnPageInit: function(sender, e) {
			JSLib.Widget.Common.DateTimeSelector.BindTo(this.txtBeginDate[0]);
			JSLib.Widget.Common.DateTimeSelector.BindTo(this.txtEndDate[0]);
			this.btnQuery.click(ss.mkdel(this, function(event) {
				this.QueryData.Id = CoreEx.ToIntNullable(this.txtId.val());
				this.QueryData.OrderType = CoreEx.ToIntNullable(this.selOrderType.val());
				this.QueryData.ReturnCustomerLegalName = this.txtReturnCustomer.val();
				this.QueryData.ReturnCustomerLegalId = $JuqeryObjectEx.GetCustomerLegalId(this.txtReturnCustomer);
				this.QueryData.AdjustCustomerLegalName = this.txtAdjustCustomer.val();
				this.QueryData.AdjustCustomerLegalId = $JuqeryObjectEx.GetCustomerLegalId(this.txtAdjustCustomer);
				this.QueryData.CreatedUserName = this.txtCreator.val();
				this.QueryData.CreatedUserId = $JuqeryObjectEx.GetCustomerLegalId(this.txtCreator);
				this.QueryData.CreateOn = this.txtBeginDate.val();
				this.QueryData.CreatedOnEnd = this.txtEndDate.val();
				if (this.QueryData.OrderType === -1) {
					this.QueryData.OrderType = null;
				}
				if (!ss.staticEquals(this.OnQueryComplete, null)) {
					this.OnQueryComplete(this.QueryData);
				}
			}));
		},
		PrepareData: function() {
			this.QueryData = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="AdjustQueryPage">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">调帐申请单查询</div>\n    </div>\n    <div class="content scroll" id="pnlContent">\n        <div class="inputPanel">\n            <div class="inputItem">\n                <div class="title">系统编号:</div>\n                <div class="inputWarp">\n                    <input id="txtId" type="search" placeholder="系统编号" value="');
			this.Write(this.QueryData.Id);
			this.WriteLiteral('">\r\n                </div>\r\n            </div>\r\n\r\n            <div class="inputItem">\r\n                <div class="title">调帐类型:</div>\r\n                <div class="inputWarp">\r\n                    <select id="selOrderType"> \r\n');
			for (var $t1 = 0; $t1 < $USOProject_Pages_ApplyAudit_Adjust_AdjustQueryPage.OrderTypes.length; $t1++) {
				var item = $USOProject_Pages_ApplyAudit_Adjust_AdjustQueryPage.OrderTypes[$t1];
				var SelectedStr = '';
				if (item.Selected) {
					SelectedStr = "selected='selected'";
				}
				this.WriteLiteral('                            <option value="');
				this.Write(item.Value);
				this.WriteLiteral('" ');
				this.Write(SelectedStr);
				this.WriteLiteral('>');
				this.Write(item.Text);
				this.WriteLiteral('</option>\r\n');
			}
			this.WriteLiteral('                    </select>\n                </div>\n            </div>\n            <div class="inputItem">\n                <div class="title">调出客户:</div>\n                <div class="inputWarp">\n                    <input id="txtReturnCustomer" type="search" class="chooseCustomer" readonly="readonly" placeholder="请击选择调出客户" value="');
			this.Write(this.QueryData.ReturnCustomerLegalName);
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="inputItem">\n                <div class="title">调入客户:</div>\n                <div class="inputWarp">\n                    <input id="txtAdjustCustomer" type="search" class="chooseCustomer" readonly="readonly" placeholder="请击选择调入客户" value="');
			this.Write(this.QueryData.ReturnCustomerLegalName);
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="inputItem">\n                <div class="title">创建人:</div>\n                <div class="inputWarp">\n                    <input id="txtCreator" type="search" placeholder="请击选择创建人"  readonly="readonly" class="chooseUser" value="');
			this.Write(this.QueryData.CreatedUserName);
			this.WriteLiteral('">\n                </div>\n            </div>\n\n            <div class="inputItem">\n                <div class="title">开始日期:</div>\n                <div class="inputWarp">\n                    <input id="txtBeginDate" type="text" placeholder="开始日期" readonly="readonly" value="');
			this.Write(this.QueryData.CreateOn);
			this.WriteLiteral('" >\n                </div>\n            </div>\n            <div class="inputItem">\n                <div class="title">结束日期:</div>\n                <div class="inputWarp">\n                    <input id="txtEndDate" type="text" placeholder="结束日期" readonly="readonly" class="" value="');
			this.Write(this.QueryData.CreatedOnEnd);
			this.WriteLiteral('">\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n    </div>\r\n    \r\n    <div class="footer">\r\n        <div class="redButton" id="btnQuery">查询</div>\r\n    </div>\r\n</div>\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.txtId = this.pageObject.find('#txtId');
			this.selOrderType = this.pageObject.find('#selOrderType');
			this.txtReturnCustomer = this.pageObject.find('#txtReturnCustomer');
			this.txtAdjustCustomer = this.pageObject.find('#txtAdjustCustomer');
			this.txtCreator = this.pageObject.find('#txtCreator');
			this.txtBeginDate = this.pageObject.find('#txtBeginDate');
			this.txtEndDate = this.pageObject.find('#txtEndDate');
			this.btnQuery = this.pageObject.find('#btnQuery');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.txtId)) {
				this.txtId.unbind().off();
				this.txtId = null;
			}
			if (ss.isValue(this.selOrderType)) {
				this.selOrderType.unbind().off();
				this.selOrderType = null;
			}
			if (ss.isValue(this.txtReturnCustomer)) {
				this.txtReturnCustomer.unbind().off();
				this.txtReturnCustomer = null;
			}
			if (ss.isValue(this.txtAdjustCustomer)) {
				this.txtAdjustCustomer.unbind().off();
				this.txtAdjustCustomer = null;
			}
			if (ss.isValue(this.txtCreator)) {
				this.txtCreator.unbind().off();
				this.txtCreator = null;
			}
			if (ss.isValue(this.txtBeginDate)) {
				this.txtBeginDate.unbind().off();
				this.txtBeginDate = null;
			}
			if (ss.isValue(this.txtEndDate)) {
				this.txtEndDate.unbind().off();
				this.txtEndDate = null;
			}
			if (ss.isValue(this.btnQuery)) {
				this.btnQuery.unbind().off();
				this.btnQuery = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_Adjust_PictureViewer, $asm, {
		$PictureViewer_OnPageInit: function(sender, e) {
			this.files = this.InitialData;
			if (ss.count(this.files) > 0) {
				this.pnlCarousel.html(this.GetImagesHtml(Enumerable.from(this.files).select(function(n) {
					return n.AdjunctAddress;
				}).toArray()).toString());
			}
			var _carousel = new JSLib.IScrollWraper.Carousel(this.pnlCarousel[0], this.pnlCarousel[0].clientWidth, true, false, 'carouselWrapwer');
		},
		GetImagesHtml: function(imageUrl) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				for (var $t1 = 0; $t1 < imageUrl.length; $t1++) {
					var item = imageUrl[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="imgContainer">\r\n            <img src="');
					this.WriteTo(__razor_helper_writer, item);
					this.WriteLiteralTo(__razor_helper_writer, '" class="productImg" onerror="this.src = \'img/image_loading_fail.png\'" />\r\n        </div>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="PictureViewer">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">查看图片</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div id="pnlCarousel"></div>\n    </div>\n</div>\n\n\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.pnlCarousel = this.pageObject.find('#pnlCarousel');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.pnlCarousel)) {
				this.pnlCarousel.unbind().off();
				this.pnlCarousel = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderAuditAction, $asm, {
		$AdjustAuditAction_OnPageInit: function(sender, e) {
			this.btnAudit.click(ss.mkdel(this, function(event) {
				var $state = 0, chkStatus, $t1, data, $t2, result, result1;
				var $sm = ss.mkdel(this, function() {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								chkStatus = this.pageObject.find('#pnlAuditOptions>.chkBox.active');
								if (chkStatus.length === 0) {
									JSLib.Mobile.MessageBox.Alert('请选择处理状态!');
									return;
								}
								//确认
								if (chkStatus.attr('data-value') === '1') {
									$t1 = $USOProject_Business_BusinessAction.EngineerOrder_DoAudit(this.$MasterId, this, true);
									$state = 2;
									$t1.continueWith($sm);
									return;
								}
								else {
									data = {};
									data.MasterId = this.$MasterId;
									data.Reason = this.txtRemark.val().trim();
									if (ss.isNullOrEmptyString(data.Reason)) {
										JSLib.Mobile.MessageBox.Alert('请填写退回原因!');
										return;
									}
									$t2 = $USOProject_Business_BusinessAction.EngineerOrder_DoReturnBack(data, this, true);
									$state = 3;
									$t2.continueWith($sm);
									return;
								}
							}
							case 2: {
								$state = -1;
								result = $t1.getAwaitedResult();
								if (!result.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
									return;
								}
								JSLib.Mobile.MessageBox.Alert('审核成功!');
								$state = 1;
								continue $sm1;
							}
							case 3: {
								$state = -1;
								result1 = $t2.getAwaitedResult();
								if (!result1.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(result1.ErrorMessage);
									return;
								}
								JSLib.Mobile.MessageBox.Alert('审核成功!');
								$state = 1;
								continue $sm1;
							}
							case 1: {
								$state = -1;
								$USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderAuditAction.IsAuditComplete = true;
								JSLib.Mobile.Application.BackTo($USOProject_Pages_HomePage).call(null);
								$USOProject_Pages_Control_MyWorkControl.TriggerTodoWorkChange();
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				});
				$sm();
			}));
			this.pnlAuditOptions.change(ss.mkdel(this, function(event1) {
				jQueryObjectEx.SetVisible(this.pnlBackReason, this.chkBack.hasClass('active'));
			}));
			this.pnlBackReason.hide();
		},
		PrepareData: function() {
			this.$MasterId = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="EngineerOrderAuditAction">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">工程订单审核</div>\n    </div>\n    <div class="content scroll" id="pnlContent">\n        <div class="AuditDetailSeg">\n            <div class="row">\n                <div class="name">处理状态:</div>\n                <div class="value">\n                    <div class="radioPanel" id="pnlAuditOptions">\n                        <span class="chkBox" data-value="1">确认</span>\n                        <span class="chkBox" data-value="0" id="chkBack">退回</span>\n                    </div>\n                </div>\n            </div>\n\n            <div class="row" id="pnlBackReason">\n                <div class="name">退回原因:</div>\n                <div class="value">\n                    <input type="text" id="txtRemark" placeholder="退回原因" value="" />\n                </div>\n            </div>\n        </div>\n    </div>\n\n    <div class="footer">\n        <div class="redButton" id="btnAudit">\n            确认审核\n        </div>\n    </div>\n</div>\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.pnlAuditOptions = this.pageObject.find('#pnlAuditOptions');
			this.chkBack = this.pageObject.find('#chkBack');
			this.pnlBackReason = this.pageObject.find('#pnlBackReason');
			this.txtRemark = this.pageObject.find('#txtRemark');
			this.btnAudit = this.pageObject.find('#btnAudit');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.pnlAuditOptions)) {
				this.pnlAuditOptions.unbind().off();
				this.pnlAuditOptions = null;
			}
			if (ss.isValue(this.chkBack)) {
				this.chkBack.unbind().off();
				this.chkBack = null;
			}
			if (ss.isValue(this.pnlBackReason)) {
				this.pnlBackReason.unbind().off();
				this.pnlBackReason = null;
			}
			if (ss.isValue(this.txtRemark)) {
				this.txtRemark.unbind().off();
				this.txtRemark = null;
			}
			if (ss.isValue(this.btnAudit)) {
				this.btnAudit.unbind().off();
				this.btnAudit = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderDetail, $asm, {
		$EngineerOrderDetail_OnPageInit: function(sender, e) {
			var $state = 0, $t1, dataResult, DetailData;
			var $sm = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							$t1 = $USOProject_Business_BusinessAction.EngineerOrder_Get(this.Data.Id, this, true);
							$state = 1;
							$t1.continueWith($sm);
							return;
						}
						case 1: {
							$state = -1;
							dataResult = $t1.getAwaitedResult();
							if (!dataResult.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(dataResult.ErrorMessage);
								return;
							}
							DetailData = dataResult.Result;
							this.pnlContent.html(this.GetDetailHtml(DetailData).toString());
							jQueryObjectEx.SetVisible(this.btnAudit, this.Data.IsToAudit);
							this.pageObject.on('click', '.attachButton', ss.thisFix(function(elem, event) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_Adjust_PictureViewer).call(null, DetailData.AttachFiles, null);
							}));
							this.btnAudit.click(ss.mkdel(this, function(event1) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderAuditAction).call(null, this.Data.Id, null);
							}));
							this.pageObject.on('click', '.productItem', ss.thisFix(function(elem1, event2) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderProductDetail).call(null, UIDataEx.GetBindData$1(Object).call(null, $(elem1)), null);
							}));
							$state = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm();
		},
		PrepareData: function() {
			this.Data = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		GetDetailHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				var item = data.SingleProject;
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="AuditDetailPanel ">\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegBody">\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('编号', item.Id));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('客户名称', item.CustomerLegalName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                \r\n                ');
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('业务组织', this.Data.StockOrganizationName));
				this.WriteLiteralTo(__razor_helper_writer, ' \r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('创建人', item.CreatedName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('创建时间', item.CreatedOn));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('审核状态', item.StatusStr));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n');
				if (ss.isValue(data.AttachFiles) && ss.count(data.AttachFiles) > 0) {
					this.WriteLiteralTo(__razor_helper_writer, '                    <div class="row toolBar">\r\n                        <div class="button attachButton" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(data.AttachFiles));
					this.WriteLiteralTo(__razor_helper_writer, '>附件</div>\r\n                    </div>\r\n');
				}
				this.WriteLiteralTo(__razor_helper_writer, '            </div>\r\n        </div>\r\n\r\n\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegTitle">\r\n                订单详情\r\n            </div>\r\n            <div class="SegBody">\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('客户代码', data.SalesCustomerLegalName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('销售组织', item.OrganizationName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n');
				var saleOrg = (ss.isNullOrUndefined(item.R3Distribution) ? '' : (item.R3Distribution.R3Code + '-' + item.R3Distribution.Name));
				this.WriteLiteralTo(__razor_helper_writer, '                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('分销渠道', saleOrg));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('产品组', (ss.isNullOrUndefined(item.R3ProductGroup) ? '' : (item.R3ProductGroup.ProductGroupR3Code + '-' + item.R3ProductGroup.ProductGroupR3Name))));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('客户经理', item.CustomerManagerName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('合同签订日期', item.FileDate));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('实施日期', item.UseDate));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('客户联系电话', item.CustomerPhone));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('工程使用单位', item.ProjectOrgName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('使用单位联系人', item.ProjectOrgUserName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('使用单位电话', item.ProjectOrgUserPhote));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('交货地点', item.ProjectAddress));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('结算方式', item.PayTypeStr));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('付款期限', item.PayTime));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('实施方式', item.ProjectTypeName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('工程简况', item.BriefDescription));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('核实人', item.InterViewUserName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('核实时间', item.InterViewTime));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('验收日期', item.CheckTime));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('核实方式', item.ProjectCheckTypeStr));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('核实结果', item.InertViewResult));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            </div>\r\n        </div>\r\n\r\n\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegTitle">\r\n                产品列表\r\n            </div>\r\n            <div class="SegBody">\r\n');
				for (var $t1 = 0; $t1 < data.SingleProject.Items.length; $t1++) {
					var proItem = data.SingleProject.Items[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '                    <div class="productItem endNavIcon" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(proItem));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('物料代码', proItem.ProductR3Code));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('数量', proItem.Num));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('价格', proItem.Price));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                    </div>\r\n');
				}
				this.WriteLiteralTo(__razor_helper_writer, '            </div>\r\n        </div>\r\n    </div>\r\n');
			}));
		},
		GetNameValueItem: function(name, value) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="row">\r\n        <div class="name">');
				this.WriteTo(__razor_helper_writer, name);
				this.WriteTo(__razor_helper_writer, ':');
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n        <div class="value">');
				this.WriteTo(__razor_helper_writer, value);
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n    </div>\r\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="EngineerOrderDetail">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">工程档案</div>\n    </div>\n    <div class="content scroll" id="pnlContent">\n\n    </div>\n    <div class="footer">\n        <div class="redButton hidden" id="btnAudit">\n            审核\n        </div>\n    </div>\n</div>\n\n');
			this.WriteLiteral('\r\n\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.btnAudit = this.pageObject.find('#btnAudit');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.btnAudit)) {
				this.btnAudit.unbind().off();
				this.btnAudit = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderDetailData, $asm, {});
	ss.initClass($USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderList, $asm, {
		$EngineerOrderList_OnPageShow: function(sender, e) {
			if ($USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderAuditAction.IsAuditComplete) {
				$USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderAuditAction.IsAuditComplete = true;
				if (ss.isValue(this.$_iscrollList)) {
					this.$_iscrollList.ReLoad();
				}
			}
		},
		$EngineerOrderList_OnPageInit: function(sender, e) {
			var query = {};
			query.Status = 1;
			//query.CreatedOn = DateTime.Now.AddMonths(-1).ToString("yyyy-MM-dd");
			var $t1 = new Date();
			query.CreatedOn = ss.formatDate(new Date($t1.getFullYear() + -1, $t1.getMonth(), $t1.getDate(), $t1.getHours(), $t1.getMinutes(), $t1.getSeconds(), $t1.getMilliseconds()), 'yyyy-MM-dd');
			query.CreatedOnEnd = ss.formatDate(new Date(), 'yyyy-MM-dd');
			this.$_iscrollList = this.SetIscrollList(this.pnlDataList[0], 20, 100, true, false, true);
			this.$_iscrollList.set_GetPageData(ss.mkdel(this, function(index) {
				var $state = 0, $tcs = new ss.TaskCompletionSource(), result, $t2, $t3, datalist, $t4;
				var $sm = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									query.Page = index;
									query.PageSize = 20;
									if (ss.unbox(query.Status) === 1) {
										$t2 = $USOProject_Business_BusinessAction.EngineerOrder_SearchWaitAudit(query, this, true);
										$state = 2;
										$t2.continueWith($sm);
										return;
									}
									else {
										$t3 = $USOProject_Business_BusinessAction.EngineerOrder_SearchAudited(query, this, true);
										$state = 3;
										$t3.continueWith($sm);
										return;
									}
								}
								case 2: {
									$state = -1;
									result = $t2.getAwaitedResult();
									$state = 1;
									continue $sm1;
								}
								case 3: {
									$state = -1;
									result = $t3.getAwaitedResult();
									$state = 1;
									continue $sm1;
								}
								case 1: {
									$state = -1;
									if (!result.IsSuccess) {
										JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
										$tcs.setResult(new JSLib.IScrollWraper.PageData());
										return;
									}
									datalist = result.Result.ProjectFileDTO;
									$t4 = new JSLib.IScrollWraper.PageData();
									$t4.PageIndex = index;
									$t4.RecordCount = (ss.isNullOrUndefined(datalist) ? 0 : datalist.Result.length);
									$t4.ResultElement = jQueryObjectEx.ToJqueryObject$1(this.GetDataListHtml(datalist));
									$tcs.setResult($t4);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t5) {
						$tcs.setException(ss.Exception.wrap($t5));
					}
				});
				$sm();
				return $tcs.task;
			}));
			this.$_iscrollList.ReLoad();
			this.pageObject.on('click', '.workTab', ss.thisFix(ss.mkdel(this, function(elem, event) {
				$(elem).addClass('active').siblings().removeClass('active');
				query.Status = UIDataEx.GetBindData$1(Object).call(null, $(elem));
				this.$_iscrollList.ReLoad();
			})));
			this.pageObject.on('click', '.workItem', ss.thisFix(function(elem1, event1) {
				var bindData = UIDataEx.GetBindData$1(Object).call(null, $(elem1));
				var $t6 = new $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderDetailData();
				$t6.Id = bindData.Id;
				$t6.IsToAudit = query.Status === 1;
				$t6.StockOrganizationName = bindData.StockOrganizationName;
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderDetail).call(null, $t6, null);
			}));
			this.btnQuery.click(ss.mkdel(this, function(event2) {
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderQueryPage).call(null, query, ss.mkdel(this, function(page) {
					page.OnQueryComplete = ss.mkdel(this, function(queryResult) {
						query = queryResult;
						JSLib.Mobile.Application.Back(1);
						this.$_iscrollList.ReLoad();
					});
				}));
			}));
		},
		GetDataListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || data.Result.length === 0) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">暂无数据</div>\r\n');
					return;
				}
				for (var $t1 = 0; $t1 < data.Result.length; $t1++) {
					var item = data.Result[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="workItem endNavIcon" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(item));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n            <div class="title">\r\n                <div class="number">');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n                <div class="status">');
					this.WriteTo(__razor_helper_writer, item.StatusStr);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n            </div>\r\n            <div class="detail">\r\n                ');
					this.WriteTo(__razor_helper_writer, item.CreatedOn);
					this.WriteLiteralTo(__razor_helper_writer, '  ');
					this.WriteTo(__razor_helper_writer, item.CustomerLegalName);
					this.WriteLiteralTo(__razor_helper_writer, '\r\n            </div>\r\n        </div>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="EngineerOrderList">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">工程档案列表</div>\n        <div class="queryButton" id="btnQuery"></div>\n\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="workTabs">\n            <div class="workTab active" ');
			this.Write(this.DataBind(1));
			this.WriteLiteral('>审核中</div>\r\n            <div class="workTab" ');
			this.Write(this.DataBind(2));
			this.WriteLiteral('>已审核</div>\r\n        </div>\r\n        <div class="workList" id="pnlDataList"></div>\r\n    </div>\r\n</div>\r\n\r\n');
			this.WriteLiteral('\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.btnQuery = this.pageObject.find('#btnQuery');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.pnlDataList = this.pageObject.find('#pnlDataList');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.btnQuery)) {
				this.btnQuery.unbind().off();
				this.btnQuery = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.pnlDataList)) {
				this.pnlDataList.unbind().off();
				this.pnlDataList = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderProductDetail, $asm, {
		$EngineerOrderProductDetail_OnPageInit: function(sender, e) {
			this.ProductData = this.InitialData;
			this.pnlContent.html(this.GetProductDetailsHtml(this.ProductData).toString());
		},
		GetProductDetailsHtml: function(item) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="AuditDetailSeg">\r\n        <div class="SegBody">\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('物料代码', item.ProductR3Code));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('物料名称', item.ProductName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('数量', item.Num));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('申请开单价格', item.Price));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('特批申请单价', item.ApplySpecialPrice));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('申请核算单价', item.ApplyAccountingPrice));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n');
				var specialStatusStr = '';
				if (ss.isNullOrUndefined(item.SpecialStatus) && item.MoreProduct <= 0 && ss.isNullOrUndefined(item.SpecialMasterId)) {
					specialStatusStr = '需要特批';
				}
				else {
					specialStatusStr = item.SpecialStatusString;
				}
				this.WriteLiteralTo(__razor_helper_writer, '            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('特批', specialStatusStr));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('特批号', item.SpecialMasterId));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('特批数量', item.SpecialNum));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('特批价格', item.SpecialPrice));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('折扣金额', item.DiscountAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n        </div>\r\n    </div>\r\n');
			}));
		},
		GetNameValueItem: function(name, value) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="row">\r\n        <div class="name">');
				this.WriteTo(__razor_helper_writer, name);
				this.WriteTo(__razor_helper_writer, ':');
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n        <div class="value">');
				this.WriteTo(__razor_helper_writer, value);
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n    </div>\r\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="EngineerOrderProductDetail">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">工程产品详情</div>\n    </div>\n    <div class="content" id="pnlContent">\n\n    </div>\n\n</div>\n\n');
			this.WriteLiteral('\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderQueryPage, $asm, {
		$EngineerOrderQueryPage_OnPageInit: function(sender, e) {
			JSLib.Widget.Common.DateTimeSelector.BindTo(this.txtBeginDate[0]);
			JSLib.Widget.Common.DateTimeSelector.BindTo(this.txtEndDate[0]);
			this.btnQuery.click(ss.mkdel(this, function(event) {
				this.QueryData.Id = CoreEx.ToIntNullable(this.txtId.val());
				this.QueryData.StockOrgId = CoreEx.ToIntNullable(this.selOrg.val());
				this.QueryData.CustomerName = this.txtCustomerName.val();
				this.QueryData.CustomerLegalId = $JuqeryObjectEx.GetCustomerLegalId(this.txtCustomerName);
				this.QueryData.CreatedUserName = this.txtCreator.val();
				this.QueryData.CreatedUserId = $JuqeryObjectEx.GetCustomerLegalId(this.txtCreator);
				this.QueryData.CreatedOn = this.txtBeginDate.val();
				this.QueryData.CreatedOnEnd = this.txtEndDate.val();
				if (this.QueryData.StockOrgId === -1) {
					this.QueryData.StockOrgId = null;
				}
				if (!ss.staticEquals(this.OnQueryComplete, null)) {
					this.OnQueryComplete(this.QueryData);
				}
			}));
		},
		PrepareData: function() {
			this.QueryData = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="EngineerOrderQueryPage">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">工程订单查询</div>\n    </div>\n    <div class="content scroll" id="pnlContent">\n        <div class="inputPanel">\n            <div class="inputItem">\n                <div class="title">系统编号:</div>\n                <div class="inputWarp">\n                    <input id="txtId" type="search" placeholder="系统编号" value="');
			this.Write(this.QueryData.Id);
			this.WriteLiteral('">\n                </div>\n            </div>\n\n            <div class="inputItem">\n                <div class="title">业务组织:</div>\n                <div class="inputWarp">\n                    <select id="selOrg">\n');
			var orgSelectData = ss.arrayClone($App.app.userInfo.StockOrganizationList);
			var $t1 = $USOProject_Business_OrganizationList.$ctor();
			$t1.Name = '--请选择--';
			$t1.Id = -1;
			ss.insert(orgSelectData, 0, $t1);
			for (var $t2 = 0; $t2 < orgSelectData.length; $t2++) {
				var item = orgSelectData[$t2];
				var SelectedStr = '';
				if (ss.isValue(this.QueryData.StockOrgId) && this.QueryData.StockOrgId === item.Id) {
					SelectedStr = "selected='selected'";
				}
				this.WriteLiteral('                            <option value="');
				this.Write(item.Id);
				this.WriteLiteral('" ');
				this.Write(SelectedStr);
				this.WriteLiteral('>');
				this.Write(item.Name);
				this.WriteLiteral('</option>\n');
			}
			this.WriteLiteral('                    </select>\n                </div>\n            </div>\n            <div class="inputItem">\n                <div class="title">客户名称:</div>\n                <div class="inputWarp">\n                    <input id="txtCustomerName" type="search" placeholder="客户名称" class="chooseCustomer" readonly="readonly" value="');
			this.Write(this.QueryData.CustomerName);
			this.WriteLiteral('">\n                </div>\n            </div>\n\n            <div class="inputItem">\n                <div class="title">创建人:</div>\n                <div class="inputWarp">\n                    <input id="txtCreator" type="search" placeholder="创建人" class="chooseUser" readonly="readonly" value="');
			this.Write(this.QueryData.CreatedUserName);
			this.WriteLiteral('">\n                </div>\n            </div>\n\n            <div class="inputItem">\n                <div class="title">开始日期:</div>\n                <div class="inputWarp">\n                    <input id="txtBeginDate" type="text" placeholder="开始日期" readonly="readonly" value="');
			this.Write(this.QueryData.CreatedOn);
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="inputItem">\n                <div class="title">结束日期:</div>\n                <div class="inputWarp">\n                    <input id="txtEndDate" type="text" placeholder="结束日期" readonly="readonly" class="" value="');
			this.Write(this.QueryData.CreatedOnEnd);
			this.WriteLiteral('">\n                </div>\n            </div>\n\n        </div>\n    </div>\n\n    <div class="footer">\n        <div class="redButton" id="btnQuery">查询</div>\n    </div>\n</div>\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.txtId = this.pageObject.find('#txtId');
			this.selOrg = this.pageObject.find('#selOrg');
			this.txtCustomerName = this.pageObject.find('#txtCustomerName');
			this.txtCreator = this.pageObject.find('#txtCreator');
			this.txtBeginDate = this.pageObject.find('#txtBeginDate');
			this.txtEndDate = this.pageObject.find('#txtEndDate');
			this.btnQuery = this.pageObject.find('#btnQuery');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.txtId)) {
				this.txtId.unbind().off();
				this.txtId = null;
			}
			if (ss.isValue(this.selOrg)) {
				this.selOrg.unbind().off();
				this.selOrg = null;
			}
			if (ss.isValue(this.txtCustomerName)) {
				this.txtCustomerName.unbind().off();
				this.txtCustomerName = null;
			}
			if (ss.isValue(this.txtCreator)) {
				this.txtCreator.unbind().off();
				this.txtCreator = null;
			}
			if (ss.isValue(this.txtBeginDate)) {
				this.txtBeginDate.unbind().off();
				this.txtBeginDate = null;
			}
			if (ss.isValue(this.txtEndDate)) {
				this.txtEndDate.unbind().off();
				this.txtEndDate = null;
			}
			if (ss.isValue(this.btnQuery)) {
				this.btnQuery.unbind().off();
				this.btnQuery = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditAction, $asm, {
		$OrderAuditAction_OnPageInit: function(sender, e) {
			var $state1 = 0, $t1, $t2, result, result1;
			var $sm1 = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state1) {
						case 0: {
							$state1 = -1;
							if (this.Data.OrderAuditType === 1) {
								$t1 = $USOProject_Business_BusinessAction.SpecificSaleOrder_InitAudit(this.Data.OrderId, this, true);
								$state1 = 2;
								$t1.continueWith($sm1);
								return;
							}
							else if (this.Data.OrderAuditType === 2) {
								$t2 = $USOProject_Business_BusinessAction.ReturnOrderWeiHuo_InitAudit(this.Data.OrderId, this, true);
								$state1 = 3;
								$t2.continueWith($sm1);
								return;
							}
							else {
								if (this.Data.OrderAuditType === 3) {
									this.pageObject.find('.pnlNextUsers').hide();
									this.pnlContent.html(this.GetAuditFlowHtmls(null, 3).toString());
								}
								$state1 = 1;
								continue $sm1;
							}
						}
						case 2: {
							$state1 = -1;
							result = $t1.getAwaitedResult();
							if (!result.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
								return;
							}
							this.InitData = result.Result;
							this.pnlContent.html(this.GetAuditFlowHtmls(result.Result, 1).toString());
							jQueryObjectEx.SetVisible(this.pageObject.find('.pnlNextUsers'), result.Result.IsLast !== 1);
							$state1 = 1;
							continue $sm1;
						}
						case 3: {
							$state1 = -1;
							result1 = $t2.getAwaitedResult();
							if (!result1.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(result1.ErrorMessage);
								return;
							}
							this.InitData = result1.Result;
							this.pnlContent.html(this.GetAuditFlowHtmls(result1.Result, 2).toString());
							jQueryObjectEx.SetVisible(this.pageObject.find('.pnlNextUsers'), result1.Result.IsLast !== 1);
							$state1 = 1;
							continue $sm1;
						}
						case 1: {
							$state1 = -1;
							this.pageObject.find('.radioPanel').change(ss.mkdel(this, function(event) {
								var data = this.InitData;
								if (ss.isNullOrUndefined(data)) {
									jQueryObjectEx.SetVisible(this.pageObject.find('.pnlNote'), this.pageObject.find('.chkBack').hasClass('active'));
								}
							}));
							jQueryObjectEx.SetVisible(this.pageObject.find('.pnlNote'), this.Data.OrderAuditType === 1 || this.Data.OrderAuditType === 2);
							this.btnAudit.click(ss.mkdel(this, function(event1) {
								var $state = 0, nextUser, note, activeState, throughStatus, data1, result2, $t3, $t4, activeState1, throughStatus1, $t5, note1, $t6, result3, result4;
								var $sm = ss.mkdel(this, function() {
									$sm1:
									for (;;) {
										switch ($state) {
											case 0: {
												$state = -1;
												if (this.Data.OrderAuditType === 1 || this.Data.OrderAuditType === 2) {
													nextUser = CoreEx.ToInt(this.pageObject.find('.selNextStepUser').val(), 0);
													note = this.pageObject.find('.txtRemark').val();
													activeState = this.pageObject.find('.chkBox.active');
													if (activeState.length === 0) {
														JSLib.Mobile.MessageBox.Alert('请选择审核状态!');
														return;
													}
													throughStatus = CoreEx.ToInt(activeState.attr('data-value'), 0);
													if (nextUser === -1) {
														JSLib.Mobile.MessageBox.Alert('请选择下步审核人!');
														return;
													}
													data1 = this.InitData;
													data1.NextUserId = nextUser;
													data1.Note = note;
													data1.Status = throughStatus;
													if (this.Data.OrderAuditType === 1) {
														$t3 = $USOProject_Business_BusinessAction.SpecificSaleOrderAuditService_DoAudit(data1, this, true);
														$state = 2;
														$t3.continueWith($sm);
														return;
													}
													else {
														$t4 = $USOProject_Business_BusinessAction.ReturnOrderWeiHuoAuditService_DoAudit(data1, this, true);
														$state = 3;
														$t4.continueWith($sm);
														return;
													}
												}
												else {
													if (this.Data.OrderAuditType === 3) {
														activeState1 = this.pageObject.find('.chkBox.active');
														if (activeState1.length === 0) {
															JSLib.Mobile.MessageBox.Alert('请选择审核状态!');
															return;
														}
														throughStatus1 = CoreEx.ToInt(activeState1.attr('data-value'), 0);
														if (throughStatus1 === 1) {
															$t5 = $USOProject_Business_BusinessAction.WaitConfirmOrderAuditService_DoAudit({ SOMasterId: this.Data.OrderId, TypeId: 0 }, this, true);
															$state = 4;
															$t5.continueWith($sm);
															return;
														}
														else {
															note1 = this.pageObject.find('.txtRemark').val().trim();
															if (ss.isNullOrEmptyString(note1)) {
																JSLib.Mobile.MessageBox.Alert('请输入退回原因!');
																return;
															}
															$t6 = $USOProject_Business_BusinessAction.WaitConfirmOrder_DoReturnBack({ MasterId: this.Data.OrderId, Reason: note1 }, this, true);
															$state = 5;
															$t6.continueWith($sm);
															return;
														}
													}
													$state = -1;
													break $sm1;
												}
											}
											case 2: {
												$state = -1;
												result2 = $t3.getAwaitedResult();
												$state = 1;
												continue $sm1;
											}
											case 3: {
												$state = -1;
												result2 = $t4.getAwaitedResult();
												$state = 1;
												continue $sm1;
											}
											case 1: {
												$state = -1;
												if (!result2.IsSuccess) {
													JSLib.Mobile.MessageBox.Alert(result2.ErrorMessage);
													return;
												}
												else {
													JSLib.Mobile.MessageBox.Alert('订单审核成功');
													JSLib.Mobile.Application.BackTo($USOProject_Pages_HomePage).call(null);
													$USOProject_Pages_Control_MyWorkControl.TriggerTodoWorkChange();
												}
												$state = -1;
												break $sm1;
											}
											case 4: {
												$state = -1;
												result3 = $t5.getAwaitedResult();
												if (!result3.IsSuccess) {
													JSLib.Mobile.MessageBox.Alert(result3.ErrorMessage);
													return;
												}
												JSLib.Mobile.MessageBox.Alert('订单审核成功');
												JSLib.Mobile.Application.BackTo($USOProject_Pages_HomePage).call(null);
												$USOProject_Pages_Control_MyWorkControl.TriggerTodoWorkChange();
												$state = -1;
												break $sm1;
											}
											case 5: {
												$state = -1;
												result4 = $t6.getAwaitedResult();
												if (!result4.IsSuccess) {
													JSLib.Mobile.MessageBox.Alert(result4.ErrorMessage);
													return;
												}
												JSLib.Mobile.MessageBox.Alert('订单审核成功');
												JSLib.Mobile.Application.BackTo($USOProject_Pages_HomePage).call(null);
												$USOProject_Pages_Control_MyWorkControl.TriggerTodoWorkChange();
												$state = -1;
												break $sm1;
											}
											default: {
												break $sm1;
											}
										}
									}
								});
								$sm();
							}));
							$state1 = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm1();
		},
		PrepareData: function() {
			this.Data = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		GetAuditFlowHtmls: function(auditData, auditType) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="AuditDetailSeg">\r\n');
				if (!!ss.isValue(auditData)) {
					this.WriteLiteralTo(__razor_helper_writer, '            <div class="row pnlNextUsers">\r\n                <div class="name">下步审核人:</div>\r\n                <div class="value">\r\n                    <select class="selNextStepUser">\r\n');
					var temp = auditData;
					for (var $t1 = 0; $t1 < temp.NextUsers.length; $t1++) {
						var item = temp.NextUsers[$t1];
						var selectedStr = '';
						if (item.Selected) {
							selectedStr = "selected='selected'";
						}
						this.WriteLiteralTo(__razor_helper_writer, '                <option value="');
						this.WriteTo(__razor_helper_writer, item.Value);
						this.WriteLiteralTo(__razor_helper_writer, '" ');
						this.WriteTo(__razor_helper_writer, selectedStr);
						this.WriteLiteralTo(__razor_helper_writer, '>');
						this.WriteTo(__razor_helper_writer, item.Text);
						this.WriteLiteralTo(__razor_helper_writer, '</option>\r\n');
					}
					this.WriteLiteralTo(__razor_helper_writer, '                    </select>\r\n                </div>\r\n            </div>\r\n');
				}
				this.WriteLiteralTo(__razor_helper_writer, '        <div class="row">\r\n            <div class="name">处理状态:</div>\r\n            <div class="value">\r\n                <div class="auditState radioPanel">\r\n                    <span class="chkBox" data-value="1">\r\n');
				var throughStr = ((auditType === 1 || auditType === 2) ? '通过' : '确认');
				this.WriteLiteralTo(__razor_helper_writer, '                        ');
				this.WriteTo(__razor_helper_writer, throughStr);
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                    </span>\r\n                    <span class="chkBox chkBack" data-value="0">退回</span>\r\n                </div>\r\n            </div>\r\n        </div>\r\n\r\n\r\n');
				var labelStr = (!!ss.isNullOrUndefined(auditData) ? '退回原因' : '备注');
				this.WriteLiteralTo(__razor_helper_writer, '        <div class="row pnlNote">\r\n            <div class="name">');
				this.WriteTo(__razor_helper_writer, labelStr);
				this.WriteLiteralTo(__razor_helper_writer, ':</div>\r\n            <div class="value">\r\n                <input type="text" class="txtRemark" placeholder="');
				this.WriteTo(__razor_helper_writer, labelStr);
				this.WriteLiteralTo(__razor_helper_writer, '" value="');
				this.WriteTo(__razor_helper_writer, (!!ss.isValue(auditData) ? auditData.Note : ''));
				this.WriteLiteralTo(__razor_helper_writer, '" />\r\n            </div>\r\n        </div>\r\n\r\n    </div>\r\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="OrderAuditAction">\r\n    <div class="head">\r\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\r\n        <div id="lblHeadText" class="headText">\r\n');
			var auditTitle = ((this.Data.OrderAuditType === 3) ? '' : '审核');
			this.WriteLiteral('            ');
			this.Write(CoreEx.ToEnumNameString($USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditType).call(null, this.Data.OrderAuditType));
			this.WriteLiteral(' ');
			this.Write(auditTitle);
			this.WriteLiteral('\r\n        </div>\r\n    </div>\r\n    <div class="content scroll" id="pnlContent">\r\n\r\n    </div>\r\n\r\n    <div class="footer">\r\n        <div class="redButton" id="btnAudit">\r\n');
			var auditStr = ((this.Data.OrderAuditType === 3) ? '确认' : '确认审核');
			this.WriteLiteral('            ');
			this.Write(auditStr);
			this.WriteLiteral('\r\n        </div>\r\n    </div>\r\n</div>\r\n\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.btnAudit = this.pageObject.find('#btnAudit');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.btnAudit)) {
				this.btnAudit.unbind().off();
				this.btnAudit = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditAction$OrderAuditActionData, $asm, {});
	ss.initEnum($USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditType, $asm, { 专供机: 1, 尾货: 2, 订单确认: 3 });
	ss.initClass($USOProject_Pages_ApplyAudit_OrderAudit_OrderDetail, $asm, {
		$OrderDetail_OnPageInit: function(sender, e) {
			var $state1 = 0, dataResult, $t1, $t2, $t3, DetailData;
			var $sm1 = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state1) {
						case 0: {
							$state1 = -1;
							dataResult = null;
							if (this.Data.OrderAuditType === 1) {
								$t1 = $USOProject_Business_BusinessAction.SpecificSaleOrder_Get(this.Data.OrderId, this, true);
								$state1 = 2;
								$t1.continueWith($sm1);
								return;
							}
							else if (this.Data.OrderAuditType === 2) {
								$t2 = $USOProject_Business_BusinessAction.ReturnOrderWeiHuo_Get(this.Data.OrderId, this, true);
								$state1 = 3;
								$t2.continueWith($sm1);
								return;
							}
							else {
								$t3 = $USOProject_Business_BusinessAction.WaitConfirmOrder_Get({ SOMasterId: this.Data.OrderId, IsOtherOrderId: null }, this, true);
								$state1 = 4;
								$t3.continueWith($sm1);
								return;
							}
						}
						case 2: {
							$state1 = -1;
							dataResult = $t1.getAwaitedResult();
							$state1 = 1;
							continue $sm1;
						}
						case 3: {
							$state1 = -1;
							dataResult = $t2.getAwaitedResult();
							$state1 = 1;
							continue $sm1;
						}
						case 4: {
							$state1 = -1;
							dataResult = $t3.getAwaitedResult();
							$state1 = 1;
							continue $sm1;
						}
						case 1: {
							$state1 = -1;
							if (!dataResult.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(dataResult.ErrorMessage);
								return;
							}
							DetailData = dataResult.Result;
							this.pnlContent.html(this.GetDetailHtml(DetailData).toString());
							jQueryObjectEx.SetVisible(this.btnAudit, this.Data.IsToAudit);
							this.pageObject.on('click', '.attachButton', ss.thisFix(function(elem, event) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_Adjust_PictureViewer).call(null, DetailData.AttachFiles, null);
							}));
							this.pageObject.on('click', '.productItem', ss.thisFix(function(elem1, event1) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_OrderAudit_OrderProductDetail).call(null, UIDataEx.GetBindData$1(Object).call(null, $(elem1)), null);
							}));
							this.pageObject.on('click', '.flowTrace', ss.thisFix(ss.mkdel(this, function(elem2, event2) {
								var $state = 0, result, $t4, $t5;
								var $sm = ss.mkdel(this, function() {
									$sm1:
									for (;;) {
										switch ($state) {
											case 0: {
												$state = -1;
												result = new (ss.makeGenericType($USOProject_Business_DataServiceResult$1, [$USOProject_Business_WorkFlowProcTrackDTO]))();
												if (this.Data.OrderAuditType === 1) {
													$t4 = $USOProject_Business_BusinessAction.SpecificSaleOrder_GetFlow(this.Data.OrderId, this, true);
													$state = 2;
													$t4.continueWith($sm);
													return;
												}
												else {
													if (this.Data.OrderAuditType === 2) {
														$t5 = $USOProject_Business_BusinessAction.ReturnOrderWeiHuo_GetFlow(this.Data.OrderId, this, true);
														$state = 3;
														$t5.continueWith($sm);
														return;
													}
													$state = 1;
													continue $sm1;
												}
											}
											case 2: {
												$state = -1;
												result = $t4.getAwaitedResult();
												$state = 1;
												continue $sm1;
											}
											case 3: {
												$state = -1;
												result = $t5.getAwaitedResult();
												$state = 1;
												continue $sm1;
											}
											case 1: {
												$state = -1;
												if (!result.IsSuccess) {
													JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
													return;
												}
												if (result.Result.WorkFlowAllStep.length === 0 || result.Result.WorkFlowSteps.length === 0) {
													JSLib.Mobile.MessageBox.Alert('没有相关流程描述');
													return;
												}
												JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Spec_SpecProcTrack).call(null, result.Result, null);
												$state = -1;
												break $sm1;
											}
											default: {
												break $sm1;
											}
										}
									}
								});
								$sm();
							})));
							this.btnAudit.click(ss.mkdel(this, function(event3) {
								var $t7 = new $USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditAction$OrderAuditActionData();
								$t7.OrderId = this.Data.OrderId;
								$t7.OrderAuditType = this.Data.OrderAuditType;
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditAction).call(null, $t7, null);
							}));
							$state1 = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm1();
		},
		PrepareData: function() {
			this.Data = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		GetDetailHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				var item = data.SingleSo;
				var Model = data;
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="AuditDetailPanel ">\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegBody">\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('订单编号', item.Id));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('订单类型', item.SalesOrderType.OrderTypeName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('客户名称', (ss.isValue(item.CustomerLegal) ? item.CustomerLegal.CustomerName : '')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('业务组织', this.Data.StockOrganizationName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('总金额', item.SOAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('创建人', item.CreatedByName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('创建时间', item.CreatedOnString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('业务经理', item.CustomerManagerName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('审核状态', item.OrderStatusString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n\r\n');
				if (ss.isValue(data.AttachFiles) && ss.count(data.AttachFiles) > 0) {
					this.WriteLiteralTo(__razor_helper_writer, '                    <div class="row toolBar">\r\n                        <div class="button attachButton" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(data.AttachFiles));
					this.WriteLiteralTo(__razor_helper_writer, '>附件</div>\r\n                    </div>\r\n');
				}
				this.WriteLiteralTo(__razor_helper_writer, '            </div>\r\n        </div>\r\n\r\n');
				if (this.Data.OrderAuditType === 1 || this.Data.OrderAuditType === 2) {
					this.WriteLiteralTo(__razor_helper_writer, '            <div class="AuditDetailSeg">\r\n                <div class="navItem endNavIcon flowTrace">\r\n                    流程跟踪\r\n                </div>\r\n            </div>\r\n');
				}
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegTitle">\r\n                订单详情\r\n            </div>\r\n            <div class="SegBody">\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('客户代码', item.SalesCustomerLegalName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('销售组织', (ss.isNullOrUndefined(Model.SingleSo.Organization) ? '' : Model.SingleSo.Organization.Name)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('订单来源', Model.SingleSo.OrderFromString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('分销渠道', (ss.isNullOrUndefined(Model.SingleSo.R3Distribution) ? '' : (Model.SingleSo.R3Distribution.R3Code + '-' + Model.SingleSo.R3Distribution.Name))));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('产品组', (ss.isNullOrUndefined(Model.SingleSo.R3ProductGroup) ? '' : (Model.SingleSo.R3ProductGroup.ProductGroupR3Code + '-' + Model.SingleSo.R3ProductGroup.ProductGroupR3Name))));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('仓库', (ss.isNullOrEmptyString(Model.SingleSo.WarehouseName) ? '' : Model.SingleSo.WarehouseName)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('配送方式', (ss.isNullOrUndefined(Model.SingleSo.DeliveryType) ? '' : Model.SingleSo.DeliveryType.DeliveryName)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('收货地址', Model.SingleSo.ReceiveAddressString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('联系电话', item.ContactPhone));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('门店代码', (ss.isNullOrEmptyString(Model.SingleSo.StoreCustomerCode) ? '' : Model.SingleSo.StoreCustomerCode)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('门店名称', Model.SingleSo.StoreName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('一次性客户标题', Model.SingleSo.TitleString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('一次性客户名称', (ss.isNullOrEmptyString(Model.SingleSo.TitleOneName) ? '' : Model.SingleSo.TitleOneName)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('国际贸易条件', ss.coalesce(Model.SingleSo.InternationalName, '')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n\r\n');
				if (this.Data.OrderAuditType === 1) {
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('信用状态', item.CreditStatusString));
				}
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('是否调帐', ((Model.SingleSo.AdjustStatus === 1) ? '是' : '否')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n');
				var specialStatusStr = '';
				if (Model.SingleSo.SpecialStatus !== 0) {
					specialStatusStr = Model.SingleSo.SpecialStatusString;
				}
				else if (Model.NeedSpecial === 1) {
					specialStatusStr = '需要特批';
				}
				else {
					specialStatusStr = '不需要特批';
				}
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('特批状态', specialStatusStr));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n\r\n\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('PO编号', item.PONum));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('退回时间', (!ss.isNullOrEmptyString(Model.SingleSo.BackDate) ? ss.formatDate(DateTimeEx.ToDateTimeForce(Model.SingleSo.BackDate), 'yyyy-MM-dd HH:mm:ss') : '')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('退回原因', ss.coalesce(Model.SingleSo.BackReason, '')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('后台备注', ss.coalesce(Model.SingleSo.Note, '')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            </div>\r\n        </div>\r\n\r\n\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegTitle">\r\n                产品列表\r\n            </div>\r\n            <div class="SegBody">\r\n');
				for (var $t1 = 0; $t1 < data.SingleSo.Items.length; $t1++) {
					var proItem = data.SingleSo.Items[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '                    <div class="productItem endNavIcon" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(proItem));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('物料代码', proItem.R3Code));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('数量', proItem.Quantity));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('价格', proItem.Price));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                    </div>\r\n');
				}
				this.WriteLiteralTo(__razor_helper_writer, '            </div>\r\n        </div>\r\n    </div>\r\n');
			}));
		},
		GetNameValueItem: function(name, value) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="row">\r\n        <div class="name">');
				this.WriteTo(__razor_helper_writer, name);
				this.WriteTo(__razor_helper_writer, ':');
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n        <div class="value">');
				this.WriteTo(__razor_helper_writer, value);
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n    </div>\r\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="OrderDetail">\r\n    <div class="head">\r\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\r\n        <div id="lblHeadText" class="headText">');
			this.Write(CoreEx.ToEnumNameString($USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditType).call(null, this.Data.OrderAuditType));
			this.WriteLiteral(' 详情</div>\r\n    </div>\r\n    <div class="content scroll" id="pnlContent">\r\n\r\n    </div>\r\n    <div class="footer">\r\n        <div class="redButton hidden" id="btnAudit">\r\n');
			var auditStr = ((this.Data.OrderAuditType === 3) ? '确认' : '审核');
			this.WriteLiteral('            ');
			this.Write(auditStr);
			this.WriteLiteral('\r\n        </div>\r\n    </div>\r\n</div>\r\n\r\n');
			this.WriteLiteral('\r\n\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.btnAudit = this.pageObject.find('#btnAudit');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.btnAudit)) {
				this.btnAudit.unbind().off();
				this.btnAudit = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_OrderAudit_OrderDetailData, $asm, {});
	ss.initClass($USOProject_Pages_ApplyAudit_OrderAudit_OrderList, $asm, {
		$OrderList_OnPageShow: function(sender, e) {
			//if (OrderAuditAction.IsAuditComplete)
			//{
			//    OrderAuditAction.IsAuditComplete = true;
			//    if (_iscrollList != null)
			//    {
			//        _iscrollList.ReLoad();
			//    }
			//}
		},
		$OrderList_OnPageInit: function(sender, e) {
			var query = {};
			//query.CreatedOn = DateTime.Now.AddMonths(-1).ToString("yyyy-MM-dd");
			var $t1 = new Date();
			query.CreatedOn = ss.formatDate(new Date($t1.getFullYear() + -1, $t1.getMonth(), $t1.getDate(), $t1.getHours(), $t1.getMinutes(), $t1.getSeconds(), $t1.getMilliseconds()), 'yyyy-MM-dd');
			query.CreatedOnEnd = ss.formatDate(new Date(), 'yyyy-MM-dd');
			this.$CurStatus = 1;
			var $t15 = ss.makeGenericType($USOProject_Business_PageCombineService$1, [Object]);
			var $t2 = [];
			var $t3 = new (ss.makeGenericType($USOProject_Business_SinglePageService$1, [Object]))();
			$t3.set_GetSinglePageData(ss.mkdel(this, function(index) {
				var pageQuery = CoreEx.Clone(Object).call(null, query);
				pageQuery.Page = index;
				pageQuery.PageSize = 10;
				var result = null;
				var tsk = new ss.TaskCompletionSource();
				window.setTimeout(ss.mkdel(this, function() {
					var $state = 0, $t4, $t5;
					var $sm = ss.mkdel(this, function() {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									if (this.$CurStatus === 1) {
										$t4 = $USOProject_Business_BusinessAction.ReturnOrderWeiHuo_SearchWaitAudit(pageQuery, this, true);
										$state = 2;
										$t4.continueWith($sm);
										return;
									}
									else {
										$t5 = $USOProject_Business_BusinessAction.ReturnOrderWeiHuo_SearchAudited(pageQuery, this, true);
										$state = 3;
										$t5.continueWith($sm);
										return;
									}
								}
								case 2: {
									$state = -1;
									result = $t4.getAwaitedResult();
									$state = 1;
									continue $sm1;
								}
								case 3: {
									$state = -1;
									result = $t5.getAwaitedResult();
									$state = 1;
									continue $sm1;
								}
								case 1: {
									$state = -1;
									if (!result.IsSuccess) {
										//MessageBox.Alert(result.ErrorMessage);
										tsk.setResult([]);
										return;
									}
									result.Result.DTO.Result.forEach(function(dto) {
										dto.OrderAuditType = 2;
									});
									$USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage.StockOrganizations = result.Result.StockOrganizations;
									$USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage.R3SalesChannel = result.Result.R3SalesChannel;
									$USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage.R3ProductGroups = result.Result.R3ProductGroups;
									tsk.setResult(result.Result.DTO.Result);
									$state = -1;
									break $sm1;
								}
								default: {
									break $sm1;
								}
							}
						}
					});
					$sm();
				}));
				return tsk.task;
			}));
			$t3.PageSize = 10;
			$t2.push($t3);
			var $t7 = new (ss.makeGenericType($USOProject_Business_SinglePageService$1, [Object]))();
			$t7.set_GetSinglePageData(ss.mkdel(this, function(index1) {
				var pageQuery1 = CoreEx.Clone(Object).call(null, query);
				pageQuery1.Page = index1;
				pageQuery1.PageSize = 10;
				var result1 = null;
				var tsk1 = new ss.TaskCompletionSource();
				window.setTimeout(ss.mkdel(this, function() {
					var $state1 = 0, $t8, $t9;
					var $sm1 = ss.mkdel(this, function() {
						$sm1:
						for (;;) {
							switch ($state1) {
								case 0: {
									$state1 = -1;
									if (this.$CurStatus === 1) {
										$t8 = $USOProject_Business_BusinessAction.SpecificSaleOrder_SearchWaitAudit(pageQuery1, this, true);
										$state1 = 2;
										$t8.continueWith($sm1);
										return;
									}
									else {
										$t9 = $USOProject_Business_BusinessAction.SpecificSaleOrder_SearchAudited(pageQuery1, this, true);
										$state1 = 3;
										$t9.continueWith($sm1);
										return;
									}
								}
								case 2: {
									$state1 = -1;
									result1 = $t8.getAwaitedResult();
									$state1 = 1;
									continue $sm1;
								}
								case 3: {
									$state1 = -1;
									result1 = $t9.getAwaitedResult();
									$state1 = 1;
									continue $sm1;
								}
								case 1: {
									$state1 = -1;
									if (!result1.IsSuccess) {
										//MessageBox.Alert(result.ErrorMessage);
										tsk1.setResult([]);
										return;
									}
									result1.Result.DTO.Result.forEach(function(dto1) {
										dto1.OrderAuditType = 1;
									});
									tsk1.setResult(result1.Result.DTO.Result);
									$state1 = -1;
									break $sm1;
								}
								default: {
									break $sm1;
								}
							}
						}
					});
					$sm1();
				}));
				return tsk1.task;
			}));
			$t7.PageSize = 10;
			$t2.push($t7);
			var $t11 = new (ss.makeGenericType($USOProject_Business_SinglePageService$1, [Object]))();
			$t11.set_GetSinglePageData(ss.mkdel(this, function(index2) {
				var pageQuery2 = CoreEx.Clone(Object).call(null, query);
				pageQuery2.Page = index2;
				pageQuery2.PageSize = 10;
				var result2 = null;
				var tsk2 = new ss.TaskCompletionSource();
				window.setTimeout(ss.mkdel(this, function() {
					var $state2 = 0, $t12, $t13;
					var $sm2 = ss.mkdel(this, function() {
						$sm1:
						for (;;) {
							switch ($state2) {
								case 0: {
									$state2 = -1;
									if (this.$CurStatus === 1) {
										$t12 = $USOProject_Business_BusinessAction.WaitConfirmOrder_SearchWaitAudit(pageQuery2, this, true);
										$state2 = 2;
										$t12.continueWith($sm2);
										return;
									}
									else {
										$t13 = $USOProject_Business_BusinessAction.WaitConfirmOrder_SearchAudited(pageQuery2, this, true);
										$state2 = 3;
										$t13.continueWith($sm2);
										return;
									}
								}
								case 2: {
									$state2 = -1;
									result2 = $t12.getAwaitedResult();
									$state2 = 1;
									continue $sm1;
								}
								case 3: {
									$state2 = -1;
									result2 = $t13.getAwaitedResult();
									$state2 = 1;
									continue $sm1;
								}
								case 1: {
									$state2 = -1;
									if (!result2.IsSuccess) {
										//MessageBox.Alert(result.ErrorMessage);
										tsk2.setResult([]);
										return;
									}
									result2.Result.DTO.Result.forEach(function(dto2) {
										dto2.OrderAuditType = 3;
									});
									tsk2.setResult(result2.Result.DTO.Result);
									$state2 = -1;
									break $sm1;
								}
								default: {
									break $sm1;
								}
							}
						}
					});
					$sm2();
				}));
				return tsk2.task;
			}));
			$t11.PageSize = 10;
			$t2.push($t11);
			var pageCombineDataService = new $t15($t2);
			this.$_iscrollList = this.SetIscrollList(this.pnlDataList[0], 20, 100, true, false, true);
			this.$_iscrollList.set_GetPageData(ss.mkdel(this, function(index3) {
				var $state3 = 0, $tcs = new ss.TaskCompletionSource(), $t16, result3, $t17;
				var $sm3 = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state3) {
								case 0: {
									$state3 = -1;
									query.Page = index3;
									query.PageSize = 30;
									if (index3 === JSLib.Mobile.Application.get_PageIndexStart()) {
										pageCombineDataService.Reset();
									}
									$t16 = pageCombineDataService.GetPageData(query.Page, query.PageSize);
									$state3 = 1;
									$t16.continueWith($sm3);
									return;
								}
								case 1: {
									$state3 = -1;
									result3 = $t16.getAwaitedResult();
									$t17 = new JSLib.IScrollWraper.PageData();
									$t17.PageIndex = index3;
									$t17.RecordCount = result3.length;
									$t17.ResultElement = jQueryObjectEx.ToJqueryObject$1(this.GetDataListHtml(result3));
									$tcs.setResult($t17);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t18) {
						$tcs.setException(ss.Exception.wrap($t18));
					}
				});
				$sm3();
				return $tcs.task;
			}));
			this.$_iscrollList.ReLoad();
			this.pageObject.on('click', '.workTab', ss.thisFix(ss.mkdel(this, function(elem, event) {
				$(elem).addClass('active').siblings().removeClass('active');
				this.$CurStatus = UIDataEx.GetBindData$1(Object).call(null, $(elem));
				this.$_iscrollList.ReLoad();
			})));
			this.pageObject.on('click', '.workItem', ss.thisFix(ss.mkdel(this, function(elem1, event1) {
				var bindData = UIDataEx.GetBindData$1(Object).call(null, $(elem1));
				var $t19 = new $USOProject_Pages_ApplyAudit_OrderAudit_OrderDetailData();
				$t19.OrderId = bindData.Id;
				$t19.IsToAudit = this.$CurStatus === 1;
				$t19.StockOrganizationName = bindData.StockOrganizationName;
				$t19.OrderAuditType = bindData.OrderAuditType;
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_OrderAudit_OrderDetail).call(null, $t19, null);
			})));
			this.btnQuery.click(ss.mkdel(this, function(event2) {
				//查询条件位于首次返回的数据中
				if (ss.isNullOrUndefined($USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage.StockOrganizations)) {
					JSLib.Mobile.MessageBox.Alert('请稍候!');
					return;
				}
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage).call(null, query, ss.mkdel(this, function(page) {
					page.OnQueryComplete = ss.mkdel(this, function(queryResult) {
						query = queryResult;
						JSLib.Mobile.Application.Back(1);
						this.$_iscrollList.ReLoad();
					});
				}));
			}));
		},
		GetDataListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || data.length === 0) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">暂无数据</div>\r\n');
					return;
				}
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="workItem endNavIcon" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(item));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n            <div class="title">\r\n                <div class="ordertype">');
					this.WriteTo(__razor_helper_writer, ss.Enum.toString($USOProject_Pages_ApplyAudit_OrderAudit_OrderAuditType, item.OrderAuditType));
					this.WriteLiteralTo(__razor_helper_writer, ' </div>\r\n                <div class="number">');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n                <div class="status">');
					this.WriteTo(__razor_helper_writer, item.OrderStatusString);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n            </div>\r\n            <div class="detail">\r\n                ');
					this.WriteTo(__razor_helper_writer, item.CreatedOn);
					this.WriteLiteralTo(__razor_helper_writer, '  ');
					this.WriteTo(__razor_helper_writer, (ss.isValue(item.CustomerLegal) ? item.CustomerLegal.CustomerName : ''));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n            </div>\r\n        </div>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="OrderList">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">订单审核列表</div>\n        <div class="queryButton" id="btnQuery"></div>\n\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="workTabs">\n            <div class="workTab active" ');
			this.Write(this.DataBind(1));
			this.WriteLiteral('>审核中</div>\r\n            <div class="workTab" ');
			this.Write(this.DataBind(2));
			this.WriteLiteral('>已审核</div>\r\n        </div>\r\n        <div class="workList" id="pnlDataList"></div>\r\n    </div>\r\n\r\n</div>\r\n\r\n');
			this.WriteLiteral('\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.btnQuery = this.pageObject.find('#btnQuery');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.pnlDataList = this.pageObject.find('#pnlDataList');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.btnQuery)) {
				this.btnQuery.unbind().off();
				this.btnQuery = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.pnlDataList)) {
				this.pnlDataList.unbind().off();
				this.pnlDataList = null;
			}
		}
	}, $USOProject_Pages_ApplyAudit_ApplyAuditBasePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_OrderAudit_OrderProductDetail, $asm, {
		$OrderProductDetail_OnPageInit: function(sender, e) {
			this.ProductData = this.InitialData;
			this.pnlContent.html(this.GetProductDetailsHtml(this.ProductData).toString());
		},
		GetProductDetailsHtml: function(item) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="AuditDetailSeg">\r\n\r\n        <div class="SegBody">\r\n\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('物料代码', item.R3Code));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('物料名称', item.ProductName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('数量', item.Quantity));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('价格', item.Price));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('折扣金额', item.DiscountAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('返利总金额', item.RebateTotalAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('批次', item.Batch));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('是否专供', item.IsSpecialString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('产品定位', item.ProductPosition));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n         </div>\r\n    </div>\r\n');
			}));
		},
		GetNameValueItem: function(name, value) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="row">\r\n        <div class="name">');
				this.WriteTo(__razor_helper_writer, name);
				this.WriteTo(__razor_helper_writer, ':');
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n        <div class="value">');
				this.WriteTo(__razor_helper_writer, value);
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n    </div>\r\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="OrderProductDetail">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">产品详情</div>\n    </div>\n    <div class="content" id="pnlContent">\n\n    </div>\n\n</div>\n\n');
			this.WriteLiteral('\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage, $asm, {
		$OrderQueryPage_OnPageInit: function(sender, e) {
			JSLib.Widget.Common.DateTimeSelector.BindTo(this.txtBeginDate[0]);
			JSLib.Widget.Common.DateTimeSelector.BindTo(this.txtEndDate[0]);
			this.btnQuery.click(ss.mkdel(this, function(event) {
				this.QueryData.Id = CoreEx.ToIntNullable(this.txtId.val());
				this.QueryData.StockOrganizationId = CoreEx.ToIntNullable(this.selStockOrg.val());
				this.QueryData.CustomerLegalName = this.txtCustomerLegalName.val();
				this.QueryData.CustomerLegalId = $JuqeryObjectEx.GetCustomerLegalId(this.txtCustomerLegalName);
				this.QueryData.R3SalesChannelId = CoreEx.ToIntNullable(this.selSaleChannels.val());
				this.QueryData.R3ProductGroupId = CoreEx.ToIntNullable(this.selProductGroup.val());
				this.QueryData.CreatedUserName = this.txtCreator.val();
				this.QueryData.CreatedUserId = $JuqeryObjectEx.GetCustomerLegalId(this.txtCreator);
				this.QueryData.CreatedOn = this.txtBeginDate.val();
				this.QueryData.CreatedOnEnd = this.txtEndDate.val();
				if (this.QueryData.StockOrganizationId === -1) {
					this.QueryData.StockOrganizationId = null;
				}
				if (this.QueryData.R3SalesChannelId === -1) {
					this.QueryData.R3SalesChannelId = null;
				}
				if (this.QueryData.R3ProductGroupId === -1) {
					this.QueryData.R3ProductGroupId = null;
				}
				if (!ss.staticEquals(this.OnQueryComplete, null)) {
					this.OnQueryComplete(this.QueryData);
				}
			}));
		},
		PrepareData: function() {
			this.QueryData = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="OrderQueryPage">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">订单审核查询</div>\n    </div>\n    <div class="content scroll" id="pnlContent">\n        <div class="inputPanel">\n            <div class="inputItem">\n                <div class="title">订单编号:</div>\n                <div class="inputWarp">\n                    <input id="txtId" type="search" placeholder="订单编号" value="');
			this.Write(this.QueryData.Id);
			this.WriteLiteral('">\r\n                </div>\r\n            </div>\r\n\r\n            <div class="inputItem">\r\n                <div class="title">业务组织:</div>\r\n                <div class="inputWarp">\r\n                    <select id="selStockOrg">\r\n');
			var orgSelectData = ss.arrayClone($App.app.userInfo.StockOrganizationList);
			var $t1 = $USOProject_Business_OrganizationList.$ctor();
			$t1.Name = '--请选择--';
			$t1.Id = -1;
			ss.insert(orgSelectData, 0, $t1);
			for (var $t2 = 0; $t2 < orgSelectData.length; $t2++) {
				var item = orgSelectData[$t2];
				var SelectedStr = '';
				if (ss.isValue(this.QueryData.StockOrganizationId) && this.QueryData.StockOrganizationId === item.Id) {
					SelectedStr = "selected='selected'";
				}
				this.WriteLiteral('                            <option value="');
				this.Write(item.Id);
				this.WriteLiteral('" ');
				this.Write(SelectedStr);
				this.WriteLiteral('>');
				this.Write(item.Name);
				this.WriteLiteral('</option>\r\n');
			}
			this.WriteLiteral('                    </select>\n                </div>\n            </div>\n\n            <div class="inputItem">\n                <div class="title">客户名称:</div>\n                <div class="inputWarp">\n                    <input id="txtCustomerLegalName" type="search" class="chooseCustomer" readonly="readonly" placeholder="客户名称" value="');
			this.Write(this.QueryData.CustomerLegalName);
			this.WriteLiteral('">\r\n                </div>\r\n            </div>\r\n\r\n            <div class="inputItem">\r\n                <div class="title">分销渠道:</div>\r\n                <div class="inputWarp">\r\n                    <select id="selSaleChannels">\r\n');
			for (var $t3 = 0; $t3 < $USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage.R3SalesChannel.length; $t3++) {
				var item1 = $USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage.R3SalesChannel[$t3];
				var SelectedStr1 = '';
				if (ss.isValue(this.QueryData.R3SalesChannelId) && ss.referenceEquals(this.QueryData.R3SalesChannelId.toString(), item1.Value)) {
					SelectedStr1 = "selected='selected'";
				}
				this.WriteLiteral('                            <option value="');
				this.Write(item1.Value);
				this.WriteLiteral('" ');
				this.Write(SelectedStr1);
				this.WriteLiteral('>');
				this.Write(item1.Text);
				this.WriteLiteral('</option>\r\n');
			}
			this.WriteLiteral('                    </select>\r\n                </div>\r\n            </div>\r\n\r\n            <div class="inputItem">\r\n                <div class="title">产品组:</div>\r\n                <div class="inputWarp">\r\n                    <select id="selProductGroup">\r\n');
			for (var $t4 = 0; $t4 < $USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage.R3ProductGroups.length; $t4++) {
				var item2 = $USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage.R3ProductGroups[$t4];
				var SelectedStr2 = '';
				if (ss.isValue(this.QueryData.R3ProductGroupId) && ss.referenceEquals(this.QueryData.R3ProductGroupId.toString(), item2.Value)) {
					SelectedStr2 = "selected='selected'";
				}
				this.WriteLiteral('                            <option value="');
				this.Write(item2.Value);
				this.WriteLiteral('" ');
				this.Write(SelectedStr2);
				this.WriteLiteral('>');
				this.Write(item2.Text);
				this.WriteLiteral('</option>\r\n');
			}
			this.WriteLiteral('                    </select>\n                </div>\n            </div>\n\n\n            <div class="inputItem">\n                <div class="title">创建人:</div>\n                <div class="inputWarp">\n                    <input id="txtCreator" type="search" readonly="readonly" class="chooseUser" placeholder="创建人" value="');
			this.Write(this.QueryData.CreatedUserName);
			this.WriteLiteral('">\n                </div>\n            </div>\n\n            <div class="inputItem">\n                <div class="title">开始日期:</div>\n                <div class="inputWarp">\n                    <input id="txtBeginDate" type="text" placeholder="开始日期" readonly="readonly" value="');
			this.Write(this.QueryData.CreatedOn);
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="inputItem">\n                <div class="title">结束日期:</div>\n                <div class="inputWarp">\n                    <input id="txtEndDate" type="text" placeholder="结束日期" readonly="readonly" class="" value="');
			this.Write(this.QueryData.CreatedOnEnd);
			this.WriteLiteral('">\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n    </div>\r\n\r\n    <div class="footer">\r\n        <div class="redButton" id="btnQuery">查询</div>\r\n    </div>\r\n</div>\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.txtId = this.pageObject.find('#txtId');
			this.selStockOrg = this.pageObject.find('#selStockOrg');
			this.txtCustomerLegalName = this.pageObject.find('#txtCustomerLegalName');
			this.selSaleChannels = this.pageObject.find('#selSaleChannels');
			this.selProductGroup = this.pageObject.find('#selProductGroup');
			this.txtCreator = this.pageObject.find('#txtCreator');
			this.txtBeginDate = this.pageObject.find('#txtBeginDate');
			this.txtEndDate = this.pageObject.find('#txtEndDate');
			this.btnQuery = this.pageObject.find('#btnQuery');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.txtId)) {
				this.txtId.unbind().off();
				this.txtId = null;
			}
			if (ss.isValue(this.selStockOrg)) {
				this.selStockOrg.unbind().off();
				this.selStockOrg = null;
			}
			if (ss.isValue(this.txtCustomerLegalName)) {
				this.txtCustomerLegalName.unbind().off();
				this.txtCustomerLegalName = null;
			}
			if (ss.isValue(this.selSaleChannels)) {
				this.selSaleChannels.unbind().off();
				this.selSaleChannels = null;
			}
			if (ss.isValue(this.selProductGroup)) {
				this.selProductGroup.unbind().off();
				this.selProductGroup = null;
			}
			if (ss.isValue(this.txtCreator)) {
				this.txtCreator.unbind().off();
				this.txtCreator = null;
			}
			if (ss.isValue(this.txtBeginDate)) {
				this.txtBeginDate.unbind().off();
				this.txtBeginDate = null;
			}
			if (ss.isValue(this.txtEndDate)) {
				this.txtEndDate.unbind().off();
				this.txtEndDate = null;
			}
			if (ss.isValue(this.btnQuery)) {
				this.btnQuery.unbind().off();
				this.btnQuery = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderAuditAction, $asm, {
		$OtherOrderAuditAction_OnPageInit: function(sender, e) {
			this.btnAudit.click(ss.mkdel(this, function(event) {
				var $state = 0, chkStatus, $t1, data, $t2, result, result1;
				var $sm = ss.mkdel(this, function() {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								chkStatus = this.pageObject.find('#pnlAuditOptions>.chkBox.active');
								if (chkStatus.length === 0) {
									JSLib.Mobile.MessageBox.Alert('请选择处理状态!');
									return;
								}
								//确认
								if (chkStatus.attr('data-value') === '1') {
									$t1 = $USOProject_Business_BusinessAction.OtherOrder_DoAudit(this.MasterId, this, true);
									$state = 2;
									$t1.continueWith($sm);
									return;
								}
								else {
									data = {};
									data.MasterId = this.MasterId;
									data.Reason = this.txtRemark.val().trim();
									if (ss.isNullOrEmptyString(data.Reason)) {
										JSLib.Mobile.MessageBox.Alert('请填写退回原因!');
										return;
									}
									$t2 = $USOProject_Business_BusinessAction.OtherOrder_DoReturnBack(data, this, true);
									$state = 3;
									$t2.continueWith($sm);
									return;
								}
							}
							case 2: {
								$state = -1;
								result = $t1.getAwaitedResult();
								if (!result.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
									return;
								}
								JSLib.Mobile.MessageBox.Alert('审核成功!');
								$state = 1;
								continue $sm1;
							}
							case 3: {
								$state = -1;
								result1 = $t2.getAwaitedResult();
								if (!result1.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(result1.ErrorMessage);
									return;
								}
								JSLib.Mobile.MessageBox.Alert('审核成功!');
								$state = 1;
								continue $sm1;
							}
							case 1: {
								$state = -1;
								$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderAuditAction.IsAuditComplete = true;
								JSLib.Mobile.Application.BackTo($USOProject_Pages_HomePage).call(null);
								$USOProject_Pages_Control_MyWorkControl.TriggerTodoWorkChange();
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				});
				$sm();
			}));
			this.pnlAuditOptions.change(ss.mkdel(this, function(event1) {
				jQueryObjectEx.SetVisible(this.pnlBackReason, this.chkBack.hasClass('active'));
			}));
			this.pnlBackReason.hide();
		},
		PrepareData: function() {
			this.MasterId = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="OtherOrderAuditAction">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">异地订单审核</div>\n    </div>\n    <div class="content scroll" id="pnlContent">\n        <div class="AuditDetailSeg">\n            <div class="row">\n                <div class="name">处理状态:</div>\n                <div class="value">\n                    <div class="radioPanel" id="pnlAuditOptions">\n                        <span class="chkBox" data-value="1">确认</span>\n                        <span class="chkBox" data-value="0" id="chkBack">退回</span>\n                    </div>\n                </div>\n            </div>\n\n            <div class="row" id="pnlBackReason">\n                <div class="name">退回原因:</div>\n                <div class="value">\n                    <input type="text" id="txtRemark" placeholder="退回原因" value="" />\n                </div>\n            </div>\n        </div>\n    </div>\n\n    <div class="footer">\n        <div class="redButton" id="btnAudit">\n            确认审核\n        </div>\n    </div>\n</div>\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.pnlAuditOptions = this.pageObject.find('#pnlAuditOptions');
			this.chkBack = this.pageObject.find('#chkBack');
			this.pnlBackReason = this.pageObject.find('#pnlBackReason');
			this.txtRemark = this.pageObject.find('#txtRemark');
			this.btnAudit = this.pageObject.find('#btnAudit');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.pnlAuditOptions)) {
				this.pnlAuditOptions.unbind().off();
				this.pnlAuditOptions = null;
			}
			if (ss.isValue(this.chkBack)) {
				this.chkBack.unbind().off();
				this.chkBack = null;
			}
			if (ss.isValue(this.pnlBackReason)) {
				this.pnlBackReason.unbind().off();
				this.pnlBackReason = null;
			}
			if (ss.isValue(this.txtRemark)) {
				this.txtRemark.unbind().off();
				this.txtRemark = null;
			}
			if (ss.isValue(this.btnAudit)) {
				this.btnAudit.unbind().off();
				this.btnAudit = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderDetail, $asm, {
		$OtherOrderDetail_OnPageInit: function(sender, e) {
			var $state = 0, $t1, dataResult, DetailData;
			var $sm = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							$t1 = $USOProject_Business_BusinessAction.OtherOrder_Get({ SoMasterId: this.Data.Id, IsOtherOrderId: -1 }, this, true);
							$state = 1;
							$t1.continueWith($sm);
							return;
						}
						case 1: {
							$state = -1;
							dataResult = $t1.getAwaitedResult();
							if (!dataResult.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(dataResult.ErrorMessage);
								return;
							}
							DetailData = dataResult.Result;
							this.pnlContent.html(this.GetDetailHtml(DetailData).toString());
							jQueryObjectEx.SetVisible(this.btnAudit, this.Data.IsToAudit);
							this.pageObject.on('click', '.attachButton', ss.thisFix(function(elem, event) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_Adjust_PictureViewer).call(null, DetailData.SingleSo.AttachFiles, null);
							}));
							this.pageObject.on('click', '.productItem', ss.thisFix(function(elem1, event1) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderProductDetail).call(null, UIDataEx.GetBindData$1(Object).call(null, $(elem1)), null);
							}));
							this.btnAudit.click(ss.mkdel(this, function(event2) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderAuditAction).call(null, this.Data.Id, null);
							}));
							$state = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm();
		},
		PrepareData: function() {
			this.Data = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		GetDetailHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				var item = data.SingleSo;
				var Model = data;
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="AuditDetailPanel ">\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegBody">\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('编号', item.Id));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('订单类型', (ss.isNullOrUndefined(Model.SingleSo.SalesOrderType) ? '' : Model.SingleSo.SalesOrderType.OrderTypeName)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('客户名称', (ss.isNullOrUndefined(item.CustomerLegal) ? '' : item.CustomerLegal.CustomerName)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('业务组织', this.Data.StockOrgName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('总金额', item.SOAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('创建人', (ss.isNullOrEmptyString(Model.SingleSo.CreatedByName) ? '' : Model.SingleSo.CreatedByName)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('创建时间', Model.SingleSo.CreatedOnString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('业务经理', item.CustomerManagerName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('审核状态', item.OrderStatusString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n');
				if (ss.isValue(item.AttachFiles) && ss.count(item.AttachFiles) > 0) {
					this.WriteLiteralTo(__razor_helper_writer, '                    <div class="row toolBar">\r\n                        <div class="button attachButton" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(item.AttachFiles));
					this.WriteLiteralTo(__razor_helper_writer, '>附件</div>\r\n                    </div>\r\n');
				}
				this.WriteLiteralTo(__razor_helper_writer, '            </div>\r\n        </div>\r\n\r\n\r\n\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegTitle">\r\n                订单详情\r\n            </div>\r\n            <div class="SegBody">\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('客户代码', item.SalesCustomerLegalName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('销售组织', (ss.isNullOrUndefined(Model.SingleSo.Organization) ? '' : Model.SingleSo.Organization.Name)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('异地销售组织', Model.SingleSo.OtherOrganzationName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('订单来源', Model.SingleSo.OrderFromString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('分销渠道', (ss.isNullOrUndefined(Model.SingleSo.R3Distribution) ? '' : (Model.SingleSo.R3Distribution.R3Code + '-' + Model.SingleSo.R3Distribution.Name))));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('产品组', (ss.isNullOrUndefined(Model.SingleSo.R3ProductGroup) ? '' : (Model.SingleSo.R3ProductGroup.ProductGroupR3Code + '-' + Model.SingleSo.R3ProductGroup.ProductGroupR3Name))));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('仓库', (ss.isNullOrEmptyString(Model.SingleSo.WarehouseName) ? '' : Model.SingleSo.WarehouseName)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('配送方式', (ss.isNullOrUndefined(Model.SingleSo.DeliveryType) ? '' : Model.SingleSo.DeliveryType.DeliveryName)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('收货地址', Model.SingleSo.ReceiveAddressString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('联系电话', item.ContactPhone));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('门店代码', (ss.isNullOrEmptyString(Model.SingleSo.StoreCustomerCode) ? '' : Model.SingleSo.StoreCustomerCode)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('门店名称', Model.SingleSo.StoreName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('一次性客户标题', Model.SingleSo.TitleString));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('一次性客户名称', (ss.isNullOrEmptyString(Model.SingleSo.TitleOneName) ? '' : Model.SingleSo.TitleOneName)));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('国际贸易条件', ss.coalesce(Model.SingleSo.InternationalName, '')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('是否调帐', ((Model.SingleSo.AdjustStatus === 1) ? '是' : '否')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n');
				var specialStatusStr = '';
				if (Model.SingleSo.SpecialStatus !== 0) {
					specialStatusStr = Model.SingleSo.SpecialStatusString;
				}
				else if (Model.NeedSpecial === 1) {
					specialStatusStr = '需要特批';
				}
				else {
					specialStatusStr = '不需要特批';
				}
				this.WriteLiteralTo(__razor_helper_writer, '                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('特批状态', specialStatusStr));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n');
				if (Model.SingleSo.OrderTypeGroup === 1 || Model.SingleSo.OrderTypeGroup === 2 || Model.SingleSo.OrderTypeGroup === 11 || Model.SingleSo.OrderTypeGroup === 3 || Model.SingleSo.OrderTypeGroup === 6 || Model.SingleSo.OrderTypeGroup === 12) {
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('信用状态', Model.SingleSo.CreditStatusString));
				}
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('PO编号', item.PONum));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('退回时间', (!ss.isNullOrEmptyString(Model.SingleSo.BackDate) ? ss.formatDate(DateTimeEx.ToDateTimeForce(Model.SingleSo.BackDate), 'yyyy-MM-dd HH:mm:ss') : '')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('退回原因', ss.coalesce(Model.SingleSo.BackReason, '')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n                ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('后台备注', ss.coalesce(Model.SingleSo.Note, '')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n\r\n            </div>\r\n        </div>\r\n\r\n        <div class="AuditDetailSeg">\r\n            <div class="SegTitle">\r\n                产品列表\r\n            </div>\r\n            <div class="SegBody">\r\n');
				for (var $t1 = 0; $t1 < data.SingleSo.Items.length; $t1++) {
					var proItem = data.SingleSo.Items[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '                    <div class="productItem endNavIcon" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(proItem));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('物料代码', proItem.R3Code));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('数量', proItem.Quantity));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                        ');
					this.WriteTo(__razor_helper_writer, this.GetNameValueItem('价格', proItem.Price));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                    </div>\r\n');
				}
				this.WriteLiteralTo(__razor_helper_writer, '            </div>\r\n        </div>\r\n    </div>\r\n');
			}));
		},
		GetNameValueItem: function(name, value) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="row">\r\n        <div class="name">');
				this.WriteTo(__razor_helper_writer, name);
				this.WriteTo(__razor_helper_writer, ':');
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n        <div class="value">');
				this.WriteTo(__razor_helper_writer, value);
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n    </div>\r\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="OtherOrderDetail">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">异地订单详情</div>\n    </div>\n    <div class="content scroll" id="pnlContent">\n\n    </div>\n    <div class="footer">\n        <div class="redButton hidden" id="btnAudit">\n            审核\n        </div>\n    </div>\n</div>\n\n');
			this.WriteLiteral('\r\n\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.btnAudit = this.pageObject.find('#btnAudit');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.btnAudit)) {
				this.btnAudit.unbind().off();
				this.btnAudit = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderDetailData, $asm, {});
	ss.initClass($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderList, $asm, {
		$OtherOrderList_OnPageShow: function(sender, e) {
			if ($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderAuditAction.IsAuditComplete) {
				$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderAuditAction.IsAuditComplete = true;
				if (ss.isValue(this.$_iscrollList)) {
					this.$_iscrollList.ReLoad();
				}
			}
		},
		$OtherOrderList_OnPageInit: function(sender, e) {
			var query = {};
			//query.CreatedOn = DateTime.Now.AddMonths(-1).ToString("yyyy-MM-dd");
			var $t1 = new Date();
			query.CreatedOn = ss.formatDate(new Date($t1.getFullYear() + -1, $t1.getMonth(), $t1.getDate(), $t1.getHours(), $t1.getMinutes(), $t1.getSeconds(), $t1.getMilliseconds()), 'yyyy-MM-dd');
			query.CreatedOnEnd = ss.formatDate(new Date(), 'yyyy-MM-dd');
			this.$_iscrollList = this.SetIscrollList(this.pnlDataList[0], 20, 100, true, false, true);
			this.$_iscrollList.set_GetPageData(ss.mkdel(this, function(index) {
				var $state = 0, $tcs = new ss.TaskCompletionSource(), result, $t2, $t3, datalist, $t4;
				var $sm = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									query.Page = index;
									query.PageSize = 20;
									if (this.$CurStatus === 1) {
										$t2 = $USOProject_Business_BusinessAction.OtherOrder_SearchWaitAudit(query, this, true);
										$state = 2;
										$t2.continueWith($sm);
										return;
									}
									else {
										$t3 = $USOProject_Business_BusinessAction.OtherOrder_SearchAudited(query, this, true);
										$state = 3;
										$t3.continueWith($sm);
										return;
									}
								}
								case 2: {
									$state = -1;
									result = $t2.getAwaitedResult();
									$state = 1;
									continue $sm1;
								}
								case 3: {
									$state = -1;
									result = $t3.getAwaitedResult();
									$state = 1;
									continue $sm1;
								}
								case 1: {
									$state = -1;
									if (!result.IsSuccess) {
										JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
										$tcs.setResult(new JSLib.IScrollWraper.PageData());
										return;
									}
									$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.StockOrganizations = result.Result.StockOrganizations;
									$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.R3SalesChannel = result.Result.R3SalesChannel;
									$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.R3ProductGroups = result.Result.R3ProductGroups;
									datalist = result.Result.SOMaster;
									$t4 = new JSLib.IScrollWraper.PageData();
									$t4.PageIndex = index;
									$t4.RecordCount = (ss.isNullOrUndefined(datalist) ? 0 : datalist.Result.length);
									$t4.ResultElement = jQueryObjectEx.ToJqueryObject$1(this.GetDataListHtml(datalist));
									$tcs.setResult($t4);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t5) {
						$tcs.setException(ss.Exception.wrap($t5));
					}
				});
				$sm();
				return $tcs.task;
			}));
			this.$_iscrollList.ReLoad();
			this.pageObject.on('click', '.workTab', ss.thisFix(ss.mkdel(this, function(elem, event) {
				$(elem).addClass('active').siblings().removeClass('active');
				this.$CurStatus = UIDataEx.GetBindData$1(Object).call(null, $(elem));
				this.$_iscrollList.ReLoad();
			})));
			this.pageObject.on('click', '.workItem', ss.thisFix(ss.mkdel(this, function(elem1, event1) {
				var bindData = UIDataEx.GetBindData$1(Object).call(null, $(elem1));
				var $t6 = new $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderDetailData();
				$t6.Id = bindData.Id;
				$t6.StockOrgName = bindData.StockOrganizationName;
				$t6.IsToAudit = this.$CurStatus === 1;
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderDetail).call(null, $t6, null);
			})));
			this.btnQuery.click(ss.mkdel(this, function(event2) {
				if (ss.isNullOrUndefined($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.StockOrganizations)) {
					return;
				}
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage).call(null, query, ss.mkdel(this, function(page) {
					page.OnQueryComplete = ss.mkdel(this, function(queryResult) {
						query = queryResult;
						JSLib.Mobile.Application.Back(1);
						this.$_iscrollList.ReLoad();
					});
				}));
			}));
		},
		GetDataListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || data.Total === 0) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">暂无数据</div>\r\n');
					return;
				}
				for (var $t1 = 0; $t1 < data.Result.length; $t1++) {
					var item = data.Result[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="workItem endNavIcon" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(item));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n            <div class="title">\r\n                <div class="number">');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n                <div class="status">');
					this.WriteTo(__razor_helper_writer, item.OrderStatusString);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n            </div>\r\n            <div class="detail">\r\n                ');
					this.WriteTo(__razor_helper_writer, item.CreatedOn);
					this.WriteLiteralTo(__razor_helper_writer, '  ');
					this.WriteTo(__razor_helper_writer, (ss.isValue(item.CustomerLegal) ? item.CustomerLegal.CustomerName : ''));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n            </div>\r\n        </div>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="OtherOrderList">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">异地订单审核列表</div>\n        <div class="queryButton" id="btnQuery"></div>\n\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="workTabs">\n            <div class="workTab active" ');
			this.Write(this.DataBind(1));
			this.WriteLiteral('>审核中</div>\r\n            <div class="workTab" ');
			this.Write(this.DataBind(2));
			this.WriteLiteral('>已审核</div>\r\n        </div>\r\n        <div class="workList" id="pnlDataList"></div>\r\n    </div>\r\n\r\n</div>\r\n\r\n');
			this.WriteLiteral('\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.btnQuery = this.pageObject.find('#btnQuery');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.pnlDataList = this.pageObject.find('#pnlDataList');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.btnQuery)) {
				this.btnQuery.unbind().off();
				this.btnQuery = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.pnlDataList)) {
				this.pnlDataList.unbind().off();
				this.pnlDataList = null;
			}
		}
	}, $USOProject_Pages_ApplyAudit_ApplyAuditBasePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderProductDetail, $asm, {
		$OtherOrderProductDetail_OnPageInit: function(sender, e) {
			this.ProductData = this.InitialData;
			this.pnlContent.html(this.GetProductDetailsHtml(this.ProductData).toString());
		},
		GetProductDetailsHtml: function(item) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="AuditDetailSeg">\r\n\r\n        <div class="SegBody">\r\n\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('物料代码', item.R3Code));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('物料名称', item.ProductName));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('数量', item.Quantity));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('价格', item.Price));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('折扣金额', item.DiscountAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('返利总金额', item.RebateTotalAmt));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('批次', item.Batch));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n            ');
				this.WriteTo(__razor_helper_writer, this.GetNameValueItem('是否专供', ((item.IsSpecial === 1) ? '是' : '否')));
				this.WriteLiteralTo(__razor_helper_writer, '\r\n        </div>\r\n    </div>\r\n');
			}));
		},
		GetNameValueItem: function(name, value) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="row">\r\n        <div class="name">');
				this.WriteTo(__razor_helper_writer, name);
				this.WriteTo(__razor_helper_writer, ':');
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n        <div class="value">');
				this.WriteTo(__razor_helper_writer, value);
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n    </div>\r\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="OtherOrderProductDetail">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">异地产品详情</div>\n    </div>\n    <div class="content" id="pnlContent">\n\n    </div>\n\n</div>\n\n');
			this.WriteLiteral('\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage, $asm, {
		$OtherOrderQueryPage_OnPageInit: function(sender, e) {
			JSLib.Widget.Common.DateTimeSelector.BindTo(this.txtBeginDate[0]);
			JSLib.Widget.Common.DateTimeSelector.BindTo(this.txtEndDate[0]);
			this.btnQuery.click(ss.mkdel(this, function(event) {
				this.QueryData.Id = CoreEx.ToIntNullable(this.txtId.val());
				this.QueryData.StockOrganizationId = CoreEx.ToIntNullable(this.selStockOrg.val());
				this.QueryData.CustomerLegalName = this.txtCustomerLegalName.val();
				this.QueryData.CustomerLegalId = $JuqeryObjectEx.GetCustomerLegalId(this.txtCustomerLegalName);
				this.QueryData.R3SalesChannelId = CoreEx.ToIntNullable(this.selSaleChannels.val());
				this.QueryData.R3ProductGroupId = CoreEx.ToIntNullable(this.selProductGroup.val());
				this.QueryData.CreatedUserName = this.txtCreator.val();
				this.QueryData.CreatedUserId = $JuqeryObjectEx.GetCustomerLegalId(this.txtCreator);
				this.QueryData.CreatedOn = this.txtBeginDate.val();
				this.QueryData.CreatedOnEnd = this.txtEndDate.val();
				if (this.QueryData.StockOrganizationId === -1) {
					this.QueryData.StockOrganizationId = null;
				}
				if (this.QueryData.R3SalesChannelId === -1) {
					this.QueryData.R3SalesChannelId = null;
				}
				if (this.QueryData.R3ProductGroupId === -1) {
					this.QueryData.R3ProductGroupId = null;
				}
				if (!ss.staticEquals(this.OnQueryComplete, null)) {
					this.OnQueryComplete(this.QueryData);
				}
			}));
		},
		PrepareData: function() {
			this.QueryData = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="OtherOrderQueryPage">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">异地订单查询</div>\n    </div>\n    <div class="content scroll" id="pnlContent">\n        <div class="inputPanel">\n            <div class="inputItem">\n                <div class="title">订单编号:</div>\n                <div class="inputWarp">\n                    <input id="txtId" type="search" placeholder="订单编号" value="');
			this.Write(this.QueryData.Id);
			this.WriteLiteral('">\r\n                </div>\r\n            </div>\r\n\r\n            <div class="inputItem">\r\n                <div class="title">业务组织:</div>\r\n                <div class="inputWarp">\r\n                    <select id="selStockOrg">\r\n');
			var orgSelectData = ss.arrayClone($App.app.userInfo.StockOrganizationList);
			var $t1 = $USOProject_Business_OrganizationList.$ctor();
			$t1.Name = '--请选择--';
			$t1.Id = -1;
			ss.insert(orgSelectData, 0, $t1);
			for (var $t2 = 0; $t2 < orgSelectData.length; $t2++) {
				var item = orgSelectData[$t2];
				var SelectedStr = '';
				if (ss.isValue(this.QueryData.StockOrganizationId) && this.QueryData.StockOrganizationId === item.Id) {
					SelectedStr = "selected='selected'";
				}
				this.WriteLiteral('                            <option value="');
				this.Write(item.Id);
				this.WriteLiteral('" ');
				this.Write(SelectedStr);
				this.WriteLiteral('>');
				this.Write(item.Name);
				this.WriteLiteral('</option>\r\n');
			}
			this.WriteLiteral('                    </select>\n                </div>\n            </div>\n\n            <div class="inputItem">\n                <div class="title">客户名称:</div>\n                <div class="inputWarp">\n                    <input id="txtCustomerLegalName" type="search" readonly="readonly" class="chooseCustomer" placeholder="客户名称" value="');
			this.Write(this.QueryData.CustomerLegalName);
			this.WriteLiteral('">\r\n                </div>\r\n            </div>\r\n \r\n            <div class="inputItem">\r\n                <div class="title">分销渠道:</div>\r\n                <div class="inputWarp">\r\n                    <select id="selSaleChannels">\r\n');
			for (var $t3 = 0; $t3 < $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.R3SalesChannel.length; $t3++) {
				var item1 = $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.R3SalesChannel[$t3];
				var SelectedStr1 = '';
				if (ss.isValue(this.QueryData.R3SalesChannelId) && ss.referenceEquals(this.QueryData.R3SalesChannelId.toString(), item1.Value)) {
					SelectedStr1 = "selected='selected'";
				}
				this.WriteLiteral('                            <option value="');
				this.Write(item1.Value);
				this.WriteLiteral('" ');
				this.Write(SelectedStr1);
				this.WriteLiteral('>');
				this.Write(item1.Text);
				this.WriteLiteral('</option>\r\n');
			}
			this.WriteLiteral('                    </select>\r\n                </div>\r\n            </div>\r\n\r\n            <div class="inputItem">\r\n                <div class="title">产品组:</div>\r\n                <div class="inputWarp">\r\n                    <select id="selProductGroup">\r\n');
			for (var $t4 = 0; $t4 < $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.R3ProductGroups.length; $t4++) {
				var item2 = $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.R3ProductGroups[$t4];
				var SelectedStr2 = '';
				if (ss.isValue(this.QueryData.R3ProductGroupId) && ss.referenceEquals(this.QueryData.R3ProductGroupId.toString(), item2.Value)) {
					SelectedStr2 = "selected='selected'";
				}
				this.WriteLiteral('                            <option value="');
				this.Write(item2.Value);
				this.WriteLiteral('" ');
				this.Write(SelectedStr2);
				this.WriteLiteral('>');
				this.Write(item2.Text);
				this.WriteLiteral('</option>\r\n');
			}
			this.WriteLiteral('                    </select>\n                </div>\n            </div>\n\n\n            <div class="inputItem">\n                <div class="title">创建人:</div>\n                <div class="inputWarp">\n                    <input id="txtCreator" type="search" readonly="readonly" class="chooseUser" placeholder="创建人" value="');
			this.Write(this.QueryData.CreatedUserName);
			this.WriteLiteral('">\n                </div>\n            </div>\n\n            <div class="inputItem">\n                <div class="title">开始日期:</div>\n                <div class="inputWarp">\n                    <input id="txtBeginDate" type="text" placeholder="开始日期" readonly="readonly" value="');
			this.Write(this.QueryData.CreatedOn);
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="inputItem">\n                <div class="title">结束日期:</div>\n                <div class="inputWarp">\n                    <input id="txtEndDate" type="text" placeholder="结束日期" readonly="readonly" class="" value="');
			this.Write(this.QueryData.CreatedOnEnd);
			this.WriteLiteral('">\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n    </div>\r\n    \r\n    <div class="footer">\r\n        <div class="redButton" id="btnQuery">查询</div>\r\n    </div>\r\n</div>\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.txtId = this.pageObject.find('#txtId');
			this.selStockOrg = this.pageObject.find('#selStockOrg');
			this.txtCustomerLegalName = this.pageObject.find('#txtCustomerLegalName');
			this.selSaleChannels = this.pageObject.find('#selSaleChannels');
			this.selProductGroup = this.pageObject.find('#selProductGroup');
			this.txtCreator = this.pageObject.find('#txtCreator');
			this.txtBeginDate = this.pageObject.find('#txtBeginDate');
			this.txtEndDate = this.pageObject.find('#txtEndDate');
			this.btnQuery = this.pageObject.find('#btnQuery');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.txtId)) {
				this.txtId.unbind().off();
				this.txtId = null;
			}
			if (ss.isValue(this.selStockOrg)) {
				this.selStockOrg.unbind().off();
				this.selStockOrg = null;
			}
			if (ss.isValue(this.txtCustomerLegalName)) {
				this.txtCustomerLegalName.unbind().off();
				this.txtCustomerLegalName = null;
			}
			if (ss.isValue(this.selSaleChannels)) {
				this.selSaleChannels.unbind().off();
				this.selSaleChannels = null;
			}
			if (ss.isValue(this.selProductGroup)) {
				this.selProductGroup.unbind().off();
				this.selProductGroup = null;
			}
			if (ss.isValue(this.txtCreator)) {
				this.txtCreator.unbind().off();
				this.txtCreator = null;
			}
			if (ss.isValue(this.txtBeginDate)) {
				this.txtBeginDate.unbind().off();
				this.txtBeginDate = null;
			}
			if (ss.isValue(this.txtEndDate)) {
				this.txtEndDate.unbind().off();
				this.txtEndDate = null;
			}
			if (ss.isValue(this.btnQuery)) {
				this.btnQuery.unbind().off();
				this.btnQuery = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Common_AddressDataInfo, $asm, {});
	ss.initClass($USOProject_Pages_Common_AddressDataInfoEx, $asm, {});
	ss.initClass($USOProject_Pages_Common_AddressSelector, $asm, {
		$OnOnPageShow: function(sender, eventArgs) {
			var provinceData = Enumerable.from($USOProject_Pages_Common_AddressSelector.get_AddressData()).where(function(n) {
				return n.PId === 1;
			}).toArray();
			this.address_select_province.html(this.GetOptionList(provinceData, '省份').toString());
			//如果包含初始数据，则加载到对应的地址数据
			var pageData = this.InitialData;
			if (ss.isValue(pageData)) {
				if (pageData.ProvinceID !== 0) {
					this.address_select_province.val(pageData.ProvinceID.toString());
					this.address_select_province.change();
					if (pageData.CityID !== 0) {
						this.address_select_city.val(pageData.CityID.toString());
						this.address_select_city.change();
						if (pageData.CountyID !== 0) {
							this.address_select_town.val(pageData.CountyID.toString());
							this.address_select_town.change();
						}
					}
				}
			}
		},
		$AddressSelector_OnPageInit: function(sender, e) {
			this.address_select_province.change(ss.mkdel(this, function(event) {
				var provineId = CoreEx.ToInt(this.address_select_province.val(), 0);
				if (provineId === 0) {
					this.address_select_city.val('0').change();
				}
				var cityData = Enumerable.from($USOProject_Pages_Common_AddressSelector.get_AddressData()).where(function(n) {
					return n.PId === provineId;
				}).toArray();
				this.address_select_city.html(this.GetOptionList(cityData, '城市').toString());
				if (cityData.length > 0) {
					this.address_select_city.val(cityData[0].Id.toString());
					this.address_select_city.change();
				}
			}));
			this.address_select_city.change(ss.mkdel(this, function(event1) {
				var cityId = CoreEx.ToInt(this.address_select_city.val(), 0);
				if (cityId === 0) {
					this.address_select_town.val('0').change();
				}
				var townData = Enumerable.from($USOProject_Pages_Common_AddressSelector.get_AddressData()).where(function(n1) {
					return n1.PId === cityId;
				}).toArray();
				this.address_select_town.html(this.GetOptionList(townData, '区县').toString());
				if (townData.length > 0) {
					this.address_select_town.val(townData[0].Id.toString());
					this.address_select_town.change();
				}
			}));
			this.btnFinished.click(ss.mkdel(this, function(event2) {
				var data = $USOProject_Pages_Common_AddressDataInfo.$ctor();
				var provineId1 = CoreEx.ToInt(this.address_select_province.val(), 0);
				if (provineId1 > 0) {
					var provine = this.$GetAddrInfo(this.address_select_province.val());
					if (ss.isValue(provine)) {
						data.ProvinceID = provine.Id;
						data.ProvinceName = provine.Name;
						var city = this.$GetAddrInfo(this.address_select_city.val());
						if (ss.isValue(city)) {
							data.CityID = city.Id;
							data.CityName = city.Name;
							var town = this.$GetAddrInfo(this.address_select_town.val());
							if (ss.isValue(town)) {
								data.CountyID = town.Id;
								data.CountyName = town.Name;
							}
						}
					}
				}
				this.OnAddressSelected(data);
				JSLib.Mobile.Application.Back(1);
			}));
		},
		$GetAddrInfo: function(value) {
			if (!ss.isNullOrEmptyString(value)) {
				var id = CoreEx.ToInt(value, 0);
				if (id !== 0) {
					return Enumerable.from($USOProject_Pages_Common_AddressSelector.get_AddressData()).firstOrDefault(function(n) {
						return n.Id === id;
					}, ss.getDefaultValue(Object));
				}
			}
			return null;
		},
		GetOptionList: function(data, labelName) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				var outLabelName = '请选择' + labelName;
				this.WriteLiteralTo(__razor_helper_writer, '    <option value="0">');
				this.WriteTo(__razor_helper_writer, outLabelName);
				this.WriteLiteralTo(__razor_helper_writer, '</option>\r\n');
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <option value="');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '">');
					this.WriteTo(__razor_helper_writer, item.Name);
					this.WriteLiteralTo(__razor_helper_writer, '</option>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="AddressSelector">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">选择地址</div>\n        <div id="btnFinished" class="iconOK"></div>\n    </div>\n    <div class="content" id="pnlContent">\n\n        <div class="withArrowDownIcon">\n            <select id="address_select_province" name="province" class="withArrowDownIcon">\n                <option value="0">请选择省份</option>\n            </select>\n        </div>\n        <div class="withArrowDownIcon">\n            <select id="address_select_city" name="city">\n                <option value="0">请选择城市</option>\n            </select>\n        </div>\n        <div class="withArrowDownIcon">\n            <select id="address_select_town" name="town" class="withArrowDownIcon">\n                <option value="0">请选择区县</option>\n            </select>\n        </div>\n    </div>\n</div>\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.btnFinished = this.pageObject.find('#btnFinished');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.address_select_province = this.pageObject.find('#address_select_province');
			this.address_select_city = this.pageObject.find('#address_select_city');
			this.address_select_town = this.pageObject.find('#address_select_town');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.btnFinished)) {
				this.btnFinished.unbind().off();
				this.btnFinished = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.address_select_province)) {
				this.address_select_province.unbind().off();
				this.address_select_province = null;
			}
			if (ss.isValue(this.address_select_city)) {
				this.address_select_city.unbind().off();
				this.address_select_city = null;
			}
			if (ss.isValue(this.address_select_town)) {
				this.address_select_town.unbind().off();
				this.address_select_town = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Common_CustomerSelector, $asm, {
		$CustomerSelector_OnPageInit: function(sender, e) {
			var iscrollList = this.SetIscrollList(this.pnlDataList[0], 20, 100, true, false, true);
			iscrollList.set_GetPageData(ss.mkdel(this, function(index) {
				var $state = 0, $tcs = new ss.TaskCompletionSource(), name, data, $t1, $t3, result, result1, $t5;
				var $sm = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									name = this.txtName.val();
									data = [];
									if (this.Data.Mode === 0) {
										$t1 = $USOProject_Business_BusinessAction.QueryCustomerLegal(name, index, 20, this);
										$state = 2;
										$t1.continueWith($sm);
										return;
									}
									else {
										$t3 = $USOProject_Business_BusinessAction.QueryUser(name, index, 20, this);
										$state = 3;
										$t3.continueWith($sm);
										return;
									}
								}
								case 2: {
									$state = -1;
									result = $t1.getAwaitedResult();
									if (!result.IsSuccess) {
										JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
										$tcs.setResult(new JSLib.IScrollWraper.PageData());
										return;
									}
									data = Enumerable.from(result.Result).select(function(n) {
										var $t2 = new $USOProject_Pages_Common_CustomerSelector$ListItem();
										$t2.Id = n.CustomerLegalId;
										$t2.Name = n.CustomerName;
										return $t2;
									}).toArray();
									$state = 1;
									continue $sm1;
								}
								case 3: {
									$state = -1;
									result1 = $t3.getAwaitedResult();
									if (!result1.IsSuccess) {
										JSLib.Mobile.MessageBox.Alert(result1.ErrorMessage);
										$tcs.setResult(new JSLib.IScrollWraper.PageData());
										return;
									}
									data = Enumerable.from(result1.Result).select(function(n1) {
										var $t4 = new $USOProject_Pages_Common_CustomerSelector$ListItem();
										$t4.Id = n1.Id;
										$t4.Name = n1.Name;
										return $t4;
									}).toArray();
									$state = 1;
									continue $sm1;
								}
								case 1: {
									$state = -1;
									$t5 = new JSLib.IScrollWraper.PageData();
									$t5.PageIndex = index;
									$t5.RecordCount = data.length;
									$t5.ResultElement = jQueryObjectEx.ToJqueryObject$1(this.GetCustomerListHtml(data));
									$tcs.setResult($t5);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t6) {
						$tcs.setException(ss.Exception.wrap($t6));
					}
				});
				$sm();
				return $tcs.task;
			}));
			iscrollList.ReLoad();
			this.btnSearch.click(function(event) {
				iscrollList.ReLoad();
			});
			this.pageObject.on('click', '.dataItem', ss.thisFix(ss.mkdel(this, function(elem, event1) {
				var customer = UIDataEx.GetBindData$1($USOProject_Pages_Common_CustomerSelector$ListItem).call(null, $(elem));
				if (!ss.staticEquals(this.OnUserSelected, null)) {
					this.OnUserSelected(customer);
				}
			})));
			this.btnClear.click(ss.mkdel(this, function(event2) {
				var user = new $USOProject_Pages_Common_CustomerSelector$ListItem();
				if (!ss.staticEquals(this.OnUserSelected, null)) {
					this.OnUserSelected(user);
				}
			}));
		},
		PrepareData: function() {
			this.Data = this.InitialData;
			if (this.Data.Mode === 0) {
				this.Data.Title = '请选择客户';
			}
			else {
				this.Data.Title = '请选择用户';
			}
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		GetCustomerListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || data.length === 0) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">暂无数据</div>\r\n');
				}
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="dataItem" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(item));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n            <div class="row">\r\n                <span class="title">\r\n                    编号:\r\n                </span>\r\n                <span class="value">\r\n                    ');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </span>\r\n            </div>\r\n\r\n            <div class="row">\r\n                <span class="title">\r\n                    名称:\r\n                </span>\r\n                <span class="value">\r\n                    ');
					this.WriteTo(__razor_helper_writer, item.Name);
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </span>\r\n            </div>\r\n        </div>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="CustomerSelector">\r\n    <div class="head">\r\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\r\n        <div id="lblHeadText" class="headText">');
			this.Write(this.Data.Title);
			this.WriteLiteral('</div>\n        <div class="clearButton" id="btnClear">清除所选</div>\n\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="toolBar">\n            <input type="search" id="txtName" placeholder="输入名称" />\n            <div class="searchButton" id="btnSearch">查找</div>\n        </div>\n        <div id="pnlDataList">\n\n        </div>\n    </div>\n</div>\n\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.btnClear = this.pageObject.find('#btnClear');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.txtName = this.pageObject.find('#txtName');
			this.btnSearch = this.pageObject.find('#btnSearch');
			this.pnlDataList = this.pageObject.find('#pnlDataList');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.btnClear)) {
				this.btnClear.unbind().off();
				this.btnClear = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.txtName)) {
				this.txtName.unbind().off();
				this.txtName = null;
			}
			if (ss.isValue(this.btnSearch)) {
				this.btnSearch.unbind().off();
				this.btnSearch = null;
			}
			if (ss.isValue(this.pnlDataList)) {
				this.pnlDataList.unbind().off();
				this.pnlDataList = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Common_CustomerSelector$ListItem, $asm, {});
	ss.initClass($USOProject_Pages_Common_CustomerSelectorData, $asm, {});
	ss.initEnum($USOProject_Pages_Common_CustomerSelectorMode, $asm, { CustomerLegal: 0, User: 1 });
	ss.initClass($USOProject_Pages_Control_AppCenterControl, $asm, {
		$OnOnShow: function(sender, eventArgs) {
			if (ss.isValue(this.$_scroller)) {
				this.$_scroller.iscroll.refresh();
			}
		},
		$AppCenterControl_OnLoad: function(sender, e) {
			this.$_scroller = this.SetScrollable(this.pageObject[0], false, true, false, null, null, null, '', false, null, true, true);
			$USOProject_Business_ToCompletion_PermissionManager.add_OnPermissionChanged(ss.mkdel(this, this.$PermissionManage_OnPermissionChanged));
			this.pageObject.on('click', 'a[data-permission_name]', ss.thisFix(function(elem, event) {
				var module = UIDataEx.GetBindData$1($USOProject_Business_ToCompletion_PermmissionModule).call(null, $(elem));
				if (ss.isValue(module) && ss.isValue(module.PageType)) {
					var pageTypeStr = ss.getTypeFullName(module.PageType);
					JSLib.Mobile.MobilePage.GotoPage$1(pageTypeStr, null, null);
				}
			}));
			this.$PermissionManage_OnPermissionChanged(null, null);
		},
		$PermissionManage_OnPermissionChanged: function(sender, e) {
			this.$_moduleItems = $USOProject_Business_ToCompletion_PermissionManager.GetAvaiableModulePermission();
			this.pageObject.html(this.GetModuleItemsHtml(this.$_moduleItems).toString());
		},
		Destroy: function() {
			$USOProject_Business_ToCompletion_PermissionManager.remove_OnPermissionChanged(ss.mkdel(this, this.$PermissionManage_OnPermissionChanged));
			JSLib.Controller.ControllerBase.prototype.Destroy.call(this);
		},
		GetModuleItemsHtml: function(moduleItems) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				for (var $t1 = 0; $t1 < moduleItems.length; $t1++) {
					var item = moduleItems[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <a data-permission_name="');
					this.WriteTo(__razor_helper_writer, item.PermissionName);
					this.WriteLiteralTo(__razor_helper_writer, '" class="moduleItem" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(item));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n            <div class="nav_img" style="background-image: url(');
					this.WriteTo(__razor_helper_writer, item.iconUrl);
					this.WriteLiteralTo(__razor_helper_writer, ')"></div>\r\n            <div class="moduleName">\r\n                ');
					this.WriteTo(__razor_helper_writer, item.ModuleName);
					this.WriteLiteralTo(__razor_helper_writer, '\r\n            </div>\r\n        </a>\r\n');
				}
				{
					var appcenterModule = new $USOProject_Business_ToCompletion_PermmissionModule('产品中心', $USOProject_Business_ToCompletion_PermissionTypeEx.ToEnumString(2), 'img/icon_product_center.png', $USOProject_Pages_Product_CategoryMaster);
					if (Enumerable.from(moduleItems).any(function(n) {
						return ss.referenceEquals(n.PermissionName, appcenterModule.PermissionName);
					}) || Enumerable.from($USOProject_Business_ToCompletion_PermissionManager.LoadDisabledPermission()).any(function(n1) {
						return ss.referenceEquals(n1, appcenterModule.PermissionName);
					})) {
					}
					else {
						this.WriteLiteralTo(__razor_helper_writer, '            <a data-permission_name="');
						this.WriteTo(__razor_helper_writer, appcenterModule.PermissionName);
						this.WriteLiteralTo(__razor_helper_writer, '" class="moduleItem" ');
						this.WriteTo(__razor_helper_writer, this.DataBind(appcenterModule));
						this.WriteLiteralTo(__razor_helper_writer, '>\r\n                <div class="nav_img" style="background-image: url(');
						this.WriteTo(__razor_helper_writer, appcenterModule.iconUrl);
						this.WriteLiteralTo(__razor_helper_writer, ')"></div>\r\n                <div class="moduleName">\r\n                    ');
						this.WriteTo(__razor_helper_writer, appcenterModule.ModuleName);
						this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n            </a>\r\n');
					}
					var retailStatisModule = new $USOProject_Business_ToCompletion_PermmissionModule('零售录入统计', $USOProject_Business_ToCompletion_PermissionTypeEx.ToEnumString(6), 'img/icon_retail.png', $USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Configure);
					if (Enumerable.from(moduleItems).any(function(n2) {
						return ss.referenceEquals(n2.PermissionName, retailStatisModule.PermissionName);
					}) || Enumerable.from($USOProject_Business_ToCompletion_PermissionManager.LoadDisabledPermission()).any(function(n3) {
						return ss.referenceEquals(n3, appcenterModule.PermissionName);
					})) {
					}
					else {
						this.WriteLiteralTo(__razor_helper_writer, '            <a data-permission_name="');
						this.WriteTo(__razor_helper_writer, retailStatisModule.PermissionName);
						this.WriteLiteralTo(__razor_helper_writer, '" class="moduleItem" ');
						this.WriteTo(__razor_helper_writer, this.DataBind(retailStatisModule));
						this.WriteLiteralTo(__razor_helper_writer, '>\r\n                <div class="nav_img" style="background-image: url(');
						this.WriteTo(__razor_helper_writer, retailStatisModule.iconUrl);
						this.WriteLiteralTo(__razor_helper_writer, ')"></div>\r\n                <div class="moduleName">\r\n                    ');
						this.WriteTo(__razor_helper_writer, retailStatisModule.ModuleName);
						this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n            </a>\r\n');
					}
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div class="AppCenter datagrid tabPanel fl" data-id="AppCenter" data-title="应用中心">\r\n\r\n</div>\r\n');
		},
		InitialComponent: function() {
		},
		DestoryComponent: function() {
		}
	}, JSLib.Controller.ControllerBase);
	ss.initClass($USOProject_Pages_Control_MyWorkControl, $asm, {
		$OnOnShow: function(sender, eventArgs) {
			if (ss.isValue(this.$_iscrollList)) {
				this.$_iscrollList.Refresh();
			}
		},
		$MyWorkControl_OnLoad: function(sender, e) {
			$(document).find('#spanWorksCount').hide();
			$USOProject_Business_ToCompletion_PermissionManager.add_OnPermissionChanged(ss.mkdel(this, this.$PermissionManage_OnPermissionChanged));
			this.$PermissionManage_OnPermissionChanged(null, null);
			this.pnlMyWorkModuls.find('.moduleItem .af-badge').hide();
			this.pnlMyWorkModuls.on('click', '.moduleItem', ss.thisFix(function(elem, event) {
				var moduleItem = UIDataEx.GetBindData$1($USOProject_Business_ToCompletion_PermmissionModule).call(null, $(elem));
				if (ss.isValue(moduleItem) && ss.isValue(moduleItem.PageType)) {
					var pageTypeStr = ss.getTypeFullName(moduleItem.PageType);
					JSLib.Mobile.MobilePage.GotoPage$1(pageTypeStr, null, null);
				}
			}));
			var todoWorkTotalCount = 0;
			var orderAuditCount = 0;
			var totalPageSize = 35;
			var itemPageSize = 5;
			this.$_iscrollList = this.SetIscrollList(this.ulWorkContainer[0], totalPageSize, 100, false, false, true);
			var $t37 = ss.makeGenericType($USOProject_Business_PageCombineService$1, [$USOProject_Business_ToDoWorkDto]);
			var $t1 = [];
			var $t2 = new (ss.makeGenericType($USOProject_Business_SinglePageService$1, [$USOProject_Business_ToDoWorkDto]))();
			$t2.set_GetSinglePageData(ss.mkdel(this, function(index) {
				var $state = 0, $tcs = new ss.TaskCompletionSource(), $t3, query, $t4, result, resultData, toDoWorkDtos, data;
				var $sm = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									$t3 = $USOProject_Business_IndexWorkTodoQuery.$ctor();
									$t3.Page = index;
									$t3.PageSize = itemPageSize;
									$t3.LastWorkStepId = this.$LastWorkStepId;
									$t3.IsOrderByLastWorkStepId = true;
									$t3.FirstWorkStepId = this.$FirstWorkStepId;
									$t3.LoadedSpecialIds = '';
									query = $t3;
									if (index === 1) {
										query.LastWorkStepId = '';
										query.FirstWorkStepId = '';
									}
									$t4 = $USOProject_Business_BusinessAction.GetIndexWorkTodoData(query, this.get_PageContainer());
									$state = 1;
									$t4.continueWith($sm);
									return;
								}
								case 1: {
									$state = -1;
									result = $t4.getAwaitedResult();
									if (!result.IsSuccess) {
										//MessageBox.Alert(result.ErrorMessage);
										$tcs.setResult([]);
										return;
									}
									resultData = result.Result;
									todoWorkTotalCount += ((JSLib.Mobile.Application.get_PageIndexStart() === index) ? resultData.TotalCount : 0);
									toDoWorkDtos = resultData.WorkList;
									if (toDoWorkDtos.length > 0) {
										this.$LastWorkStepId = toDoWorkDtos[0].LastStepID;
										this.$FirstWorkStepId = Enumerable.from(toDoWorkDtos).last().LastStepID;
										this.$lastedFirstWorkStepId = this.$FirstWorkStepId;
									}
									this.UpdateToDoNumber('特批审核', resultData.TotalCount);
									data = Enumerable.from(toDoWorkDtos).select(function(n) {
										var $t5 = $USOProject_Business_ToDoWorkDto.$ctor();
										$t5.TaskType = '特批';
										$t5.TaskName = n.TaskName;
										$t5.TaskCreateTime = n.TaskCreateTime;
										$t5.TaskId = n.TaskId;
										return $t5;
									}).toArray();
									$tcs.setResult(data);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t6) {
						$tcs.setException(ss.Exception.wrap($t6));
					}
				});
				$sm();
				return $tcs.task;
			}));
			$t2.PageSize = itemPageSize;
			$t1.push($t2);
			var $t7 = new (ss.makeGenericType($USOProject_Business_SinglePageService$1, [$USOProject_Business_ToDoWorkDto]))();
			$t7.set_GetSinglePageData(ss.mkdel(this, function(index1) {
				var $state1 = 0, $tcs1 = new ss.TaskCompletionSource(), query1, $t8, $t9, result1, todoWorks;
				var $sm1 = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state1) {
								case 0: {
									$state1 = -1;
									query1 = {};
									$t8 = new Date();
									query1.CreateOn = ss.formatDate(new Date($t8.getFullYear() + -1, $t8.getMonth(), $t8.getDate(), $t8.getHours(), $t8.getMinutes(), $t8.getSeconds(), $t8.getMilliseconds()), 'yyyy-MM-dd');
									query1.Page = index1;
									query1.PageSize = itemPageSize;
									$t9 = $USOProject_Business_BusinessAction.AdjustApply_SearchWaitAudit(query1, this.get_PageContainer(), true);
									$state1 = 1;
									$t9.continueWith($sm1);
									return;
								}
								case 1: {
									$state1 = -1;
									result1 = $t9.getAwaitedResult();
									if (!result1.IsSuccess) {
										//MessageBox.Alert(result.ErrorMessage);
										$tcs1.setResult([]);
										return;
									}
									todoWorkTotalCount += ((index1 === JSLib.Mobile.Application.get_PageIndexStart()) ? result1.Result.QueryResult.Total : 0);
									this.UpdateToDoNumber('调帐审核', result1.Result.QueryResult.Total);
									todoWorks = Enumerable.from(result1.Result.QueryResult.Result).select(function(n1) {
										var $t10 = $USOProject_Business_ToDoWorkDto.$ctor();
										$t10.TaskType = '调帐';
										$t10.TaskName = n1.Id.toString();
										$t10.TaskCreateTime = n1.CreatedOn;
										$t10.TaskId = n1.Id;
										return $t10;
									}).toArray();
									$tcs1.setResult(todoWorks);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t11) {
						$tcs1.setException(ss.Exception.wrap($t11));
					}
				});
				$sm1();
				return $tcs1.task;
			}));
			$t7.PageSize = itemPageSize;
			$t1.push($t7);
			var $t12 = new (ss.makeGenericType($USOProject_Business_SinglePageService$1, [$USOProject_Business_ToDoWorkDto]))();
			$t12.set_GetSinglePageData(ss.mkdel(this, function(index2) {
				var $state2 = 0, $tcs2 = new ss.TaskCompletionSource(), pageQuery, $t13, $t14, result2, totalCount, data1;
				var $sm2 = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state2) {
								case 0: {
									$state2 = -1;
									pageQuery = {};
									pageQuery.Page = index2;
									pageQuery.PageSize = itemPageSize;
									$t13 = new Date();
									pageQuery.CreatedOn = ss.formatDate(new Date($t13.getFullYear() + -1, $t13.getMonth(), $t13.getDate(), $t13.getHours(), $t13.getMinutes(), $t13.getSeconds(), $t13.getMilliseconds()), 'yyyy-MM-dd');
									$t14 = $USOProject_Business_BusinessAction.ReturnOrderWeiHuo_SearchWaitAudit(pageQuery, this.get_PageContainer(), true);
									$state2 = 1;
									$t14.continueWith($sm2);
									return;
								}
								case 1: {
									$state2 = -1;
									result2 = $t14.getAwaitedResult();
									if (!result2.IsSuccess) {
										//MessageBox.Alert(result.ErrorMessage);
										$tcs2.setResult([]);
										return;
									}
									totalCount = ((JSLib.Mobile.Application.get_PageIndexStart() === index2) ? result2.Result.DTO.Total : 0);
									todoWorkTotalCount += totalCount;
									orderAuditCount += totalCount;
									this.UpdateToDoNumber('订单审核', orderAuditCount);
									data1 = Enumerable.from(result2.Result.DTO.Result).select(function(n2) {
										var $t15 = $USOProject_Business_ToDoWorkDto.$ctor();
										$t15.TaskType = '尾货';
										$t15.TaskName = n2.Id.toString();
										$t15.TaskCreateTime = n2.CreatedOn;
										$t15.TaskId = n2.Id;
										$t15.StockOrganizationName = n2.StockOrganizationName;
										return $t15;
									}).toArray();
									$tcs2.setResult(data1);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t16) {
						$tcs2.setException(ss.Exception.wrap($t16));
					}
				});
				$sm2();
				return $tcs2.task;
			}));
			$t12.PageSize = itemPageSize;
			$t1.push($t12);
			var $t17 = new (ss.makeGenericType($USOProject_Business_SinglePageService$1, [$USOProject_Business_ToDoWorkDto]))();
			$t17.set_GetSinglePageData(ss.mkdel(this, function(index3) {
				var $state3 = 0, $tcs3 = new ss.TaskCompletionSource(), pageQuery1, $t18, $t19, result3, totalCount1, data2;
				var $sm3 = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state3) {
								case 0: {
									$state3 = -1;
									pageQuery1 = {};
									$t18 = new Date();
									pageQuery1.CreatedOn = ss.formatDate(new Date($t18.getFullYear() + -1, $t18.getMonth(), $t18.getDate(), $t18.getHours(), $t18.getMinutes(), $t18.getSeconds(), $t18.getMilliseconds()), 'yyyy-MM-dd');
									pageQuery1.Page = index3;
									pageQuery1.PageSize = itemPageSize;
									$t19 = $USOProject_Business_BusinessAction.SpecificSaleOrder_SearchWaitAudit(pageQuery1, this.get_PageContainer(), true);
									$state3 = 1;
									$t19.continueWith($sm3);
									return;
								}
								case 1: {
									$state3 = -1;
									result3 = $t19.getAwaitedResult();
									if (!result3.IsSuccess) {
										//MessageBox.Alert(result.ErrorMessage);
										$tcs3.setResult([]);
										return;
									}
									totalCount1 = ((JSLib.Mobile.Application.get_PageIndexStart() === index3) ? result3.Result.DTO.Total : 0);
									todoWorkTotalCount += totalCount1;
									orderAuditCount += totalCount1;
									this.UpdateToDoNumber('订单审核', orderAuditCount);
									data2 = Enumerable.from(result3.Result.DTO.Result).select(function(n3) {
										var $t20 = $USOProject_Business_ToDoWorkDto.$ctor();
										$t20.TaskType = '专供机';
										$t20.TaskName = n3.Id.toString();
										$t20.TaskCreateTime = n3.CreatedOn;
										$t20.TaskId = n3.Id;
										$t20.StockOrganizationName = n3.StockOrganizationName;
										return $t20;
									}).toArray();
									$tcs3.setResult(data2);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t21) {
						$tcs3.setException(ss.Exception.wrap($t21));
					}
				});
				$sm3();
				return $tcs3.task;
			}));
			$t17.PageSize = itemPageSize;
			$t1.push($t17);
			var $t22 = new (ss.makeGenericType($USOProject_Business_SinglePageService$1, [$USOProject_Business_ToDoWorkDto]))();
			$t22.set_GetSinglePageData(ss.mkdel(this, function(index4) {
				var $state4 = 0, $tcs4 = new ss.TaskCompletionSource(), pageQuery2, $t23, $t24, result4, totalCount2, data3;
				var $sm4 = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state4) {
								case 0: {
									$state4 = -1;
									pageQuery2 = {};
									$t23 = new Date();
									pageQuery2.CreatedOn = ss.formatDate(new Date($t23.getFullYear() + -1, $t23.getMonth(), $t23.getDate(), $t23.getHours(), $t23.getMinutes(), $t23.getSeconds(), $t23.getMilliseconds()), 'yyyy-MM-dd');
									pageQuery2.Page = index4;
									pageQuery2.PageSize = itemPageSize;
									$t24 = $USOProject_Business_BusinessAction.WaitConfirmOrder_SearchWaitAudit(pageQuery2, this.get_PageContainer(), true);
									$state4 = 1;
									$t24.continueWith($sm4);
									return;
								}
								case 1: {
									$state4 = -1;
									result4 = $t24.getAwaitedResult();
									if (!result4.IsSuccess) {
										//MessageBox.Alert(result.ErrorMessage);
										$tcs4.setResult([]);
										return;
									}
									totalCount2 = ((JSLib.Mobile.Application.get_PageIndexStart() === index4) ? result4.Result.DTO.Total : 0);
									todoWorkTotalCount += totalCount2;
									orderAuditCount += totalCount2;
									this.UpdateToDoNumber('订单审核', orderAuditCount);
									data3 = Enumerable.from(result4.Result.DTO.Result).select(function(n4) {
										var $t25 = $USOProject_Business_ToDoWorkDto.$ctor();
										$t25.TaskType = '订单确认';
										$t25.TaskName = n4.Id.toString();
										$t25.TaskCreateTime = n4.CreatedOn;
										$t25.TaskId = n4.Id;
										$t25.StockOrganizationName = n4.StockOrganizationName;
										return $t25;
									}).toArray();
									$tcs4.setResult(data3);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t26) {
						$tcs4.setException(ss.Exception.wrap($t26));
					}
				});
				$sm4();
				return $tcs4.task;
			}));
			$t22.PageSize = itemPageSize;
			$t1.push($t22);
			var $t27 = new (ss.makeGenericType($USOProject_Business_SinglePageService$1, [$USOProject_Business_ToDoWorkDto]))();
			$t27.set_GetSinglePageData(ss.mkdel(this, function(index5) {
				var $state5 = 0, $tcs5 = new ss.TaskCompletionSource(), query2, $t28, $t29, result5, todoWorks1;
				var $sm5 = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state5) {
								case 0: {
									$state5 = -1;
									query2 = {};
									$t28 = new Date();
									query2.CreatedOn = ss.formatDate(new Date($t28.getFullYear() + -1, $t28.getMonth(), $t28.getDate(), $t28.getHours(), $t28.getMinutes(), $t28.getSeconds(), $t28.getMilliseconds()), 'yyyy-MM-dd');
									query2.Page = index5;
									query2.PageSize = itemPageSize;
									$t29 = $USOProject_Business_BusinessAction.OtherOrder_SearchWaitAudit(query2, this.get_PageContainer(), true);
									$state5 = 1;
									$t29.continueWith($sm5);
									return;
								}
								case 1: {
									$state5 = -1;
									result5 = $t29.getAwaitedResult();
									if (!result5.IsSuccess) {
										//MessageBox.Alert(result.ErrorMessage);
										$tcs5.setResult([]);
										return;
									}
									todoWorkTotalCount += ((JSLib.Mobile.Application.get_PageIndexStart() === index5) ? result5.Result.SOMaster.Total : 0);
									this.UpdateToDoNumber('异地订单', result5.Result.SOMaster.Total);
									todoWorks1 = Enumerable.from(result5.Result.SOMaster.Result).select(function(n5) {
										var $t30 = $USOProject_Business_ToDoWorkDto.$ctor();
										$t30.TaskType = '异地订单';
										$t30.TaskName = n5.Id.toString();
										$t30.TaskCreateTime = n5.CreatedOn;
										$t30.TaskId = n5.Id;
										$t30.StockOrganizationName = n5.StockOrganizationName;
										return $t30;
									}).toArray();
									$tcs5.setResult(todoWorks1);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t31) {
						$tcs5.setException(ss.Exception.wrap($t31));
					}
				});
				$sm5();
				return $tcs5.task;
			}));
			$t27.PageSize = itemPageSize;
			$t1.push($t27);
			var $t32 = new (ss.makeGenericType($USOProject_Business_SinglePageService$1, [$USOProject_Business_ToDoWorkDto]))();
			$t32.set_GetSinglePageData(ss.mkdel(this, function(index6) {
				var $state6 = 0, $tcs6 = new ss.TaskCompletionSource(), query3, $t33, $t34, result6, todoWorks2;
				var $sm6 = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state6) {
								case 0: {
									$state6 = -1;
									query3 = {};
									$t33 = new Date();
									query3.CreatedOn = ss.formatDate(new Date($t33.getFullYear() + -1, $t33.getMonth(), $t33.getDate(), $t33.getHours(), $t33.getMinutes(), $t33.getSeconds(), $t33.getMilliseconds()), 'yyyy-MM-dd');
									query3.PageSize = itemPageSize;
									query3.Page = index6;
									$t34 = $USOProject_Business_BusinessAction.EngineerOrder_SearchWaitAudit(query3, this.get_PageContainer(), true);
									$state6 = 1;
									$t34.continueWith($sm6);
									return;
								}
								case 1: {
									$state6 = -1;
									result6 = $t34.getAwaitedResult();
									if (!result6.IsSuccess) {
										//MessageBox.Alert(result.ErrorMessage);
										$tcs6.setResult([]);
										return;
									}
									todoWorkTotalCount += ((JSLib.Mobile.Application.get_PageIndexStart() === index6) ? result6.Result.ProjectFileDTO.Total : 0);
									this.UpdateToDoNumber('工程档案', result6.Result.ProjectFileDTO.Total);
									todoWorks2 = Enumerable.from(result6.Result.ProjectFileDTO.Result).select(function(n6) {
										var $t35 = $USOProject_Business_ToDoWorkDto.$ctor();
										$t35.TaskType = '工程档案';
										$t35.TaskName = n6.Id.toString();
										$t35.StockOrganizationName = n6.StockOrganizationName;
										$t35.TaskCreateTime = n6.CreatedOn;
										$t35.TaskId = n6.Id;
										return $t35;
									}).toArray();
									$tcs6.setResult(todoWorks2);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t36) {
						$tcs6.setException(ss.Exception.wrap($t36));
					}
				});
				$sm6();
				return $tcs6.task;
			}));
			$t32.PageSize = itemPageSize;
			$t1.push($t32);
			var tsk = new $t37($t1);
			this.$_iscrollList.set_GetPageData(ss.mkdel(this, function(index7) {
				var $state7 = 0, $tcs7 = new ss.TaskCompletionSource(), $t38, resultData1, $t39;
				var $sm7 = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state7) {
								case 0: {
									$state7 = -1;
									if (index7 === JSLib.Mobile.Application.get_PageIndexStart()) {
										todoWorkTotalCount = 0;
										orderAuditCount = 0;
										tsk.Reset();
									}
									$t38 = tsk.GetPageData(index7, totalPageSize);
									$state7 = 1;
									$t38.continueWith($sm7);
									return;
								}
								case 1: {
									$state7 = -1;
									resultData1 = $t38.getAwaitedResult();
									if (resultData1.length <= 0) {
										$(document).find('#spanWorksCount').hide();
									}
									else {
										$(document).find('#spanWorksCount').text(todoWorkTotalCount.toString()).show();
									}
									$t39 = new JSLib.IScrollWraper.PageData();
									$t39.PageIndex = index7;
									$t39.RecordCount = resultData1.length;
									$t39.ResultElement = jQueryObjectEx.ToJqueryObject$1(this.GetWorkItemHtml(resultData1));
									$tcs7.setResult($t39);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t40) {
						$tcs7.setException(ss.Exception.wrap($t40));
					}
				});
				$sm7();
				return $tcs7.task;
			}));
			this.$_iscrollList.ReLoad();
			this.pageObject.on('click', '.todoworkItem', ss.thisFix(function(elem1, event1) {
				var todoWork = UIDataEx.GetBindData$1($USOProject_Business_ToDoWorkDto).call(null, $(elem1));
				var orderAuditType = 3;
				switch (todoWork.TaskType) {
					case '特批': {
						JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Spec_SpecDetail).call(null, todoWork.TaskId, null);
						break;
					}
					case '调帐': {
						JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_Adjust_AdjustDetail).call(null, todoWork.TaskId, null);
						break;
					}
					case '尾货':
					case '专供机':
					case '订单确认': {
						if (todoWork.TaskType === '尾货') {
							orderAuditType = 2;
						}
						else if (todoWork.TaskType === '专供机') {
							orderAuditType = 1;
						}
						else if (todoWork.TaskType === '订单确认') {
							orderAuditType = 3;
						}
						var $t41 = new $USOProject_Pages_ApplyAudit_OrderAudit_OrderDetailData();
						$t41.OrderId = todoWork.TaskId;
						$t41.IsToAudit = true;
						$t41.StockOrganizationName = todoWork.StockOrganizationName;
						$t41.OrderAuditType = orderAuditType;
						JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_OrderAudit_OrderDetail).call(null, $t41, null);
						break;
					}
					case '异地订单': {
						var $t42 = new $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderDetailData();
						$t42.Id = todoWork.TaskId;
						$t42.StockOrgName = todoWork.StockOrganizationName;
						$t42.IsToAudit = true;
						JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderDetail).call(null, $t42, null);
						break;
					}
					case '工程档案': {
						var $t43 = new $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderDetailData();
						$t43.Id = todoWork.TaskId;
						$t43.IsToAudit = true;
						$t43.StockOrganizationName = todoWork.StockOrganizationName;
						JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderDetail).call(null, $t43, null);
						break;
					}
				}
			}));
			$USOProject_Pages_Control_MyWorkControl.add_TodoWorkChange(ss.mkdel(this, this.$OnTodoWorkChange));
		},
		$OnTodoWorkChange: function(o, args) {
			this.$_iscrollList.ReLoad();
		},
		$PermissionManage_OnPermissionChanged: function(sender, e) {
			var $t1 = [];
			$t1.push('特批审核');
			$t1.push('零售录入');
			$t1.push('工程档案');
			$t1.push('调帐审核');
			$t1.push('订单审核');
			$t1.push('异地订单');
			var showModuleNames = $t1;
			var _moduleItems = Enumerable.from($USOProject_Business_ToCompletion_PermissionManager.GetAvaiableModulePermission()).where(function(n) {
				return ss.contains(showModuleNames, n.ModuleName);
			}).toArray();
			this.pnlMyWorkModuls.html(this.GetModuleItemsHtml(_moduleItems).toString());
			if (ss.isValue(this.$_iscrollList)) {
				this.$_iscrollList.ReLoad();
			}
		},
		UpdateToDoNumber: function(moduleName, count) {
			var item = Enumerable.from(this.pnlMyWorkModuls.find('.moduleItem').toArray()).firstOrDefault(function(n) {
				return ss.referenceEquals(UIDataEx.GetBindData($USOProject_Business_ToCompletion_PermmissionModule).call(null, n).ModuleName, moduleName);
			}, ss.getDefaultValue(HTMLElement));
			var badge = $(item).find('.af-badge');
			jQueryObjectEx.SetVisible(badge, count > 0);
			badge.text(count.toString());
		},
		Destroy: function() {
			$USOProject_Pages_Control_MyWorkControl.remove_TodoWorkChange(ss.mkdel(this, this.$OnTodoWorkChange));
			JSLib.Controller.ControllerBase.prototype.Destroy.call(this);
		},
		GetWorkItemHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || data.length === 0) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">暂无数据</div>\r\n');
				}
				else {
					for (var $t1 = 0; $t1 < data.length; $t1++) {
						var item = data[$t1];
						this.WriteLiteralTo(__razor_helper_writer, '            <li class="todoworkItem" ');
						this.WriteTo(__razor_helper_writer, this.DataBind(item));
						this.WriteLiteralTo(__razor_helper_writer, '>\r\n                <a class="li_a_work home_work_item">\r\n                    <div>\r\n                        <div class="work_title">[');
						this.WriteTo(__razor_helper_writer, item.TaskType);
						this.WriteLiteralTo(__razor_helper_writer, '] ');
						this.WriteTo(__razor_helper_writer, item.TaskName);
						this.WriteLiteralTo(__razor_helper_writer, '  </div>\r\n                        <div class="work_time">');
						this.WriteTo(__razor_helper_writer, item.TaskCreateTime);
						this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n                    </div>\r\n                </a>\r\n            </li>\r\n');
					}
				}
			}));
		},
		GetModuleItemsHtml: function(moduleItems) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				for (var $t1 = 0; $t1 < moduleItems.length; $t1++) {
					var item = moduleItems[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <a data-permission_name="');
					this.WriteTo(__razor_helper_writer, item.PermissionName);
					this.WriteLiteralTo(__razor_helper_writer, '" class="moduleItem" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(item));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n            <div class="nav_img" style="background-image: url(');
					this.WriteTo(__razor_helper_writer, item.iconUrl);
					this.WriteLiteralTo(__razor_helper_writer, ')"></div>\r\n            <div class="moduleName">\r\n                ');
					this.WriteTo(__razor_helper_writer, item.ModuleName);
					this.WriteLiteralTo(__razor_helper_writer, '\r\n            </div>\r\n            <span class="af-badge lr"></span>\r\n        </a>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div title="" id="work" class="tabPanel MyWorkPanel" data-tab="a_work" data-title="我的工作" data-id="MyWork">\n    <div class="datagrid fl" id="pnlMyWorkModuls">\n\n    </div>\n    <ul id="ul1" style="width: 100%;" class="list inset  ">\n        <li class="divider textBadge">\n            <span id="spanWorkTitle">待办事项</span>\n        </li>\n    </ul>\n    <ul id="ulWorkContainer" style="width: 100%;" class="list inset workList"></ul>\n</div>\n\n');
			this.WriteLiteral('\r\n\r\n');
		},
		InitialComponent: function() {
			this.work = this.pageObject.find('#work');
			this.pnlMyWorkModuls = this.pageObject.find('#pnlMyWorkModuls');
			this.ul1 = this.pageObject.find('#ul1');
			this.spanWorkTitle = this.pageObject.find('#spanWorkTitle');
			this.ulWorkContainer = this.pageObject.find('#ulWorkContainer');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.work)) {
				this.work.unbind().off();
				this.work = null;
			}
			if (ss.isValue(this.pnlMyWorkModuls)) {
				this.pnlMyWorkModuls.unbind().off();
				this.pnlMyWorkModuls = null;
			}
			if (ss.isValue(this.ul1)) {
				this.ul1.unbind().off();
				this.ul1 = null;
			}
			if (ss.isValue(this.spanWorkTitle)) {
				this.spanWorkTitle.unbind().off();
				this.spanWorkTitle = null;
			}
			if (ss.isValue(this.ulWorkContainer)) {
				this.ulWorkContainer.unbind().off();
				this.ulWorkContainer = null;
			}
		}
	}, JSLib.Controller.ControllerBase);
	ss.initClass($USOProject_Pages_Control_PersonalCenterControl, $asm, {
		$OnOnShow: function(sender, eventArgs) {
			if (ss.isValue(this.$_iscroller)) {
				this.$_iscroller.iscroll.refresh();
			}
		},
		$PersonalCenterControl_OnLoad: function(sender, e) {
			this.$_iscroller = this.SetScrollable(this.pageObject[0], false, true, false, null, null, null, '', false, null, true, true);
			this.span_dept.val($App.app.userInfo.User.CurrentStockOrganizationId.toString());
			this.span_dept.change(ss.thisFix(function(ele, event) {
				var currentOrganizationId = $(ele).val();
				if (!ss.isNullOrEmptyString(currentOrganizationId)) {
					window.localStorage.setItem('currentStockOrganizationId|' + $App.app.userInfo.User.Id, currentOrganizationId);
					$App.app.userInfo.User.CurrentStockOrganizationId = CoreEx.ToInt(currentOrganizationId, 0);
				}
				else {
					JSLib.Mobile.MessageBox.Alert('无法获取组织机构ID');
				}
			}));
			this.user_logout.click(function(event1) {
				var $state = 0, $t1, confirmResult;
				var $sm = function() {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								$t1 = JSLib.Mobile.MessageBox.Confirm('你确认要注销当前用户吗?');
								$state = 1;
								$t1.continueWith($sm);
								return;
							}
							case 1: {
								$state = -1;
								confirmResult = $t1.getAwaitedResult();
								if (!confirmResult) {
									return;
								}
								$USOProject_SecurityLayerJS.RemovePersistentToken();
								JSLib.Mobile.MessageBox.Alert('注销成功');
								$USOProject_Business_JPush.SetAlias('');
								window.location.reload();
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				};
				$sm();
			});
			this.messageSwich_button.change(ss.thisFix(function(ele1, event2) {
				if ($(ele1).hasClass('active')) {
					$USOProject_Business_JPush.SetAlias('userid_' + $App.app.userInfo.User.Id);
					window.localStorage.setItem('messageSwich', 'on');
				}
				else {
					$USOProject_Business_JPush.SetAlias('');
					window.localStorage.setItem('messageSwich', 'off');
				}
			}));
			this.pers_myFavorite_li.click(function(event3) {
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Product_ProductFavorite).call(null, null, null);
			});
			this.btnGotoModifyPassword.click(function(event4) {
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_SystemModule_ModifyPassword).call(null, null, null);
			});
		},
		Execute: function() {
			this.WriteLiteral('<ul class="list inset" data-id="PersonalCenter" data-title="个人中心">\r\n    <li>\r\n        <div class="list_title">用户信息</div>\r\n        <div id="span_userinfo" class="list_content">');
			this.Write($App.app.userInfo.User.IdentityNumber);
			this.WriteLiteral('</div>\r\n    </li>\r\n    <li>\r\n        <div class="list_title">用户名</div>\r\n        <div id="span_username" class="list_content">');
			this.Write($App.app.userInfo.User.Name);
			this.WriteLiteral('</div>\r\n    </li>\r\n    <li class="endnavIcon">\r\n        <div class="list_title" style="padding-top: 10px;">组织机构</div>\r\n        <div class="list_content">\r\n            <select id="span_dept">\r\n');
			for (var $t1 = 0; $t1 < $App.app.userInfo.StockOrganizationList.length; $t1++) {
				var orgItem = $App.app.userInfo.StockOrganizationList[$t1];
				this.WriteLiteral('                    <option value="');
				this.Write(orgItem.Id);
				this.WriteLiteral('">');
				this.Write(orgItem.Name);
				this.WriteLiteral('</option>\r\n');
			}
			this.WriteLiteral('            </select>\r\n        </div>\r\n    </li>\r\n');
			//根据用户权限来显示/隐藏我的收藏入口
			if ($USOProject_Business_ToCompletion_PermissionManager.HavePerssion(2)) {
				this.WriteLiteral('            <li class="divider" id="pers_myFavorite_devider"></li>\r\n');
				this.WriteLiteral('            <li id="pers_myFavorite_li">\r\n                <a id="pers_myFavorite" class="">我的收藏</a>\r\n            </li>\r\n');
			}
			this.WriteLiteral('    <li class="divider"></li>\n    <li class="">\n        <table style="width: 100%; margin: -10px -10px -10px 0;" class="">\n            <tbody>\n                <tr>\n                    <td class="">\n                        <label class="lbforPers">系统消息</label>\n                    </td>\n                    <td style="width: 7%;">\n                        <label data-off="Off" data-on="On" for="toggle1">\n                        </label>\n');
			var messageSwitchValue = window.localStorage.getItem('messageSwich');
			var activeClass = '';
			if (ss.isValue(messageSwitchValue) && messageSwitchValue === 'on') {
				activeClass = 'active';
			}
			this.WriteLiteral('                        <div id="messageSwich_button" class="toggleButton ');
			this.Write(activeClass);
			this.WriteLiteral('"  >\n                            <div class="on">ON</div>\n                            <div class="off">OFF</div>\n                        </div>\n                    </td>\n                </tr>\n            </tbody>\n        </table>\n    </li>\n    <li class="divider"></li>\n    ');
			this.WriteLiteral('\r\n    <li><a id="btnGotoModifyPassword" class="">修改密码</a></li>\r\n    <li><a id="user_logout">注销</a></li>\r\n</ul>');
		},
		InitialComponent: function() {
			this.span_userinfo = this.pageObject.find('#span_userinfo');
			this.span_username = this.pageObject.find('#span_username');
			this.span_dept = this.pageObject.find('#span_dept');
			this.pers_myFavorite_devider = this.pageObject.find('#pers_myFavorite_devider');
			this.pers_myFavorite_li = this.pageObject.find('#pers_myFavorite_li');
			this.pers_myFavorite = this.pageObject.find('#pers_myFavorite');
			this.messageSwich_button = this.pageObject.find('#messageSwich_button');
			this.sk_ios = this.pageObject.find('#sk_ios');
			this.sk_iosgreen = this.pageObject.find('#sk_iosgreen');
			this.btnGotoModifyPassword = this.pageObject.find('#btnGotoModifyPassword');
			this.user_logout = this.pageObject.find('#user_logout');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.span_userinfo)) {
				this.span_userinfo.unbind().off();
				this.span_userinfo = null;
			}
			if (ss.isValue(this.span_username)) {
				this.span_username.unbind().off();
				this.span_username = null;
			}
			if (ss.isValue(this.span_dept)) {
				this.span_dept.unbind().off();
				this.span_dept = null;
			}
			if (ss.isValue(this.pers_myFavorite_devider)) {
				this.pers_myFavorite_devider.unbind().off();
				this.pers_myFavorite_devider = null;
			}
			if (ss.isValue(this.pers_myFavorite_li)) {
				this.pers_myFavorite_li.unbind().off();
				this.pers_myFavorite_li = null;
			}
			if (ss.isValue(this.pers_myFavorite)) {
				this.pers_myFavorite.unbind().off();
				this.pers_myFavorite = null;
			}
			if (ss.isValue(this.messageSwich_button)) {
				this.messageSwich_button.unbind().off();
				this.messageSwich_button = null;
			}
			if (ss.isValue(this.sk_ios)) {
				this.sk_ios.unbind().off();
				this.sk_ios = null;
			}
			if (ss.isValue(this.sk_iosgreen)) {
				this.sk_iosgreen.unbind().off();
				this.sk_iosgreen = null;
			}
			if (ss.isValue(this.btnGotoModifyPassword)) {
				this.btnGotoModifyPassword.unbind().off();
				this.btnGotoModifyPassword = null;
			}
			if (ss.isValue(this.user_logout)) {
				this.user_logout.unbind().off();
				this.user_logout = null;
			}
		}
	}, JSLib.Controller.ControllerBase);
	ss.initClass($USOProject_Pages_Control_TodoWorkItem, $asm, {});
	ss.initClass($USOProject_Pages_Control_UpgradePlugin, $asm, {});
	ss.initClass($USOProject_Pages_Control_UpgradeTipController, $asm, {
		$UpgradeTipController_OnLoad: function(sender, e) {
			this.btn_startdownload.add(this.btn_startManualDownload).click(ss.thisFix(ss.mkdel(this, function(elem, event) {
				var isByForceUpgrade = elem.id === 'btn_startdownload';
				if (JSLib.Mobile.Application.DeviceType === 1) {
					window.location.href = (isByForceUpgrade ? this.ServerInfo.strongV.iosUrl : this.ServerInfo.weakV.iosUrl);
					return;
				}
				this.btn_startdownload.html('正在升级').attr('disabled', 'disabled').css('color', 'gray');
				this.dl_content.hide();
				this.dl_content_loading.show();
				this.$GetDownloadInfo();
				$USOProject_Pages_Control_UpgradePlugin.download((isByForceUpgrade ? this.ServerInfo.strongV.url : this.ServerInfo.weakV.url));
			})));
			this.btn_cancelUpdate.click(ss.mkdel(this, function(event1) {
				if (!ss.staticEquals(this.UpgradeCancel, null)) {
					this.UpgradeCancel();
				}
			}));
			var isForceUpgrade = $USOProject_Pages_Control_UpgradeTipController.CheckShouldUpdate(this.ServerInfo.strongV.version);
			if (isForceUpgrade) {
				this.btn_startManualDownload.hide();
				this.btn_cancelUpdate.hide();
				this.splash_download.show();
				return;
			}
			var isManualUpdate = $USOProject_Pages_Control_UpgradeTipController.CheckShouldUpdate(this.ServerInfo.weakV.version);
			if (isManualUpdate) {
				this.btn_startdownload.hide();
				this.btn_startManualDownload.show();
				this.btn_cancelUpdate.show();
				this.splash_download.show();
			}
		},
		$GetDownloadInfo: function() {
			cordova.exec(ss.mkdel(this, function(o) {
				var r = o;
				if (r === 'suc') {
					window.localStorage.setItem('isUSOInit', '0');
					this.progress_persent.val('下载完成');
					return;
				}
				if (!ss.isNullOrEmptyString(r)) {
					var rev = JSON.parse(r);
					if (ss.isValue(rev)) {
						this.progress_info.html(rev.proMsg);
						var downsize = CoreEx.ToDouble(rev.downsize);
						var fsize = CoreEx.ToDouble(rev.fsize);
						var progressvalue = (downsize / fsize * 100).toFixed(0);
						this.loading_has.width(ss.formatString('{0}%', progressvalue));
						this.progress_persent.html(progressvalue + '%');
					}
				}
				this.$GetDownloadInfo();
			}), function(o1) {
				JSLib.Mobile.MessageBox.Alert(JSON.stringify(o1));
			}, 'CustomPlugin', 'getdownloadinfo', []);
		},
		get_isForceUpgrade: function() {
			return $USOProject_Pages_Control_UpgradeTipController.CheckShouldUpdate(this.ServerInfo.strongV.version);
		},
		Execute: function() {
			this.WriteLiteral('<div id="splash_download">\r\n    <div id="splash_download_title">\r\n        <div id="dl_title">版本更新提示</div>\r\n');
			var upgradeComment = (!this.get_isForceUpgrade() ? '您当前版本不升级也可以使用，不过建议您升级到最新的版本。' : '这是一次强制性的升级，如不升级，系统将无法继续使用。');
			var curVersion = (this.get_isForceUpgrade() ? this.ServerInfo.strongV.version : this.ServerInfo.weakV.version);
			var upgradetip = (!ss.isNullOrEmptyString(this.ServerInfo.upgradeTip) ? this.ServerInfo.upgradeTip : '');
			this.WriteLiteral('        <div id="dl_content" class="dl_content">\r\n            <div class="upgradeVersionInfoPanel">\r\n                <span id="progress_nowv">');
			this.Write($App.app.AppVersion);
			this.WriteLiteral('</span>--&gt;\r\n                <span id="progress_objv">');
			this.Write(curVersion);
			this.WriteLiteral('</span>\r\n            </div>\r\n            <span id="updateComment">');
			this.Write(upgradeComment);
			this.WriteLiteral('</span>\r\n');
			if (!ss.isNullOrEmptyString(upgradetip)) {
				this.WriteLiteral('                <div class="upgradeTip" id="lblUpgradeTip">\r\n                    升级说明：');
				this.Write(upgradetip);
				this.WriteLiteral('\r\n                </div>\r\n');
			}
			this.WriteLiteral('        </div>\n        <div id="dl_content_loading" class="dl_content">\n            正在下载新版本的长虹营销业务移动平台<br>\n            已完成：<span id="progress_info">0&nbsp;KB/0&nbsp;MB</span><br>\n            <div id="loading_main">\n                <div id="loading_has"></div>\n                <div id="loading_not"></div>\n                <span id="progress_persent">0%</span>\n            </div>\n        </div>\n        <button id="btn_startdownload">立即下载</button>\n        <div>\n            <div id="btn_startManualDownload" class="manual" style="display: none;">升级</div>\n            <div id="btn_cancelUpdate" class="manual" style="display: none;">取消</div>\n        </div>\n    </div>\n</div>');
		},
		InitialComponent: function() {
			this.splash_download = this.pageObject.find('#splash_download');
			this.splash_download_title = this.pageObject.find('#splash_download_title');
			this.dl_title = this.pageObject.find('#dl_title');
			this.dl_content = this.pageObject.find('#dl_content');
			this.progress_nowv = this.pageObject.find('#progress_nowv');
			this.progress_objv = this.pageObject.find('#progress_objv');
			this.updateComment = this.pageObject.find('#updateComment');
			this.lblUpgradeTip = this.pageObject.find('#lblUpgradeTip');
			this.dl_content_loading = this.pageObject.find('#dl_content_loading');
			this.progress_info = this.pageObject.find('#progress_info');
			this.loading_main = this.pageObject.find('#loading_main');
			this.loading_has = this.pageObject.find('#loading_has');
			this.loading_not = this.pageObject.find('#loading_not');
			this.progress_persent = this.pageObject.find('#progress_persent');
			this.btn_startdownload = this.pageObject.find('#btn_startdownload');
			this.btn_startManualDownload = this.pageObject.find('#btn_startManualDownload');
			this.btn_cancelUpdate = this.pageObject.find('#btn_cancelUpdate');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.splash_download)) {
				this.splash_download.unbind().off();
				this.splash_download = null;
			}
			if (ss.isValue(this.splash_download_title)) {
				this.splash_download_title.unbind().off();
				this.splash_download_title = null;
			}
			if (ss.isValue(this.dl_title)) {
				this.dl_title.unbind().off();
				this.dl_title = null;
			}
			if (ss.isValue(this.dl_content)) {
				this.dl_content.unbind().off();
				this.dl_content = null;
			}
			if (ss.isValue(this.progress_nowv)) {
				this.progress_nowv.unbind().off();
				this.progress_nowv = null;
			}
			if (ss.isValue(this.progress_objv)) {
				this.progress_objv.unbind().off();
				this.progress_objv = null;
			}
			if (ss.isValue(this.updateComment)) {
				this.updateComment.unbind().off();
				this.updateComment = null;
			}
			if (ss.isValue(this.lblUpgradeTip)) {
				this.lblUpgradeTip.unbind().off();
				this.lblUpgradeTip = null;
			}
			if (ss.isValue(this.dl_content_loading)) {
				this.dl_content_loading.unbind().off();
				this.dl_content_loading = null;
			}
			if (ss.isValue(this.progress_info)) {
				this.progress_info.unbind().off();
				this.progress_info = null;
			}
			if (ss.isValue(this.loading_main)) {
				this.loading_main.unbind().off();
				this.loading_main = null;
			}
			if (ss.isValue(this.loading_has)) {
				this.loading_has.unbind().off();
				this.loading_has = null;
			}
			if (ss.isValue(this.loading_not)) {
				this.loading_not.unbind().off();
				this.loading_not = null;
			}
			if (ss.isValue(this.progress_persent)) {
				this.progress_persent.unbind().off();
				this.progress_persent = null;
			}
			if (ss.isValue(this.btn_startdownload)) {
				this.btn_startdownload.unbind().off();
				this.btn_startdownload = null;
			}
			if (ss.isValue(this.btn_startManualDownload)) {
				this.btn_startManualDownload.unbind().off();
				this.btn_startManualDownload = null;
			}
			if (ss.isValue(this.btn_cancelUpdate)) {
				this.btn_cancelUpdate.unbind().off();
				this.btn_cancelUpdate = null;
			}
		}
	}, JSLib.Controller.ControllerBase);
	ss.initClass($USOProject_Pages_Control_ViewMoreControl, $asm, {
		$ViewMoreControl_OnShow: function(sender, e) {
			if (ss.isValue(this.$_scroller)) {
				this.$_scroller.iscroll.refresh();
			}
		},
		$ViewMoreControl_OnLoad: function(sender, e) {
			jQueryObjectEx.SetVisible(this.pnlCheckNew, JSLib.Mobile.Application.DeviceType !== 1);
			this.$_scroller = this.SetScrollable(this.pageObject[0], false, true, false, null, null, null, '', false, null, true, true);
			this.btn_modulesetting.click(function(event) {
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_SystemModule_ModuleSettings).call(null, null, null);
			});
			this.btnCheckNew.click(function(event1) {
				var $state = 0, $t1, result, data, serverInfo, bodyContainer, upgradeController, $t2;
				var $sm = function() {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								$t1 = $USOProject_Business_BusinessAction.ManualUpgrade();
								$state = 1;
								$t1.continueWith($sm);
								return;
							}
							case 1: {
								$state = -1;
								result = $t1.getAwaitedResult();
								if (!result.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
									return;
								}
								data = result.Result;
								serverInfo = { strongV: { iosUrl: data.strongAppUrl_IOS, url: data.strongAppUrl, version: data.strongAppVersion }, weakV: { iosUrl: data.weekAppUrl_IOS, url: data.weekAppUrl, version: data.weekAppVersion }, upgradeTip: data.upgradeTip };
								//检查版本更新
								if ($USOProject_Pages_Control_UpgradeTipController.CheckShouldUpdate(serverInfo.strongV.version) || $USOProject_Pages_Control_UpgradeTipController.CheckShouldUpdate(serverInfo.weakV.version)) {
									bodyContainer = JSLib.Controller.Panel.FromElement(document.body);
									upgradeController = new $USOProject_Pages_Control_UpgradeTipController(serverInfo);
									upgradeController.UpgradeCancel = function() {
										bodyContainer.RemoveChild();
									};
									$t2 = bodyContainer.AddChild(upgradeController, true, false, null);
									$state = 2;
									$t2.continueWith($sm);
									return;
								}
								else {
									JSLib.Mobile.MessageBox.Alert('您目前使用的是最新版本!');
									$state = -1;
									break $sm1;
								}
							}
							case 2: {
								$state = -1;
								$t2.getAwaitedResult();
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				};
				$sm();
			});
		},
		Execute: function() {
			this.WriteLiteral('<ul class="list inset tabPanel" data-title="查看更多" data-id="ViewMore">\r\n    <li>\r\n        <div class="list_title">系统版本</div>\r\n        <div id="more_version" class="list_content">\r\n            ');
			this.Write($App.app.AppVersion);
			this.WriteLiteral('\r\n        </div>\r\n    </li>\r\n    <li id="pnlCheckNew">\r\n        <a id="btnCheckNew" class="">检查更新</a>\r\n    </li>\r\n    <li >\r\n        <a id="btn_modulesetting">模块设置</a>\r\n    </li>\r\n</ul>');
		},
		InitialComponent: function() {
			this.more_version = this.pageObject.find('#more_version');
			this.pnlCheckNew = this.pageObject.find('#pnlCheckNew');
			this.btnCheckNew = this.pageObject.find('#btnCheckNew');
			this.btn_modulesetting = this.pageObject.find('#btn_modulesetting');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.more_version)) {
				this.more_version.unbind().off();
				this.more_version = null;
			}
			if (ss.isValue(this.pnlCheckNew)) {
				this.pnlCheckNew.unbind().off();
				this.pnlCheckNew = null;
			}
			if (ss.isValue(this.btnCheckNew)) {
				this.btnCheckNew.unbind().off();
				this.btnCheckNew = null;
			}
			if (ss.isValue(this.btn_modulesetting)) {
				this.btn_modulesetting.unbind().off();
				this.btn_modulesetting = null;
			}
		}
	}, JSLib.Controller.ControllerBase);
	ss.initClass($USOProject_Pages_NewRetailInputStatistics_CustomizeDateRange, $asm, {});
	ss.initEnum($USOProject_Pages_NewRetailInputStatistics_QueryReportDateType, $asm, { Today: 1, Yestoday: 2, ThisWeek: 3, ThisMonth: 4, Customize: 5, ThisQuater: 6, ThisHalfYear: 7, ThisYear: 8 });
	ss.initClass($USOProject_Pages_NewRetailInputStatistics_QueryReportRequest, $asm, {});
	ss.initEnum($USOProject_Pages_NewRetailInputStatistics_QueryReportViewType, $asm, { Org: 1, Sery: 2, SeryProduct: 3, SeryProductDrillOrg: 4 });
	ss.initClass($USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Configure, $asm, {
		$RetailInputStatistics_Configure_OnPageInit: function(sender, e) {
			var $state = 0, $t1, getUpdateResult, data, levelItemDoms, $t3, itemData, levelItemDom;
			var $sm = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							$t1 = $USOProject_Business_BusinessAction.GetLastLogDate(this);
							$state = 1;
							$t1.continueWith($sm);
							return;
						}
						case 1: {
							$state = -1;
							getUpdateResult = $t1.getAwaitedResult();
							if (getUpdateResult.IsSuccess) {
								this.$lastUpdateDate = getUpdateResult.Result;
							}
							this.lblHeadText.text(ss.formatString('零售录入统计 {0}', ss.formatDate(DateTimeEx.ToDateTimeForce(this.$lastUpdateDate), 'yyyy-MM-dd')));
							data = Enumerable.from($RetailStatisticsCurrentUser.get_ViewOrgTypes()).where(function(n) {
								return n > $App.LoginResult.User.UserMinOrgType;
							}).select(function(n1) {
								var $t2 = new $USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Configure$LevelItemData();
								$t2.Name = ss.Enum.toString($RetailStatisticsOrgType, n1);
								$t2.Level = n1;
								$t2.OrgType = n1;
								return $t2;
							}).toArray();
							levelItemDoms = $([]);
							for ($t3 = 0; $t3 < data.length; $t3++) {
								itemData = data[$t3];
								levelItemDom = jQueryObjectEx.ToJqueryObject$1(this.GetLeveItemHtml(itemData));
								levelItemDom.data(itemData);
								levelItemDoms = levelItemDoms.add(levelItemDom);
							}
							this.pnlConfigData.append(levelItemDoms);
							this.pageObject.on('click', '.LevelItem:not(.top)', ss.thisFix(ss.mkdel(this, function(elem, event) {
								var target = $(elem);
								//不能取消最后一项
								if ($(elem).index() === this.pageObject.find('.LevelItem').length - 1) {
									return;
								}
								var curToActive = !target.hasClass('active');
								var isAllValid = ss.mkdel(this, function() {
									var curActive = true;
									var preActive = true;
									var items = this.pageObject.find('.LevelItem');
									for (var i = 0; i < items.length; i++) {
										preActive = curActive;
										if (i === items.length - 1) {
											curActive = true;
										}
										else {
											var curTarget = $(items[i]);
											curActive = (curTarget.is(target) ? curToActive : curTarget.hasClass('active'));
										}
										if (!preActive && !curActive) {
											return false;
										}
									}
									return true;
								});
								if (!isAllValid()) {
									return;
								}
								target.toggleClass('active');
								var isActive = target.hasClass('active');
								target.data().IsActive = isActive;
							})));
							//if (RetailStatisticsCurrentUser.OwnOrgType != RetailStatisticsOrgType.业务经理 && RetailStatisticsCurrentUser.OwnOrgType != RetailStatisticsOrgType.门店)
							//{
							//    DataServiceResult<List<OrgData>> result = await BusinessAction.QueryCurrentTopLevelOrg((int)App.app.userInfo.UserMinOrgType, App.app.userInfo.User.CurrentStockOrganizationId, this);
							//    if (!result.IsSuccess)
							//    {
							//        MessageBox.Alert(result.ErrorMessage);
							//        return;
							//    }
							//    _topLevelOrg = result.Result.FirstOrDefault();
							//}
							this.btnContinue.click(ss.mkdel(this, function(event1) {
								var notCheckedChilds = Enumerable.from(this.pageObject.find('.LevelItem:not(.active)').toArray()).select(function(n2) {
									return $(n2).data().OrgType;
								}).toArray();
								$RetailStatisticsCurrentUser.SelectedOrgTypes = Enumerable.from($RetailStatisticsCurrentUser.get_ViewOrgTypes()).where(function(n3) {
									return !ss.contains(notCheckedChilds, n3);
								}).toArray();
								console.info($RetailStatisticsCurrentUser.SelectedOrgTypes);
								var $t4 = new $RetailStatisticsPageData();
								$t4.IsModel = false;
								var pageData = $t4;
								pageData.CurrentOrgType = $RetailStatisticsCurrentUser.OwnOrgType;
								if (ss.unbox(pageData.CurrentOrgType) < 1) {
									pageData.CurrentOrgType = 1;
								}
								if ($App.LoginResult.RetailInputStatRoleType !== 2) {
									pageData.CurrentOrgId = CoreEx.ToInt(this.selOrg.val(), 0);
								}
								pageData.CurrentOrgName = this.selOrg.find('option:checked').text();
								if ($App.LoginResult.RetailInputStatRoleType === 1) {
									pageData.CustomerManagerId = $App.LoginResult.User.User.Id;
									pageData.CurrentOrgName = $App.LoginResult.User.User.Name;
								}
								else if ($App.LoginResult.RetailInputStatRoleType === 2) {
									var bindData = UIDataEx.GetBindData$1($USOProject_Business_CustomerLegalOrgList).call(null, this.selCustomerLegalIds.find(':checked'));
									pageData.CurrentOrgId = $App.app.userInfo.User.CurrentStockOrganizationId;
									pageData.CustomerLegalId = bindData.CustomerLegalId;
									pageData.CustomerStoreId = CoreEx.ToInt(this.selOrg.val(), 0);
									pageData.OrganizationId = bindData.OrganizationId;
								}
								$RetailStatisticsCurrentUser.CurrentOrgId = pageData.CurrentOrgId;
								$RetailStatisticsCurrentUser.CustomerStoreId = pageData.CurrentOrgId;
								$RetailStatisticsCurrentUser.CustomerManagerId = pageData.CustomerManagerId;
								$RetailStatisticsCurrentUser.CustomerLegalId = pageData.CustomerLegalId;
								pageData.CurrentDrillToOrgType = $RetailStatisticsCurrentUser.GetNextOrgType(ss.unbox(pageData.CurrentOrgType));
								//如果跃级跳转
								var isSkipOne = ss.Nullable$1.sub(pageData.CurrentDrillToOrgType, pageData.CurrentOrgType) === 2;
								if (isSkipOne) {
									if (ss.unbox(pageData.CurrentOrgType) === 3) {
										pageData.CustomerManagerId = 0;
										$RetailStatisticsCurrentUser.CustomerManagerId = pageData.CustomerManagerId;
									}
									if (ss.unbox(pageData.CurrentOrgType) === 4) {
										pageData.CustomerLegalId = 0;
										$RetailStatisticsCurrentUser.CustomerLegalId = pageData.CustomerLegalId;
									}
								}
								if ($App.LoginResult.RetailInputStatRoleType === 2) {
									pageData.CustomerManagerId = 0;
								}
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Detail).call(null, pageData, null);
							}));
							//if (RetailStatisticsCurrentUser.ViewOrgTypes.Count <= 1)
							//{
							//    await Task.Delay(500);
							//    btnContinue.Click();
							//}
							if ($App.LoginResult.RetailInputStatRoleType === 2) {
								this.selOrg.change(ss.mkdel(this, function(event2) {
									this.selCustomerLegalIds.html(this.GetOptionsHtml(UIDataEx.GetBindData$1($USOProject_Business_CustomerLegalStoreOrgDTO).call(null, this.selOrg.find(':checked')).CustomerLegalOrgList).toString());
								}));
								this.selOrg.change();
							}
							$state = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm();
		},
		PrintCurrentSelectedOrgs: function() {
			var notCheckedChilds = Enumerable.from(this.pageObject.find('.LevelItem:not(.active)').toArray()).select(function(n) {
				return $(n).data().OrgType;
			}).toArray();
			$RetailStatisticsCurrentUser.SelectedOrgTypes = Enumerable.from($RetailStatisticsCurrentUser.get_ViewOrgTypes()).where(function(n1) {
				return !ss.contains(notCheckedChilds, n1);
			}).toArray();
			console.info($RetailStatisticsCurrentUser.SelectedOrgTypes);
		},
		PrepareData: function() {
			var $state = 0, $tcs = new ss.TaskCompletionSource(), $t1;
			var $sm = ss.mkdel(this, function() {
				try {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								$RetailStatisticsCurrentUser.OwnOrgType = $App.app.userInfo.UserMinOrgType;
								//处理长虹集团的特殊情况
								if ($RetailStatisticsCurrentUser.OwnOrgType === 0) {
									$RetailStatisticsCurrentUser.OwnOrgType = 1;
								}
								if ($App.LoginResult.RetailInputStatRoleType === 1) {
									$RetailStatisticsCurrentUser.OwnOrgType = 4;
									$RetailStatisticsCurrentUser.CustomerManagerId = $App.LoginResult.User.User.Id;
								}
								else if ($App.LoginResult.RetailInputStatRoleType === 2) {
									$RetailStatisticsCurrentUser.OwnOrgType = 6;
									$RetailStatisticsCurrentUser.CustomerManagerId = 0;
								}
								if ($App.LoginResult.RetailInputStatRoleType === 2) {
									//加载门店数据
									$t1 = $USOProject_Business_BusinessAction.GetCustomerStoreAction();
									$state = 1;
									$t1.continueWith($sm);
									return;
								}
								$state = -1;
								break $sm1;
							}
							case 1: {
								$state = -1;
								this.StoreData = $t1.getAwaitedResult().Result;
								if (ss.isNullOrUndefined(this.StoreData) || this.StoreData.length === 0) {
									JSLib.Mobile.MessageBox.Alert('加载门店数据失败!');
									window.setTimeout(function() {
										JSLib.Mobile.Application.Back(1);
									}, 500);
									$tcs.setResult(null);
									return;
								}
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
					$tcs.setResult(null);
				}
				catch ($t2) {
					$tcs.setException(ss.Exception.wrap($t2));
				}
			});
			$sm();
			return $tcs.task;
		},
		GetLeveItemHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="LevelItem active" data-level="');
				this.WriteTo(__razor_helper_writer, data.Level);
				this.WriteLiteralTo(__razor_helper_writer, '">\r\n        <div class="leftLine">\r\n            <div class="line upLine"></div>\r\n            <div class="line downLine"></div>\r\n        </div>\r\n        <div class="middleLine"></div>\r\n        <div class="checkbox"></div>\r\n        <div class="itemContent">');
				this.WriteTo(__razor_helper_writer, data.Name);
				this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n    </div>\r\n');
			}));
		},
		GetOptionsHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isValue(data) && data.length > 0) {
					for (var $t1 = 0; $t1 < data.length; $t1++) {
						var item = data[$t1];
						this.WriteLiteralTo(__razor_helper_writer, '            <option value="');
						this.WriteTo(__razor_helper_writer, item.CustomerLegalId);
						this.WriteLiteralTo(__razor_helper_writer, '" ');
						this.WriteTo(__razor_helper_writer, this.DataBind(item));
						this.WriteLiteralTo(__razor_helper_writer, '>');
						this.WriteTo(__razor_helper_writer, item.CustomerLegalName);
						this.WriteLiteralTo(__razor_helper_writer, '</option>\r\n');
					}
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="RetailInputStatistics_Configure">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">零售录入统计</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="tipPanel">\n            <div class="tip tip1">选择你想要查看的层级</div>\n            <div class="tip tip2">不可连续取消两个相邻的层级</div>\n\n        </div>\n        <div class="configArea" id="pnlConfigData">\n            <div class="LevelItem active top" data-level="');
			this.Write($RetailStatisticsCurrentUser.OwnOrgType);
			this.WriteLiteral('">\r\n                <select class="selCompany" id="selOrg">\r\n');
			if ($App.LoginResult.RetailInputStatRoleType === 1) {
				var $t1 = Enumerable.from($App.app.userInfo.StockOrganizationList).where(function(n) {
					return n.OrganizationType === 3;
				}).getEnumerator();
				try {
					while ($t1.moveNext()) {
						var item = $t1.current();
						this.WriteLiteral('                            <option value="');
						this.Write(item.Id);
						this.WriteLiteral('">');
						this.Write(item.Name);
						this.WriteLiteral('</option>\r\n');
					}
				}
				finally {
					$t1.dispose();
				}
			}
			else if ($App.LoginResult.RetailInputStatRoleType === 2) {
				//后台代码加载门店数据，并设置列表
				if (ss.isValue(this.StoreData)) {
					for (var $t2 = 0; $t2 < this.StoreData.length; $t2++) {
						var item1 = this.StoreData[$t2];
						this.WriteLiteral('                                <option value="');
						this.Write(item1.CustomerStoreId);
						this.WriteLiteral('" ');
						this.Write(this.DataBind(item1));
						this.WriteLiteral('>');
						this.Write(item1.CustomerStoreName);
						this.WriteLiteral('</option>\r\n');
					}
				}
			}
			else if ($RetailStatisticsCurrentUser.OwnOrgType <= 3) {
				var $t3 = Enumerable.from($App.app.userInfo.StockOrganizationList).where(function(n1) {
					return n1.OrganizationType === $RetailStatisticsCurrentUser.OwnOrgType;
				}).getEnumerator();
				try {
					while ($t3.moveNext()) {
						var item2 = $t3.current();
						this.WriteLiteral('                            <option value="');
						this.Write(item2.Id);
						this.WriteLiteral('">');
						this.Write(item2.Name);
						this.WriteLiteral('</option>\r\n');
					}
				}
				finally {
					$t3.dispose();
				}
			}
			this.WriteLiteral('\r\n                </select>\r\n            </div>\r\n\r\n\r\n');
			if ($App.LoginResult.RetailInputStatRoleType === 2) {
				this.WriteLiteral('                <div class="LevelItem LevelCustomerLegal">\r\n                    <select class="selCompany" id="selCustomerLegalIds"></select>\r\n                </div>\r\n');
			}
			this.WriteLiteral('        </div>\r\n\r\n        <div class="btn pressure" id="btnContinue">继续查看</div>\r\n    </div>\r\n</div>\r\n');
			this.WriteLiteral('\r\n\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.pnlConfigData = this.pageObject.find('#pnlConfigData');
			this.selOrg = this.pageObject.find('#selOrg');
			this.selCustomerLegalIds = this.pageObject.find('#selCustomerLegalIds');
			this.btnContinue = this.pageObject.find('#btnContinue');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.pnlConfigData)) {
				this.pnlConfigData.unbind().off();
				this.pnlConfigData = null;
			}
			if (ss.isValue(this.selOrg)) {
				this.selOrg.unbind().off();
				this.selOrg = null;
			}
			if (ss.isValue(this.selCustomerLegalIds)) {
				this.selCustomerLegalIds.unbind().off();
				this.selCustomerLegalIds = null;
			}
			if (ss.isValue(this.btnContinue)) {
				this.btnContinue.unbind().off();
				this.btnContinue = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Configure$LevelItemData, $asm, {});
	ss.initClass($USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Detail, $asm, {
		$RetailInputStatistics_Detail_OnPageInit: function(sender, e) {
			var $state2 = 0, $t1, getUpdateResult, curDateTypeStr, selectedText;
			var $sm2 = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state2) {
						case 0: {
							$state2 = -1;
							$t1 = $USOProject_Business_BusinessAction.GetLastLogDate(this);
							$state2 = 1;
							$t1.continueWith($sm2);
							return;
						}
						case 1: {
							$state2 = -1;
							getUpdateResult = $t1.getAwaitedResult();
							if (getUpdateResult.IsSuccess) {
								this.$lastUpdateDate = getUpdateResult.Result;
							}
							this.lblHeadText.text(ss.formatString('零售录入统计 {0}', ss.formatDate(DateTimeEx.ToDateTimeForce(this.$lastUpdateDate), 'yyyy-MM-dd')));
							curDateTypeStr = this.pnlDateChoose.find(ss.formatString('.filterItem[data-value={0}]', this.$query.DateType)).text();
							this.lblCurDateCondtion.text(curDateTypeStr);
							this.pnlDateChoose.find(ss.formatString('.filterItem[data-value={0}]', this.$query.DateType)).addClass('active');
							selectedText = (ss.isNullOrUndefined(this.$query.IsMarkedStore) ? '全部门店' : '标识门店');
							this.lblCurMarkCondition.text(selectedText);
							if (selectedText === '标识门店') {
								$(this.pnlStoreChoose.children()[0]).addClass('active');
							}
							else {
								$(this.pnlStoreChoose.children()[1]).addClass('active');
							}
							this.pageObject.on('click', '.filterItem', ss.thisFix(ss.mkdel(this, function(elem, event) {
								$(elem).addClass('active').siblings().removeClass('active');
								this.pnlConditionalPanel.focusout();
							})));
							//日期选择
							this.pnlDateChoose.on('click', '.filterItem', ss.thisFix(ss.mkdel(this, function(elem1, event1) {
								var $state = 0, initDateRange, oriDateType, quater, quaterBeginMonth, beginMonth, $t2, result, $t4, $t3, $t5, date, str;
								var $sm = ss.mkdel(this, function() {
									$sm1:
									for (;;) {
										switch ($state) {
											case 0: {
												$state = -1;
												this.$query.DateType = CoreEx.ToInt(elem1.getAttribute('data-value'), 0);
												if (this.$query.DateType === 6 || this.$query.DateType === 7 || this.$query.DateType === 8) {
													this.$query.OriDateType = this.$query.DateType;
												}
												else {
													this.$query.OriDateType = null;
												}
												if (this.$query.DateType === 5) {
													initDateRange = new JSLib.Widget.Common.DateRange();
													if (ss.isValue(this.$query.CustomizeDateRange)) {
														initDateRange.BeginDate = new Date(Date.parse(this.$query.CustomizeDateRange.From));
														initDateRange.EndDate = new Date(Date.parse(this.$query.CustomizeDateRange.To));
													}
													oriDateType = this.$query.OriDateType;
													if (ss.isValue(oriDateType)) {
														if (ss.unbox(oriDateType) === 6) {
															quater = ss.Int32.div((new Date()).getMonth() + 1 - 1, 3) + 1;
															quaterBeginMonth = (quater - 1) * 3 + 1;
															initDateRange.BeginDate = new Date((new Date()).getFullYear(), quaterBeginMonth - 1, (new Date()).getDate());
														}
														else if (ss.unbox(oriDateType) === 7) {
															beginMonth = 1;
															if ((new Date()).getMonth() + 1 >= 7) {
																beginMonth = 7;
															}
															initDateRange.BeginDate = new Date((new Date()).getFullYear(), beginMonth - 1, (new Date()).getDate());
														}
														else if (ss.unbox(oriDateType) === 8) {
															initDateRange.BeginDate = new Date((new Date()).getFullYear(), 1 - 1, 1);
														}
													}
													initDateRange.MaxDate = new Date();
													initDateRange.MinDate = new Date(2013, 1 - 1, 1);
													$t2 = JSLib.Widget.Common.DateRangeSelector.ChooseDateRange(initDateRange, this.pageObject[0]);
													$state = 2;
													$t2.continueWith($sm);
													return;
												}
												$state = 1;
												continue $sm1;
											}
											case 2: {
												$state = -1;
												result = $t2.getAwaitedResult();
												$t4 = this.$query;
												$t3 = new $USOProject_Pages_NewRetailInputStatistics_CustomizeDateRange();
												$t3.From = ss.formatDate(ss.unbox(result.BeginDate), 'yyyy-MM-dd');
												$t3.To = ss.formatDate(ss.unbox(result.EndDate), 'yyyy-MM-dd');
												$t4.CustomizeDateRange = $t3;
												$state = 1;
												continue $sm1;
											}
											case 1: {
												$state = -1;
												this.$LoadUIData('', false);
												if (this.$query.DateType === 1) {
													$t5 = $USOProject_Business_BusinessAction.GetLastLogDate(this);
													$state = 3;
													$t5.continueWith($sm);
													return;
												}
												else {
													this.lblCurDateCondtion.text(elem1.innerText);
													$state = -1;
													break $sm1;
												}
											}
											case 3: {
												$state = -1;
												date = $t5.getAwaitedResult();
												if (date.IsSuccess) {
													this.$lastUpdateDate = date.Result;
												}
												str = elem1.innerText;
												str = str + ' [' + ss.formatDate(DateTimeEx.ToDateTimeForce(this.$lastUpdateDate), 'HH:mm') + ']';
												this.lblCurDateCondtion.text(str);
												$state = -1;
												break $sm1;
											}
											default: {
												break $sm1;
											}
										}
									}
								});
								$sm();
							})));
							//标识门店选择
							this.pnlStoreChoose.on('click', '.filterItem', ss.thisFix(ss.mkdel(this, function(elem2, event2) {
								this.$query.IsMarkedStore = elem2.getAttribute('data-value').toUpperCase() === 'TRUE';
								if (ss.Nullable$1.not(this.$query.IsMarkedStore) === true) {
									this.$query.IsMarkedStore = null;
								}
								this.$LoadUIData('', false);
								this.lblCurMarkCondition.text(elem2.innerText);
							})));
							//点击排序
							this.pageObject.on('click', '.colHeadItem', ss.thisFix(ss.mkdel(this, function(elem3, event3) {
								var colheadItem = $(elem3);
								colheadItem.find('.colHeadSort').each(function(index, element) {
									var target = $(element);
									if (target.hasClass('sortup') || target.hasClass('unsort')) {
										target.removeClass('sortup').removeClass('unsort').addClass('sortdown');
									}
									else if (target.hasClass('sortdown')) {
										target.removeClass('sortdown').addClass('sortup');
									}
								});
								colheadItem.siblings('.colHeadItem').find('.colHeadSort').removeClass('sortup').removeClass('sortdown').addClass('unsort');
								var isSortUp = colheadItem.find('.colHeadSort').hasClass('sortup');
								var sortFiled = colheadItem.attr('data-sortfield');
								this.UISort(sortFiled, isSortUp);
							})));
							this.pageObject.on('click', '.filterGroupItem', ss.thisFix(ss.mkdel(this, function(elem4, event4) {
								var target1 = $(elem4);
								target1.addClass('active').siblings().removeClass('active');
								var isBySeries = false;
								isBySeries = target1.hasClass('byModel');
								this.$IsByModel = isBySeries;
								if (!this.Data.IsModel) {
									this.$query.QueryReportViewType = (!isBySeries ? 1 : 2);
								}
								else {
									this.$query.QueryReportViewType = (!isBySeries ? 4 : 3);
								}
								this.$SetLevelId(this.$query);
								this.$LoadUIData('', false);
							})));
							this.pageObject.on('click', '.condition>.chooseMore', ss.thisFix(ss.mkdel(this, function(elem5, event5) {
								var target2 = $(elem5).parent();
								var index1 = target2.index();
								if (target2.hasClass('active')) {
									target2.removeClass('active');
									this.pnlFilterMore.hide();
									return;
								}
								target2.addClass('active').siblings().removeClass('active');
								$(this.pnlFilterMore.show().children().children()[index1]).addClass('active').siblings().removeClass('active');
							})));
							this.pnlConditionalPanel.on('focusout', ss.mkdel(this, function(event6) {
								this.pnlFilterMore.hide();
								this.pnlConditionalPanel.find('.condition').removeClass('active');
							}));
							//行数据展开
							this.pageObject.on('click', '.dataRow', ss.thisFix(ss.mkdel(this, function(elem6, event7) {
								var $state1 = 0, target3, bindItem, productCompanyQuery, $t7, data;
								var $sm1 = ss.mkdel(this, function() {
									$sm1:
									for (;;) {
										switch ($state1) {
											case 0: {
												$state1 = -1;
												if (this.Data.IsModel) {
													target3 = $(elem6);
													bindItem = UIDataEx.GetBindData$1(Object).call(null, target3.find('>.rowData'));
													if (ss.isNullOrUndefined(bindItem)) {
														return;
													}
													productCompanyQuery = new $USOProject_Pages_NewRetailInputStatistics_QueryReportRequest();
													productCompanyQuery = CoreEx.Clone($USOProject_Pages_NewRetailInputStatistics_QueryReportRequest).call(null, this.$query);
													//最后一级的页面
													if (ss.isNullOrUndefined(this.Data.CurrentDrillToOrgType)) {
														productCompanyQuery.QueryReportViewType = 3;
														productCompanyQuery.ProductSeryId = bindItem.ProductSeryId;
													}
													else {
														//查询产品对应的公司
														productCompanyQuery.QueryReportViewType = 4;
														productCompanyQuery.ProductId = bindItem.ProductId;
														//productCompanyQuery.ProductSeryId = Data.ProductSeryId;
														//productCompanyQuery.CustomerManagerId = bindItem.CustomerManagerId;
														//productCompanyQuery.CustomerLegalId = bindItem.CustomerLegalId;
														productCompanyQuery.CustomerStoreId = bindItem.CustomerStoreId;
													}
													if (ss.isValue(this.Data.CurrentDrillToOrgType)) {
														productCompanyQuery.AncestorDepth = ss.unbox(this.Data.CurrentDrillToOrgType) - ss.unbox(this.Data.CurrentOrgType);
													}
													else {
														productCompanyQuery.AncestorDepth = 1;
													}
													this.$SetLevelId(productCompanyQuery);
													if (target3.find('.rowDetailPanel').length > 0) {
														target3.toggleClass('active');
														return;
													}
													else {
														$t7 = $USOProject_Business_BusinessAction.QueryStatisticsRetailReport(productCompanyQuery, this);
														$state1 = 1;
														$t7.continueWith($sm1);
														return;
													}
												}
												$state1 = -1;
												break $sm1;
											}
											case 1: {
												$state1 = -1;
												data = $t7.getAwaitedResult();
												if (!data.IsSuccess) {
													JSLib.Mobile.MessageBox.Alert(data.ErrorMessage);
													return;
												}
												if (ss.isValue(data.Result) && data.Result.length > 0) {
													target3.append(this.GetChildDataHtml(data.Result).toString());
													target3.toggleClass('active');
												}
												$state1 = -1;
												break $sm1;
											}
											default: {
												break $sm1;
											}
										}
									}
								});
								$sm1();
							})));
							//行数据跳转
							this.pageObject.on('click', '.rowData', ss.thisFix(ss.mkdel(this, function(elem7, event8) {
								if (this.Data.IsModel) {
									return;
								}
								var bindItem1 = UIDataEx.GetBindData$1(Object).call(null, $(elem7));
								if (ss.isNullOrUndefined(bindItem1)) {
									return;
								}
								var pageData = new $RetailStatisticsPageData();
								pageData.QueryDateType = this.$query.DateType;
								pageData.OriDateType = this.$query.OriDateType;
								pageData.QueryDateRange = this.$query.CustomizeDateRange;
								pageData.IsMarkedStore = this.$query.IsMarkedStore;
								pageData.IsModel = this.$IsByModel;
								if (this.$IsByModel) {
									pageData.QueryReportViewType = 3;
									pageData.CurrentOrgId = this.Data.CurrentOrgId;
									pageData.CurrentOrgName = this.Data.CurrentOrgName;
									pageData.CurrentOrgType = this.Data.CurrentOrgType;
									pageData.CurrentDrillToOrgType = this.Data.CurrentDrillToOrgType;
								}
								else {
									pageData.CurrentOrgType = this.Data.CurrentDrillToOrgType;
									pageData.CurrentDrillToOrgType = $RetailStatisticsCurrentUser.GetNextOrgType(ss.unbox(pageData.CurrentOrgType));
									if (ss.isValue(this.Data.CurrentDrillToOrgType) && ss.unbox(this.Data.CurrentDrillToOrgType) <= 3) {
										$RetailStatisticsCurrentUser.CurrentOrgId = bindItem1.StockOrganizationId;
									}
									//如果是业务经理，组织ID使用传入页面的组织ID;
									if ($RetailStatisticsCurrentUser.CurrentOrgId === 0 && $App.LoginResult.RetailInputStatRoleType === 1) {
										$RetailStatisticsCurrentUser.CurrentOrgId = this.Data.CurrentOrgId;
									}
									pageData.CurrentOrgId = $RetailStatisticsCurrentUser.CurrentOrgId;
									pageData.CurrentOrgName = bindItem1.StatItemName;
								}
								if (this.$query.QueryReportViewType === 2) {
									$RetailStatisticsCurrentUser.ProductSeryId = bindItem1.ProductSeryId;
								}
								pageData.CurModelId = $RetailStatisticsCurrentUser.ProductSeryId;
								pageData.CurModelName = bindItem1.StatItemName;
								if (this.Data.QueryReportViewType === 1 && ss.isValue(this.Data.CurrentDrillToOrgType)) {
									if (ss.unbox(this.Data.CurrentDrillToOrgType) === 4 && $App.LoginResult.RetailInputStatRoleType !== 1) {
										$RetailStatisticsCurrentUser.CustomerManagerId = bindItem1.CustomerManagerId;
									}
									pageData.CustomerManagerId = $RetailStatisticsCurrentUser.CustomerManagerId;
									if (ss.unbox(this.Data.CurrentDrillToOrgType) === 5) {
										$RetailStatisticsCurrentUser.CustomerLegalId = bindItem1.CustomerLegalId;
									}
									pageData.CustomerLegalId = $RetailStatisticsCurrentUser.CustomerLegalId;
									if (ss.unbox(this.Data.CurrentDrillToOrgType) === 6 && $App.LoginResult.RetailInputStatRoleType !== 2) {
										$RetailStatisticsCurrentUser.CustomerStoreId = bindItem1.CustomerStoreId;
									}
									pageData.CustomerStoreId = $RetailStatisticsCurrentUser.CustomerStoreId;
								}
								//如果跃级跳转
								var isSkipOne = ss.Nullable$1.sub(pageData.CurrentDrillToOrgType, pageData.CurrentOrgType) === 2;
								if (isSkipOne) {
									if (ss.unbox(pageData.CurrentOrgType) === 3) {
										pageData.CustomerManagerId = 0;
										$RetailStatisticsCurrentUser.CustomerManagerId = pageData.CustomerManagerId;
									}
									if (ss.unbox(pageData.CurrentOrgType) === 4) {
										pageData.CustomerLegalId = 0;
										$RetailStatisticsCurrentUser.CustomerLegalId = pageData.CustomerLegalId;
									}
								}
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Detail).call(null, pageData, null);
							})));
							this.$LoadUIData('', false);
							$state2 = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm2();
		},
		$LoadUIData: function(sortFiled, isSortUp) {
			var $state = 0, $t1, data, sortKeySelector;
			var $sm = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							this.$query.StockOrganizationId = this.Data.CurrentOrgId;
							this.$query.OrganizationId = this.Data.OrganizationId;
							if (ss.isValue(this.Data.CurrentDrillToOrgType)) {
								this.$query.AncestorDepth = ss.unbox(this.Data.CurrentDrillToOrgType) - ss.unbox(this.Data.CurrentOrgType);
							}
							else {
								this.$query.AncestorDepth = 1;
							}
							if (this.$query.QueryReportViewType === 2 || this.$query.QueryReportViewType === 3) {
								this.$query.AncestorDepth = 1;
							}
							//加载数据
							$t1 = $USOProject_Business_BusinessAction.QueryStatisticsRetailReport(this.$query, this);
							$state = 1;
							$t1.continueWith($sm);
							return;
						}
						case 1: {
							$state = -1;
							data = $t1.getAwaitedResult();
							if (!data.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(data.ErrorMessage);
								return;
							}
							this.$_listData = data.Result;
							jQueryObjectEx.SetVisible(this.lblVerticalLine, ss.isValue(this.$_listData) && this.$_listData.length > 0);
							if (!ss.isNullOrEmptyString(sortFiled)) {
								sortKeySelector = function(n) {
									if (sortFiled === 'Amount') {
										return n.Amount;
									}
									else if (sortFiled === 'Quantity') {
										return n.Quantity;
									}
									else {
										return n.Average;
									}
								};
								if (isSortUp) {
									this.$_listData = Enumerable.from(this.$_listData).orderBy(sortKeySelector).toArray();
								}
								else {
									this.$_listData = Enumerable.from(this.$_listData).orderByDescending(sortKeySelector).toArray();
								}
							}
							this.pnlList.html(this.GetGridDataHtml(this.$_listData).toString());
							this.lblTotalQuantity.text($USOProject_Business_RetailStatisticsExtension.GetTotalQuantity(this.$_listData).toString());
							this.lblTotalAver.text($USOProject_Business_RetailStatisticsExtension.ToMoney($USOProject_Business_RetailStatisticsExtension.GetTotalAvg(this.$_listData)));
							this.lblTotalAmount.text($USOProject_Business_RetailStatisticsExtension.ToMoney($USOProject_Business_RetailStatisticsExtension.GetTotalAmount(this.$_listData)));
							$state = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm();
		},
		UISort: function(sortFiled, isSortUp) {
			if (!ss.isNullOrEmptyString(sortFiled)) {
				var sortKeySelector = function(n) {
					if (sortFiled === 'Amount') {
						return n.Amount;
					}
					else if (sortFiled === 'Quantity') {
						return n.Quantity;
					}
					else {
						return n.Average;
					}
				};
				if (isSortUp) {
					this.$_listData = Enumerable.from(this.$_listData).orderBy(sortKeySelector).toArray();
				}
				else {
					this.$_listData = Enumerable.from(this.$_listData).orderByDescending(sortKeySelector).toArray();
				}
			}
			this.pnlList.html(this.GetGridDataHtml(this.$_listData).toString());
		},
		PrepareData: function() {
			this.Data = this.InitialData;
			this.$query.DateType = this.Data.QueryDateType;
			this.$query.CustomizeDateRange = this.Data.QueryDateRange;
			this.$query.IsMarkedStore = this.Data.IsMarkedStore;
			this.$query.QueryReportViewType = this.Data.QueryReportViewType;
			this.$query.ProductSeryId = this.Data.CurModelId;
			this.$query.CustomerManagerId = this.Data.CustomerManagerId;
			this.$query.CustomerLegalId = this.Data.CustomerLegalId;
			this.$query.CustomerStoreId = this.Data.CustomerStoreId;
			//如果没有可以钻取的组织了，则显示系列
			if (ss.isNullOrUndefined(this.Data.CurrentDrillToOrgType)) {
				this.$query.QueryReportViewType = 2;
				this.Data.IsModel = true;
				this.Data.CurModelName = '';
			}
			this.$SetLevelId(this.$query);
			this.ChildOrg = this.Data.CurrentDrillToOrgType;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		$SetLevelId: function(query) {
			if (query.QueryReportViewType === 1) {
				query.LevelId = (ss.isNullOrUndefined(this.Data.CurrentDrillToOrgType) ? (this.Data.CurrentOrgType + 1) : this.Data.CurrentDrillToOrgType);
			}
			else if (query.QueryReportViewType === 4) {
				var nextlevelOrg = $RetailStatisticsCurrentUser.GetNextOrgType(ss.unbox(this.Data.CurrentOrgType));
				query.LevelId = nextlevelOrg;
			}
			else {
				query.LevelId = this.Data.CurrentOrgType;
			}
		},
		GetCurLevePrefixString: function() {
			var prefix = '';
			if (!ss.isValue(this.Data.CurrentOrgType)) {
				return prefix;
			}
			if (ss.unbox(this.Data.CurrentOrgType) === 4) {
				prefix = '业务经理|';
			}
			else if (ss.unbox(this.Data.CurrentOrgType) === 5) {
				prefix = '客户|';
			}
			return prefix;
		},
		Destroy: function() {
			if (this.Data.QueryReportViewType === 1 && ss.isValue(this.Data.CurrentDrillToOrgType)) {
				if (ss.unbox(this.Data.CurrentDrillToOrgType) === 4) {
					$RetailStatisticsCurrentUser.CustomerManagerId = null;
				}
				if (ss.unbox(this.Data.CurrentDrillToOrgType) === 5) {
					$RetailStatisticsCurrentUser.CustomerLegalId = null;
				}
				if (ss.unbox(this.Data.CurrentDrillToOrgType) === 6) {
					$RetailStatisticsCurrentUser.CustomerStoreId = null;
				}
			}
			JSLib.Mobile.BasePage.prototype.Destroy.call(this);
		},
		GetGridDataHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || !Enumerable.from(data).any()) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">\r\n            暂无数据\r\n        </div>\r\n');
					return;
				}
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="dataRow">\r\n            <div class="rowData pressure" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(item));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n                <div class="col col1">\r\n                    ');
					this.WriteTo(__razor_helper_writer, item.StatItemName);
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n                <div class="col col2 ">\r\n                    ');
					this.WriteTo(__razor_helper_writer, item.Quantity);
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n                <div class="col col6 ">\r\n                    ');
					this.WriteTo(__razor_helper_writer, $USOProject_Business_RetailStatisticsExtension.GetQuantityRatioIn(item, $USOProject_Business_RetailStatisticsExtension.GetTotalQuantity(data)));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n                <div class="col col3  ">\r\n                    ');
					this.WriteTo(__razor_helper_writer, $USOProject_Business_RetailStatisticsExtension.ToMoney(item.Average));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n                <div class="col col4  ">\r\n                    ');
					this.WriteTo(__razor_helper_writer, $USOProject_Business_RetailStatisticsExtension.ToMoney(item.Amount));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n                <div class="col col5  ">\r\n                    ');
					this.WriteTo(__razor_helper_writer, $USOProject_Business_RetailStatisticsExtension.GetAmountRatioIn(item, $USOProject_Business_RetailStatisticsExtension.GetTotalAmount(data)));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n');
				}
			}));
		},
		GetChildDataHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <div class="rowDetailPanel">\r\n');
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '            <div class="rowData dataRow">\r\n                <div class="col col1">\r\n                    ');
					this.WriteTo(__razor_helper_writer, item.StatItemName);
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n                <div class="col col2 ">\r\n                   ');
					this.WriteTo(__razor_helper_writer, item.Quantity);
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n                <div class="col col6 ">\r\n                    ');
					this.WriteTo(__razor_helper_writer, $USOProject_Business_RetailStatisticsExtension.GetQuantityRatioIn(item, $USOProject_Business_RetailStatisticsExtension.GetTotalQuantity(data)));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n                <div class="col col3  ">\r\n                    ');
					this.WriteTo(__razor_helper_writer, $USOProject_Business_RetailStatisticsExtension.ToMoney(item.Average));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n                <div class="col col4  ">\r\n                    ');
					this.WriteTo(__razor_helper_writer, $USOProject_Business_RetailStatisticsExtension.ToMoney(item.Amount));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n                <div class="col col5  ">\r\n                    ');
					this.WriteTo(__razor_helper_writer, $USOProject_Business_RetailStatisticsExtension.GetAmountRatioIn(item, $USOProject_Business_RetailStatisticsExtension.GetTotalAmount(data)));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n            </div>\r\n');
				}
				this.WriteLiteralTo(__razor_helper_writer, '    </div>\r\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="RetailInputStatistics_Detail">\n\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">零售录入统计</div>\n        <div class="iconQuickNav"></div>\n    </div>\n    <div class="quickNavpanel">\n        <div class="quickNavItem">\n            总部\n        </div>\n        <div class="quickNavItem">\n            分公司\n        </div>\n        <div class="quickNavItem">\n            经营部\n        </div>\n        <div class="quickNavItem">\n            业务经理\n        </div>\n        <div class="quickNavItem">\n            客户\n        </div>\n        <div class="quickNavItem">\n            门店\n        </div>\n    </div>\n\n    <div class="content" id="pnlContent">\n        <div class="curPanel">\n            <div class="curLevel">[');
			this.Write(this.GetCurLevePrefixString());
			this.WriteLiteral(' ');
			this.Write(this.Data.CurrentOrgName);
			this.WriteLiteral(']</div>\r\n');
			if (this.Data.IsModel && !ss.isNullOrEmptyString(this.Data.CurModelName)) {
				this.WriteLiteral('                <div class="curModel">[');
				this.Write(this.Data.CurModelName);
				this.WriteLiteral(']</div>\r\n');
			}
			this.WriteLiteral('        </div>\n        <div class="filterPanel" tabindex="-1" id="pnlConditionalPanel">\n            <div class="conditionPanel">\n                <div class="condition">\n                    <div class="curCondition" id="lblCurDateCondtion"></div>\n                    <div class="chooseMore"></div>\n                </div>\n                <div class="condition">\n                    <div class="curCondition" id="lblCurMarkCondition"></div>\n                    <div class="chooseMore"></div>\n                </div>\n            </div>\n            <div class="filterMore" id="pnlFilterMore">\n                <div class="filterMoreContentPanel">\n                    <div class="filterMoreItem" id="pnlDateChoose">\n                        <div class="filterItem" data-value="');
			this.Write(1);
			this.WriteLiteral('">\r\n                            今天\r\n                        </div>\r\n                        <div class="filterItem" data-value="');
			this.Write(2);
			this.WriteLiteral('">\r\n                            昨天\r\n                        </div>\r\n                        <div class="filterItem" data-value="');
			this.Write(3);
			this.WriteLiteral('">\r\n                            本周\r\n                        </div>\r\n                        <div class="filterItem" data-value="');
			this.Write(4);
			this.WriteLiteral('">\r\n                            本月\r\n                        </div>\r\n                        <div class="filterItem" data-value="');
			this.Write(6);
			this.WriteLiteral('">\r\n                            本季\r\n                        </div>\r\n                        <div class="filterItem" data-value="');
			this.Write(7);
			this.WriteLiteral('">\r\n                            半年\r\n                        </div>\r\n                        <div class="filterItem" data-value="');
			this.Write(8);
			this.WriteLiteral('">\r\n                            今年\r\n                        </div>\r\n                        <div class="filterItem" data-value="');
			this.Write(5);
			this.WriteLiteral('">\r\n                            自选\r\n                        </div>\r\n\r\n                    </div>\r\n                    <div class="filterMoreItem" id="pnlStoreChoose">\r\n                        <div class="filterItem" data-value="');
			this.Write(true);
			this.WriteLiteral('">\r\n                            标识门店\r\n                        </div>\r\n                        <div class="filterItem" data-value="');
			this.Write(false);
			this.WriteLiteral('">\n                            全部门店\n                        </div>\n                    </div>\n                </div>\n            </div>\n\n        </div>\n        <div class="datagrid" id="pnlGridData">\n            <div class="leftLine" id="lblVerticalLine"></div>\n            <div class="gridhead">\n                <div class="rowData headRow">\n                    <div class="col col1">\n');
			if (!this.Data.IsModel) {
				this.WriteLiteral('                            <div class="filterGroup">\r\n');
				if (ss.isValue(this.ChildOrg)) {
					this.WriteLiteral('                                    <div class="filterGroupItem byOrg pressure active">');
					this.Write(ss.Enum.toString($RetailStatisticsOrgType, ss.unbox(this.ChildOrg)));
					this.WriteLiteral('</div>\r\n');
					this.WriteLiteral('                                    ');
					this.WriteLiteral('/\r\n');
				}
				this.WriteLiteral('\r\n                                <div class="filterGroupItem byModel pressure">系列</div>\r\n                            </div>\r\n');
			}
			else {
				this.WriteLiteral('                            ');
				this.WriteLiteral('系列-型号\r\n');
			}
			this.WriteLiteral('                    </div>\r\n                    <div class="col col2 colHeadItem pressure" data-sortfield="Quantity">\r\n                        <div class="colHeadName">数量</div>\r\n                        <div class="colHeadSort unsort"></div>\r\n                    </div>\r\n                    <div class="col col6 colHeadItem pressure" data-sortfield="Quantity">\r\n                        <div class="colHeadName">占比</div>\r\n                        <div class="colHeadSort unsort"></div>\r\n                    </div>\r\n                    <div class="col col3 colHeadItem pressure" data-sortfield="Average">\r\n                        <div class="colHeadName">均价</div>\r\n                        <div class="colHeadSort unsort"></div>\r\n                    </div>\r\n                    <div class="col col4 colHeadItem pressure" data-sortfield="Amount">\r\n                        <div class="colHeadName">总额</div>\r\n                        <div class="colHeadSort unsort"></div>\r\n                    </div>\r\n                    <div class="col col5 colHeadItem pressure" data-sortfield="Amount">\r\n                        <div class="colHeadName">占比</div>\r\n                        <div class="colHeadSort unsort"></div>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n            <div class="gridData" id="pnlList">\r\n\r\n            </div>\r\n\r\n        </div>\r\n    </div>\r\n    <div class="summaryPanel">\r\n        <div class="summaryItem">\r\n            <span class="label">销量</span>\r\n            <span class="value" id="lblTotalQuantity">0</span>\r\n        </div>\r\n        <div class="summaryItem">\r\n            <span class="label">均价</span>\r\n            <span class="value" id="lblTotalAver">0</span>\r\n        </div>\r\n        <div class="summaryItem">\r\n            <span class="label">总额</span>\r\n            <span class="value" id="lblTotalAmount">0</span>\r\n        </div>\r\n    </div>\r\n</div>\r\n\r\n');
			this.WriteLiteral('\r\n\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.pnlConditionalPanel = this.pageObject.find('#pnlConditionalPanel');
			this.lblCurDateCondtion = this.pageObject.find('#lblCurDateCondtion');
			this.lblCurMarkCondition = this.pageObject.find('#lblCurMarkCondition');
			this.pnlFilterMore = this.pageObject.find('#pnlFilterMore');
			this.pnlDateChoose = this.pageObject.find('#pnlDateChoose');
			this.pnlStoreChoose = this.pageObject.find('#pnlStoreChoose');
			this.pnlGridData = this.pageObject.find('#pnlGridData');
			this.lblVerticalLine = this.pageObject.find('#lblVerticalLine');
			this.pnlList = this.pageObject.find('#pnlList');
			this.lblTotalQuantity = this.pageObject.find('#lblTotalQuantity');
			this.lblTotalAver = this.pageObject.find('#lblTotalAver');
			this.lblTotalAmount = this.pageObject.find('#lblTotalAmount');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.pnlConditionalPanel)) {
				this.pnlConditionalPanel.unbind().off();
				this.pnlConditionalPanel = null;
			}
			if (ss.isValue(this.lblCurDateCondtion)) {
				this.lblCurDateCondtion.unbind().off();
				this.lblCurDateCondtion = null;
			}
			if (ss.isValue(this.lblCurMarkCondition)) {
				this.lblCurMarkCondition.unbind().off();
				this.lblCurMarkCondition = null;
			}
			if (ss.isValue(this.pnlFilterMore)) {
				this.pnlFilterMore.unbind().off();
				this.pnlFilterMore = null;
			}
			if (ss.isValue(this.pnlDateChoose)) {
				this.pnlDateChoose.unbind().off();
				this.pnlDateChoose = null;
			}
			if (ss.isValue(this.pnlStoreChoose)) {
				this.pnlStoreChoose.unbind().off();
				this.pnlStoreChoose = null;
			}
			if (ss.isValue(this.pnlGridData)) {
				this.pnlGridData.unbind().off();
				this.pnlGridData = null;
			}
			if (ss.isValue(this.lblVerticalLine)) {
				this.lblVerticalLine.unbind().off();
				this.lblVerticalLine = null;
			}
			if (ss.isValue(this.pnlList)) {
				this.pnlList.unbind().off();
				this.pnlList = null;
			}
			if (ss.isValue(this.lblTotalQuantity)) {
				this.lblTotalQuantity.unbind().off();
				this.lblTotalQuantity = null;
			}
			if (ss.isValue(this.lblTotalAver)) {
				this.lblTotalAver.unbind().off();
				this.lblTotalAver = null;
			}
			if (ss.isValue(this.lblTotalAmount)) {
				this.lblTotalAmount.unbind().off();
				this.lblTotalAmount = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Index, $asm, {
		$RetailInputStatistics_Index_OnPageInit: function(sender, e) {
			this.pageObject.on('click', '.EntryItem', ss.thisFix(function(ele, event) {
				$RetailStatisticsCurrentUser.OwnOrgType = CoreEx.ToInt(ele.getAttribute('data-id'), 0);
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Configure).call(null, null, null);
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="RetailInputStatistics_Index">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">零售录入统计</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="ContentArea">\n            <div class="EntryWraper">\n                <div class="EntryItem full color1" data-id="1">总部</div>\n            </div>\n            <div class="EntryWraper">\n                <div class="EntryItem half  left color2" data-id="2">分公司</div>\n                <div class="EntryItem half right color3" data-id="3">经营部</div>\n            </div>\n            <div class="EntryWraper">\n                <div class="EntryItem half left color4" data-id="4">业务经理</div>\n                <div class="EntryItem half right color5" data-id="5">客户</div>\n            </div>\n            <div class="EntryWraper">\n                <div class="EntryItem full color6" data-id="6">门店导购</div>\n            </div>\n        </div>\n \n    </div>\n    \n</div>\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Product_CategoryDetail, $asm, {
		$CategoryDetail_OnPageInit: function(sender, e) {
			this.SetScrollable(this.cateLeft[0], false, true, false, null, null, null, 'cate2Container', false, null, true, true);
			this.SetScrollable(this.cateRight[0], false, true, false, null, null, null, 'cate3Container', false, null, true, true);
			this.cateLeft.on('click', 'li[data-cate2]', ss.thisFix(ss.mkdel(this, function(elem, event) {
				var target = $(elem);
				this.cateLeft.find('li[data-cate2]').removeClass('selected');
				target.addClass('selected');
				var cate2Id = CoreEx.ToInt(elem.getAttribute('data-cate2'), 0);
				var cate3ListData = Enumerable.from($USOProject_Pages_Product_CategoryMaster.AllCategory.Category3).where(function(n) {
					return n.C2ID === cate2Id;
				}).toArray();
				this.pnlCate3List.html(this.GetCate3ListHtml(cate3ListData).toString());
				this.RefreshPageScroll();
			})));
			this.cateRight.on('click', 'li[data-cate3]', ss.thisFix(ss.mkdel(this, function(elem1, event1) {
				var target1 = $(elem1);
				this.cateRight.find('li[data-cate3]').removeClass('selected');
				target1.addClass('selected');
				var cate3Id = CoreEx.ToInt(target1.attr('data-cate3'), 0);
				//跳转至产品详情页面
				var $t1 = new $USOProject_Pages_Product_ProductList$ProductListData();
				$t1.IsFromClickSearch = false;
				$t1.C3Id = cate3Id.toString();
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Product_ProductList).call(null, $t1, null);
			})));
			this.cate2List.children().first().click();
		},
		GetCate3ListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <li class="li_cate3" data-cate3="');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '">\r\n            <p>');
					this.WriteTo(__razor_helper_writer, item.C3Name);
					this.WriteLiteralTo(__razor_helper_writer, '</p>\r\n        </li>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="CategoryDetail">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">详细分类</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div id="cateLeft" class="cateLeft">\n            <ul id="cate2List" class="cate2List">\n');
			var cate2DataList = Enumerable.from($USOProject_Pages_Product_CategoryMaster.AllCategory.Category2).where(ss.mkdel(this, function(n) {
				return n.C1ID === this.InitialData;
			}));
			var $t1 = cate2DataList.getEnumerator();
			try {
				while ($t1.moveNext()) {
					var item = $t1.current();
					this.WriteLiteral('                    <li class="li_cate2" data-cate2="');
					this.Write(item.Id);
					this.WriteLiteral('">\r\n');
					var imgUrl = $App.app.config.MobileCategoryImgUrl + '2_' + item.Id + '@2x.png';
					this.WriteLiteral('                        <img src="');
					this.Write(imgUrl);
					this.WriteLiteral('" class="cate2Img" onerror="imgError(this)">\r\n                        <p class="cate2Title">');
					this.Write(item.C2Name);
					this.WriteLiteral('</p>\r\n                    </li>\r\n');
				}
			}
			finally {
				$t1.dispose();
			}
			this.WriteLiteral('            </ul>\r\n        </div>\r\n        <div id="cateRight" class="cateRight">\r\n            <ul class="clate3List" id="pnlCate3List"></ul>\r\n        </div>\r\n    </div>\r\n\r\n</div>\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.cateLeft = this.pageObject.find('#cateLeft');
			this.cate2List = this.pageObject.find('#cate2List');
			this.cateRight = this.pageObject.find('#cateRight');
			this.pnlCate3List = this.pageObject.find('#pnlCate3List');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.cateLeft)) {
				this.cateLeft.unbind().off();
				this.cateLeft = null;
			}
			if (ss.isValue(this.cate2List)) {
				this.cate2List.unbind().off();
				this.cate2List = null;
			}
			if (ss.isValue(this.cateRight)) {
				this.cateRight.unbind().off();
				this.cateRight = null;
			}
			if (ss.isValue(this.pnlCate3List)) {
				this.pnlCate3List.unbind().off();
				this.pnlCate3List = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Product_CategoryMaster, $asm, {
		$CategoryMaster_OnPageInit: function(sender, e) {
			var $state = 0, $t1, result;
			var $sm = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							this.SetScrollable(this.pnlContent[0], false, true, false, null, null, null, '', false, null, true, true);
							//如果已经有分类数据，则不再读取
							if (ss.isNullOrUndefined($USOProject_Pages_Product_CategoryMaster.AllCategory)) {
								$t1 = $USOProject_Business_BusinessAction.GetAllCategory();
								$state = 2;
								$t1.continueWith($sm);
								return;
							}
							$state = 1;
							continue $sm1;
						}
						case 2: {
							$state = -1;
							result = $t1.getAwaitedResult();
							if (!result.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
								window.setTimeout(function() {
									JSLib.Mobile.Application.Back(1);
								}, 500);
								return;
							}
							else {
								$USOProject_Pages_Product_CategoryMaster.AllCategory = result.Result;
							}
							$state = 1;
							continue $sm1;
						}
						case 1: {
							$state = -1;
							this.ulCategory1Container.html(this.GetCategoriesHtml().toString());
							this.ulCategory1Container.on('click', 'li[data-categoryid]', ss.thisFix(function(elem, event) {
								var categoryId = CoreEx.ToInt(elem.getAttribute('data-categoryid'), 0);
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Product_CategoryDetail).call(null, categoryId, null);
							}));
							this.btnGotoFav.click(function(event1) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Product_ProductFavorite).call(null, null, null);
							});
							this.btnGotoCart.click(function(event2) {
								//跳转到购物车
							});
							this.btnGotoSearch.click(function(event3) {
								var $t2 = new $USOProject_Pages_Product_ProductList$ProductListData();
								$t2.IsFromClickSearch = true;
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Product_ProductList).call(null, $t2, null);
							});
							$state = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm();
		},
		GetCategoriesHtml: function() {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				for (var $t1 = 0; $t1 < $USOProject_Pages_Product_CategoryMaster.AllCategory.Category1.length; $t1++) {
					var item = { $: $USOProject_Pages_Product_CategoryMaster.AllCategory.Category1[$t1] };
					this.WriteLiteralTo(__razor_helper_writer, '        <li class="li_cate1 li_a_cate" data-categoryid="');
					this.WriteTo(__razor_helper_writer, item.$.Id);
					this.WriteLiteralTo(__razor_helper_writer, '" >\n');
					var imgUrl = $App.app.config.MobileCategoryImgUrl + '1_' + item.$.Id + '@2x.png';
					this.WriteLiteralTo(__razor_helper_writer, '            <img class="cateImg" src="');
					this.WriteTo(__razor_helper_writer, imgUrl);
					this.WriteLiteralTo(__razor_helper_writer, '" onerror="this.onerror=\'\'; this.src=\'img/noPic.jpg\'">\n            <div class="catedesc">\n                <div class="cate_title">');
					this.WriteTo(__razor_helper_writer, item.$.C1Name);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\n');
					var cate2Descrip = '';
					if (ss.isValue($USOProject_Pages_Product_CategoryMaster.AllCategory.Category2)) {
						var cate2Data = Enumerable.from($USOProject_Pages_Product_CategoryMaster.AllCategory.Category2).where(ss.mkdel({ item: item }, function(n) {
							return n.C1ID === this.item.$.Id;
						})).toArray();
						for (var index = 0; index < cate2Data.length; index++) {
							var cateItem = cate2Data[index];
							cate2Descrip += cateItem.C2Name;
							if (index !== cate2Data.length - 1) {
								cate2Descrip += '/';
							}
						}
					}
					this.WriteLiteralTo(__razor_helper_writer, '                <div class="cate_subtitle">');
					this.WriteTo(__razor_helper_writer, cate2Descrip);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\n            </div>\n        </li>\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="CategoryMaster">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div class="headSearch" id="btnGotoSearch">\n            <input class="searchTextBox" type="text" id="txtSearchPlaceHolder" readonly="readonly" placeholder="请输入查找内容" />\n        </div>\n    </div>\n    <div class="content" id="pnlContent">\n        <ul id="ulCategory1Container"></ul>\n    </div>\n    <div class="toobar" id="pnlCategoryMasterFooter">\n        <div class="toolbarItemText redButton fav" id="btnGotoFav">我的收藏</div>\n        <div class="toolbarItemText redButton cart" id="btnGotoCart">购物车</div>\n    </div>\n</div>\n\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.btnGotoSearch = this.pageObject.find('#btnGotoSearch');
			this.txtSearchPlaceHolder = this.pageObject.find('#txtSearchPlaceHolder');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.ulCategory1Container = this.pageObject.find('#ulCategory1Container');
			this.pnlCategoryMasterFooter = this.pageObject.find('#pnlCategoryMasterFooter');
			this.btnGotoFav = this.pageObject.find('#btnGotoFav');
			this.btnGotoCart = this.pageObject.find('#btnGotoCart');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.btnGotoSearch)) {
				this.btnGotoSearch.unbind().off();
				this.btnGotoSearch = null;
			}
			if (ss.isValue(this.txtSearchPlaceHolder)) {
				this.txtSearchPlaceHolder.unbind().off();
				this.txtSearchPlaceHolder = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.ulCategory1Container)) {
				this.ulCategory1Container.unbind().off();
				this.ulCategory1Container = null;
			}
			if (ss.isValue(this.pnlCategoryMasterFooter)) {
				this.pnlCategoryMasterFooter.unbind().off();
				this.pnlCategoryMasterFooter = null;
			}
			if (ss.isValue(this.btnGotoFav)) {
				this.btnGotoFav.unbind().off();
				this.btnGotoFav = null;
			}
			if (ss.isValue(this.btnGotoCart)) {
				this.btnGotoCart.unbind().off();
				this.btnGotoCart = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initEnum($USOProject_Pages_Product_ListSortDirection, $asm, { Ascending: 0, Descending: 1 });
	ss.initClass($USOProject_Pages_Product_MobileProductFavorite, $asm, {});
	ss.initClass($USOProject_Pages_Product_MobileProductFavoriteQuery, $asm, {
		get_Page: function() {
			return this.$1$PageField;
		},
		set_Page: function(value) {
			this.$1$PageField = value;
		},
		get_PageSize: function() {
			return this.$1$PageSizeField;
		},
		set_PageSize: function(value) {
			this.$1$PageSizeField = value;
		},
		get_Id: function() {
			return this.$1$IdField;
		},
		set_Id: function(value) {
			this.$1$IdField = value;
		},
		get_UserId: function() {
			return this.$1$UserIdField;
		},
		set_UserId: function(value) {
			this.$1$UserIdField = value;
		},
		get_ProductId: function() {
			return this.$1$ProductIdField;
		},
		set_ProductId: function(value) {
			this.$1$ProductIdField = value;
		},
		get_OrderByColumns: function() {
			return this.$1$OrderByColumnsField;
		},
		set_OrderByColumns: function(value) {
			this.$1$OrderByColumnsField = value;
		}
	});
	ss.initClass($USOProject_Pages_Product_OrderByColumn, $asm, {});
	ss.initClass($USOProject_Pages_Product_ProductDetail, $asm, {
		$ProductDetail_OnPageShow: function(sender, e) {
			this.$pageScroller.refresh();
		},
		$checkRefresh: function(iscroll) {
			var needrefresh = false;
			if (iscroll.vScroll) {
				if (iscroll.scrollerH !== iscroll.scroller.offsetHeight) {
					needrefresh = true;
				}
			}
			if (iscroll.hScroll) {
				if (iscroll.scrollerW !== iscroll.scroller.offsetWidth) {
					needrefresh = true;
				}
			}
			if (needrefresh) {
				iscroll.refresh();
			}
		},
		$handleWebView: function() {
			//处理内容页的图片
			this.pnlWebView.find('img').each(ss.mkdel(this, function(index, element) {
				//如果图片是相对路径，则添加对应的域名地址
				if (element.getAttribute('src').indexOf('http') !== 0) {
					element.setAttribute('src', this.ProductData.ArticleImageBaseUrl + element.getAttribute('src'));
				}
			}));
		},
		$ProductDetail_OnPageInit: function(sender, e) {
			var $state2 = 0, pageScrollOption, dialogScrollOption, canfavClick, waitCustomerLegalClick;
			var $sm2 = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state2) {
						case 0: {
							$state2 = -1;
							this.pnlTabHeads.hide();
							//创建页面滚动
							pageScrollOption = { fadeScrollbar: true, hideScrollbar: true, onScrollMove: ss.mkdel(this, this.$onScrollMove), onScrollEnd: ss.mkdel(this, function(event) {
								this.$onScrollEnd();
								this.$checkRefresh(this.$pageScroller);
							}), vScrollbar: false, hScrollbar: false };
							if (JSLib.Mobile.Application.DeviceType !== 1) {
								pageScrollOption.useTransform = false;
								pageScrollOption.useTransition = false;
							}
							this.$pageScroller = new iScroll(this.pnlContent.parent()[0], pageScrollOption);
							window.setTimeout(ss.mkdel(this, function() {
								this.$pageScroller.refresh();
							}), 200);
							//创建弹窗内容选择区滚动
							dialogScrollOption = { vScrollbar: false, hScrollbar: false, hideScrollbar: true, useTransform: true, useTransition: true };
							if (JSLib.Mobile.Application.DeviceType !== 1) {
								dialogScrollOption.useTransform = false;
								dialogScrollOption.useTransition = false;
							}
							this.$dialogIscroll = new iScroll(this.pnlChooseContent.parent()[0], dialogScrollOption);
							this.$dialogIscroll.refresh();
							//相册滚动区
							this.$carousel = new iScroll(this.carouselWarper[0], { snap: true, momentum: false, hScrollbar: false, bounceLock: true, useTransform: false, useTransition: false, onScrollEnd: ss.mkdel(this, function(event1) {
								if (this.indicator.children().length > 1) {
									this.indicator.find('li').removeClass('active');
									$(this.indicator.find('li:nth-child(' + (this.$carousel.currPageX + 1) + ')')[0]).addClass('active');
								}
							}) });
							this.carouselScroller.width(this.carouselScroller.children().length * 320);
							window.setTimeout(ss.mkdel(this, function() {
								this.$carousel.refresh();
							}), 1000);
							//选项卡页
							this.pnlTabHeads.on('click', '.tabHeadItem', ss.thisFix(ss.mkdel(this, function(ele, event2) {
								var target = $(ele);
								target.addClass('active').siblings().removeClass('active');
								$(this.pnlTabPages.children().hide()[target.index()]).show();
								this.$pageScroller.refresh();
							})));
							//点击产品资料
							this.pnlProductInfo.click();
							//数量改变事件
							this.pnlChangeNumber.on('click', '.btnIcon', ss.thisFix(ss.mkdel(this, function(elem1, event3) {
								if (elem1.className.indexOf('minusIcon') !== -1) {
									this.$currentBuyNumber--;
								}
								if (elem1.className.indexOf('plusIcon') !== -1) {
									this.$currentBuyNumber++;
								}
								if (this.$currentBuyNumber <= 0) {
									this.$currentBuyNumber = 1;
								}
								if (this.$currentBuyNumber > this.$quantity) {
									this.$currentBuyNumber = this.$quantity;
								}
								if (this.$currentBuyNumber > 0) {
									this.lblNumberText.text(this.$currentBuyNumber.toString());
								}
							})));
							//导航事件
							this.pnlNav.on('click', '[data-index]', ss.thisFix(ss.mkdel(this, function(elem, event4) {
								var indexValue = CoreEx.ToInt(elem.getAttribute('data-index'), 0);
								this.$isAutoScroll = true;
								this.$moveToSep2();
								this.pnlTabHeads.children().eq(indexValue).click();
								jQueryObjectEx.SetVisible(this.pnlTabHeads, this.$isInpage2);
							})));
							//处理html代码里的图片
							this.$handleWebView();
							//注册收藏事件
							canfavClick = true;
							this.btnAddToFavToolBar.add(this.btnToggleFavIcon).click(ss.mkdel(this, function(event5) {
								var $state = 0, $t1, result;
								var $sm = ss.mkdel(this, function() {
									$sm1:
									for (;;) {
										switch ($state) {
											case 0: {
												$state = -1;
												if (!canfavClick) {
													return;
												}
												window.setTimeout(function() {
													canfavClick = true;
												}, 100);
												canfavClick = false;
												//切换收藏
												$t1 = $USOProject_Business_BusinessAction.AddProductFavorite(this.$productId, 1);
												$state = 1;
												$t1.continueWith($sm);
												return;
											}
											case 1: {
												$state = -1;
												result = $t1.getAwaitedResult();
												if (!result.IsSuccess) {
													JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
													return;
												}
												this.btnAddToFavToolBar.add(this.btnToggleFavIcon).toggleClass('active');
												$state = -1;
												break $sm1;
											}
											default: {
												break $sm1;
											}
										}
									}
								});
								$sm();
							}));
							//选择组织机构
							this.btnChooseOrg.click(ss.mkdel(this, function(event6) {
								this.$curSelectType = 1;
								if (ss.isNullOrUndefined(this.productOrg) || this.productOrg.length < 1) {
									JSLib.Mobile.MessageBox.Alert('暂无组织机构数据!');
									return;
								}
								var dataArray = this.productOrg.map(function(type) {
									return type.Id;
								});
								var dataTextArray = this.productOrg.map(function(type1) {
									return type1.Name;
								});
								this.BuildDialogAndShow(dataArray, dataTextArray, this.$orgId);
							}));
							//选择仓库
							this.btnChooseWarehouse.click(ss.mkdel(this, function(event7) {
								this.$curSelectType = 3;
								if (ss.isNullOrUndefined(this.$wareHouseData) || this.$wareHouseData.length < 1) {
									JSLib.Mobile.MessageBox.Alert('暂无仓库数据!');
									return;
								}
								var dataArray1 = this.$wareHouseData.map(function(dto) {
									return dto.Id;
								});
								var dataTextArray1 = this.$wareHouseData.map(function(dto1) {
									return dto1.Name;
								});
								this.BuildDialogAndShow(dataArray1, dataTextArray1, this.$curWareHouseId);
							}));
							//选择法人
							waitCustomerLegalClick = false;
							this.btnChooseCustomerLegal.click(ss.mkdel(this, function(event8) {
								if (waitCustomerLegalClick) {
									return;
								}
								window.setTimeout(function() {
									waitCustomerLegalClick = false;
								}, 100);
								waitCustomerLegalClick = true;
								this.$curSelectType = 2;
								if (ss.isNullOrUndefined(this.$customerLeagls) || this.$customerLeagls.length < 1) {
									JSLib.Mobile.MessageBox.Alert('暂无法人数据!');
									return;
								}
								var dataArray2 = this.$customerLeagls.map(function(dto2) {
									return dto2.Id;
								});
								var dataTextArray2 = this.$customerLeagls.map(function(dto3) {
									return dto3.CustomerName;
								});
								this.BuildDialogAndShow(dataArray2, dataTextArray2, this.$curCustomerLegalId);
							}));
							//处理选择弹窗项的事件
							this.pnlChooseDialog.on('click', '[data-chooseitemid]', ss.thisFix(ss.mkdel(this, function(elem2, event9) {
								this.pnlChooseDialog.find('[data-chooseitemid]').removeClass('active');
								var target1 = $(elem2);
								target1.addClass('active');
								window.setTimeout(ss.mkdel(this, function() {
									var $state1 = 0, choosedResult, selectedText, $t3, $t5, $t7, result1, $t4, result2, $t6, result3, warehouseResult, discountResult;
									var $sm1 = ss.mkdel(this, function() {
										$sm1:
										for (;;) {
											switch ($state1) {
												case 0: {
													$state1 = -1;
													choosedResult = CoreEx.ToInt(target1.attr('data-chooseitemid'), 0);
													selectedText = target1.text();
													//组织
													if (this.$curSelectType === 1) {
														this.$orgId = choosedResult;
														this.btnChooseOrg.text(selectedText);
														this.btnChooseCustomerLegal.text('请选择');
														this.btnChooseWarehouse.text('请选择');
														this.pnlChooseDialog.find('.product_detail_buyPrice').text('￥-');
														this.pnlChooseDialog.find('.product_detail_discountPrice').text('￥-');
														this.pnlChooseDialog.find('.discountDes').text('');
														this.pnlChooseDialog.find('.productStock').text('参考库存:-');
														this.$curCustomerLegalId = 0;
														this.$curWareHouseId = 0;
														$t3 = $USOProject_Business_BusinessAction.GetCustomerLegalAction(this.$orgId);
														$state1 = 2;
														$t3.continueWith($sm1);
														return;
													}
													else if (this.$curSelectType === 2) {
														//法人
														this.$curCustomerLegalId = choosedResult;
														this.btnChooseCustomerLegal.text(selectedText);
														$t5 = $USOProject_Business_BusinessAction.GetPriceAction(this.$productId, this.$orgId, this.$curCustomerLegalId);
														$state1 = 3;
														$t5.continueWith($sm1);
														return;
													}
													else {
														if (this.$curSelectType === 3) {
															//仓库
															this.$curWareHouseId = choosedResult;
															this.btnChooseWarehouse.text(selectedText);
															$t7 = $USOProject_Business_BusinessAction.GetProductQuantity(this.$orgId, this.$curWareHouseId, this.$productId);
															$state1 = 4;
															$t7.continueWith($sm1);
															return;
														}
														$state1 = 1;
														continue $sm1;
													}
												}
												case 2: {
													$state1 = -1;
													result1 = $t3.getAwaitedResult();
													if (!result1.IsSuccess) {
														JSLib.Mobile.MessageBox.Alert(result1.ErrorMessage);
														return;
													}
													this.$customerLeagls = result1.Result;
													$t4 = $USOProject_Business_BusinessAction.GetWarehouseAcction(this.$orgId);
													$state1 = 5;
													$t4.continueWith($sm1);
													return;
												}
												case 3: {
													$state1 = -1;
													result2 = $t5.getAwaitedResult();
													if (!result2.IsSuccess) {
														JSLib.Mobile.MessageBox.Alert(result2.ErrorMessage);
														return;
													}
													this.$priceInfo = result2.Result;
													if (ss.isValue(this.$priceInfo) && this.$priceInfo.IsDiscountCustomer) {
														$t6 = $USOProject_Business_BusinessAction.GetProductDiscount(this.$curCustomerLegalId, this.$orgId);
														$state1 = 7;
														$t6.continueWith($sm1);
														return;
													}
													$state1 = 6;
													continue $sm1;
												}
												case 4: {
													$state1 = -1;
													result3 = $t7.getAwaitedResult();
													if (!result3.IsSuccess) {
														JSLib.Mobile.MessageBox.Alert(result3.ErrorMessage);
														return;
													}
													this.$quantity = result3.Result;
													if (this.$quantity > 0) {
														this.pageObject.find('.productStock').text('参考库存:' + this.$quantity);
													}
													this.$currentBuyNumber = CoreEx.ToInt(this.lblNumberText.text(), 0);
													if (this.$quantity <= 0) {
														this.$currentBuyNumber = 0;
													}
													if (this.$quantity < this.$currentBuyNumber) {
														this.$currentBuyNumber = this.$quantity;
													}
													if (this.$currentBuyNumber > 0) {
														this.lblNumberText.text(this.$currentBuyNumber.toString());
													}
													$state1 = 1;
													continue $sm1;
												}
												case 1: {
													$state1 = -1;
													this.pageObject.find('.c-modal-window').hide();
													$state1 = -1;
													break $sm1;
												}
												case 5: {
													$state1 = -1;
													warehouseResult = $t4.getAwaitedResult();
													if (!warehouseResult.IsSuccess) {
														JSLib.Mobile.MessageBox.Alert(result1.ErrorMessage);
														return;
													}
													this.$wareHouseData = warehouseResult.Result;
													$state1 = 1;
													continue $sm1;
												}
												case 7: {
													$state1 = -1;
													discountResult = $t6.getAwaitedResult();
													if (!discountResult.IsSuccess) {
														JSLib.Mobile.MessageBox.Alert(discountResult.ErrorMessage);
														return;
													}
													this.$discountInfo = discountResult.Result;
													$state1 = 6;
													continue $sm1;
												}
												case 6: {
													$state1 = -1;
													this.$ShowPriceAndDiscount();
													$state1 = 1;
													continue $sm1;
												}
												default: {
													break $sm1;
												}
											}
										}
									});
									$sm1();
								}), 300);
							})));
							//关闭弹窗
							this.btnClose.click(ss.mkdel(this, function(event10) {
								window.setTimeout(function() {
									canfavClick = true;
								}, 100);
								canfavClick = false;
								this.pageObject.find('.c-modal-window').hide();
								this.$pageScroller.refresh();
							}));
							//弹窗模态区域点击
							this.pageObject.on('click', '.c-modal-usercontent', ss.thisFix(ss.mkdel(this, function(elem3, event11) {
								if ($(elem3).hasClass('c-modal-usercontent')) {
									window.setTimeout(function() {
										canfavClick = true;
									}, 100);
									canfavClick = false;
									this.pageObject.find('.c-modal-window').hide();
									this.$pageScroller.refresh();
								}
							})));
							//默认隐藏第二部分
							this.pnlSep2.hide();
							$state2 = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm2();
		},
		$ShowPriceAndDiscount: function() {
			if (ss.isValue(this.$priceInfo) && !this.$priceInfo.IsDiscountCustomer || ss.isValue(this.$priceInfo) && ss.isValue(this.$discountInfo)) {
				if (ss.Nullable$1.gt(this.$priceInfo.OriginalCustomerPrice, 0)) {
					//下单价格
					this.pageObject.find('.product_detail_buyPrice').text('￥' + $NullableExtenion.FormatMoney$1(this.$priceInfo.OriginalCustomerPrice, ''));
				}
				var discountPrice;
				//如果是固定折扣用户
				if (this.$priceInfo.IsDiscountCustomer) {
					if (ss.isValue(this.$discountInfo.DiscountRate)) {
						discountPrice = ss.unbox(this.$priceInfo.OriginalCustomerPrice) * ss.unbox(this.$discountInfo.DiscountRate);
						this.pageObject.find('.discountDes').text('(固定折扣:' + this.$discountInfo.DiscountRate + ')');
					}
					else {
						discountPrice = ss.unbox(this.$priceInfo.OriginalCustomerPrice);
					}
				}
				else if (ss.isValue(this.$priceInfo.Discount)) {
					discountPrice = ss.unbox(this.$priceInfo.OriginalCustomerPrice) * ss.unbox(this.$priceInfo.Discount);
					this.pageObject.find('.discountDes').text('折扣:' + this.$priceInfo.Discount);
				}
				else {
					discountPrice = ss.unbox(this.$priceInfo.OriginalCustomerPrice);
				}
				if (ss.Nullable$1.gt(discountPrice, 0)) {
					//折扣价格
					this.pageObject.find('.product_detail_discountPrice').text('￥' + $NullableExtenion.FormatMoney$1(discountPrice, ''));
				}
			}
		},
		BuildDialogAndShow: function(dataArray, dataTextArray, activeData) {
			var resultString = '';
			for (var i = 0; !!(i < dataArray.length); i++) {
				var isActive = ss.referenceEquals(dataArray[i], activeData);
				var temp = "<div class='chooseItem active' data-chooseItemID='" + dataArray[i] + "'><div class='chooseIcon'></div><div class='chooseItemText'>" + dataTextArray[i] + '</div></div>';
				if (!!!isActive) {
					temp = temp.replace('chooseItem active', 'chooseItem');
				}
				resultString += temp;
			}
			var htmlContent = resultString;
			this.pnlChooseContent.html(htmlContent);
			this.pageObject.find('.c-modal-window').show();
			this.$dialogIscroll.refresh();
			window.setTimeout(ss.mkdel(this, function() {
				var activeItem = this.pageObject.find('div.chooseItem.active');
				if (activeItem.length === 0) {
					this.$dialogIscroll.scrollTo(0, 0, 0, null);
				}
				else {
					this.$dialogIscroll.scrollTo(0, -activeItem[0].offsetTop, 0, null);
				}
			}), 100);
		},
		$onScrollMove: function(event) {
			if (this.$isAutoScroll) {
				return;
			}
			this.$isPullLongEnough = this.$pageScroller.y > 50 || Math.abs(this.$pageScroller.y) - Math.abs(this.$pageScroller.maxScrollY) > 50;
			//向上拉动，距离大于50
			if (this.$pageScroller.distY < 0 && this.$pageScroller.y < this.$pageScroller.maxScrollY - 50) {
				this.$isUPPull = true;
			}
			else if (this.$pageScroller.y > 50) {
				this.$isUPPull = false;
			}
			if (this.$isInpage2 && this.$pageScroller.y > 0 && this.$pageScroller.y < 50) {
				if (!jQueryObjectEx.IsVisible(this.pnlSep2PullTip)) {
					this.pnlSep2PullTip.show();
				}
				this.lblSep2PullTip.text('下拉 返回宝贝详情');
				if (this.pnlSep2PullTip.hasClass('release')) {
					this.pnlSep2PullTip.removeClass('release');
				}
			}
			else if (this.$isInpage2 && this.$pageScroller.y > 50) {
				if (!jQueryObjectEx.IsVisible(this.pnlSep2PullTip)) {
					this.pnlSep2PullTip.show();
				}
				this.lblSep2PullTip.text('释放 返回宝贝详情');
				if (!this.pnlSep2PullTip.hasClass('release')) {
					this.pnlSep2PullTip.addClass('release');
				}
			}
			else {
				this.pnlSep2PullTip.hide();
			}
		},
		$onScrollEnd: function() {
			this.pnlSep2PullTip.hide();
			if (!this.$isPullLongEnough || this.$isAutoScroll) {
				return;
			}
			if (this.$isUPPull && !this.$isInpage2) {
				this.$isUPPull = false;
				this.$moveToSep2();
			}
			else if (!this.$isUPPull && this.$isInpage2) {
				this.$moveToSep1();
			}
			jQueryObjectEx.SetVisible(this.pnlTabHeads, this.$isInpage2);
		},
		$moveToSep2: function() {
			this.pnlSep2.show();
			this.pnlSep1.hide();
			this.$pageScroller.refresh();
			this.$isInpage2 = true;
			window.setTimeout(ss.mkdel(this, function() {
				this.$pageScroller.scrollTo(0, 0, 100, false);
			}), 0);
			this.$isAutoScroll = true;
			window.setTimeout(ss.mkdel(this, function() {
				this.$isAutoScroll = false;
			}), 300);
		},
		$moveToSep1: function() {
			this.$isInpage2 = false;
			this.pnlSep2.hide();
			this.pnlSep1.show();
			this.$pageScroller.refresh();
			this.$isAutoScroll = true;
			this.$pageScroller.scrollTo(0, 0, 100, false);
			window.setTimeout(ss.mkdel(this, function() {
				this.$isAutoScroll = false;
			}), 300);
		},
		PrepareData: function() {
			var $state = 0, $tcs = new ss.TaskCompletionSource(), $t1, dataServiceResult, $t2, serviceResult;
			var $sm = ss.mkdel(this, function() {
				try {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								this.$productId = this.InitialData;
								$t1 = $USOProject_Business_BusinessAction.GetProductDetail(this.$productId);
								$state = 1;
								$t1.continueWith($sm);
								return;
							}
							case 1: {
								$state = -1;
								dataServiceResult = $t1.getAwaitedResult();
								if (!dataServiceResult.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(dataServiceResult.ErrorMessage);
									$tcs.setResult(null);
									return;
								}
								this.ProductData = dataServiceResult.Result;
								$t2 = $USOProject_Business_BusinessAction.GetProductOrg(this.ProductData.TheProduct.R3ProductGroupID);
								$state = 2;
								$t2.continueWith($sm);
								return;
							}
							case 2: {
								$state = -1;
								serviceResult = $t2.getAwaitedResult();
								if (!serviceResult.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(serviceResult.ErrorMessage);
									$tcs.setResult(null);
									return;
								}
								this.productOrg = serviceResult.Result;
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
					$tcs.setResult(null);
				}
				catch ($t3) {
					$tcs.setException(ss.Exception.wrap($t3));
				}
			});
			$sm();
			return $tcs.task;
		},
		Destroy: function() {
			if (ss.isValue(this.$dialogIscroll)) {
				this.$dialogIscroll.destroy();
			}
			if (ss.isValue(this.$pageScroller)) {
				this.$pageScroller.destroy();
			}
			if (ss.isValue(this.$carousel)) {
				this.$carousel.destroy();
			}
			JSLib.Mobile.BasePage.prototype.Destroy.call(this);
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="ProductDetail">\r\n    <div class="head">\r\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\r\n        <div id="lblHeadText" class="headText">产品详情</div>\r\n    </div>\r\n    <div id="pnlChooseDialog" class="c-modal-window" data-type="chooseOrg" style="display:none;">\r\n        <div class="c-modal-content">\r\n            <div class="c-modal-usercontent">\r\n                <div class="stockChooser">\r\n                    <div class="labelTitle">\r\n                        <div class="titleText">请选择</div>\r\n                        <div id="btnClose" class="closeIconWarp">\r\n                            <div class="closeIcon"></div>\r\n                        </div>\r\n                    </div>\r\n                    <div class="c-scroll-container" style="overflow: hidden;">\r\n                        <div class="content" id="pnlChooseContent">\r\n                            <div class="chooseItem active" data-chooseitemid="">\r\n                                <div class="chooseIcon "></div>\r\n                                <div class="chooseItemText">##choose Item##</div>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n    <div class="Sep2PullTip release" id="pnlSep2PullTip">\r\n        <div class="pullIcon">\r\n\r\n        </div>\r\n        <div id="lblSep2PullTip">\r\n            下拉返回宝贝详情\r\n        </div>\r\n\r\n    </div>\r\n    <div class="tabHeads" id="pnlTabHeads">\r\n        <div class="tabHeadItem active" id="pnlProductInfo">\r\n            产品资料\r\n        </div>\r\n        <div class="tabHeadItem">\r\n            产品参数\r\n        </div>\r\n    </div>\r\n\r\n    <div class="c-scroll-container PageScroller" style="overflow: hidden;">\r\n\r\n        <div class="content" id="pnlContent">\r\n            <div id="pnlSep1">\r\n                <div class="seg">\r\n                 \r\n                    <div id="PictureArea" class="c-carousel-warper">\r\n                        <div id="carouselWarper" class="c-carousel" style="overflow: hidden;">\r\n                            <ul id="carouselScroller" class="c-carousel-dataList">\r\n');
			if (this.ProductData.TheProduct.PicNum === 0) {
				this.WriteLiteral('                                        <li><img src="img/noPic.jpg"> </li>\r\n');
			}
			else {
				for (var i = 0; i < this.ProductData.TheProduct.PicNum; i++) {
					var $t1 = new $USOProject_Business_Model_ImageInfo();
					$t1.id = this.ProductData.TheProduct.Id.toString();
					$t1.type = 2;
					$t1.index = i + 1;
					var imageInfo = $t1;
					this.WriteLiteral('                                            <li>\r\n                                                <img src="');
					this.Write($App.GetProductImageUrl(imageInfo));
					this.WriteLiteral('" />\r\n                                            </li>\r\n');
				}
			}
			this.WriteLiteral('                            </ul>\r\n                        </div>\r\n                    </div>\r\n                    <ul id="indicator" class="indicator">\r\n');
			if (this.ProductData.TheProduct.PicNum === 0) {
				this.WriteLiteral('                            <li class="active"></li>\r\n');
			}
			else {
				for (var i1 = 0; i1 < this.ProductData.TheProduct.PicNum; i1++) {
					if (i1 === 0) {
						this.WriteLiteral('                                    <li class="active"></li>\r\n');
					}
					else {
						this.WriteLiteral('                                    <li></li>\r\n');
					}
				}
			}
			this.WriteLiteral('                    </ul>\n\n                    <div class="product_detail_price">\n                        <div class="priceTop">\n\n                            <ul class="priceArea">\n                                <li class="product_detail_price_title">');
			this.Write(this.ProductData.TheProduct.ProductName);
			this.WriteLiteral('</li>\r\n\r\n                            </ul>\r\n');
			var favActiveClass = (this.ProductData.IsFav ? 'active' : '');
			this.WriteLiteral('                            <div class="favButton ');
			this.Write(favActiveClass);
			this.WriteLiteral('" id="btnToggleFavIcon">\n                                <div class="favImg"></div>\n                                <span class="NormalFavText">收藏</span>\n                                <span class="activefavText">已收藏</span>\n                            </div>\n                        </div>\n                        <ul class="priceBottom">\n                            <li class="slaePrice">\n                                <span class="label">市场参考价:</span>\n');
			var consultPrice = '-';
			if (this.ProductData.TheProduct.ConsultPrice !== 0) {
				consultPrice = this.ProductData.TheProduct.ConsultPrice.toFixed(2);
			}
			this.WriteLiteral('                                <span class="salePriceValue">￥');
			this.Write(consultPrice);
			this.WriteLiteral('</span>\r\n                            </li>\r\n                            <li>\r\n                                <span class="label">\r\n                                    下单价格:\r\n                                </span>\r\n                                <span class="product_detail_buyPrice">￥-</span>\r\n                            </li>\r\n                            <li>\r\n                                <span class="label">\r\n                                    折扣价格:\r\n                                </span>\r\n                                <span class="product_detail_discountPrice">￥- </span>\r\n                                <span class="discountDes"></span>\r\n                            </li>\r\n                        </ul>\r\n\r\n                    </div>\r\n                </div>\r\n                <div class="seg">\r\n                    <div class="stockPanel">\r\n                        <div class="chooseNav">\r\n                            <div class="chooseNavTitle">组织机构:</div>\r\n                            <div class="chooseNavItem endNavIcon">\r\n                                <div class="chooseNavItemText" id="btnChooseOrg">\r\n                                    请选择\r\n                                </div>\r\n                            </div>\r\n                        </div>\r\n                        <div class="chooseNav">\r\n                            <div class="chooseNavTitle">法人:</div>\r\n                            <div class="chooseNavItem endNavIcon">\r\n                                <div class="chooseNavItemText" id="btnChooseCustomerLegal">\r\n                                    请选择\r\n                                </div>\r\n                            </div>\r\n                        </div>\r\n                        <div class="chooseNav">\r\n                            <div class="chooseNavTitle">仓库:</div>\r\n                            <div class="chooseNavItem endNavIcon">\r\n                                <div class="chooseNavItemText" id="btnChooseWarehouse">\r\n                                    请选择\r\n                                </div>\r\n                            </div>\r\n                        </div>\r\n\r\n                        <div class="stockInfos">\r\n                            <div class="stockInfoItemPanel">\r\n                                <div class="stockInfoItem productStock">\r\n                                    参考库存:<span id="lblConsultStock">-</span>\r\n                                </div>\r\n                                <div class="stockInfoItem productId">产品编号:');
			this.Write(this.ProductData.TheProduct.Id);
			this.WriteLiteral('</div>\r\n                            </div>\r\n                            <div class="stockInfoItemPanel">\r\n                                <div class="stockInfoItem productMode">产品型号:');
			this.Write(this.ProductData.TheProduct.ProductMode);
			this.WriteLiteral('</div>\r\n                                <div class="stockInfoItem productWeight">产品净重:');
			this.Write(this.ProductData.TheProduct.Weight);
			this.WriteLiteral(' kg</div>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n                <div class="seg">\r\n                    <div class="numberPanel endNavIcon">\r\n                        <span class="numberLabel">数量</span>\r\n\r\n                        <div class="numberInputControl" id="pnlChangeNumber">\r\n                            <div class="btnIcon minusIcon enable"></div>\r\n                            <div class="numberText" id="lblNumberText"></div>\r\n                            <div class="btnIcon plusIcon enable"></div>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n                <div class="seg">\r\n                    <div class="nav" id="pnlNav">\r\n                        <div data-index="0" class="navItem endNavIcon">\r\n                            产品资料\r\n                        </div>\r\n                        <div data-index="1" class="navItem endNavIcon">\r\n                            产品参数\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n                <div class="sep sepContinueScroll" >\r\n                    <div class="line"></div>\r\n                    <div class="sepText">继续拖动，查看图文详情</div>\r\n                    <div class="line"></div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class="seg" id="pnlSep2" style="display: none;">\r\n                <div id="tabPanelGroup" class="tabPanelGroup">\r\n                    <div class="tablPages" id="pnlTabPages">\r\n                        <div id="pnlWebView" class="tabPageItem webview" style="display: block;">\r\n                            ');
			this.Write(this.ProductData.TheProduct.Material);
			this.WriteLiteral('\r\n                        </div>\r\n                        <div id="pnlParameter" class="tabPageItem " style="display: none;">\r\n');
			if (ss.isValue(this.ProductData.Attributes) && this.ProductData.Attributes.length > 0) {
				for (var $t2 = 0; $t2 < this.ProductData.Attributes.length; $t2++) {
					var attrGroup = this.ProductData.Attributes[$t2];
					this.WriteLiteral('                                    <div class="parameterGroup">\r\n                                        <div class="paragroupTitle">');
					this.Write(attrGroup.GroupName);
					this.WriteLiteral('</div>\r\n');
					if (ss.isValue(attrGroup.Attributes) && attrGroup.Attributes.length > 0) {
						this.WriteLiteral('                                            <div class="parameterValues">\r\n');
						for (var $t3 = 0; $t3 < attrGroup.Attributes.length; $t3++) {
							var item = attrGroup.Attributes[$t3];
							this.WriteLiteral('                                                    <div class="parameterItem">\r\n                                                        <div class="title">');
							this.Write(item.AttributeName);
							this.WriteLiteral('</div>\r\n                                                        <div class="value">');
							this.Write(item.AttributeValue);
							this.WriteLiteral('</div>\r\n                                                    </div>\r\n');
						}
						this.WriteLiteral('\r\n                                            </div>\r\n');
					}
					this.WriteLiteral('                                    </div>\r\n');
				}
			}
			this.WriteLiteral('                        </div>\r\n\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n    </div>\r\n    <div class="toolBar">\r\n        <div class="left">\r\n            <div id="btnAddToFavToolBar" class="btn addtoFav ');
			this.Write(favActiveClass);
			this.WriteLiteral('">\n                <span class="activeFavText">取消收藏</span>\n                <span class="NormalFavText">加入收藏</span>\n            </div>\n            <div class="btn addToShopCart">加入购物车</div>\n        </div>\n        <div class="right">\n            <div class="gotoShopCartIcon"></div>\n        </div>\n    </div>\n</div>\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlChooseDialog = this.pageObject.find('#pnlChooseDialog');
			this.btnClose = this.pageObject.find('#btnClose');
			this.pnlChooseContent = this.pageObject.find('#pnlChooseContent');
			this.pnlSep2PullTip = this.pageObject.find('#pnlSep2PullTip');
			this.lblSep2PullTip = this.pageObject.find('#lblSep2PullTip');
			this.pnlTabHeads = this.pageObject.find('#pnlTabHeads');
			this.pnlProductInfo = this.pageObject.find('#pnlProductInfo');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.pnlSep1 = this.pageObject.find('#pnlSep1');
			this.PictureArea = this.pageObject.find('#PictureArea');
			this.carouselWarper = this.pageObject.find('#carouselWarper');
			this.carouselScroller = this.pageObject.find('#carouselScroller');
			this.indicator = this.pageObject.find('#indicator');
			this.btnToggleFavIcon = this.pageObject.find('#btnToggleFavIcon');
			this.btnChooseOrg = this.pageObject.find('#btnChooseOrg');
			this.btnChooseCustomerLegal = this.pageObject.find('#btnChooseCustomerLegal');
			this.btnChooseWarehouse = this.pageObject.find('#btnChooseWarehouse');
			this.lblConsultStock = this.pageObject.find('#lblConsultStock');
			this.pnlChangeNumber = this.pageObject.find('#pnlChangeNumber');
			this.lblNumberText = this.pageObject.find('#lblNumberText');
			this.pnlNav = this.pageObject.find('#pnlNav');
			this.pnlSep2 = this.pageObject.find('#pnlSep2');
			this.tabPanelGroup = this.pageObject.find('#tabPanelGroup');
			this.pnlTabPages = this.pageObject.find('#pnlTabPages');
			this.pnlWebView = this.pageObject.find('#pnlWebView');
			this.pnlParameter = this.pageObject.find('#pnlParameter');
			this.btnAddToFavToolBar = this.pageObject.find('#btnAddToFavToolBar');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlChooseDialog)) {
				this.pnlChooseDialog.unbind().off();
				this.pnlChooseDialog = null;
			}
			if (ss.isValue(this.btnClose)) {
				this.btnClose.unbind().off();
				this.btnClose = null;
			}
			if (ss.isValue(this.pnlChooseContent)) {
				this.pnlChooseContent.unbind().off();
				this.pnlChooseContent = null;
			}
			if (ss.isValue(this.pnlSep2PullTip)) {
				this.pnlSep2PullTip.unbind().off();
				this.pnlSep2PullTip = null;
			}
			if (ss.isValue(this.lblSep2PullTip)) {
				this.lblSep2PullTip.unbind().off();
				this.lblSep2PullTip = null;
			}
			if (ss.isValue(this.pnlTabHeads)) {
				this.pnlTabHeads.unbind().off();
				this.pnlTabHeads = null;
			}
			if (ss.isValue(this.pnlProductInfo)) {
				this.pnlProductInfo.unbind().off();
				this.pnlProductInfo = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.pnlSep1)) {
				this.pnlSep1.unbind().off();
				this.pnlSep1 = null;
			}
			if (ss.isValue(this.PictureArea)) {
				this.PictureArea.unbind().off();
				this.PictureArea = null;
			}
			if (ss.isValue(this.carouselWarper)) {
				this.carouselWarper.unbind().off();
				this.carouselWarper = null;
			}
			if (ss.isValue(this.carouselScroller)) {
				this.carouselScroller.unbind().off();
				this.carouselScroller = null;
			}
			if (ss.isValue(this.indicator)) {
				this.indicator.unbind().off();
				this.indicator = null;
			}
			if (ss.isValue(this.btnToggleFavIcon)) {
				this.btnToggleFavIcon.unbind().off();
				this.btnToggleFavIcon = null;
			}
			if (ss.isValue(this.btnChooseOrg)) {
				this.btnChooseOrg.unbind().off();
				this.btnChooseOrg = null;
			}
			if (ss.isValue(this.btnChooseCustomerLegal)) {
				this.btnChooseCustomerLegal.unbind().off();
				this.btnChooseCustomerLegal = null;
			}
			if (ss.isValue(this.btnChooseWarehouse)) {
				this.btnChooseWarehouse.unbind().off();
				this.btnChooseWarehouse = null;
			}
			if (ss.isValue(this.lblConsultStock)) {
				this.lblConsultStock.unbind().off();
				this.lblConsultStock = null;
			}
			if (ss.isValue(this.pnlChangeNumber)) {
				this.pnlChangeNumber.unbind().off();
				this.pnlChangeNumber = null;
			}
			if (ss.isValue(this.lblNumberText)) {
				this.lblNumberText.unbind().off();
				this.lblNumberText = null;
			}
			if (ss.isValue(this.pnlNav)) {
				this.pnlNav.unbind().off();
				this.pnlNav = null;
			}
			if (ss.isValue(this.pnlSep2)) {
				this.pnlSep2.unbind().off();
				this.pnlSep2 = null;
			}
			if (ss.isValue(this.tabPanelGroup)) {
				this.tabPanelGroup.unbind().off();
				this.tabPanelGroup = null;
			}
			if (ss.isValue(this.pnlTabPages)) {
				this.pnlTabPages.unbind().off();
				this.pnlTabPages = null;
			}
			if (ss.isValue(this.pnlWebView)) {
				this.pnlWebView.unbind().off();
				this.pnlWebView = null;
			}
			if (ss.isValue(this.pnlParameter)) {
				this.pnlParameter.unbind().off();
				this.pnlParameter = null;
			}
			if (ss.isValue(this.btnAddToFavToolBar)) {
				this.btnAddToFavToolBar.unbind().off();
				this.btnAddToFavToolBar = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Product_ProductFavorite, $asm, {
		$ProductFavorite_OnPageInit: function(sender, e) {
			//配置列表数据
			this.$_scrollList = this.SetIscrollList(this.ulProductFavoriteContainer[0], 20, 100, true, false, false);
			this.$_scrollList.set_GetPageData(ss.mkdel(this, function(index) {
				var $state = 0, $tcs = new ss.TaskCompletionSource(), $t1, $t2, result, listElement, $t3;
				var $sm = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									$t1 = new $USOProject_Pages_Product_MobileProductFavoriteQuery();
									$t1.set_Page(index);
									$t1.set_PageSize(20);
									$t2 = $USOProject_Business_BusinessAction.QeuryProductFavorite($t1, this);
									$state = 1;
									$t2.continueWith($sm);
									return;
								}
								case 1: {
									$state = -1;
									result = $t2.getAwaitedResult();
									listElement = jQueryObjectEx.ToJqueryObject$1(this.GetProductFavoriteItemHtml(result.Result));
									$t3 = new JSLib.IScrollWraper.PageData();
									$t3.PageIndex = index;
									$t3.RecordCount = result.Result.length;
									$t3.ResultElement = listElement;
									$tcs.setResult($t3);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t4) {
						$tcs.setException(ss.Exception.wrap($t4));
					}
				});
				$sm();
				return $tcs.task;
			}));
			this.$_scrollList.ReLoad();
			//_scrollList.OnScroll=delegate(Event @event) { needForbindMove = true; };
			//绑定跳转事件
			this.ulProductFavoriteContainer.on('click', '.favListItem', ss.thisFix(function(elem, event) {
				var $state1 = 0, $t5, productId;
				var $sm1 = function() {
					$sm1:
					for (;;) {
						switch ($state1) {
							case 0: {
								$state1 = -1;
								$t5 = ss.Task.delay(100);
								$state1 = 1;
								$t5.continueWith($sm1);
								return;
							}
							case 1: {
								$state1 = -1;
								$t5.getAwaitedResult();
								if ($(elem).find('.itemContent').css('right') !== '0px') {
									return;
								}
								//如果点击的是删除按钮，则取消跳转
								if (event.target.hasAttribute('del-favoriteid')) {
									return;
								}
								productId = CoreEx.ToInt(elem.getAttribute('productid'), 0);
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Product_ProductDetail).call(null, productId, null);
								$state1 = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				};
				$sm1();
			}));
			//绑定删除事件
			this.ulProductFavoriteContainer.on('click', 'div[del-favoriteid]', ss.thisFix(ss.mkdel(this, function(elem1, event1) {
				var $state2 = 0, favId, $t7, result1;
				var $sm2 = ss.mkdel(this, function() {
					$sm1:
					for (;;) {
						switch ($state2) {
							case 0: {
								$state2 = -1;
								favId = elem1.getAttribute('del-favoriteid');
								$t7 = $USOProject_Business_BusinessAction.DelteFavorite(CoreEx.ToInt(favId, 0), this);
								$state2 = 1;
								$t7.continueWith($sm2);
								return;
							}
							case 1: {
								$state2 = -1;
								result1 = $t7.getAwaitedResult();
								if (!result1.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(result1.ErrorMessage);
								}
								else {
									$(elem1).closest('.favListItem').remove();
									this.$_scrollList.Refresh();
								}
								$state2 = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				});
				$sm2();
			})));
			this.$_slideToDeleteList = new $USOProject_Business_SlideList(this.ulProductFavoriteContainer, '.favListItem', '.itemContent', '.productfav_option_option');
		},
		Destroy: function() {
			if (ss.isValue(this.$_slideToDeleteList)) {
				this.$_slideToDeleteList.dispose();
			}
			JSLib.Mobile.BasePage.prototype.Destroy.call(this);
		},
		GetProductFavoriteItemHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || data.length === 0) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">暂无数据</div>\r\n');
					return;
				}
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <li class="favListItem" productid="');
					this.WriteTo(__razor_helper_writer, item.ProductId);
					this.WriteLiteralTo(__razor_helper_writer, '" favoriteid="');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '">\r\n            <div class="itemContent">\r\n');
					var $t2 = new $USOProject_Business_Model_ImageInfo();
					$t2.id = item.ProductId.toString();
					$t2.index = 1;
					$t2.type = 3;
					var imageUrl = $App.GetProductImageUrl($t2);
					var consultPrice = (ss.isValue(item.ConsultPrice) ? ss.unbox(item.ConsultPrice).toFixed(2) : '');
					this.WriteLiteralTo(__razor_helper_writer, '                <img class="li_productfav_img" src="');
					this.WriteTo(__razor_helper_writer, imageUrl);
					this.WriteLiteralTo(__razor_helper_writer, '" onerror="imgError(this)">\r\n                <div class="productfav_content">\r\n                    <div class="productfav_contentheader">');
					this.WriteTo(__razor_helper_writer, item.BriefName);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n                    <div class="productfav_contentdetail">\r\n                        <span class="title">市场参考价:</span>￥<span class="value">');
					this.WriteTo(__razor_helper_writer, consultPrice);
					this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                    </div><div class="productfav_contentdetail">\r\n                        <span class="title">产品型号:</span>\r\n                        <span class="value">');
					this.WriteTo(__razor_helper_writer, item.ProductMode);
					this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class="productfav_option_option" del-favoriteid="');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '">删除</div>\r\n        </li>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="ProductFavorite">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">我的收藏</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <ul id="ulProductFavoriteContainer" style="width: 100%;"></ul>\n    </div>\n</div>\n');
			this.WriteLiteral('\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.ulProductFavoriteContainer = this.pageObject.find('#ulProductFavoriteContainer');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.ulProductFavoriteContainer)) {
				this.ulProductFavoriteContainer.unbind().off();
				this.ulProductFavoriteContainer = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Product_ProductFavorite$Point, $asm, {});
	ss.initEnum($USOProject_Pages_Product_ProductFavoriteType, $asm, { USO: 1 });
	ss.initClass($USOProject_Pages_Product_ProductList, $asm, {
		$ProductList_OnPageShow: function(sender, e) {
		},
		$ProductList_OnPageInit: function(sender, e) {
			this.$_queryDto = this.InitialData;
			var queryData = { Page: 1, C3ID: this.InitialData.C3Id, PageSize: 10 };
			if (this.$_queryDto.QueryType === 'Filter') {
				queryData.QueryType = 'Filter';
				queryData.Filter = this.$_queryDto.FilterString;
				queryData.C3ID = this.$_queryDto.C3Id;
			}
			else if (this.$_queryDto.C3Id !== '') {
				queryData.C3ID = this.$_queryDto.C3Id;
				queryData.QueryType = 'C3ID';
			}
			this.$_queryProductDto = queryData;
			this.$_iscrollList = this.SetIscrollList(this.ulProductContainer[0], 10, 100, true, false, true);
			this.$_iscrollList.set_GetPageData(ss.mkdel(this, function(index) {
				var $state = 0, $tcs = new ss.TaskCompletionSource(), $t1, result, products, $t2;
				var $sm = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									//根据查询条件取出数据
									this.$_queryProductDto.Page = index;
									//返回结果为不固定类型的数据
									$t1 = $USOProject_Business_BusinessAction.GetProductList(this.$_queryProductDto);
									$state = 1;
									$t1.continueWith($sm);
									return;
								}
								case 1: {
									$state = -1;
									result = $t1.getAwaitedResult();
									if (!!!result.IsSuccess) {
										JSLib.Mobile.MessageBox.Alert(ss.cast(result.ErrorMessage, String));
										$tcs.setResult(null);
										return;
									}
									if (!!(result.Result && result.Result.Result)) {
										products = ss.cast(result.Result.Result, Array);
									}
									else {
										products = ss.cast(result.Result.products, Array);
									}
									$t2 = new JSLib.IScrollWraper.PageData();
									$t2.PageIndex = index;
									$t2.RecordCount = Enumerable.from(products).count();
									$t2.ResultElement = jQueryObjectEx.ToJqueryObject(this.GetProductListHtml(products).toString());
									$tcs.setResult($t2);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t3) {
						$tcs.setException(ss.Exception.wrap($t3));
					}
				});
				$sm();
				return $tcs.task;
			}));
			if (!this.$_queryDto.IsFromClickSearch) {
				this.$_iscrollList.ReLoad();
			}
			if (this.$_queryDto.IsFromClickSearch) {
				window.setTimeout(ss.mkdel(this, function() {
					this.txtKeyWord.focus();
				}), 100);
			}
			this.btnFilter.click(ss.thisFix(ss.mkdel(this, function(elem, event) {
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Product_ProductListCondition).call(null, this.$_productListRestDto, ss.mkdel(this, function(page) {
					page.OnConditionComplete = ss.mkdel(this, function(condition) {
						this.$_queryProductDto.QueryType = 'Filter';
						this.$_queryProductDto.Filter = condition.FilterString;
						this.$_queryProductDto.C3ID = condition.C3Id;
						this.$_iscrollList.ReLoad();
					});
				}));
			})));
			this.ulProductContainer.on('click', 'li[data-produclistid]', ss.thisFix(function(elem1, event1) {
				var retailId = CoreEx.ToInt(elem1.getAttribute('data-produclistid'), 0);
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Product_ProductDetail).call(null, retailId, null);
			}));
			var lastword = '';
			this.txtKeyWord.on('keyup change input keydown', ss.mkdel(this, function(event2) {
				var $state1 = 0, word, $t4, result1;
				var $sm1 = ss.mkdel(this, function() {
					$sm1:
					for (;;) {
						switch ($state1) {
							case 0: {
								$state1 = -1;
								word = this.txtKeyWord.val();
								this.$UpdateButtonState();
								if (ss.isNullOrEmptyString(word)) {
									return;
								}
								if (ss.referenceEquals(lastword, word)) {
									return;
								}
								lastword = word;
								$t4 = $USOProject_Business_BusinessAction.GetProductNameList(word);
								$state1 = 1;
								$t4.continueWith($sm1);
								return;
							}
							case 1: {
								$state1 = -1;
								result1 = $t4.getAwaitedResult();
								if (!result1.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(result1.ErrorMessage);
									return;
								}
								this.pnlCompleteList.html(this.GetCompleteListHtml(result1.Result).toString()).show();
								$state1 = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				});
				$sm1();
			}));
			this.txtKeyWord.focusin(ss.mkdel(this, function(event3) {
				this.$UpdateButtonState();
				if (ss.isNullOrEmptyString(this.txtKeyWord.val())) {
					this.pnlCompleteList.empty();
				}
				this.pnlCompleteList.show();
			}));
			this.txtKeyWord.focusout(ss.mkdel(this, function(event4) {
				window.setTimeout(ss.mkdel(this, function() {
					if (ss.isValue(this.pnlCompleteList)) {
						this.pnlCompleteList.hide();
					}
				}), 100);
			}));
			this.btnSearch.click(ss.mkdel(this, function(event5) {
				this.$_queryProductDto.QueryType = 'KeyWords';
				this.$_queryProductDto.KeyWords = this.txtKeyWord.val().trim();
				this.$_iscrollList.ReLoad();
				this.pnlCompleteList.hide();
			}));
			this.pnlCompleteList.on('click', '[data-id]', ss.thisFix(function(elem2, event6) {
				var productId = CoreEx.ToInt(elem2.getAttribute('data-id'), 0);
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Product_ProductDetail).call(null, productId, null);
			}));
			this.ulProductContainer.on('touchStart', ss.mkdel(this, function(event7) {
				this.txtKeyWord.focusout();
			}));
		},
		$UpdateButtonState: function() {
			var word = this.txtKeyWord.val();
			var isEmpty = ss.isNullOrEmptyString(word);
			if (isEmpty) {
				this.pnlCompleteList.hide();
			}
			if (this.$_queryDto.IsFromClickSearch) {
				this.btnFilter.hide();
				this.btnSearch.show();
			}
			else if (isEmpty) {
				this.btnFilter.show();
				this.btnSearch.hide();
			}
			else {
				this.btnFilter.hide();
				this.btnSearch.show();
			}
		},
		GetProductListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || !Enumerable.from(data).any()) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">暂无数据</div>\r\n');
					return;
				}
				var $t1 = ss.getEnumerator(data);
				try {
					while ($t1.moveNext()) {
						var item = $t1.current();
						var $t3;
						if (item.PicNum === 0) {
							$t3 = 'img/noPic.jpg';
						}
						else {
							var $t2 = new $USOProject_Business_Model_ImageInfo();
							$t2.id = item.Id.toString();
							$t2.type = 1;
							$t2.index = 1;
							$t3 = $App.GetProductImageUrl($t2);
						}
						var imgUrl = $t3;
						this.WriteLiteralTo(__razor_helper_writer, '        <li data-produclistid="');
						this.WriteTo(__razor_helper_writer, item.Id);
						this.WriteLiteralTo(__razor_helper_writer, '" class="li_cate1 li_a_cate">\r\n\r\n            <img src="');
						this.WriteTo(__razor_helper_writer, imgUrl);
						this.WriteLiteralTo(__razor_helper_writer, '" class="cateImg" onerror="imgError(this)" />\r\n            <div class="catedesc">\r\n                <div class="cate_title">');
						this.WriteTo(__razor_helper_writer, item.BriefName);
						this.WriteLiteralTo(__razor_helper_writer, '</div>\n                <div class="cate_subtitle">\n                    <div class="item">\n                        <div class="itemTitle">\n                            市场参考价格:\n                        </div>\n                        <div class="itemValue">\n                            ￥');
						this.WriteTo(__razor_helper_writer, item.ConsultPrice);
						this.WriteLiteralTo(__razor_helper_writer, '\n                        </div>\n                    </div>\n                    <div class="item">\n                        <div class="itemTitle">\n                            产品型号:\n                        </div>\n                        <div class="itemValue">\n');
						var modelValue = item.ProductName;
						if (!ss.isNullOrEmptyString(item.ProductMode)) {
							modelValue = item.ProductMode;
						}
						this.WriteLiteralTo(__razor_helper_writer, '                            ');
						this.WriteTo(__razor_helper_writer, modelValue);
						this.WriteLiteralTo(__razor_helper_writer, '\r\n                        </div>\r\n                    </div>\r\n\r\n                </div>\r\n            </div>\r\n        </li>\r\n');
					}
				}
				finally {
					$t1.dispose();
				}
			}));
		},
		GetCompleteListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || !Enumerable.from(data.Result).any()) {
					return;
				}
				for (var $t1 = 0; $t1 < data.Result.length; $t1++) {
					var item = data.Result[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <div data-id="');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '">');
					this.WriteTo(__razor_helper_writer, item.ProductName);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="ProductList">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div class="headSearch" id="btnGotoSearch">\n            <input class="searchTextBox" type="text" id="txtKeyWord" placeholder="请输入查找内容" />\n            ');
			this.WriteLiteral('\n            <span id="btnSearch" class="searchFilter" style="display:none">搜索</span>\n        </div>\n    </div>\n    <div class="content" id="pnlContent">\n\n        <ul id="ulProductContainer"></ul>\n    </div>\n    <div id="pnlCompleteList">\n\n    </div>\n</div>\n\n');
			this.WriteLiteral('\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.btnGotoSearch = this.pageObject.find('#btnGotoSearch');
			this.txtKeyWord = this.pageObject.find('#txtKeyWord');
			this.btnFilter = this.pageObject.find('#btnFilter');
			this.btnSearch = this.pageObject.find('#btnSearch');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.ulProductContainer = this.pageObject.find('#ulProductContainer');
			this.pnlCompleteList = this.pageObject.find('#pnlCompleteList');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.btnGotoSearch)) {
				this.btnGotoSearch.unbind().off();
				this.btnGotoSearch = null;
			}
			if (ss.isValue(this.txtKeyWord)) {
				this.txtKeyWord.unbind().off();
				this.txtKeyWord = null;
			}
			if (ss.isValue(this.btnFilter)) {
				this.btnFilter.unbind().off();
				this.btnFilter = null;
			}
			if (ss.isValue(this.btnSearch)) {
				this.btnSearch.unbind().off();
				this.btnSearch = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.ulProductContainer)) {
				this.ulProductContainer.unbind().off();
				this.ulProductContainer = null;
			}
			if (ss.isValue(this.pnlCompleteList)) {
				this.pnlCompleteList.unbind().off();
				this.pnlCompleteList = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Product_ProductList$ProductListData, $asm, {});
	ss.initClass($USOProject_Pages_Product_ProductListCondition, $asm, {
		$ProductListCondition_OnPageInit: function(sender, e) {
			this.ProductListRestDto = this.InitialData;
			this.CreateProductFilterHtml(this.ProductListRestDto);
		},
		CreateProductFilterHtml: function(result) {
			console.info(result);
			var tempHtml = '<div class="inputPanel">';
			if (ss.isValue(result.priceQueryRange) && result.priceQueryRange.length > 0) {
				tempHtml += '<div class="InputItem submit_input_first">';
				tempHtml += '<div class="title">价格</div>';
				tempHtml += '<div class="inputWarp">';
				tempHtml += '<select id="spec_sel_specstatussearch">';
				tempHtml += '<option value="ALL">全部</option>';
				for (var i = 0; i < result.priceQueryRange.length; i++) {
					tempHtml += '<option value="price_' + result.priceQueryRange[i].PriceFrom + '~' + result.priceQueryRange[i].PriceTo + '">' + result.priceQueryRange[i].PriceFrom + '-' + result.priceQueryRange[i].PriceTo + '</option>';
				}
				tempHtml += '</select>';
				tempHtml += '</div>';
				tempHtml += '</div>';
			}
			var keys = Object.keys(result.propertys);
			var dic = result.propertys;
			for (var $t1 = 0; $t1 < keys.length; $t1++) {
				var key = keys[$t1];
				var groupName = key.split('-')[1];
				var groupValue = key.split('-')[0];
				tempHtml += '<div class="InputItem submit_input">';
				tempHtml += '<div class="title">' + groupName + '</div>';
				tempHtml += '<div class="inputWarp">';
				tempHtml += '<select id="spec_sel_specstatussearch">';
				tempHtml += '<option value="ALL">全部</option>';
				var propertysList = dic[key];
				for (var j = 0; j < propertysList.length; j++) {
					var groupAttrs = propertysList[j];
					tempHtml += '<option value="' + groupValue + '_' + groupAttrs.Id + '">' + groupAttrs.ValueName + '</option>';
				}
				tempHtml += '</select>';
				tempHtml += '</div>';
				tempHtml += '</div>';
			}
			tempHtml += '</div>';
			this.pnlContent.html(tempHtml);
			//product_dosearch.Click((elem, @event) => MobilePage.GotoPage<ProductList>(GetFilterString()));
			this.product_dosearch.click(ss.mkdel(this, function(event) {
				if (!ss.staticEquals(this.OnConditionComplete, null)) {
					this.OnConditionComplete(this.$GetFilterString());
				}
				JSLib.Mobile.Application.Back(1);
			}));
		},
		$GetFilterString: function() {
			var returnHtml = '';
			var priceSelecter = $(".ProductListCondition .submit_input_first option:checked[value^='price']");
			var attrsSelecter = $(".ProductListCondition .submit_input option:checked[value *='_']");
			priceSelecter.each(function(i, priceObj) {
				if (i === priceSelecter.length - 1) {
					returnHtml += priceObj.getAttribute('value');
				}
				else {
					returnHtml += priceObj.getAttribute('value') + '-';
				}
			});
			attrsSelecter.each(function(i1, attrsObj) {
				if (i1 === 0 && returnHtml !== '') {
					returnHtml += '-';
				}
				if (i1 === attrsSelecter.length - 1) {
					returnHtml += attrsObj.getAttribute('value');
				}
				else {
					returnHtml += attrsObj.getAttribute('value') + '-';
				}
			});
			var $t1 = new $USOProject_Pages_Product_ProductList$ProductListData();
			$t1.FilterString = returnHtml;
			$t1.QueryType = 'Filter';
			$t1.C3Id = this.ProductListRestDto.categoryThirdDTO.Id.toString();
			var dto = $t1;
			return dto;
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="ProductListCondition">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">产品筛选</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="inputPanel">\n            <div class="InputItem">\n                <div class="title">状态:</div>\n                <div class="inputWarp">\n                    <select id="retail_sel_salesStatus" class="">\n                        <option value="-1">----所有状态----</option>\n                        <option value="1">待处理</option>\n                        <option value="2">已处理</option>\n                        <option value="4">已审核</option>\n                        <option value="3">已作废</option>\n                    </select>\n                </div>\n            </div>\n        </div>\n    </div>\n    <div class="queryButton" id="product_dosearch">\n        查询\n    </div>\n</div>\n\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.retail_sel_salesStatus = this.pageObject.find('#retail_sel_salesStatus');
			this.product_dosearch = this.pageObject.find('#product_dosearch');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.retail_sel_salesStatus)) {
				this.retail_sel_salesStatus.unbind().off();
				this.retail_sel_salesStatus = null;
			}
			if (ss.isValue(this.product_dosearch)) {
				this.product_dosearch.unbind().off();
				this.product_dosearch = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Retail_RetailInput, $asm, {
		$OnOnPageShow: function(sender, eventArgs) {
			this.$LoadData();
		},
		$RetailInput_OnPageInit: function(sender, e) {
			var $state1 = 0, $t4, orgs;
			var $sm1 = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state1) {
						case 0: {
							$state1 = -1;
							//_pageScroller = this.SetScrollable(pnlContent[0], false, false, false, null,null,null, "", true, async delegate
							//{
							//    RetailInput_OnPageInit(null, null);
							//    await Task.Delay(100);
							//});
							this.$_pageScroller = this.SetScrollable(this.pnlContent[0], false, true, false, null, null, null, '', true, ss.mkdel(this, function() {
								var $state = 0, $tcs = new ss.TaskCompletionSource(), $t1;
								var $sm = ss.mkdel(this, function() {
									try {
										$sm1:
										for (;;) {
											switch ($state) {
												case 0: {
													$state = -1;
													this.$LoadData();
													$t1 = ss.Task.delay(100);
													$state = 1;
													$t1.continueWith($sm);
													return;
												}
												case 1: {
													$state = -1;
													$t1.getAwaitedResult();
													$state = -1;
													break $sm1;
												}
												default: {
													break $sm1;
												}
											}
										}
										$tcs.setResult(null);
									}
									catch ($t2) {
										$tcs.setException(ss.Exception.wrap($t2));
									}
								});
								$sm();
								return $tcs.task;
							}), true, true);
							//新增
							this.retailInput_new.click(function(event) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_Add_RetailInputAdd).call(null, null, null);
							});
							//查询
							this.retailInput_list.click(function(event1) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_RetailInputList).call(null, $USOProject_Pages_Retail_RetailInputQuery$QueryCondition.$ctor(), null);
							});
							this.retailindex_top_content.click(ss.mkdel(this, function(event2) {
								var query = $USOProject_Pages_Retail_RetailInputProductSaleStatistics$StatisticsData.$ctor();
								query.storeId = null;
								query.fromDate = this.$queryDto.fromDate;
								query.toDate = this.$queryDto.toDate;
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_RetailInputProductSaleStatistics).call(null, query, null);
							}));
							this.pnlContent.on('click', 'div[retailindextag]', ss.thisFix(ss.mkdel(this, function(elem, event3) {
								var target = $(elem);
								var bindData = UIDataEx.GetBindData$1(Object).call(null, target);
								var $t3 = $USOProject_Pages_Retail_RetailInputProductSaleStatistics$StatisticsData.$ctor();
								$t3.storeName = bindData.CustomerStoreName;
								$t3.storeId = bindData.CustomerStoreId;
								$t3.CustomerLegalId = bindData.CustomerLegalId;
								$t3.customerName = bindData.CustomerName;
								$t3.fromDate = this.$queryDto.fromDate;
								$t3.toDate = this.$queryDto.toDate;
								$t3.satGroupId = CoreEx.ToInt(this.retailindex_top_title_select.val(), 0);
								var pageData = $t3;
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_RetailInputProductSaleStatistics).call(null, pageData, null);
							})));
							//切换当年和当月
							this.retailindex_top_title_right.click(ss.mkdel(this, function(event4) {
								this.$queryDto.isYear = !this.$queryDto.isYear;
								this.pnlContent.find('.retailindex_title_span').text((this.$queryDto.isYear ? '年' : '月'));
								if (this.$queryDto.isYear) {
									this.$queryDto.fromDate = ss.formatDate(new Date(), 'yyyy') + '-01-01';
									this.$queryDto.toDate = ss.formatDate(new Date(), 'yyyy') + '-12-31';
								}
								else {
									this.$queryDto.fromDate = ss.formatDate(new Date(), 'yyyy-MM') + '-01';
									this.$queryDto.toDate = ss.formatDate(new Date(), 'yyyy-MM-dd');
								}
								this.$LoadData();
							}));
							this.$queryDto = $USOProject_Business_Retail_RetailInputSimpleQuery.$ctor();
							this.$queryDto.fromDate = ss.formatDate(new Date(), 'yyyy-MM') + '-01';
							this.$queryDto.toDate = ss.formatDate(new Date(), 'yyyy-MM-dd');
							$t4 = $USOProject_Business_BusinessAction.GetRetailInputProductOrgs(this, true);
							$state1 = 1;
							$t4.continueWith($sm1);
							return;
						}
						case 1: {
							$state1 = -1;
							orgs = $t4.getAwaitedResult();
							if (!orgs.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(orgs.ErrorMessage);
								return;
							}
							this.retailindex_top_title_select.html(this.GetOptionsHtml(orgs.Result).toString());
							this.retailindex_top_title_select.change(ss.mkdel(this, function(event5) {
								this.$queryDto.satGroupId = CoreEx.ToInt(this.retailindex_top_title_select.val(), 0);
								this.$LoadData();
							}));
							$state1 = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm1();
		},
		$LoadData: function() {
			var $state = 0, $t1, ajaxResult, values, TotalSalesAmount, TotalCommisionAmount, SalesCount, Stores, tmp_TotalSalesAmount, tmp_TotalCommisionAmount, tmp_SalesCount, tmpi, intervalId;
			var $sm = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							$t1 = $USOProject_Business_BusinessAction.RetailInputStatistic(this.$queryDto, this);
							$state = 1;
							$t1.continueWith($sm);
							return;
						}
						case 1: {
							$state = -1;
							ajaxResult = $t1.getAwaitedResult();
							if (!ajaxResult.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(ajaxResult.ErrorMessage);
								return;
							}
							values = ajaxResult.Result;
							TotalSalesAmount = values.TotalSalesAmount;
							TotalCommisionAmount = values.TotalCommisionAmount;
							SalesCount = values.SalesCount;
							Stores = values.Stores;
							tmp_TotalSalesAmount = 0;
							tmp_TotalCommisionAmount = 0;
							tmp_SalesCount = 0;
							if (TotalSalesAmount > 0) {
								tmp_TotalSalesAmount = TotalSalesAmount / 10;
							}
							if (TotalCommisionAmount > 0) {
								tmp_TotalCommisionAmount = TotalCommisionAmount / 10;
							}
							if (SalesCount > 0) {
								tmp_SalesCount = ss.Int32.div(SalesCount, 10);
							}
							tmpi = 0;
							intervalId = 0;
							intervalId = window.setInterval(ss.mkdel(this, function() {
								if (tmpi === 10) {
									tmpi = 0;
									this.retailindex_top_content.text(TotalSalesAmount.toFixed(2));
									this.retailindex_middle_left_content.text(TotalCommisionAmount.toFixed(2));
									this.retailindex_middle_right_content.text(SalesCount.toString());
									for (var $t2 = 0; $t2 < this.$intervalIds.length; $t2++) {
										var tId = this.$intervalIds[$t2];
										window.clearInterval(tId);
										ss.remove(this.$intervalIds, tId);
									}
									return;
								}
								tmpi++;
								this.retailindex_top_content.text((tmp_TotalSalesAmount * tmpi).toFixed(2));
								this.retailindex_middle_left_content.text((tmp_TotalCommisionAmount * tmpi).toFixed(2));
								this.retailindex_middle_right_content.text((tmp_SalesCount * tmpi).toFixed(0));
							}), 100);
							this.$intervalIds.push(intervalId);
							if (ss.isNullOrUndefined(Stores) || ss.count(Stores) === 0) {
								this.retailindex_bottom_list.html('暂无门店信息');
								return;
							}
							//retailindex_bottom_list
							this.retailindex_bottom_list.html(this.GetListHtml(Stores).toString());
							this.$_pageScroller.iscroll.refresh();
							$state = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm();
		},
		Destroy: function() {
			for (var $t1 = 0; $t1 < this.$intervalIds.length; $t1++) {
				var tId = this.$intervalIds[$t1];
				window.clearInterval(tId);
				ss.remove(this.$intervalIds, tId);
			}
			JSLib.Mobile.BasePage.prototype.Destroy.call(this);
		},
		GetListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				for (var i = 0; i < ss.count(data); i++) {
					var item = ss.getItem(data, i);
					var groupclass = 'retailindex_bottom_list_group';
					if (i === ss.count(data) - 1) {
						groupclass = 'retailindex_bottom_list_group_last';
					}
					this.WriteLiteralTo(__razor_helper_writer, '        <div data-id="retailindex_bottom_list');
					this.WriteTo(__razor_helper_writer, item.CustomerStoreId);
					this.WriteLiteralTo(__razor_helper_writer, '" class="');
					this.WriteTo(__razor_helper_writer, groupclass);
					this.WriteLiteralTo(__razor_helper_writer, ' endnavIcon" retailindextag="');
					this.WriteTo(__razor_helper_writer, item.CustomerStoreId);
					this.WriteLiteralTo(__razor_helper_writer, '" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(item));
					this.WriteLiteralTo(__razor_helper_writer, '>\r\n            <div class="retailindex_bottom_list_group_left_top">\r\n                <span class="customerName">');
					this.WriteTo(__razor_helper_writer, item.CustomerName);
					this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                <span class="storeName">');
					this.WriteTo(__razor_helper_writer, item.CustomerStoreName);
					this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n            </div>\r\n            <div class="row2">\r\n                <div class="retailindex_bottom_list_group_left_bottom_left">\r\n                    ');
					this.WriteTo(__razor_helper_writer, item.TotalSalesAmount.toFixed(2));
					this.WriteLiteralTo(__razor_helper_writer, '\r\n                </div>\r\n                <div class="retailindex_bottom_list_group_left_bottom_right">');
					this.WriteTo(__razor_helper_writer, item.SalesCount);
					this.WriteLiteralTo(__razor_helper_writer, '&nbsp;单</div>\r\n            </div>\r\n        </div>\r\n');
				}
			}));
		},
		GetOptionsHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, "    <option value='-1'>全部</option>\r\n");
				if (ss.isValue(data) && data.length > 0) {
					for (var $t1 = 0; $t1 < data.length; $t1++) {
						var item = data[$t1];
						this.WriteLiteralTo(__razor_helper_writer, "            <option value='");
						this.WriteTo(__razor_helper_writer, item.Id);
						this.WriteLiteralTo(__razor_helper_writer, "'>");
						this.WriteTo(__razor_helper_writer, item.Name);
						this.WriteLiteralTo(__razor_helper_writer, '</option>\r\n');
					}
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="RetailInput">\r\n    <div class="head">\r\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\r\n        <div id="lblHeadText" class="headText">零售录入</div>\r\n    </div>\r\n    <div class="content" id="pnlContent">\r\n        <div id="retailindex_top">\r\n            <div id="retailindex_top_title">\r\n                <div id="retailindex_top_title_left">\r\n                    当<span class="retailindex_title_span" id="retailindex_title_span">月</span>销售额(元)\r\n                    <br /><br />统计范围<select id="retailindex_top_title_select"></select>\r\n                </div>\r\n                <div id="retailindex_top_title_right"></div>\r\n            </div>\r\n            <div id="retailindex_top_content"></div>\r\n        </div>\r\n        <div id="retailindex_middle">\r\n            <div class="retailindex_middle_left">\r\n                <div class="retailindex_middle_left_title">\r\n                    当<span class="retailindex_title_span">月</span>估算提成(元)\r\n                </div>\r\n                <div id="retailindex_middle_left_content" class="retailindex_middle_left_content"></div>\r\n            </div>\r\n            <div class="retailindex_middle_right">\r\n                <div class="retailindex_middle_right_title">\r\n                    当<span class="retailindex_title_span">月</span>单据数\r\n                </div>\r\n                <div id="retailindex_middle_right_content" class="retailindex_middle_right_content">\r\n\r\n                </div>\r\n            </div>\r\n        </div>\r\n        <div id="retailindex_bottom">\r\n            <div id="retailindex_bottom_list" class="retailindex_bottom_list">\r\n            </div>\r\n        </div>\r\n    </div>\r\n\r\n    <div id="navbar" style="background-color: #ffffff; margin-top: 1px;" class="footer">\r\n        <footer class="submit_footer_multi" data-parent="retail_index">\r\n            <a id="retailInput_new" class="button block">\r\n                新建\r\n            </a>\r\n            <a id="retailInput_list" class="button block">\r\n                查询\r\n            </a>\r\n        </footer>\r\n    </div>\r\n</div>\r\n\r\n');
			this.WriteLiteral('\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.retailindex_top = this.pageObject.find('#retailindex_top');
			this.retailindex_top_title = this.pageObject.find('#retailindex_top_title');
			this.retailindex_top_title_left = this.pageObject.find('#retailindex_top_title_left');
			this.retailindex_title_span = this.pageObject.find('#retailindex_title_span');
			this.retailindex_top_title_select = this.pageObject.find('#retailindex_top_title_select');
			this.retailindex_top_title_right = this.pageObject.find('#retailindex_top_title_right');
			this.retailindex_top_content = this.pageObject.find('#retailindex_top_content');
			this.retailindex_middle = this.pageObject.find('#retailindex_middle');
			this.retailindex_middle_left_content = this.pageObject.find('#retailindex_middle_left_content');
			this.retailindex_middle_right_content = this.pageObject.find('#retailindex_middle_right_content');
			this.retailindex_bottom = this.pageObject.find('#retailindex_bottom');
			this.retailindex_bottom_list = this.pageObject.find('#retailindex_bottom_list');
			this.navbar = this.pageObject.find('#navbar');
			this.retailInput_new = this.pageObject.find('#retailInput_new');
			this.retailInput_list = this.pageObject.find('#retailInput_list');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.retailindex_top)) {
				this.retailindex_top.unbind().off();
				this.retailindex_top = null;
			}
			if (ss.isValue(this.retailindex_top_title)) {
				this.retailindex_top_title.unbind().off();
				this.retailindex_top_title = null;
			}
			if (ss.isValue(this.retailindex_top_title_left)) {
				this.retailindex_top_title_left.unbind().off();
				this.retailindex_top_title_left = null;
			}
			if (ss.isValue(this.retailindex_title_span)) {
				this.retailindex_title_span.unbind().off();
				this.retailindex_title_span = null;
			}
			if (ss.isValue(this.retailindex_top_title_select)) {
				this.retailindex_top_title_select.unbind().off();
				this.retailindex_top_title_select = null;
			}
			if (ss.isValue(this.retailindex_top_title_right)) {
				this.retailindex_top_title_right.unbind().off();
				this.retailindex_top_title_right = null;
			}
			if (ss.isValue(this.retailindex_top_content)) {
				this.retailindex_top_content.unbind().off();
				this.retailindex_top_content = null;
			}
			if (ss.isValue(this.retailindex_middle)) {
				this.retailindex_middle.unbind().off();
				this.retailindex_middle = null;
			}
			if (ss.isValue(this.retailindex_middle_left_content)) {
				this.retailindex_middle_left_content.unbind().off();
				this.retailindex_middle_left_content = null;
			}
			if (ss.isValue(this.retailindex_middle_right_content)) {
				this.retailindex_middle_right_content.unbind().off();
				this.retailindex_middle_right_content = null;
			}
			if (ss.isValue(this.retailindex_bottom)) {
				this.retailindex_bottom.unbind().off();
				this.retailindex_bottom = null;
			}
			if (ss.isValue(this.retailindex_bottom_list)) {
				this.retailindex_bottom_list.unbind().off();
				this.retailindex_bottom_list = null;
			}
			if (ss.isValue(this.navbar)) {
				this.navbar.unbind().off();
				this.navbar = null;
			}
			if (ss.isValue(this.retailInput_new)) {
				this.retailInput_new.unbind().off();
				this.retailInput_new = null;
			}
			if (ss.isValue(this.retailInput_list)) {
				this.retailInput_list.unbind().off();
				this.retailInput_list = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Retail_RetailInputList, $asm, {
		$RetailInputList_OnPageInit: function(sender, e) {
			var iscrollList = this.SetIscrollList(this.ulRetailInputListContainer[0], 20, 100, true, false, true);
			iscrollList.set_GetPageData(ss.mkdel(this, function(index) {
				var $state = 0, $tcs = new ss.TaskCompletionSource(), $t1, tskResult, result, data, $t2;
				var $sm = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									//根据查询条件取出数据
									this.QueryData.CurrentUserId = $App.app.userInfo.User.Id.toString();
									this.QueryData.Page = index;
									this.QueryData.PageSize = 20;
									$t1 = $USOProject_Business_BusinessAction.RetailListQuery(this.QueryData, this);
									$state = 1;
									$t1.continueWith($sm);
									return;
								}
								case 1: {
									$state = -1;
									tskResult = $t1.getAwaitedResult();
									result = null;
									if (!tskResult.IsSuccess) {
										JSLib.Mobile.MessageBox.Alert(tskResult.ErrorMessage);
										result = [];
									}
									else {
										data = tskResult.Result;
										result = data.Result;
									}
									$t2 = new JSLib.IScrollWraper.PageData();
									$t2.PageIndex = index;
									$t2.RecordCount = Enumerable.from(result).count();
									$t2.ResultElement = jQueryObjectEx.ToJqueryObject(this.GetRetailInputListHtml(result).toString());
									$tcs.setResult($t2);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t3) {
						$tcs.setException(ss.Exception.wrap($t3));
					}
				});
				$sm();
				return $tcs.task;
			}));
			iscrollList.ReLoad();
			this.header_search.click(ss.mkdel(this, function(event) {
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_RetailInputQuery).call(null, this.QueryData, ss.mkdel(this, function(page) {
					page.OnConditionComplete = ss.mkdel(this, function(condition) {
						//更新查询条件，重新根据条件加载数据列表
						this.QueryData = condition;
						this.pnlInfoPanel.hide();
						iscrollList.ReLoad();
					});
				}));
			}));
			this.ulRetailInputListContainer.on('click', 'div[data-retailid]', ss.thisFix(ss.mkdel(this, function(elem, event1) {
				var $state1 = 0, bindData, $t4, $t5, result1, retailinputid;
				var $sm1 = ss.mkdel(this, function() {
					$sm1:
					for (;;) {
						switch ($state1) {
							case 0: {
								$state1 = -1;
								bindData = UIDataEx.GetBindData$1($CustomerSalesRestDTO).call(null, $(elem));
								if (bindData.SaleType >= 6 && bindData.SaleType <= 9) {
									$t4 = $USOProject_Pages_Retail_Add_RetailReturnData.$ctor();
									$t4.returnId = bindData.Id;
									JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_Add_RetailReturnPage).call(null, $t4, function(page1) {
										page1.OnDrop = function() {
											$(elem).find('.salestatus').text('已作废');
										};
									});
									return;
								}
								else {
									$t5 = $USOProject_Business_BusinessAction.RetailInputInit(bindData.Id, this);
									$state1 = 1;
									$t5.continueWith($sm1);
									return;
								}
							}
							case 1: {
								$state1 = -1;
								result1 = $t5.getAwaitedResult();
								if (!result1.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(result1.ErrorMessage);
									return;
								}
								retailinputid = result1.Result;
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_Add_RetailInputAdd).call(null, retailinputid, function(add) {
									add.OnBlankOut = function() {
										iscrollList.ReLoad();
									};
								});
								return;
							}
							default: {
								break $sm1;
							}
						}
					}
				});
				$sm1();
			})));
			this.btnNewRetailInput.click(function(event2) {
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_Add_RetailInputAdd).call(null, null, null);
			});
		},
		PrepareData: function() {
			this.QueryData = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		GetRetailInputListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || !Enumerable.from(data).any()) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">暂无数据</div>\r\n');
					return;
				}
				var $t1 = ss.getEnumerator(data);
				try {
					while ($t1.moveNext()) {
						var item = $t1.current();
						this.WriteLiteralTo(__razor_helper_writer, '        <div data-retailid="');
						this.WriteTo(__razor_helper_writer, item.Id);
						this.WriteLiteralTo(__razor_helper_writer, '" class="retailItem endnavIcon" ');
						this.WriteTo(__razor_helper_writer, this.DataBind(item));
						this.WriteLiteralTo(__razor_helper_writer, '>\r\n            <div class="work_title">\r\n                <span class="storename">');
						this.WriteTo(__razor_helper_writer, item.CustomerStoreName);
						this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                <span class="retail_status salestatus" style="color:black">');
						this.WriteTo(__razor_helper_writer, item.CustomerSalesStatusString);
						this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                <span >(');
						this.WriteTo(__razor_helper_writer, item.CreateByName);
						this.WriteLiteralTo(__razor_helper_writer, ')</span>\r\n\r\n');
						var orderTypStr = '';
						if (item.SaleType === 6 || item.SaleType === 7 || item.SaleType === 8 || item.SaleType === 9) {
							orderTypStr = '退货单';
						}
						this.WriteLiteralTo(__razor_helper_writer, '                <span class="retail_status">');
						this.WriteTo(__razor_helper_writer, orderTypStr);
						this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n\r\n            </div>\r\n            <div class="work_time">\r\n                <span class="customername">');
						this.WriteTo(__razor_helper_writer, item.ClientName);
						this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                <span class="customeraddress">');
						this.WriteTo(__razor_helper_writer, item.ClientAddress);
						this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                <span class="price">￥');
						this.WriteTo(__razor_helper_writer, item.SalesAmount);
						this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                <span class="date">');
						this.WriteTo(__razor_helper_writer, ss.formatDate(DateTimeEx.ToDateTimeForce(item.SaleOn), 'yyyy-MM-dd'));
						this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n            </div>\r\n        </div>\r\n');
					}
				}
				finally {
					$t1.dispose();
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="RetailInputList">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">零售录入列表</div>\n        <div id="header_search" class="iconSearch"></div>\n    </div>\n    <div class="content" id="pnlContent">\n        <a id="btnNewRetailInput" class="button block">新建零售录入</a>\n');
			if (ss.isValue(this.QueryData) && !ss.isNullOrEmptyString(this.QueryData.FromDate)) {
				this.WriteLiteral('            <div id="pnlInfoPanel" class="infoPanel tipInfo" style="display: block;">\r\n                <div class="infoPanelRow">\r\n                    <span id="lblCustomerName">');
				this.Write(this.QueryData.customerName);
				this.WriteLiteral('</span>\r\n                    <span id="lblStoreName">');
				this.Write(this.QueryData.storeName);
				this.WriteLiteral('</span>\r\n                </div>\r\n                <div class="infoPanelRow">\r\n                    <span id="lblProductName">');
				this.Write(this.QueryData.ProductName);
				this.WriteLiteral('</span>\r\n                </div>\r\n                <div class="infoPanelRow">\r\n                    <span id="lblQueryDate">\r\n                        <span id="lblBeginDate">');
				this.Write(this.QueryData.FromDate);
				this.WriteLiteral('</span> ~\r\n                        <span id="lblEndDate">');
				this.Write(this.QueryData.ToDate);
				this.WriteLiteral('</span>\r\n                    </span>\r\n                </div>\r\n            </div>\r\n');
			}
			this.WriteLiteral('\r\n        <ul id="ulRetailInputListContainer"></ul>\r\n    </div>\r\n</div>\r\n\r\n');
			this.WriteLiteral('\r\n\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.header_search = this.pageObject.find('#header_search');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.btnNewRetailInput = this.pageObject.find('#btnNewRetailInput');
			this.pnlInfoPanel = this.pageObject.find('#pnlInfoPanel');
			this.lblCustomerName = this.pageObject.find('#lblCustomerName');
			this.lblStoreName = this.pageObject.find('#lblStoreName');
			this.lblProductName = this.pageObject.find('#lblProductName');
			this.lblQueryDate = this.pageObject.find('#lblQueryDate');
			this.lblBeginDate = this.pageObject.find('#lblBeginDate');
			this.lblEndDate = this.pageObject.find('#lblEndDate');
			this.ulRetailInputListContainer = this.pageObject.find('#ulRetailInputListContainer');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.header_search)) {
				this.header_search.unbind().off();
				this.header_search = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.btnNewRetailInput)) {
				this.btnNewRetailInput.unbind().off();
				this.btnNewRetailInput = null;
			}
			if (ss.isValue(this.pnlInfoPanel)) {
				this.pnlInfoPanel.unbind().off();
				this.pnlInfoPanel = null;
			}
			if (ss.isValue(this.lblCustomerName)) {
				this.lblCustomerName.unbind().off();
				this.lblCustomerName = null;
			}
			if (ss.isValue(this.lblStoreName)) {
				this.lblStoreName.unbind().off();
				this.lblStoreName = null;
			}
			if (ss.isValue(this.lblProductName)) {
				this.lblProductName.unbind().off();
				this.lblProductName = null;
			}
			if (ss.isValue(this.lblQueryDate)) {
				this.lblQueryDate.unbind().off();
				this.lblQueryDate = null;
			}
			if (ss.isValue(this.lblBeginDate)) {
				this.lblBeginDate.unbind().off();
				this.lblBeginDate = null;
			}
			if (ss.isValue(this.lblEndDate)) {
				this.lblEndDate.unbind().off();
				this.lblEndDate = null;
			}
			if (ss.isValue(this.ulRetailInputListContainer)) {
				this.ulRetailInputListContainer.unbind().off();
				this.ulRetailInputListContainer = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Retail_RetailInputProductDetail, $asm, {
		$RetailInputProductDetail_OnPageInit: function(sender, e) {
			this.SetScrollable(this.pnlContent[0], false, true, false, null, null, null, '', false, null, true, true);
		},
		PrepareData: function() {
			this.PageData = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="RetailInputProductDetail">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">零售录入产品详情</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div id="divRetailProductListContainer" style="width: 100%; overflow: auto;" class="list inset">\n            <div class="div_work">\n                <div id="div_work_content" class="div_work_content">\n                    <div style="margin-left: 10px;">\n                        <div class="work_title">');
			this.Write(this.PageData.ProductId);
			this.WriteLiteral(' &nbsp;');
			this.Write(this.PageData.ProductName);
			this.WriteLiteral('</div>\r\n                        <div class="work_time">\r\n                            <div class="work_time">\r\n                                产品数量:\r\n                                <span id="div_work_pnumber_span">');
			this.Write(this.PageData.Quantity);
			this.WriteLiteral('</span>\r\n                            </div>\r\n                        </div>\r\n                        <div class="work_time">\r\n                            零售价格:\r\n                            <span id="div_work_pprice_span">');
			this.Write($NullableExtenion.FormatMoney$1(this.PageData.Price, '无'));
			this.WriteLiteral('</span>\r\n                        </div>\r\n                        <div class="work_time">\r\n                            提成金额:\r\n                            <span id="div_work_commAmount_span">');
			this.Write($NullableExtenion.FormatMoney$1(this.PageData.CommissionAmount, '无'));
			this.WriteLiteral('</span>\r\n                        </div>\r\n                        <div class="work_time">\r\n                            安装方式:\r\n');
			var setupType = '';
			if (ss.isValue(this.PageData.SetupTypeCode)) {
				setupType = $App.GetSetupTypeText(ss.unbox(this.PageData.SetupTypeCode));
			}
			this.WriteLiteral('                            <span id="div_work_smode_span">');
			this.Write(setupType);
			this.WriteLiteral('</span>\r\n                        </div>\r\n                        <div class="work_time">\r\n                            网络环境:\r\n');
			var networkType = '无网络';
			if (ss.isValue(this.PageData.HomeNetWorkCode)) {
				networkType = $App.GetNetWorkTypesText(ss.unbox(this.PageData.HomeNetWorkCode));
			}
			this.WriteLiteral('                            <span id="div_work_networktype_span">');
			this.Write(networkType);
			this.WriteLiteral('</span>\r\n                        </div>\r\n                        <div class="work_time">\r\n                            购机日期:\r\n                            <span id="div_work_saledate_span">');
			this.Write(ss.formatDate(ss.unbox(DateTimeEx.ToDateTime(this.PageData.PurchaseDate)), 'yyyy-MM-dd'));
			this.WriteLiteral('</span>\r\n                        </div>\r\n                        <div class="work_time">\r\n                            产品备注:\r\n                            <span id="div_work_remark_span">');
			this.Write(this.PageData.Memo);
			this.WriteLiteral('</span>\r\n                        </div>\r\n                    </div>\r\n\r\n\r\n                    <div class="feeInfos">\r\n');
			if (ss.isValue(this.PageData.Fees) && this.PageData.Fees.length > 0) {
				for (var $t1 = 0; $t1 < this.PageData.Fees.length; $t1++) {
					var item = this.PageData.Fees[$t1];
					this.WriteLiteral('                                <div class="feeItem">\r\n                                    <div class="feeName">\r\n                                        <span class="feeTitle">费用名称:</span>\r\n');
					var feeName = '';
					switch (item.FeeCode) {
						case 61: {
							feeName = '买赠';
							break;
						}
						case 62: {
							feeName = '长虹券';
							break;
						}
						case 63: {
							feeName = '客户券';
							break;
						}
						case 196: {
							feeName = '能效费用';
							break;
						}
						default: {
							feeName = '费用代码' + item.FeeCode;
							break;
						}
					}
					this.WriteLiteral('                                        <span class="feeValue">');
					this.Write(feeName);
					this.WriteLiteral('</span>\r\n                                    </div>\r\n                                    <div class="feeAmount">\r\n                                        <span class="feeTitle">费用金额:</span>\r\n                                        <span class="feeValue">');
					this.Write(item.Amount);
					this.WriteLiteral('</span>\r\n                                    </div>\r\n                                    <div class="feeAmount">\r\n                                        <span class="feeTitle">费用备注:</span>\r\n                                        <span class="feeValue">');
					this.Write(item.Memo);
					this.WriteLiteral('</span>\r\n                                    </div>\r\n                                </div>\r\n');
				}
			}
			this.WriteLiteral('                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n\r\n    </div>\r\n</div>\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.divRetailProductListContainer = this.pageObject.find('#divRetailProductListContainer');
			this.div_work_content = this.pageObject.find('#div_work_content');
			this.div_work_pnumber_span = this.pageObject.find('#div_work_pnumber_span');
			this.div_work_pprice_span = this.pageObject.find('#div_work_pprice_span');
			this.div_work_commAmount_span = this.pageObject.find('#div_work_commAmount_span');
			this.div_work_smode_span = this.pageObject.find('#div_work_smode_span');
			this.div_work_networktype_span = this.pageObject.find('#div_work_networktype_span');
			this.div_work_saledate_span = this.pageObject.find('#div_work_saledate_span');
			this.div_work_remark_span = this.pageObject.find('#div_work_remark_span');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.divRetailProductListContainer)) {
				this.divRetailProductListContainer.unbind().off();
				this.divRetailProductListContainer = null;
			}
			if (ss.isValue(this.div_work_content)) {
				this.div_work_content.unbind().off();
				this.div_work_content = null;
			}
			if (ss.isValue(this.div_work_pnumber_span)) {
				this.div_work_pnumber_span.unbind().off();
				this.div_work_pnumber_span = null;
			}
			if (ss.isValue(this.div_work_pprice_span)) {
				this.div_work_pprice_span.unbind().off();
				this.div_work_pprice_span = null;
			}
			if (ss.isValue(this.div_work_commAmount_span)) {
				this.div_work_commAmount_span.unbind().off();
				this.div_work_commAmount_span = null;
			}
			if (ss.isValue(this.div_work_smode_span)) {
				this.div_work_smode_span.unbind().off();
				this.div_work_smode_span = null;
			}
			if (ss.isValue(this.div_work_networktype_span)) {
				this.div_work_networktype_span.unbind().off();
				this.div_work_networktype_span = null;
			}
			if (ss.isValue(this.div_work_saledate_span)) {
				this.div_work_saledate_span.unbind().off();
				this.div_work_saledate_span = null;
			}
			if (ss.isValue(this.div_work_remark_span)) {
				this.div_work_remark_span.unbind().off();
				this.div_work_remark_span = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Retail_RetailInputProductSaleStatistics, $asm, {
		$RetailInputProductSaleStatistics_OnPageShow: function(sender, e) {
			this.retail_productSaleStatistics_information.html(this.GetQueryTipHtml(this.Data).toString());
			if (ss.isValue(this.$_iscrollList)) {
				this.$_iscrollList.Refresh();
			}
		},
		$RetailInputProductSaleStatistics_OnPageInit: function(sender, e) {
			this.$_iscrollList = this.SetIscrollList(this.ulRetailInputProductSaleStatisticsContainer[0], 20, 100, true, false, true);
			this.$_iscrollList.set_GetPageData(ss.mkdel(this, function(index) {
				var $state = 0, $tcs = new ss.TaskCompletionSource(), query, $t1, result, data, $t2;
				var $sm = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									query = $USOProject_Business_Retail_RetailInputStatisticQuery.$ctor();
									query.FromDate = this.Data.fromDate;
									query.ToDate = this.Data.toDate;
									query.satGroupId = this.Data.satGroupId;
									query.CustomerStoreId = this.Data.storeId;
									query.CustomerLegalId = this.Data.CustomerLegalId;
									query.CurrentUserId = $App.app.userInfo.User.Id;
									query.Page = index;
									query.PageSize = 20;
									$t1 = $USOProject_Business_BusinessAction.RetailInputStatisticProduct(query, this);
									$state = 1;
									$t1.continueWith($sm);
									return;
								}
								case 1: {
									$state = -1;
									result = $t1.getAwaitedResult();
									data = result.Result;
									if (!result.IsSuccess) {
										JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
										$tcs.setResult(new JSLib.IScrollWraper.PageData());
										return;
									}
									$t2 = new JSLib.IScrollWraper.PageData();
									$t2.PageIndex = index;
									$t2.RecordCount = data.length;
									$t2.ResultElement = jQueryObjectEx.ToJqueryObject(this.GetProductListHtml(data, 0).toString());
									$tcs.setResult($t2);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t3) {
						$tcs.setException(ss.Exception.wrap($t3));
					}
				});
				$sm();
				return $tcs.task;
			}));
			this.$_iscrollList.ReLoad();
			this.ulRetailInputProductSaleStatisticsContainer.on('click', 'div[data-productid]', ss.thisFix(ss.mkdel(this, function(elem, event) {
				var productId = elem.getAttribute('data-productid');
				var $t4 = $USOProject_Pages_Retail_RetailInputQuery$QueryCondition.$ctor();
				$t4.customerName = this.Data.customerName;
				$t4.storeName = this.Data.storeName;
				$t4.FromDate = this.Data.fromDate;
				$t4.ToDate = this.Data.toDate;
				$t4.ProductName = $(elem).find('.product_price_name').text();
				$t4.ProductId = productId;
				$t4.CustomerStoreId = this.Data.storeId;
				var query1 = $t4;
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_RetailInputList).call(null, query1, null);
			})));
		},
		PrepareData: function() {
			this.Data = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		GetProductListHtml: function(data, pageIndex) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || data.length === 0) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">暂无数据</div>\r\n');
					return;
				}
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="productItem li_work endnavIcon" data-productid="');
					this.WriteTo(__razor_helper_writer, item.ProductId);
					this.WriteLiteralTo(__razor_helper_writer, '">\r\n            <div class="product_price_name">     ');
					this.WriteTo(__razor_helper_writer, item.ProductName);
					this.WriteLiteralTo(__razor_helper_writer, '     </div>\r\n            <div class="product_price ">\r\n                <div class="colItem col2">\r\n                    <span class="title">销售额:</span>\r\n                    <span class="sale_amount">￥');
					this.WriteTo(__razor_helper_writer, item.TotalSalesAmount.toFixed(2));
					this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                </div>\r\n                <div class="colItem col1">\r\n                    <span class="title">数量:</span>\r\n                    <span class="quantity">');
					this.WriteTo(__razor_helper_writer, item.TotalQuantity);
					this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                </div>\r\n                <div class="colItem col2">\r\n                    <span class="title">提成:</span><span class="commission">￥');
					this.WriteTo(__razor_helper_writer, item.TotalCommisionAmount.toFixed(2));
					this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                </div>\r\n            </div>\r\n        </div>\r\n');
				}
			}));
		},
		GetQueryTipHtml: function(Data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				var customerName = (!ss.isNullOrEmptyString(Data.customerName) ? Data.customerName : '全部');
				this.WriteLiteralTo(__razor_helper_writer, '    <div>\r\n        <!--门店：-->\r\n        <span id="lblCustomerName">');
				this.WriteTo(__razor_helper_writer, customerName);
				this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n        <span id="lblStoreName">');
				this.WriteTo(__razor_helper_writer, Data.storeName);
				this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n        <br>\r\n\r\n        <span id="lblQueryDate">\r\n            <span id="lblBeginDate">');
				this.WriteTo(__razor_helper_writer, Data.fromDate);
				this.WriteLiteralTo(__razor_helper_writer, '</span> ~\r\n            <span id="lblEndDate">');
				this.WriteTo(__razor_helper_writer, Data.toDate);
				this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n        </span>\r\n    </div>\r\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="RetailInputProductSaleStatistics">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">产品销售统计</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div id="retail_productSaleStatistics_information" class="infoPanel tipInfo">\n        </div>\n        <ul id="ulRetailInputProductSaleStatisticsContainer"></ul>\n    </div>\n\n\n</div>\n');
			this.WriteLiteral('\r\n\r\n');
			this.WriteLiteral('\r\n\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.retail_productSaleStatistics_information = this.pageObject.find('#retail_productSaleStatistics_information');
			this.ulRetailInputProductSaleStatisticsContainer = this.pageObject.find('#ulRetailInputProductSaleStatisticsContainer');
			this.lblCustomerName = this.pageObject.find('#lblCustomerName');
			this.lblStoreName = this.pageObject.find('#lblStoreName');
			this.lblQueryDate = this.pageObject.find('#lblQueryDate');
			this.lblBeginDate = this.pageObject.find('#lblBeginDate');
			this.lblEndDate = this.pageObject.find('#lblEndDate');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.retail_productSaleStatistics_information)) {
				this.retail_productSaleStatistics_information.unbind().off();
				this.retail_productSaleStatistics_information = null;
			}
			if (ss.isValue(this.ulRetailInputProductSaleStatisticsContainer)) {
				this.ulRetailInputProductSaleStatisticsContainer.unbind().off();
				this.ulRetailInputProductSaleStatisticsContainer = null;
			}
			if (ss.isValue(this.lblCustomerName)) {
				this.lblCustomerName.unbind().off();
				this.lblCustomerName = null;
			}
			if (ss.isValue(this.lblStoreName)) {
				this.lblStoreName.unbind().off();
				this.lblStoreName = null;
			}
			if (ss.isValue(this.lblQueryDate)) {
				this.lblQueryDate.unbind().off();
				this.lblQueryDate = null;
			}
			if (ss.isValue(this.lblBeginDate)) {
				this.lblBeginDate.unbind().off();
				this.lblBeginDate = null;
			}
			if (ss.isValue(this.lblEndDate)) {
				this.lblEndDate.unbind().off();
				this.lblEndDate = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Retail_RetailInputProductSaleStatistics$StatisticsData, $asm, {});
	ss.initClass($USOProject_Pages_Retail_RetailInputQuery, $asm, {
		$RetailInputQuery_OnPageInit: function(sender, e) {
			var $state = 0, $t1, result;
			var $sm = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							JSLib.Widget.Common.DateTimeSelector.BindTo(this.retail_search_date_beginDate[0]);
							JSLib.Widget.Common.DateTimeSelector.BindTo(this.retail_search_date_endDate[0]);
							//加载现有条件
							{
								if (this.PageQueryCondition.IsReturnOrder) {
									this.retail_sel_salestype.val('2');
								}
								if (!ss.isNullOrEmptyString(this.PageQueryCondition.OrderType)) {
									this.retail_sel_orderytype.val(this.PageQueryCondition.OrderType);
								}
								if (!ss.isNullOrEmptyString(this.PageQueryCondition.SalesStatus)) {
									this.retail_sel_salesStatus.val(this.PageQueryCondition.SalesStatus);
								}
							}
							this.retail_a_dosearch.click(ss.mkdel(this, function(event) {
								this.PageQueryCondition.ClientName = this.retail_txt_clientName.val().trim();
								this.PageQueryCondition.SalesStatus = this.retail_sel_salesStatus.val().trim();
								var orderType = CoreEx.ToInt(this.retail_sel_orderytype.val().trim(), 0);
								this.PageQueryCondition.OrderType = ((orderType === -1) ? '' : orderType.toString());
								this.PageQueryCondition.ProductId = this.retail_search_txt_productId.val().trim();
								this.PageQueryCondition.CustomerStoreId = CoreEx.ToInt(this.retail_sel_customerStore.val(), 0);
								var productId = this.retail_search_txt_productId.val().trim();
								if (!ss.isNullOrEmptyString(productId) && productId !== '' && isNaN(parseInt(productId))) {
									JSLib.Mobile.MessageBox.Alert('产品编号无效');
									return;
								}
								this.PageQueryCondition.ProductId = productId;
								var fromDate = this.retail_search_date_beginDate.val().trim();
								var toDate = this.retail_search_date_endDate.val().trim();
								this.PageQueryCondition.FromDate = fromDate;
								this.PageQueryCondition.ToDate = toDate;
								var isReturnOrder = CoreEx.ToInt(this.retail_sel_salestype.val().trim(), 0) === 2;
								this.PageQueryCondition.IsReturnOrder = isReturnOrder;
								if (!ss.staticEquals(this.OnConditionComplete, null)) {
									this.OnConditionComplete(this.PageQueryCondition);
								}
								JSLib.Mobile.Application.Back(1);
							}));
							if ($USOProject_Pages_Retail_RetailInputQuery.$CurrentOrgId !== $App.app.userInfo.User.CurrentStockOrganizationId || ss.isNullOrUndefined($USOProject_Pages_Retail_RetailInputQuery.$OrgData)) {
								$USOProject_Pages_Retail_RetailInputQuery.$CurrentOrgId = $App.app.userInfo.User.CurrentStockOrganizationId;
								//准备门店数据
								$t1 = $USOProject_Business_BusinessAction.GetCustomerStoreAction();
								$state = 1;
								$t1.continueWith($sm);
								return;
							}
							else {
								this.retail_sel_customerStore.html(this.GetOptionListHtml($USOProject_Pages_Retail_RetailInputQuery.$OrgData).toString());
								this.$UpdateStoreSelect();
								$state = -1;
								break $sm1;
							}
						}
						case 1: {
							$state = -1;
							result = $t1.getAwaitedResult();
							if (result.IsSuccess) {
								$USOProject_Pages_Retail_RetailInputQuery.$OrgData = result.Result;
								this.retail_sel_customerStore.html(this.GetOptionListHtml($USOProject_Pages_Retail_RetailInputQuery.$OrgData).toString());
								this.$UpdateStoreSelect();
							}
							$state = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm();
		},
		$UpdateStoreSelect: function() {
			if (ss.isValue(this.PageQueryCondition.CustomerStoreId) && Enumerable.from($USOProject_Pages_Retail_RetailInputQuery.$OrgData).any(ss.mkdel(this, function(n) {
				return n.CustomerStoreId === this.PageQueryCondition.CustomerUserId;
			}))) {
				this.retail_sel_customerStore.val(this.PageQueryCondition.CustomerStoreId.toString());
			}
		},
		PrepareData: function() {
			var $state = 0, $tcs = new ss.TaskCompletionSource();
			var $sm = ss.mkdel(this, function() {
				try {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								this.PageQueryCondition = this.InitialData;
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
					$tcs.setResult(null);
				}
				catch ($t1) {
					$tcs.setException(ss.Exception.wrap($t1));
				}
			});
			$sm();
			return $tcs.task;
		},
		GetOptionListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isValue(data) && data.length > 0) {
					for (var $t1 = 0; $t1 < data.length; $t1++) {
						var item = data[$t1];
						this.WriteLiteralTo(__razor_helper_writer, '            <option value="');
						this.WriteTo(__razor_helper_writer, item.CustomerStoreId);
						this.WriteLiteralTo(__razor_helper_writer, '">');
						this.WriteTo(__razor_helper_writer, item.CustomerStoreName);
						this.WriteLiteralTo(__razor_helper_writer, '</option>\r\n');
					}
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="RetailInputQuery">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">零售录入查询</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="inputPanel">\n            <!--<input id="retail_txt_legalName" class="" type="search" placeholder="法人名称">-->\n            <div class="InputItem">\n                <div class="title">顾客姓名:</div>\n                <div class="inputWarp">\n                    <input id="retail_txt_clientName" type="text" placeholder="顾客姓名" class="" value="');
			this.Write(this.PageQueryCondition.ClientName);
			this.WriteLiteral('">\n                </div>\n            </div>\n\n            <div class="InputItem">\n                <div class="title">产品系统编号:</div>\n                <div class="inputWarp">\n                    <input id="retail_search_txt_productId" type="text" placeholder="产品系统编号" class="" value="');
			this.Write(this.PageQueryCondition.ProductId);
			this.WriteLiteral('">\r\n                </div>\r\n            </div>\r\n\r\n            <div class="InputItem">\r\n                <div class="title">查询类型:</div>\r\n                <div class="inputWarp">\r\n                    <select id="retail_sel_salestype">\r\n                        <option value="1">订单</option>\r\n                        <option value="2">退货单</option>\r\n                    </select>\r\n                </div>\r\n            </div>\r\n\r\n            <div class="InputItem">\r\n                <div class="title">订单类型:</div>\r\n                <div class="inputWarp">\r\n                    <select id="retail_sel_orderytype">\r\n                        <option value="-1">所有订单</option>\r\n                        <option value="0">销售订单</option>\r\n                        <option value="1">工程订单</option>\r\n                    </select>\r\n                </div>\r\n            </div>\r\n\r\n            <div class="InputItem">\r\n                <div class="title">状态:</div>\r\n                <div class="inputWarp">\r\n                    <select id="retail_sel_salesStatus" class="">\r\n                        <option value="-1">----所有状态----</option>\r\n                        <option value="1">待处理</option>\r\n                        <option value="2">已处理</option>\r\n                        <option value="4">已审核</option>\r\n                        <option value="3">已作废</option>\r\n                    </select>\r\n                </div>\r\n            </div>\r\n\r\n            <div class="InputItem">\r\n                <div class="title">门店:</div>\r\n                <div class="inputWarp">\r\n                    <select id="retail_sel_customerStore" style="width: 100%;" class="">\r\n                        <option value="-1">----所有门店----</option>\r\n                    </select>\r\n                </div>\r\n            </div>\r\n\r\n            <div class="InputItem">\r\n                <div class="title">开始日期:</div>\r\n                <div class="inputWarp">\r\n                    <input id="retail_search_date_beginDate" type="text" placeholder="开始日期" readonly="readonly" class="" value="');
			this.Write(this.PageQueryCondition.FromDate);
			this.WriteLiteral('">\n                </div>\n            </div>\n\n            <div class="InputItem">\n                <div class="title">结束日期:</div>\n                <div class="inputWarp">\n                    <input id="retail_search_date_endDate" type="text" placeholder="结束日期" readonly="readonly" class="" value="');
			this.Write(this.PageQueryCondition.ToDate);
			this.WriteLiteral('">\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n    </div>\r\n    <div class="footer">\r\n        <div class="queryButton" id="retail_a_dosearch">\r\n            查询\r\n        </div>\r\n    </div>\r\n</div>\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.retail_txt_legalName = this.pageObject.find('#retail_txt_legalName');
			this.retail_txt_clientName = this.pageObject.find('#retail_txt_clientName');
			this.retail_search_txt_productId = this.pageObject.find('#retail_search_txt_productId');
			this.retail_sel_salestype = this.pageObject.find('#retail_sel_salestype');
			this.retail_sel_orderytype = this.pageObject.find('#retail_sel_orderytype');
			this.retail_sel_salesStatus = this.pageObject.find('#retail_sel_salesStatus');
			this.retail_sel_customerStore = this.pageObject.find('#retail_sel_customerStore');
			this.retail_search_date_beginDate = this.pageObject.find('#retail_search_date_beginDate');
			this.retail_search_date_endDate = this.pageObject.find('#retail_search_date_endDate');
			this.retail_a_dosearch = this.pageObject.find('#retail_a_dosearch');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.retail_txt_legalName)) {
				this.retail_txt_legalName.unbind().off();
				this.retail_txt_legalName = null;
			}
			if (ss.isValue(this.retail_txt_clientName)) {
				this.retail_txt_clientName.unbind().off();
				this.retail_txt_clientName = null;
			}
			if (ss.isValue(this.retail_search_txt_productId)) {
				this.retail_search_txt_productId.unbind().off();
				this.retail_search_txt_productId = null;
			}
			if (ss.isValue(this.retail_sel_salestype)) {
				this.retail_sel_salestype.unbind().off();
				this.retail_sel_salestype = null;
			}
			if (ss.isValue(this.retail_sel_orderytype)) {
				this.retail_sel_orderytype.unbind().off();
				this.retail_sel_orderytype = null;
			}
			if (ss.isValue(this.retail_sel_salesStatus)) {
				this.retail_sel_salesStatus.unbind().off();
				this.retail_sel_salesStatus = null;
			}
			if (ss.isValue(this.retail_sel_customerStore)) {
				this.retail_sel_customerStore.unbind().off();
				this.retail_sel_customerStore = null;
			}
			if (ss.isValue(this.retail_search_date_beginDate)) {
				this.retail_search_date_beginDate.unbind().off();
				this.retail_search_date_beginDate = null;
			}
			if (ss.isValue(this.retail_search_date_endDate)) {
				this.retail_search_date_endDate.unbind().off();
				this.retail_search_date_endDate = null;
			}
			if (ss.isValue(this.retail_a_dosearch)) {
				this.retail_a_dosearch.unbind().off();
				this.retail_a_dosearch = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Retail_RetailInputQuery$QueryCondition, $asm, {});
	ss.initClass($USOProject_Pages_Retail_Add_AddFeeItem, $asm, {
		$AddFeeItem_OnPageInit: function(sender, e) {
			var $state = 0, $t1, feeResult, $t2;
			var $sm = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							this.SetScrollable(this.pnlContent[0], false, true, false, null, null, null, '', false, null, true, true);
							if (ss.isNullOrUndefined($USOProject_Pages_Retail_Add_AddFeeItem.FeeList)) {
								$t1 = $USOProject_Business_BusinessAction.GetFeeList(this, true);
								$state = 2;
								$t1.continueWith($sm);
								return;
							}
							$state = 1;
							continue $sm1;
						}
						case 2: {
							$state = -1;
							feeResult = $t1.getAwaitedResult();
							if (!feeResult.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(feeResult.ErrorMessage);
								$t2 = ss.Task.delay(500);
								$state = 4;
								$t2.continueWith($sm);
								return;
							}
							$state = 3;
							continue $sm1;
						}
						case 1: {
							$state = -1;
							this.btnOK.click(ss.mkdel(this, function(event) {
								var typeId = CoreEx.ToIntNullable(this.retail_feelist_feedata.val());
								var typeName = jQueryObjectEx.GetSelectedText(this.retail_feelist_feedata);
								var amount = CoreEx.ToDouble(this.retail_feelist_amount.val());
								if (isNaN(amount)) {
									JSLib.Mobile.MessageBox.Alert('请输入正确的金额!');
									return;
								}
								var memo = this.retail_feelist_remark.val();
								if (amount > 0) {
									var data = { FeeCode: typeId, FeeName: typeName, Amount: amount, Memo: memo };
									if (!ss.staticEquals(this.OnFinished, null)) {
										this.OnFinished(data);
									}
								}
								else {
									JSLib.Mobile.MessageBox.Alert('金额必须大于0');
								}
							}));
							$state = -1;
							break $sm1;
						}
						case 4: {
							$state = -1;
							$t2.getAwaitedResult();
							JSLib.Mobile.Application.Back(1);
							$state = 3;
							continue $sm1;
						}
						case 3: {
							$state = -1;
							this.retail_feelist_feedata.html(this.GetFeeListHtml(feeResult.Result).toString());
							$state = 1;
							continue $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm();
		},
		GetFeeListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <option value="');
					this.WriteTo(__razor_helper_writer, item.FeeCode);
					this.WriteLiteralTo(__razor_helper_writer, '" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(item));
					this.WriteLiteralTo(__razor_helper_writer, '>');
					this.WriteTo(__razor_helper_writer, item.FeeName);
					this.WriteLiteralTo(__razor_helper_writer, '</option>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="AddFeeItem">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">添加优惠券</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="inputPanel">\n            <div class="InputItem">\n                <div class="title">\n                    费用类型\n                </div>\n                <div class="inputWarp">\n                    <select id="retail_feelist_feedata" name="feedata" class=""></select>\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">\n                    金额\n                </div>\n                <div class="inputWarp">\n                    <input id="retail_feelist_amount" data-modal-number placeholder="请输入金额" type="text" class="">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">\n                    备注\n                </div>\n                <div class="inputWarp">\n                    <input id="retail_feelist_remark" placeholder="请输入备注" type="search" class="">\n                </div>\n            </div>\n        </div>\n    </div>\n    <div id="btnOK" class="redButton">\n        确定\n    </div>\n</div>\n\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.retail_feelist_feedata = this.pageObject.find('#retail_feelist_feedata');
			this.retail_feelist_amount = this.pageObject.find('#retail_feelist_amount');
			this.retail_feelist_remark = this.pageObject.find('#retail_feelist_remark');
			this.btnOK = this.pageObject.find('#btnOK');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.retail_feelist_feedata)) {
				this.retail_feelist_feedata.unbind().off();
				this.retail_feelist_feedata = null;
			}
			if (ss.isValue(this.retail_feelist_amount)) {
				this.retail_feelist_amount.unbind().off();
				this.retail_feelist_amount = null;
			}
			if (ss.isValue(this.retail_feelist_remark)) {
				this.retail_feelist_remark.unbind().off();
				this.retail_feelist_remark = null;
			}
			if (ss.isValue(this.btnOK)) {
				this.btnOK.unbind().off();
				this.btnOK = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Retail_Add_ChooseProductDetail, $asm, {
		$ChooseProductDetail_OnPageInit: function(sender, e) {
			var $state = 0, pageScroller, $t1, result;
			var $sm = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							if (this.PageData.JYBOrgAndCustomerId.length <= 1) {
								jQueryObjectEx.SetEnable(this.retailInput_orgList, false);
							}
							this.$product.Fees = [];
							pageScroller = this.SetScrollable(this.pnlContent[0], true, true, false, null, null, null, '', false, null, true, true);
							this.retailInput_addGiftCardItem.click(ss.mkdel(this, function(event) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_Add_AddFeeItem).call(null, null, ss.mkdel(this, function(page) {
									page.OnFinished = ss.mkdel(this, function(dto) {
										var feeCode = dto.FeeCode;
										if (Enumerable.from(this.$product.Fees).any(function(n) {
											return ss.referenceEquals(n.FeeCode, feeCode);
										})) {
											JSLib.Mobile.MessageBox.Alert('已存在此类型的费用!');
											return;
										}
										JSLib.Mobile.Application.Back(1);
										this.$product.Fees.push(dto);
										this.pnlFeeItems.append(this.GetFeeItemHtml(dto).toString());
										this.$UpdateFeeInfo();
										pageScroller.iscroll.refresh();
										pageScroller.iscroll.scrollTo(0, pageScroller.iscroll.maxScrollY);
									});
								}));
							}));
							//执行删除费用操作
							this.pnlFeeItems.on('click', 'img[data_delete_code]', ss.thisFix(ss.mkdel(this, function(elem, event1) {
								var feeCode1 = CoreEx.ToInt(elem.getAttribute('data_delete_code'), 0);
								ss.remove(this.$product.Fees, Enumerable.from(this.$product.Fees).first(function(n1) {
									return n1.FeeCode === feeCode1;
								}));
								jQueryObjectEx.ParentUntil($(elem), '.feeitem').remove();
								this.$UpdateFeeInfo();
								this.pnlFeeItems.find(ss.formatString(".feeitem[data-code='{0}']", feeCode1));
							})));
							this.btnOK.click(ss.mkdel(this, function(event2) {
								//产品数量 产品价格赋值
								var quantity = CoreEx.ToInt(this.input_retail_productdetail_quantity.val(), 0);
								var price = CoreEx.ToDoubleNullable(this.input_retail_productdetail_price.val());
								//提成金额赋值
								var CommissionAmount = CoreEx.ToDoubleWithDefault(this.input_retail_productdetail_commAmount.val(), 0);
								//安装方式 网络环境赋值
								var SetupTypeCode = this.select_retail_productdetail_smode.val();
								var HomeNetWorkCode = this.select_retail_productdetail_nwtype.val();
								//购机日期 产品备注赋值
								var PurchaseDate = this.input_retail_productdetail_saledate.val();
								var Memo = this.input_retail_productdetail_memo.val();
								if (quantity <= 0) {
									JSLib.Mobile.MessageBox.Alert('产品数量必须大于0!');
									return;
								}
								//if (quantity > PageData.StoreQuantity)
								//{
								//    MessageBox.Alert(PageData.ProductName + "产品数量不能超出库存!");
								//    return;
								//}
								if (quantity > 99999) {
									JSLib.Mobile.MessageBox.Alert('产品数量超过最大值');
									return;
								}
								if (ss.isNullOrUndefined(price) || ss.unbox(price) <= 0) {
									JSLib.Mobile.MessageBox.Alert('请输入正确的零售价格!');
									return;
								}
								if (ss.isValue(this.$RedLinePrice) && !ss.referenceEquals(this.$RedLinePrice, 0)) {
									if (ss.Nullable$1.gt(ss.Nullable$1.mul(price, 100), ss.unbox(this.$RedLinePrice) * 100 * $App.app.config.AllowPriceUpValue)) {
										JSLib.Mobile.MessageBox.Alert(this.PageData.ProductName + '售价异常超高，无法保存！');
										return;
									}
								}
								else if (ss.Nullable$1.gt(price, $App.app.config.SaleOrderMaxPrice)) {
									JSLib.Mobile.MessageBox.Alert('零售价格不能大于' + $App.app.config.SaleOrderMaxPrice);
									return;
								}
								if (ss.Nullable$1.lt(price, $App.app.config.SaleOrderMinPrice)) {
									JSLib.Mobile.MessageBox.Alert('零售价格不能低于' + $App.app.config.SaleOrderMinPrice);
									return;
								}
								if (!$App.IsProjectOrder && quantity > $App.app.config.SaleOrderMaxValue) {
									JSLib.Mobile.MessageBox.Alert('非工程单据单品数量不可超过' + $App.app.config.SaleOrderMaxValue + '台');
									return;
								}
								if (!ss.isNullOrEmptyString(this.input_retail_productdetail_commAmount.val())) {
									if (isNaN(CommissionAmount)) {
										JSLib.Mobile.MessageBox.Alert(this.PageData.ProductName + '提成金额必须为数字类型!');
										return;
									}
									if (CommissionAmount < 0) {
										JSLib.Mobile.MessageBox.Alert(this.PageData.ProductName + '提成金额不能小于0!');
										return;
									}
									if (ss.Nullable$1.gt(CommissionAmount, price)) {
										JSLib.Mobile.MessageBox.Alert(this.PageData.ProductName + '提成金额不能超过零售价格!');
										return;
									}
								}
								this.$product.Quantity = quantity;
								this.$product.Price = price;
								this.$product.CommissionAmount = CommissionAmount;
								this.$product.SetupTypeCode = CoreEx.ToIntNullable(SetupTypeCode);
								this.$product.HomeNetWorkCode = CoreEx.ToIntNullable(HomeNetWorkCode);
								this.$product.PurchaseDate = PurchaseDate;
								this.$product.Memo = Memo;
								this.$product.ProductId = this.PageData.Id;
								this.$product.ProductName = this.PageData.ProductName;
								this.$product.OrganizationId = CoreEx.ToInt(this.retailInput_orgList.val(), 0);
								var selectedOption = this.retailInput_orgList.find('option:checked');
								this.$product.CustomerLegalId = UIDataEx.GetBindData$1(Object).call(null, selectedOption).CustomerLegalId;
								this.$product.MoreProduct = -1;
								if (!ss.staticEquals(this.OnProductSave, null)) {
									this.OnProductSave(this.$product);
								}
							}));
							$t1 = $USOProject_Business_BusinessAction.GetInternalAccountPriceForApp(ss.unbox(this.PageData.Id), CoreEx.ToInt(this.retailInput_orgList.val(), 0), 11, this.PageData.CustomerLegalId, this, true);
							$state = 1;
							$t1.continueWith($sm);
							return;
						}
						case 1: {
							$state = -1;
							result = $t1.getAwaitedResult();
							if (!result.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
								return;
							}
							else {
								this.$RedLinePrice = result.Result.Result;
								//NOTE：不能显示内核价
								//span_retail_productdetail_innerprice.Text(RedLinePrice.As<string>());
							}
							$state = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm();
		},
		$UpdateFeeInfo: function() {
			var sumAmountValue = Enumerable.from(this.$product.Fees).sum(function(n) {
				return ss.unbox(n.Amount);
			});
			if (sumAmountValue > 0) {
				this.lblFeeAmount.text(ss.formatString(' (合计金额:￥{0}元)', sumAmountValue.toFixed(2)));
			}
			else {
				this.lblFeeAmount.text('');
			}
			this.RefreshPageScroll();
		},
		PrepareData: function() {
			this.PageData = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		GetFeeItemHtml: function(item) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <li class="feeitem" data-code="');
				this.WriteTo(__razor_helper_writer, item.FeeCode);
				this.WriteLiteralTo(__razor_helper_writer, '">\r\n        <span>');
				this.WriteTo(__razor_helper_writer, item.FeeName);
				this.WriteLiteralTo(__razor_helper_writer, '  ');
				this.WriteTo(__razor_helper_writer, ss.unbox(item.Amount).toFixed(2));
				this.WriteLiteralTo(__razor_helper_writer, ' 元 </span>\r\n        <img class="deleteIcon" data_delete_code="');
				this.WriteTo(__razor_helper_writer, item.FeeCode);
				this.WriteLiteralTo(__razor_helper_writer, '" src="./img/log_delete.png">\r\n    </li>\r\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="ChooseProductDetail">\r\n    <div class="head">\r\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\r\n        <div id="lblHeadText" class="headText">添加产品详情</div>\r\n    </div>\r\n    <div class="content" id="pnlContent">\r\n        <div class="div_work">\r\n            <div class="div_work_content tipInfo">\r\n                <div>\r\n                    <div class="work_title">\r\n                        <span id="span_retail_productdetail_pid">');
			this.Write(this.PageData.Id);
			this.WriteLiteral('</span>\r\n                        <span id="span_retail_productdetail_pname">');
			this.Write(this.PageData.ProductName);
			this.WriteLiteral('</span>\r\n                        <span id="span_retail_productdetail_innerprice"></span>\r\n                    </div>\r\n                    <div class="work_time">\r\n                        产品库存:\r\n                        <span id="span_retail_productdetail_quantity">');
			this.Write(this.PageData.RealStock);
			this.WriteLiteral('</span>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n        <div id="divRetailProductDetail" class="submit_all">\r\n            <div class="inputPanel">\r\n                <div class="inputItem">\r\n                    <div class="title">选择经营部:</div>\r\n                    <div class="inputWarp">\r\n                        <select id="retailInput_orgList">\r\n');
			for (var $t1 = 0; $t1 < this.PageData.JYBOrgAndCustomerId.length; $t1++) {
				var item = this.PageData.JYBOrgAndCustomerId[$t1];
				this.WriteLiteral('                                <option value="');
				this.Write(item.OrganizationId);
				this.WriteLiteral('" ');
				this.Write(this.DataBind(item));
				this.WriteLiteral('>\r\n                                    ');
				this.Write(item.OrganizationName);
				this.WriteLiteral('\r\n                                </option>\r\n');
			}
			this.WriteLiteral('                        </select>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class="InputItem">\r\n                    <div class="title">产品数量:</div>\r\n                    <div class="inputWarp">\r\n                        <input id="input_retail_productdetail_quantity" data-modal-number="" type="text" value="" placeholder="请录入商品数量" class="">\r\n                    </div>\r\n                </div>\r\n\r\n                <div class="InputItem">\r\n                    <div class="title">零售价格:</div>\r\n                    <div class="inputWarp">\r\n                        <input id="input_retail_productdetail_price" data-modal-number="" type="text" placeholder="请录入商品价格" class="">\r\n                    </div>\r\n                </div>\r\n\r\n                <div class="InputItem">\r\n                    <div class="title">提成金额:</div>\r\n                    <div class="inputWarp">\r\n                        <input id="input_retail_productdetail_commAmount" data-modal-number="" type="text" placeholder="请录入提成金额" class="">\r\n                    </div>\r\n                </div>\r\n                <div class="InputItem">\r\n                    <div class="title">安装方式:</div>\r\n                    <div class="inputWarp">\r\n                        <select id="select_retail_productdetail_smode" class="">\r\n');
			for (var $t2 = 0; $t2 < $App.SetupTypes.length; $t2++) {
				var item1 = $App.SetupTypes[$t2];
				this.WriteLiteral('                                <option value="');
				this.Write(item1.Value);
				this.WriteLiteral('">');
				this.Write(item1.Name);
				this.WriteLiteral('</option>\r\n');
			}
			this.WriteLiteral('                        </select>\r\n                    </div>\r\n                </div>\r\n                <div class="InputItem">\r\n                    <div class="title">网络环境:</div>\r\n                    <div class="inputWarp">\r\n                        <select id="select_retail_productdetail_nwtype">\r\n');
			for (var $t3 = 0; $t3 < $App.NetWorkTypes.length; $t3++) {
				var item2 = $App.NetWorkTypes[$t3];
				this.WriteLiteral('                                <option value="');
				this.Write(item2.Value);
				this.WriteLiteral('">');
				this.Write(item2.Name);
				this.WriteLiteral('</option>\r\n');
			}
			this.WriteLiteral('                        </select>\r\n                    </div>\r\n                </div>\r\n                <div class="InputItem">\r\n                    <div class="title">购机日期:</div>\r\n                    <div class="inputWarp">\r\n');
			var curDateStr = ss.formatDate(new Date(), 'yyyy-MM-dd');
			this.WriteLiteral('                        <input id="input_retail_productdetail_saledate" type="text" placeholder="购机日期" readonly="readonly" class="" value="');
			this.Write(curDateStr);
			this.WriteLiteral('">\r\n                    </div>\r\n                </div>\r\n                <div class="InputItem">\r\n                    <div class="title">产品备注:</div>\r\n                    <div class="inputWarp">\r\n                        <input id="input_retail_productdetail_memo" data-modal="" type="text" placeholder="请录入备注信息" class="">\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n        <div id="retailInput_addGiftCardItem" class="nbutton endnavIcon buttonEndNavIcon">\r\n            添加费用<span id="lblFeeAmount"></span>\r\n        </div>\r\n        <ul class="list inset" id="pnlFeeItems"></ul>\r\n    </div>\r\n    <div id="btnOK" class="redButton">\r\n        提交产品\r\n    </div>\r\n\r\n</div>\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.span_retail_productdetail_pid = this.pageObject.find('#span_retail_productdetail_pid');
			this.span_retail_productdetail_pname = this.pageObject.find('#span_retail_productdetail_pname');
			this.span_retail_productdetail_innerprice = this.pageObject.find('#span_retail_productdetail_innerprice');
			this.span_retail_productdetail_quantity = this.pageObject.find('#span_retail_productdetail_quantity');
			this.divRetailProductDetail = this.pageObject.find('#divRetailProductDetail');
			this.retailInput_orgList = this.pageObject.find('#retailInput_orgList');
			this.input_retail_productdetail_quantity = this.pageObject.find('#input_retail_productdetail_quantity');
			this.input_retail_productdetail_price = this.pageObject.find('#input_retail_productdetail_price');
			this.input_retail_productdetail_commAmount = this.pageObject.find('#input_retail_productdetail_commAmount');
			this.select_retail_productdetail_smode = this.pageObject.find('#select_retail_productdetail_smode');
			this.select_retail_productdetail_nwtype = this.pageObject.find('#select_retail_productdetail_nwtype');
			this.input_retail_productdetail_saledate = this.pageObject.find('#input_retail_productdetail_saledate');
			this.input_retail_productdetail_memo = this.pageObject.find('#input_retail_productdetail_memo');
			this.retailInput_addGiftCardItem = this.pageObject.find('#retailInput_addGiftCardItem');
			this.lblFeeAmount = this.pageObject.find('#lblFeeAmount');
			this.pnlFeeItems = this.pageObject.find('#pnlFeeItems');
			this.btnOK = this.pageObject.find('#btnOK');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.span_retail_productdetail_pid)) {
				this.span_retail_productdetail_pid.unbind().off();
				this.span_retail_productdetail_pid = null;
			}
			if (ss.isValue(this.span_retail_productdetail_pname)) {
				this.span_retail_productdetail_pname.unbind().off();
				this.span_retail_productdetail_pname = null;
			}
			if (ss.isValue(this.span_retail_productdetail_innerprice)) {
				this.span_retail_productdetail_innerprice.unbind().off();
				this.span_retail_productdetail_innerprice = null;
			}
			if (ss.isValue(this.span_retail_productdetail_quantity)) {
				this.span_retail_productdetail_quantity.unbind().off();
				this.span_retail_productdetail_quantity = null;
			}
			if (ss.isValue(this.divRetailProductDetail)) {
				this.divRetailProductDetail.unbind().off();
				this.divRetailProductDetail = null;
			}
			if (ss.isValue(this.retailInput_orgList)) {
				this.retailInput_orgList.unbind().off();
				this.retailInput_orgList = null;
			}
			if (ss.isValue(this.input_retail_productdetail_quantity)) {
				this.input_retail_productdetail_quantity.unbind().off();
				this.input_retail_productdetail_quantity = null;
			}
			if (ss.isValue(this.input_retail_productdetail_price)) {
				this.input_retail_productdetail_price.unbind().off();
				this.input_retail_productdetail_price = null;
			}
			if (ss.isValue(this.input_retail_productdetail_commAmount)) {
				this.input_retail_productdetail_commAmount.unbind().off();
				this.input_retail_productdetail_commAmount = null;
			}
			if (ss.isValue(this.select_retail_productdetail_smode)) {
				this.select_retail_productdetail_smode.unbind().off();
				this.select_retail_productdetail_smode = null;
			}
			if (ss.isValue(this.select_retail_productdetail_nwtype)) {
				this.select_retail_productdetail_nwtype.unbind().off();
				this.select_retail_productdetail_nwtype = null;
			}
			if (ss.isValue(this.input_retail_productdetail_saledate)) {
				this.input_retail_productdetail_saledate.unbind().off();
				this.input_retail_productdetail_saledate = null;
			}
			if (ss.isValue(this.input_retail_productdetail_memo)) {
				this.input_retail_productdetail_memo.unbind().off();
				this.input_retail_productdetail_memo = null;
			}
			if (ss.isValue(this.retailInput_addGiftCardItem)) {
				this.retailInput_addGiftCardItem.unbind().off();
				this.retailInput_addGiftCardItem = null;
			}
			if (ss.isValue(this.lblFeeAmount)) {
				this.lblFeeAmount.unbind().off();
				this.lblFeeAmount = null;
			}
			if (ss.isValue(this.pnlFeeItems)) {
				this.pnlFeeItems.unbind().off();
				this.pnlFeeItems = null;
			}
			if (ss.isValue(this.btnOK)) {
				this.btnOK.unbind().off();
				this.btnOK = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Retail_Add_ChooseProductList, $asm, {
		$ChooseProductList_OnPageInit: function(sender, e) {
			this.$ParamData = this.InitialData;
			var query = {};
			query.Page = 1;
			query.PageSize = 20;
			//query.CSId=this.ParamData.CustomerStoreId;
			query.CustomerLegalOrgList = this.$ParamData.CustomerLegalOrgList;
			query.CustomerStoreId = this.$ParamData.CustomerStoreId;
			var iscrollList = this.SetIscrollList(this.divRetailProductListContainer[0], 20, 100, true, false, true);
			iscrollList.set_GetPageData(ss.mkdel(this, function(index) {
				var $state = 0, $tcs = new ss.TaskCompletionSource(), $t1, data, dataList, $t2;
				var $sm = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									query.Page = index;
									$t1 = $USOProject_Business_BusinessAction.RetailInputProductListAction(query, this);
									$state = 1;
									$t1.continueWith($sm);
									return;
								}
								case 1: {
									$state = -1;
									data = $t1.getAwaitedResult();
									dataList = data.Result;
									$t2 = new JSLib.IScrollWraper.PageData();
									$t2.PageIndex = index;
									$t2.RecordCount = dataList.length;
									$t2.ResultElement = jQueryObjectEx.ToJqueryObject$1(this.GetProductListHtml(dataList));
									$tcs.setResult($t2);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t3) {
						$tcs.setException(ss.Exception.wrap($t3));
					}
				});
				$sm();
				return $tcs.task;
			}));
			iscrollList.ReLoad();
			this.retail_productlist_searchbutton.click(ss.thisFix(ss.mkdel(this, function(ele, event) {
				var keyWord = this.retail_productlist_searchinput.val().trim();
				query.KeyWord = keyWord;
				iscrollList.ReLoad();
			})));
			this.pnlContent.on('click', 'div[data-productid]', ss.thisFix(ss.mkdel(this, function(elem, event1) {
				var dataItem = UIDataEx.GetBindData$1(Object).call(null, $(elem));
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_Add_ChooseProductDetail).call(null, dataItem, ss.mkdel(this, function(page) {
					page.OnProductSave = ss.mkdel(this, function(dto) {
						if (!ss.staticEquals(this.OnProductChoosed, null)) {
							this.OnProductChoosed(dto);
						}
					});
				}));
			})));
		},
		GetProductListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || data.length === 0) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">暂无数据</div>\n');
					return;
				}
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="div_work endnavIcon div_work_content" data-productid="');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '" ');
					this.WriteTo(__razor_helper_writer, this.DataBind(item));
					this.WriteLiteralTo(__razor_helper_writer, '>\n            <div class="work_title">');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '&nbsp;');
					this.WriteTo(__razor_helper_writer, item.ProductName);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\n            <div class="work_time">\n                产品库存:\n                <span>');
					this.WriteTo(__razor_helper_writer, item.RealStock);
					this.WriteLiteralTo(__razor_helper_writer, '</span>\n            </div>\n        </div>\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="ChooseProductList">\r\n    <div class="head">\r\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\r\n        <div id="lblHeadText" class="headText">零售录入产品选择</div>\r\n    </div>\r\n    <div class="content" id="pnlContent">\r\n        <div id="retail_productlist_searcharea">\r\n            <input id="retail_productlist_searchinput" type="search" value="" placeholder="编号/名称模糊查询">\r\n            <a id="retail_productlist_searchbutton" class="">查询</a>\r\n        </div>\r\n\r\n        <div id="divRetailProductListContainer">\r\n\r\n        </div>\r\n    </div>\r\n</div>\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.retail_productlist_searcharea = this.pageObject.find('#retail_productlist_searcharea');
			this.retail_productlist_searchinput = this.pageObject.find('#retail_productlist_searchinput');
			this.retail_productlist_searchbutton = this.pageObject.find('#retail_productlist_searchbutton');
			this.divRetailProductListContainer = this.pageObject.find('#divRetailProductListContainer');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.retail_productlist_searcharea)) {
				this.retail_productlist_searcharea.unbind().off();
				this.retail_productlist_searcharea = null;
			}
			if (ss.isValue(this.retail_productlist_searchinput)) {
				this.retail_productlist_searchinput.unbind().off();
				this.retail_productlist_searchinput = null;
			}
			if (ss.isValue(this.retail_productlist_searchbutton)) {
				this.retail_productlist_searchbutton.unbind().off();
				this.retail_productlist_searchbutton = null;
			}
			if (ss.isValue(this.divRetailProductListContainer)) {
				this.divRetailProductListContainer.unbind().off();
				this.divRetailProductListContainer = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Retail_Add_RetailInputAdd, $asm, {
		get_CanEdit: function() {
			if (ss.isNullOrUndefined(this.InData.CreateOn)) {
				return true;
			}
			//判断是否超过可修改日期
			//创建时间+过期分钟数 > 当前时间
			var isInEditTimeSpan = true;
			isInEditTimeSpan = new Date(DateTimeEx.ToDateTimeForce(this.InData.CreateOn).valueOf() + Math.round($App.app.config.RetailInputEditTime * 60000)) > $App.GetCurrentServerDate();
			return isInEditTimeSpan;
		},
		get_IsWithPageParam: function() {
			return ss.isValue(this.InitialData);
		},
		$IsSelf: function() {
			return this.InData.CreateBy === $App.app.userInfo.User.Id;
		},
		$IsInAllowEditTimePeriod: function() {
			return $App.GetCurrentServerDate() < new Date(DateTimeEx.ToDateTimeForce(this.InData.CreateOn).valueOf() + Math.round($App.app.config.RetailInputEditTime * 60000));
		},
		$IsInAllowBlankoutTimePeriod: function() {
			return $App.GetCurrentServerDate() < new Date(DateTimeEx.ToDateTimeForce(this.InData.CreateOn).valueOf() + Math.round($App.app.config.RetailInputBlankOutTime * 60000));
		},
		$IsInAllowReturnTimePeroid: function() {
			return $App.GetCurrentServerDate() <= new Date(DateTimeEx.ToDateTimeForce(this.InData.CreateOn).valueOf() + Math.round($App.app.config.RetailInputReturnTime * 60000));
		},
		UpdateState: function() {
			if (this.PageState === 1) {
				this.pnlContent.addClass('readonly');
			}
			else {
				this.pnlContent.removeClass('readonly');
			}
			var isSelf = this.$IsSelf();
			jQueryObjectEx.SetVisible(this.btnSave, this.PageState === 2 || this.PageState === 3);
			var isCanModify = (this.InData.SalesStatus === 1 || this.InData.SalesStatus === 2 || this.InData.SalesStatus === 0) && isSelf && this.$IsInAllowEditTimePeriod();
			var canModifyInState = this.PageState === 1 && isCanModify;
			jQueryObjectEx.SetVisible(this.btnModify, canModifyInState);
			jQueryObjectEx.SetVisible(this.btn_retailInput_return, !isCanModify && (this.PageState === 1 || this.PageState === 3) && isSelf && this.$IsInAllowReturnTimePeroid());
			jQueryObjectEx.SetVisible(this.btn_retailInput_delete, isSelf && this.InData.SalesStatus !== 3 && this.$IsInAllowBlankoutTimePeriod());
			var editcontrolEnable = jQueryObjectEx.IsVisible(this.btnSave);
			jQueryObjectEx.SetEnable(this.retailInput_ShopList, editcontrolEnable);
			jQueryObjectEx.SetEnable(this.retailInput_OrderType, editcontrolEnable);
			jQueryObjectEx.SetEnable(this.retailInput_customerName, editcontrolEnable);
			jQueryObjectEx.SetEnable(this.retailInput_Sex, editcontrolEnable);
			jQueryObjectEx.SetEnable(this.retailInput_purchaseDate, editcontrolEnable);
			jQueryObjectEx.SetEnable(this.retailInput_teleNum, editcontrolEnable);
			jQueryObjectEx.SetEnable(this.retailInput_fixedLineTelephone, editcontrolEnable);
			jQueryObjectEx.SetEnable(this.retailInput_chooseAreaButton, editcontrolEnable);
			jQueryObjectEx.SetEnable(this.retailInput_address, editcontrolEnable);
			//有产品的情况下，不可修改门店
			if (this.PageState === 2 || this.PageState === 3) {
				if (this.InData.Items.length === 0) {
					jQueryObjectEx.SetEnable(this.retailInput_ShopList, true);
				}
				else if (this.InData.Items.length > 0) {
					jQueryObjectEx.SetEnable(this.retailInput_ShopList, false);
				}
			}
		},
		$RetailInputAdd_OnPageInit: function(sender, e) {
			this.SetScrollable(this.pnlContent[0], false, true, false, null, null, null, '', false, null, true, true);
			if (ss.isNullOrUndefined(this.InData.Items)) {
				this.InData.Items = [];
			}
			if (this.get_IsWithPageParam()) {
				this.PageState = 1;
			}
			else {
				this.PageState = 2;
			}
			this.UpdateState();
			if (ss.isValue(this.InData.CustomerStoreId)) {
				//Console.Log(InData.CustomerStoreId + "-" + InData.CustomerStoreName);
				//foreach (CustomerLegalStoreOrgDTO st in StoreData)
				//{
				//    Console.Log(st.CustomerStoreId + "/" + st.CustomerStoreName);
				//}
				if (this.$isFrozenStore(ss.unbox(this.InData.CustomerStoreId))) {
					// 可显示而不可选择
					var html = "<option selected disabled value = '" + this.InData.CustomerStoreId + "'>" + this.InData.CustomerStoreName + '</option>';
					this.retailInput_ShopList.append(html);
				}
				this.retailInput_ShopList.val(ss.unbox(this.InData.CustomerStoreId).toString());
			}
			if (!ss.isNullOrEmptyString(this.InData.Sex)) {
				this.retailInput_Sex.val(this.InData.Sex);
			}
			//选择地址
			this.retailInput_chooseAreaButton.click(ss.mkdel(this, function(event) {
				var addressDataInfo = $USOProject_Pages_Common_AddressDataInfo.$ctor();
				if (ss.isValue(this.InData.ProvinceCode)) {
					addressDataInfo = $USOProject_Pages_Common_AddressDataInfo.$ctor1(ss.unbox(this.InData.ProvinceCode), ss.unbox(this.InData.CityCode), ss.unbox(this.InData.CountyCode));
				}
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Common_AddressSelector).call(null, addressDataInfo, ss.mkdel(this, function(page) {
					page.OnAddressSelected = ss.mkdel(this, function(info) {
						addressDataInfo = info;
						this.retailInput_chooseAreaButton.val($USOProject_Pages_Common_AddressDataInfoEx.ToDisplayString(addressDataInfo));
						this.InData.ProvinceCode = info.ProvinceID;
						this.InData.CityCode = info.CityID;
						this.InData.CountyCode = info.CountyID;
					});
				}));
			}));
			//添加产品
			this.retailInput_addProductItem.click(ss.mkdel(this, function(event1) {
				if (!jQueryObjectEx.IsVisible(this.btnSave)) {
					return;
				}
				$App.IsProjectOrder = this.retailInput_OrderType.hasClass('active');
				var selectStore = UIDataEx.GetBindData$1($USOProject_Business_CustomerLegalStoreOrgDTO).call(null, this.retailInput_ShopList.find(':checked'));
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_Add_ChooseProductList).call(null, selectStore, ss.mkdel(this, function(page1) {
					page1.OnProductChoosed = ss.mkdel(this, function(dto) {
						if (Enumerable.from(this.InData.Items).any(function(n) {
							return ss.unbox(n.ProductId) === ss.unbox(dto.ProductId);
						})) {
							JSLib.Mobile.MessageBox.Alert('已添加此产品！');
							return;
						}
						this.InData.Items.push(dto);
						this.pnlProductList.append(this.GetProductListHtml(dto).toString());
						JSLib.Mobile.Application.BackTo($USOProject_Pages_Retail_Add_RetailInputAdd).call(null);
						this.RefreshPageScroll();
						// 添加产品后不可修改门店
						jQueryObjectEx.SetEnable(this.retailInput_ShopList, false);
					});
				}));
			}));
			this.retailInput_purchaseDate.click(ss.mkdel(this, function(event2) {
				var $state = 0, oriDate, oriData, $t1, $t2, result;
				var $sm = ss.mkdel(this, function() {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								oriDate = new Date();
								oriData = this.retailInput_purchaseDate.val();
								if (!ss.isNullOrEmptyString(oriData)) {
									oriDate = new Date(Date.parse(oriData));
								}
								$t1 = new JSLib.Widget.Common.DateTimeTarget();
								$t1.EnalbeClean = false;
								$t1.set_DefaultDate(oriDate);
								$t1.ShowDate = true;
								$t1.ShowTime = false;
								$t2 = JSLib.Widget.Common.DateTimeSelector.ChooseDate($t1, this.pageObject[0]);
								$state = 1;
								$t2.continueWith($sm);
								return;
							}
							case 1: {
								$state = -1;
								result = $t2.getAwaitedResult();
								if (!ss.staticEquals(result, null)) {
									this.retailInput_purchaseDate.val(ss.formatDate(ss.unbox(result), 'yyyy-MM-dd'));
								}
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				});
				$sm();
			}));
			//保存按钮
			this.btnSave.click(ss.mkdel(this, function(event3) {
				var $state1 = 0, curStoreData, purchaseDate, hasTel, errorProducts, $t4, result1;
				var $sm1 = ss.mkdel(this, function() {
					$sm1:
					for (;;) {
						switch ($state1) {
							case 0: {
								$state1 = -1;
								curStoreData = Enumerable.from(this.StoreData).first(ss.mkdel(this, function(n1) {
									return n1.CustomerStoreId === CoreEx.ToInt(this.retailInput_ShopList.val(), 0);
								}));
								//var checkStoreOrgData = retailInput_ShopList.Find(":checked").GetBindData<CustomerLegalStoreOrgDTO>();
								//InData.CustomerLegalName = checkStoreOrgData.CustomerLegalName;
								//InData.CustomerLegalId = curStoreData.CustomerLegalId;
								this.InData.CustomerStoreId = curStoreData.CustomerStoreId;
								this.InData.CustomerStoreName = curStoreData.CustomerStoreName;
								this.InData.OrderType = (this.retailInput_OrderType.hasClass('active') ? 1 : 0);
								this.InData.ClientName = this.retailInput_customerName.val();
								if (ss.isNullOrEmptyString(this.InData.ClientName)) {
									JSLib.Mobile.MessageBox.Alert('客户姓名不能为空!');
									return;
								}
								this.InData.Sex = this.retailInput_Sex.val();
								this.InData.ClientPhone = this.retailInput_teleNum.val().trim();
								this.InData.FixedLineTelephone = this.retailInput_fixedLineTelephone.val().trim();
								this.InData.ExactAddress = this.retailInput_address.val();
								this.InData.ClientAddress = ss.replaceAllString(this.retailInput_chooseAreaButton.val(), '-', '') + this.retailInput_address.val().trim();
								this.InData.PurchaseDate = this.retailInput_purchaseDate.val();
								if (ss.isNullOrEmptyString(this.InData.PurchaseDate)) {
									JSLib.Mobile.MessageBox.Alert('请输入购机日期');
									return;
								}
								purchaseDate = DateTimeEx.ToDateTime(this.InData.PurchaseDate);
								if (ss.Nullable$1.gt(purchaseDate, new Date())) {
									JSLib.Mobile.MessageBox.Alert('购机日期不能超过当前日期');
									return;
								}
								hasTel = false;
								if (!ss.isNullOrEmptyString(this.InData.ClientPhone)) {
									if (!(new RegExp('^1[3-8]\\d{9}$')).test(this.InData.ClientPhone)) {
										JSLib.Mobile.MessageBox.Alert('客户手机不正确');
										return;
									}
									hasTel = true;
								}
								if (!ss.isNullOrEmptyString(this.InData.FixedLineTelephone)) {
									if (!(new RegExp('^(\\d{3,4}\\-)?\\d{7,8}$')).test(this.InData.FixedLineTelephone)) {
										JSLib.Mobile.MessageBox.Alert('座机号输入不正确');
										return;
									}
									hasTel = true;
								}
								if (!ss.isNullOrEmptyString(this.InData.FixedLineTelephone)) {
									hasTel = true;
								}
								if (!hasTel) {
									JSLib.Mobile.MessageBox.Alert('手机和座机必须要填写一个！');
									return;
								}
								if (ss.isNullOrUndefined(this.InData.Items) || this.InData.Items.length === 0) {
									JSLib.Mobile.MessageBox.Alert('请添加产品!');
									return;
								}
								//如果是工程订单，检查产品数量是否有超过限制
								if (this.InData.OrderType === 0) {
									errorProducts = Enumerable.from(this.InData.Items).where(function(n2) {
										return ss.Nullable$1.gt(n2.Quantity, $App.app.config.SaleOrderMaxValue);
									}).toArray();
									if (ss.isValue(errorProducts) && errorProducts.length > 0) {
										JSLib.Mobile.MessageBox.Alert(ss.formatString('非工程订单中的产品 {0} 数量超出最大限制{1}', Enumerable.from(errorProducts).first().ProductName, $App.app.config.SaleOrderMaxValue));
										return;
									}
								}
								$t4 = $USOProject_Business_BusinessAction.RetailInputAddOrUpdate(this.InData, this);
								$state1 = 1;
								$t4.continueWith($sm1);
								return;
							}
							case 1: {
								$state1 = -1;
								result1 = $t4.getAwaitedResult();
								if (!result1.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(result1.ErrorMessage);
									return;
								}
								else {
									JSLib.Mobile.MessageBox.Alert('数据保存成功!');
									JSLib.Mobile.Application.BackTo($USOProject_Pages_Retail_RetailInput).call(null);
								}
								$state1 = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				});
				$sm1();
			}));
			//删除产品
			this.pnlProductList.on('click', '[data-delete-productid]', ss.thisFix(ss.mkdel(this, function(elem, event4) {
				var productData = Enumerable.from(this.InData.Items).first(function(n3) {
					return n3.ProductId === CoreEx.ToInt(elem.getAttribute('data-delete-productid'), 0);
				});
				ss.remove(this.InData.Items, productData);
				jQueryObjectEx.ParentUntil($(elem), '.feeitem').remove();
				this.RefreshPageScroll();
				// 没有任何产品时可修改门店
				if (this.InData.Items.length === 0) {
					jQueryObjectEx.SetEnable(this.retailInput_ShopList, true);
				}
			})));
			//切换门店
			this.retailInput_ShopList.change(ss.mkdel(this, function(event5) {
				var $state2 = 0, $t6, address;
				var $sm2 = ss.mkdel(this, function() {
					$sm1:
					for (;;) {
						switch ($state2) {
							case 0: {
								$state2 = -1;
								$t6 = $USOProject_Business_BusinessAction.GetStoreAddress(CoreEx.ToInt(this.retailInput_ShopList.val(), 0), this, true);
								$state2 = 1;
								$t6.continueWith($sm2);
								return;
							}
							case 1: {
								$state2 = -1;
								address = $t6.getAwaitedResult();
								this.InData.ProvinceCode = address.Result.ProvinceID;
								this.InData.CityCode = address.Result.CityID;
								this.InData.CountyCode = address.Result.CountyID;
								this.retailInput_chooseAreaButton.val($USOProject_Pages_Common_AddressDataInfoEx.ToDisplayString(address.Result));
								$state2 = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				});
				$sm2();
			}));
			//跳转产品详情
			this.pnlProductList.on('click', '[data-productid]', ss.thisFix(ss.mkdel(this, function(elem1, event6) {
				if (!ss.referenceEquals(event6.target.tagName.toUpperCase(), 'img'.toUpperCase())) {
					var productData1 = Enumerable.from(this.InData.Items).first(function(n4) {
						return n4.ProductId === CoreEx.ToInt(elem1.getAttribute('data-productid'), 0);
					});
					JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_RetailInputProductDetail).call(null, productData1, null);
				}
			})));
			if (this.PageState === 2) {
				//触发改变事件，加载省市县数据
				this.retailInput_ShopList.change();
			}
			else if (this.PageState === 1) {
				//初始化页面数据
				this.retailInput_OrderType.toggleClass('active', this.InData.OrderType === 1);
				this.retailInput_Sex.val(this.InData.Sex);
			}
			//修改
			this.btnModify.click(ss.mkdel(this, function(event7) {
				this.PageState = 3;
				this.UpdateState();
			}));
			//作废
			this.btn_retailInput_delete.click(ss.mkdel(this, function(event8) {
				var $state3 = 0, $t8, confirmResult, $t9, result2;
				var $sm3 = ss.mkdel(this, function() {
					$sm1:
					for (;;) {
						switch ($state3) {
							case 0: {
								$state3 = -1;
								$t8 = JSLib.Mobile.MessageBox.Confirm('作废订单后，将无法继续操作,确实要作废?');
								$state3 = 1;
								$t8.continueWith($sm3);
								return;
							}
							case 1: {
								$state3 = -1;
								confirmResult = $t8.getAwaitedResult();
								if (confirmResult) {
									$t9 = $USOProject_Business_BusinessAction.BlankOut(this.InData.Id, this, true);
									$state3 = 2;
									$t9.continueWith($sm3);
									return;
								}
								$state3 = -1;
								break $sm1;
							}
							case 2: {
								$state3 = -1;
								result2 = $t9.getAwaitedResult();
								if (result2.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert('订单作废成功!');
									if (!ss.staticEquals(this.OnBlankOut, null)) {
										this.OnBlankOut();
									}
									JSLib.Mobile.Application.BackTo($USOProject_Pages_Retail_RetailInput).call(null);
								}
								else {
									JSLib.Mobile.MessageBox.Alert('订单作废失败');
								}
								$state3 = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				});
				$sm3();
			}));
			//退货
			this.btn_retailInput_return.click(ss.mkdel(this, function(event9) {
				var $state4 = 0, $t11, isProductAllReturn, $t12;
				var $sm4 = ss.mkdel(this, function() {
					$sm1:
					for (;;) {
						switch ($state4) {
							case 0: {
								$state4 = -1;
								//是否所有产品都已退货
								$t11 = $USOProject_Business_BusinessAction.IsProductAllReturn(this.InData.Id, this, true);
								$state4 = 1;
								$t11.continueWith($sm4);
								return;
							}
							case 1: {
								$state4 = -1;
								isProductAllReturn = $t11.getAwaitedResult();
								if (!isProductAllReturn.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(isProductAllReturn.ErrorMessage);
									return;
								}
								if (!isProductAllReturn.Result) {
									$t12 = $USOProject_Pages_Retail_Add_RetailReturnData.$ctor();
									$t12.saleId = this.InData.Id;
									$t12.Mode = 'New';
									JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_Add_RetailReturnPage).call(null, $t12, null);
								}
								else {
									JSLib.Mobile.MessageBox.Alert('该订单没有可退货的产品!');
								}
								$state4 = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				});
				$sm4();
			}));
		},
		$isFrozenStore: function(store_id) {
			// StoreData 不包含冻结门店
			for (var $t1 = 0; $t1 < this.StoreData.length; $t1++) {
				var store = this.StoreData[$t1];
				if (store.CustomerStoreId === store_id) {
					return false;
				}
			}
			return true;
		},
		PrepareData: function() {
			var $state = 0, $tcs = new ss.TaskCompletionSource(), $t1, retailId, $t2, result;
			var $sm = ss.mkdel(this, function() {
				try {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								//获取门店数据
								$t1 = $USOProject_Business_BusinessAction.GetCustomerStoreAction();
								$state = 1;
								$t1.continueWith($sm);
								return;
							}
							case 1: {
								$state = -1;
								this.StoreData = $t1.getAwaitedResult().Result;
								if (ss.isNullOrUndefined(this.StoreData) || this.StoreData.length === 0) {
									JSLib.Mobile.MessageBox.Alert('加载门店数据失败!');
									window.setTimeout(function() {
										JSLib.Mobile.Application.Back(1);
									}, 500);
									$tcs.setResult(null);
									return;
								}
								if (ss.isValue(this.InitialData)) {
									retailId = this.InitialData;
									$t2 = $USOProject_Business_BusinessAction.RetailInputDetailQuery(retailId, this);
									$state = 2;
									$t2.continueWith($sm);
									return;
								}
								$state = -1;
								break $sm1;
							}
							case 2: {
								$state = -1;
								result = $t2.getAwaitedResult();
								if (!result.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
									window.setTimeout(function() {
										JSLib.Mobile.Application.Back(1);
									}, 500);
									$tcs.setResult(null);
									return;
								}
								this.InData = result.Result;
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
					$tcs.setResult(null);
				}
				catch ($t3) {
					$tcs.setException(ss.Exception.wrap($t3));
				}
			});
			$sm();
			return $tcs.task;
		},
		Destroy: function() {
			$App.IsProjectOrder = false;
			JSLib.Mobile.BasePage.prototype.Destroy.call(this);
		},
		GetProductListHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				//界面上只显示主产品MoreProduct == -1其余为赠品
				if (data.MoreProduct === -1 || data.MoreProduct === 0) {
					this.WriteLiteralTo(__razor_helper_writer, '        <li class="feeitem" data-productid="');
					this.WriteTo(__razor_helper_writer, data.ProductId);
					this.WriteLiteralTo(__razor_helper_writer, '">\r\n            <span class="">');
					this.WriteTo(__razor_helper_writer, data.ProductName);
					this.WriteLiteralTo(__razor_helper_writer, ' ');
					this.WriteTo(__razor_helper_writer, $NullableExtenion.FormatMoney$1(data.CommissionAmount, '无'));
					this.WriteLiteralTo(__razor_helper_writer, ' / ');
					this.WriteTo(__razor_helper_writer, $NullableExtenion.FormatMoney$1(data.Price, '无'));
					this.WriteLiteralTo(__razor_helper_writer, '  ');
					this.WriteTo(__razor_helper_writer, data.Quantity);
					this.WriteLiteralTo(__razor_helper_writer, ' 台</span>\r\n');
					if (this.get_CanEdit()) {
						this.WriteLiteralTo(__razor_helper_writer, '                <img class="iconDeleteProduct" data-delete-productid="');
						this.WriteTo(__razor_helper_writer, data.ProductId);
						this.WriteLiteralTo(__razor_helper_writer, '" src="./img/log_delete.png" style=" height: 30px; width: 34px" />\r\n');
					}
					this.WriteLiteralTo(__razor_helper_writer, '        </li>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="RetailInputAdd ">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">零售录入</div>\n    </div>\n    <div class="content " id="pnlContent">\n             <div class="sep inputPanel">\n                <div class="inputItem">\n                    <div class="title">选择门店:</div>\n                    <div class="inputWarp">\n                        <select id="retailInput_ShopList">\n');
			for (var $t1 = 0; $t1 < this.StoreData.length; $t1++) {
				var item = this.StoreData[$t1];
				this.WriteLiteral('                                <option value="');
				this.Write(item.CustomerStoreId);
				this.WriteLiteral('" ');
				this.Write(this.DataBind(item));
				this.WriteLiteral('>\r\n                                    ');
				this.Write(item.CustomerStoreName);
				this.WriteLiteral('\r\n                                </option>\r\n');
			}
			this.WriteLiteral('                        </select>\n                    </div>\n                </div>\n            </div>\n\n            <div class="sep inputPanel">\n                <div class="inputItem projectOrderItem">\n                    <div class="title">订单选项:</div>\n                    <div class="inputWarp">\n                        <span class="chkBox" id="retailInput_OrderType">是否为工程订单</span>\n                    </div>\n                </div>\n\n                <div class="inputItem">\n                    <div class="title">客户姓名:</div>\n                    <div class="inputWarp">\n                        <input id="retailInput_customerName" data-modal="" type="text" placeholder="请输入中文姓名" value="');
			this.Write(this.InData.ClientName);
			this.WriteLiteral('">\n                    </div>\n                </div>\n\n                <div class="inputItem">\n                    <div class="title">客户性别:</div>\n                    <div class="inputWarp">\n                        <select id="retailInput_Sex">\n                            <option value="0" selected="selected">\n                                男\n                            </option>\n                            <option value="1">\n                                女\n                            </option>\n                        </select>\n                    </div>\n                </div>\n\n                <div class="inputItem">\n                    <div class="title">购机日期:</div>\n                    <div class="inputWarp">\n');
			var purchaseDateStr = '';
			if (!ss.isNullOrEmptyString(this.InData.PurchaseDate)) {
				purchaseDateStr = DateTimeEx.ToDateStr(DateTimeEx.ToDateTimeForce(this.InData.PurchaseDate), 'yyyy-MM-dd');
			}
			this.WriteLiteral('                        <input id="retailInput_purchaseDate" type="text" readonly="readonly" placeholder="购机日期" value="');
			this.Write(purchaseDateStr);
			this.WriteLiteral('">\n                    </div>\n                </div>\n                <div class="inputItem">\n                    <div class="title">客户手机:</div>\n                    <div class="inputWarp">\n                        <input id="retailInput_teleNum" type="text" data-modal-number placeholder="请输入收货人手机号码" value="');
			this.Write(this.InData.ClientPhone);
			this.WriteLiteral('">\n                    </div>\n                </div>\n\n                <div class="inputItem">\n                    <div class="title">客户座机:</div>\n                    <div class="inputWarp">\n                        <input id="retailInput_fixedLineTelephone" type="text" data-modal="" placeholder="座机号码(XXX-XXXXXXXX)" value="');
			this.Write(this.InData.FixedLineTelephone);
			this.WriteLiteral('">\n                    </div>\n\n                </div>\n\n                <div class="inputItem endnavIcon">\n                    <div class="title">选择区域:</div>\n                    <div class="inputWarp endnavIcon selectAreaContent" id="btnChooseAddressArea">\n');
			var addres = '';
			if (ss.isValue(this.InData.ProvinceCode)) {
				addres = $USOProject_Pages_Common_AddressDataInfoEx.ToDisplayString($USOProject_Pages_Common_AddressDataInfo.$ctor1(ss.unbox(this.InData.ProvinceCode), ss.unbox(this.InData.CityCode), ss.unbox(this.InData.CountyCode)));
			}
			this.WriteLiteral(' <input id="retailInput_chooseAreaButton" type="text" readonly="readonly" placeholder="请选择省市区" class="" value="');
			this.Write(addres);
			this.WriteLiteral('">\n                    </div>\n                </div>\n                <div class="inputItem">\n                    <div class="title">详细地址:</div>\n                    <div class="inputWarp">\n\n                        <input id="retailInput_address" type="text" data-modal="" placeholder="请输入详细地址" value="');
			this.Write(this.InData.ExactAddress);
			this.WriteLiteral('">\n                    </div>\n                </div>\n            </div>\n\n            <div class="sep">\n                <div id="retailInput_addProductItem" class="nbutton endnavIcon buttonEndNavIcon">\n                    选择产品<span id="retailInput_productValue"></span>\n                </div>\n            </div>\n            <ul class="list inset" id="pnlProductList">\n');
			if (ss.isValue(this.InData.Items) && this.InData.Items.length > 0) {
				for (var $t2 = 0; $t2 < this.InData.Items.length; $t2++) {
					var item1 = this.InData.Items[$t2];
					this.WriteLiteral(this.GetProductListHtml(item1).toString());
				}
			}
			this.WriteLiteral('\n            </ul>\n\n    \n    </div>\n\n    <footer class="submit_footer" data-parent="retail_input">\n        <div id="btnSave" class="redButton">\n            保存\n        </div>\n        <div id="btnModify" class="redButton">\n            修改\n        </div>\n\n        <div id="btn_retailInput_return" class="redButton">\n            退货\n        </div>\n        <div id="btn_retailInput_delete" class="redButton">\n            作废\n        </div>\n    </footer>\n</div>\n\n');
			this.WriteLiteral('\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.retailInput_ShopList = this.pageObject.find('#retailInput_ShopList');
			this.retailInput_OrderType = this.pageObject.find('#retailInput_OrderType');
			this.retailInput_customerName = this.pageObject.find('#retailInput_customerName');
			this.retailInput_Sex = this.pageObject.find('#retailInput_Sex');
			this.retailInput_purchaseDate = this.pageObject.find('#retailInput_purchaseDate');
			this.retailInput_teleNum = this.pageObject.find('#retailInput_teleNum');
			this.retailInput_fixedLineTelephone = this.pageObject.find('#retailInput_fixedLineTelephone');
			this.btnChooseAddressArea = this.pageObject.find('#btnChooseAddressArea');
			this.retailInput_chooseAreaButton = this.pageObject.find('#retailInput_chooseAreaButton');
			this.retailInput_address = this.pageObject.find('#retailInput_address');
			this.retailInput_addProductItem = this.pageObject.find('#retailInput_addProductItem');
			this.retailInput_productValue = this.pageObject.find('#retailInput_productValue');
			this.pnlProductList = this.pageObject.find('#pnlProductList');
			this.btnSave = this.pageObject.find('#btnSave');
			this.btnModify = this.pageObject.find('#btnModify');
			this.btn_retailInput_return = this.pageObject.find('#btn_retailInput_return');
			this.btn_retailInput_delete = this.pageObject.find('#btn_retailInput_delete');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.retailInput_ShopList)) {
				this.retailInput_ShopList.unbind().off();
				this.retailInput_ShopList = null;
			}
			if (ss.isValue(this.retailInput_OrderType)) {
				this.retailInput_OrderType.unbind().off();
				this.retailInput_OrderType = null;
			}
			if (ss.isValue(this.retailInput_customerName)) {
				this.retailInput_customerName.unbind().off();
				this.retailInput_customerName = null;
			}
			if (ss.isValue(this.retailInput_Sex)) {
				this.retailInput_Sex.unbind().off();
				this.retailInput_Sex = null;
			}
			if (ss.isValue(this.retailInput_purchaseDate)) {
				this.retailInput_purchaseDate.unbind().off();
				this.retailInput_purchaseDate = null;
			}
			if (ss.isValue(this.retailInput_teleNum)) {
				this.retailInput_teleNum.unbind().off();
				this.retailInput_teleNum = null;
			}
			if (ss.isValue(this.retailInput_fixedLineTelephone)) {
				this.retailInput_fixedLineTelephone.unbind().off();
				this.retailInput_fixedLineTelephone = null;
			}
			if (ss.isValue(this.btnChooseAddressArea)) {
				this.btnChooseAddressArea.unbind().off();
				this.btnChooseAddressArea = null;
			}
			if (ss.isValue(this.retailInput_chooseAreaButton)) {
				this.retailInput_chooseAreaButton.unbind().off();
				this.retailInput_chooseAreaButton = null;
			}
			if (ss.isValue(this.retailInput_address)) {
				this.retailInput_address.unbind().off();
				this.retailInput_address = null;
			}
			if (ss.isValue(this.retailInput_addProductItem)) {
				this.retailInput_addProductItem.unbind().off();
				this.retailInput_addProductItem = null;
			}
			if (ss.isValue(this.retailInput_productValue)) {
				this.retailInput_productValue.unbind().off();
				this.retailInput_productValue = null;
			}
			if (ss.isValue(this.pnlProductList)) {
				this.pnlProductList.unbind().off();
				this.pnlProductList = null;
			}
			if (ss.isValue(this.btnSave)) {
				this.btnSave.unbind().off();
				this.btnSave = null;
			}
			if (ss.isValue(this.btnModify)) {
				this.btnModify.unbind().off();
				this.btnModify = null;
			}
			if (ss.isValue(this.btn_retailInput_return)) {
				this.btn_retailInput_return.unbind().off();
				this.btn_retailInput_return = null;
			}
			if (ss.isValue(this.btn_retailInput_delete)) {
				this.btn_retailInput_delete.unbind().off();
				this.btn_retailInput_delete = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initEnum($USOProject_Pages_Retail_Add_RetailInputAdd$State, $asm, { View: 1, Insert: 2, Modify: 3 });
	ss.initClass($USOProject_Pages_Retail_Add_RetailReturnData, $asm, {});
	ss.initClass($USOProject_Pages_Retail_Add_RetailReturnPage, $asm, {
		$RetailReturnPage_OnPageInit: function(sender, e) {
			var $state2 = 0, $t6, saleItemResult, data, isInAllowDeleteTimePeroid, $t7, queryResult, numberResult, $t8, temp, container;
			var $sm2 = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state2) {
						case 0: {
							$state2 = -1;
							this.btnDrop.hide();
							$JuqeryObjectEx.UpdateState(this.pageObject, 'dt', this.PageParam.Mode);
							//点击切换数据选择框是否可用
							this.pageObject.on('click', '.returnItem', ss.thisFix(function(elem, event) {
								if ($(event.target).closest('.numberInputControl').length > 0) {
									return;
								}
								var targetClass = elem.className;
								if (targetClass.indexOf('btnIcon') !== -1 || targetClass.indexOf('numberText') !== -1) {
									return;
								}
								var checkBox = $(elem).find('input[data-id]');
								if (checkBox.length > 0) {
									var target = checkBox[0];
									target.checked = !target.checked;
									$(event.currentTarget).toggleClass('dtEdit', target.checked);
								}
							}));
							//保存按钮操作
							this.btnSave.click(ss.mkdel(this, function(event1) {
								var $state = 0, returnDetailData, $t1, result;
								var $sm = ss.mkdel(this, function() {
									$sm1:
									for (;;) {
										switch ($state) {
											case 0: {
												$state = -1;
												//获取要退货的商品记录id
												returnDetailData = [];
												this.pnlReturnList.find('input[type=checkbox]:checked').each(function(i, ele) {
													var detailId = CoreEx.ToInt(ele.getAttribute('data-id'), 0);
													var number = CoreEx.ToInt($(ele).parents('.returnItem').find('.numberText').text(), 0);
													returnDetailData.push({ DetailId: detailId, Number: number });
												});
												if (returnDetailData.length < 1) {
													JSLib.Mobile.MessageBox.Alert('请至少选择一个产品！');
													return;
												}
												$t1 = $USOProject_Business_BusinessAction.ReturnGoods(this.PageParam.saleId, returnDetailData, this, true);
												$state = 1;
												$t1.continueWith($sm);
												return;
											}
											case 1: {
												$state = -1;
												result = $t1.getAwaitedResult();
												if (!result.IsSuccess) {
													JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
													return;
												}
												this.PageParam.returnId = result.Result;
												$JuqeryObjectEx.UpdateState(this.pageObject, 'dt', 'View');
												JSLib.Mobile.MessageBox.Alert('保存成功！');
												this.hideUnCheckedProduct();
												this.btnDrop.show();
												$state = -1;
												break $sm1;
											}
											default: {
												break $sm1;
											}
										}
									}
								});
								$sm();
							}));
							//数量增减操作
							this.pageObject.on('click', '.btnIcon', function(ev) {
								if ($(ev.target).parents('.returnItem').hasClass('dtEdit')) {
									var numberText = $(ev.target).parents('.numberInputControl').find('.numberText');
									var curNumber = CoreEx.ToInt(numberText.text(), 0);
									var maxNumber = CoreEx.ToInt(numberText.attr('data-max'), 0);
									var isAdd = ev.target.classList.contains('plusIcon');
									if (isAdd) {
										curNumber++;
										if (curNumber >= maxNumber) {
											curNumber = maxNumber;
										}
									}
									else {
										curNumber--;
										if (curNumber <= 1) {
											curNumber = 1;
										}
									}
									numberText.text(curNumber.toString());
									$(ev.target).parents('.returnItem').find('.returnNumberText').text(curNumber.toString());
								}
							});
							//查看订单按钮
							this.pageObject.on('click', '.viewDetailPanel', ss.mkdel(this, function(ev1) {
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Retail_Add_RetailInputAdd).call(null, this.returnData.SourceRetailInputID, null);
							}));
							//修改按钮，切换到修改视图
							this.pageObject.on('click', '#btnModify', ss.mkdel(this, function(ev2) {
								$JuqeryObjectEx.UpdateState(this.pageObject, 'dt', 'Edit');
							}));
							//取消按钮，切换到只读视图
							this.pageObject.on('click', '#btnCancel', ss.mkdel(this, function(ev3) {
								$JuqeryObjectEx.UpdateState(this.pageObject, 'dt', 'view');
							}));
							this.btnDrop.click(ss.mkdel(this, function(ev4) {
								var $state1 = 0, $t3, confirmResult, $t4, result1;
								var $sm1 = ss.mkdel(this, function() {
									$sm1:
									for (;;) {
										switch ($state1) {
											case 0: {
												$state1 = -1;
												$t3 = JSLib.Mobile.MessageBox.Confirm('是否确认要作废此退货单?');
												$state1 = 1;
												$t3.continueWith($sm1);
												return;
											}
											case 1: {
												$state1 = -1;
												confirmResult = $t3.getAwaitedResult();
												if (!confirmResult) {
													return;
												}
												$t4 = $USOProject_Business_BusinessAction.BlankOutReturnSale(this.PageParam.returnId, this, true);
												$state1 = 2;
												$t4.continueWith($sm1);
												return;
											}
											case 2: {
												$state1 = -1;
												result1 = $t4.getAwaitedResult();
												if (!result1.IsSuccess) {
													JSLib.Mobile.MessageBox.Alert(result1.ErrorMessage);
													return;
												}
												$JuqeryObjectEx.UpdateState(this.pageObject, 'dt', 'View');
												JSLib.Mobile.MessageBox.Alert('作废成功！');
												this.btnDrop.hide();
												if (!ss.staticEquals(this.OnDrop, null)) {
													this.OnDrop();
												}
												$state1 = -1;
												break $sm1;
											}
											default: {
												break $sm1;
											}
										}
									}
								});
								$sm1();
							}));
							$t6 = $USOProject_Business_BusinessAction.RetailInputDetailQuery(((this.PageParam.saleId > 0) ? this.PageParam.saleId : this.PageParam.returnId), this);
							$state2 = 1;
							$t6.continueWith($sm2);
							return;
						}
						case 1: {
							$state2 = -1;
							saleItemResult = $t6.getAwaitedResult();
							if (!saleItemResult.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(saleItemResult.ErrorMessage);
								return;
							}
							data = saleItemResult.Result;
							this.lblCustomerName.text(data.ClientName);
							this.lblBuyDate.text(ss.formatDate(DateTimeEx.ToDateTimeForce(data.CreateOn), 'yyyy-MM-dd'));
							if (this.PageParam.saleId > 0) {
								this.retailData = data;
							}
							else {
								this.returnData = data;
							}
							this.pnlReturnList.html(this.GetProductItemsHtml(data.Items).toString());
							//如果是退货单
							//判断是否超过可修改日期
							//创建时间+过期分钟数 > 当前时间
							isInAllowDeleteTimePeroid = $App.GetCurrentServerDate() < new Date(DateTimeEx.ToDateTimeForce(data.CreateOn).valueOf() + Math.round($App.app.config.RetailInputBlankOutTime * 60000));
							if (this.pageObject.hasClass('dtView') && isInAllowDeleteTimePeroid && (data.SalesStatus === 1 || data.SalesStatus === 2 || data.SalesStatus === 0)) {
								this.btnDrop.show();
							}
							$t7 = $USOProject_Business_BusinessAction.GetRetailReturnProductCount(((this.PageParam.saleId > 0) ? this.PageParam.saleId : data.SourceRetailInputID), this, true);
							$state2 = 2;
							$t7.continueWith($sm2);
							return;
						}
						case 2: {
							$state2 = -1;
							queryResult = $t7.getAwaitedResult();
							if (!queryResult.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(queryResult.ErrorMessage);
								return;
							}
							numberResult = queryResult.Result;
							for ($t8 = 0; $t8 < numberResult.length; $t8++) {
								temp = numberResult[$t8];
								container = this.pageObject.find(".returnItem[data-id='" + temp.DetailId + "']");
								container.find('.numberText').text(temp.Quantity.toString()).attr('data-max', temp.Quantity.toString());
								container.find('.returnNumberText').text(temp.Quantity.toString());
								if (temp.Quantity === 0) {
									container.hide();
								}
							}
							$state2 = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm2();
		},
		hideUnCheckedProduct: function() {
			this.pnlReturnList.find('input[type=checkbox]').not(':checked').each(function(index, ele) {
				$(ele).parents('.returnItem').hide();
			}).hide();
		},
		PrepareData: function() {
			this.PageParam = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		GetProductItemsHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					this.WriteLiteralTo(__razor_helper_writer, "        <li class='returnItem' data-id='");
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, "' ");
					this.WriteTo(__razor_helper_writer, this.DataBind(item));
					this.WriteLiteralTo(__razor_helper_writer, ">\r\n            <input type='checkbox' data-id='");
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, "' />\r\n            <div class='col2'>\r\n                <div class='RetailProductInfoPanel'>\r\n                    <div class='retailName'>");
					this.WriteTo(__razor_helper_writer, item.ProductName);
					this.WriteLiteralTo(__razor_helper_writer, "</div>\r\n                    <div class='moneyPanel'>\r\n                        <div class='moneyItem'>\r\n                            <span class='infoName'>零售价格:</span>\r\n                            <span class='infoValue'>");
					this.WriteTo(__razor_helper_writer, item.Price);
					this.WriteLiteralTo(__razor_helper_writer, "</span>\r\n                        </div>\r\n                        <div class='moneyItem'>\r\n\r\n                            <span class='infoName'>提成金额:</span>\r\n");
					var commisionamountstr = (ss.isNullOrUndefined(item.CommissionAmount) ? '无' : Math.abs(ss.unbox(item.CommissionAmount)).toString());
					this.WriteLiteralTo(__razor_helper_writer, "                            <span class='infoValue'>");
					this.WriteTo(__razor_helper_writer, commisionamountstr);
					this.WriteLiteralTo(__razor_helper_writer, " </span>\r\n                        </div>\r\n                    </div>\r\n                    <div class='retailProductReturnNumber'>\r\n                        退货数量:<span class='returnNumberText'> ");
					this.WriteTo(__razor_helper_writer, Math.abs(ss.unbox(item.Quantity)));
					this.WriteLiteralTo(__razor_helper_writer, "</span>\r\n                    </div>\r\n                </div>\r\n                <div class='numberInputControl'>\r\n                    <div class='btnIcon minusIcon enable'></div>\r\n                    <div class='numberText' data-max='");
					this.WriteTo(__razor_helper_writer, Math.abs(ss.unbox(item.Quantity)));
					this.WriteLiteralTo(__razor_helper_writer, "'> ");
					this.WriteTo(__razor_helper_writer, Math.abs(ss.unbox(item.Quantity)));
					this.WriteLiteralTo(__razor_helper_writer, "</div>\r\n                    <div class='btnIcon plusIcon enable'></div>\r\n                </div>\r\n            </div>\r\n        </li>\r\n");
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="RetailReturnPage">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">零售录入退货</div>\n        <div class="headRightButtonGroup">\n            <div class="headButtonItem">\n                <span class="modifyText" id="btnModify">修改</span>\n                <span class="cancelText" id="btnCancel">取消</span>\n            </div>\n        </div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="pnlRetailInfo">\n            <span class="customerName" id="lblCustomerName"> </span>\n            <span class="buyDate" id="lblBuyDate"> </span>\n\n');
			if (this.PageParam.showRetailInputDetailNavLink) {
				this.WriteLiteral('                <div class="viewDetailPanel">\r\n                    <a>查看零售录入单详情</a>\r\n                </div>\r\n');
			}
			this.WriteLiteral('        </div>\n        <ul class="pnlReturnList" id="pnlReturnList">\n            \n        </ul>\n    </div>\n    <div class="toolBar">\n        <div class="toolBarItem redButton" id="btnSave">保存</div>\n        <div class="toolBarItem redButton ui-hidden" id="btnDrop">作废</div>\n    </div>\n</div>\n\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.btnModify = this.pageObject.find('#btnModify');
			this.btnCancel = this.pageObject.find('#btnCancel');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.lblCustomerName = this.pageObject.find('#lblCustomerName');
			this.lblBuyDate = this.pageObject.find('#lblBuyDate');
			this.pnlReturnList = this.pageObject.find('#pnlReturnList');
			this.btnSave = this.pageObject.find('#btnSave');
			this.btnDrop = this.pageObject.find('#btnDrop');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.btnModify)) {
				this.btnModify.unbind().off();
				this.btnModify = null;
			}
			if (ss.isValue(this.btnCancel)) {
				this.btnCancel.unbind().off();
				this.btnCancel = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.lblCustomerName)) {
				this.lblCustomerName.unbind().off();
				this.lblCustomerName = null;
			}
			if (ss.isValue(this.lblBuyDate)) {
				this.lblBuyDate.unbind().off();
				this.lblBuyDate = null;
			}
			if (ss.isValue(this.pnlReturnList)) {
				this.pnlReturnList.unbind().off();
				this.pnlReturnList = null;
			}
			if (ss.isValue(this.btnSave)) {
				this.btnSave.unbind().off();
				this.btnSave = null;
			}
			if (ss.isValue(this.btnDrop)) {
				this.btnDrop.unbind().off();
				this.btnDrop = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Retail_Return_RetailInputReturnDetail, $asm, {
		$RetailInputReturnDetail_OnPageInit: function(sender, e) {
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" title=\'零售录入退货\'  class="panel nopaddingtop RetailInputReturnDetail">\n    <div class="content">\n        <ul class="pnlReturnList">\n            <li class="returnItem">\n                <div class="checkBox">\n                    <input type="checkbox" data-id="" />\n                </div>\n                <div class="RetailName">\n                    零售录入退货产品名称及其它信息\n                </div>\n                <div class="ReturnNumberPanel">\n                    <div class="nubmerAdjustIcon numberPlus">-</div>\n                    <div class="numberText">1</div>\n                    <div class="nubmerAdjustIcon numberMinus"></div>\n                </div>\n            </li>\n        </ul>\n    </div>\n    <div class="toolBar">\n        <div class="toolBarItem" id="btnSave">保存</div>\n        <div class="toolBarItem" id="btnDrop">作废</div>\n    </div>\n</div>\n');
		},
		InitialComponent: function() {
			this.btnSave = this.pageObject.find('#btnSave');
			this.btnDrop = this.pageObject.find('#btnDrop');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnSave)) {
				this.btnSave.unbind().off();
				this.btnSave = null;
			}
			if (ss.isValue(this.btnDrop)) {
				this.btnDrop.unbind().off();
				this.btnDrop = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Spec_SpecAuditAction, $asm, {
		$SpecAuditAction_OnPageShow: function(sender, e) {
		},
		$SpecAuditAction_OnPageInit: function(sender, e) {
			var $state1 = 0, specAuditActionData, $t1, initResult, islast;
			var $sm1 = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state1) {
						case 0: {
							$state1 = -1;
							specAuditActionData = this.InitialData;
							$t1 = $USOProject_Business_BusinessAction.GetSpecialApproveInitData(specAuditActionData.SpecId, this);
							$state1 = 1;
							$t1.continueWith($sm1);
							return;
						}
						case 1: {
							$state1 = -1;
							initResult = $t1.getAwaitedResult();
							if (!initResult.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(initResult.ErrorMessage);
								return;
							}
							this.$Data = initResult.Result;
							this.$Data.SpecialItems = specAuditActionData.SpecItems;
							this.spec_audit_action_specialNum.val(this.$Data.SpecialNum);
							this.spec_audit_action_specialName.val(this.$Data.SpecialName);
							this.spec_audit_action_createName.val(this.$Data.CreateName);
							this.spec_audit_action_nextUserId.html(this.GetOptionHtmls(this.$Data.NextUsers).toString());
							this.spec_audit_action_productType.html(this.GetOptionHtmls(this.$Data.ProductType).toString());
							this.spec_audit_action_apportionOrg.html(this.GetOptionHtmls(this.$Data.ApportionOrg).toString());
							islast = this.$Data.IsLast === 1;
							jQueryObjectEx.SetVisible(this.pnlNextUsers, !islast);
							//下步审核人只有一人，则自动选中
							if (this.$Data.NextUsers.length === 1) {
								this.spec_audit_action_nextUserId.val(this.$Data.NextUsers[0].Value);
							}
							//点击确认审核
							this.btnAudit.click(ss.mkdel(this, function(event) {
								var $state = 0, nextUserId, chkSatus, statudVal, apportionOrgId, productTypeId, $t2, postData, $t3, result;
								var $sm = ss.mkdel(this, function() {
									$sm1:
									for (;;) {
										switch ($state) {
											case 0: {
												$state = -1;
												nextUserId = CoreEx.ToInt(this.spec_audit_action_nextUserId.val(), 0);
												chkSatus = this.pnlAuditOptions.find('.chkBox.active');
												if (chkSatus.length === 0) {
													JSLib.Mobile.MessageBox.Alert('请选择处理状态!');
													return;
												}
												statudVal = CoreEx.ToInt(chkSatus.attr('data-value'), 0);
												apportionOrgId = CoreEx.ToInt(this.spec_audit_action_apportionOrg.val(), 0);
												productTypeId = CoreEx.ToInt(this.spec_audit_action_productType.val(), 0);
												//当流程是最后一个 或者 处理状态选“退回“时，不用检查下步审核人
												if (this.$Data.IsLast !== 1 && statudVal !== 2) {
													if (nextUserId <= 0) {
														JSLib.Mobile.MessageBox.Alert('下步审核人必选。');
														return;
													}
												}
												if (apportionOrgId <= 0) {
													JSLib.Mobile.MessageBox.Alert('毛利分摊部门必选。');
													return;
												}
												if (productTypeId < 0) {
													JSLib.Mobile.MessageBox.Alert('产品类型必选。');
													return;
												}
												$t2 = $USOProject_Business_SpecialAuditActionViewModel.$ctor();
												$t2.SpecialId = this.$Data.SpecialId;
												$t2.Note = this.spec_audit_action_remark.val();
												$t2.ProductTypeId = productTypeId;
												$t2.ApportionOrgId = apportionOrgId;
												$t2.Status = statudVal;
												$t2.NextUserId = nextUserId;
												$t2.SpecialItems = this.$Data.SpecialItems;
												postData = $t2;
												$t3 = $USOProject_Business_BusinessAction.SpecialApprove(postData, this);
												$state = 1;
												$t3.continueWith($sm);
												return;
											}
											case 1: {
												$state = -1;
												result = $t3.getAwaitedResult();
												if (result.IsSuccess) {
													if (!ss.staticEquals(this.IsSpecAuditFinished, null)) {
														this.IsSpecAuditFinished();
													}
													JSLib.Mobile.MessageBox.Alert('审核成功!');
													JSLib.Mobile.Application.BackTo($USOProject_Pages_HomePage).call(null);
													$USOProject_Pages_Control_MyWorkControl.TriggerTodoWorkChange();
												}
												else {
													JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
												}
												$state = -1;
												break $sm1;
											}
											default: {
												break $sm1;
											}
										}
									}
								});
								$sm();
							}));
							$state1 = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm1();
		},
		GetOptionHtmls: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					var selectedStr = (item.Selected ? 'selected' : '');
					this.WriteLiteralTo(__razor_helper_writer, '        <option value="');
					this.WriteTo(__razor_helper_writer, item.Value);
					this.WriteLiteralTo(__razor_helper_writer, '" ');
					this.WriteTo(__razor_helper_writer, selectedStr);
					this.WriteLiteralTo(__razor_helper_writer, '>');
					this.WriteTo(__razor_helper_writer, item.Text);
					this.WriteLiteralTo(__razor_helper_writer, '</option>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="SpecAuditAction">\r\n    <div class="head">\r\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\r\n        <div id="lblHeadText" class="headText">特批审核</div>\r\n    </div>\r\n    <div class="content" id="pnlContent">\r\n        <div class="AuditDetailSeg">\r\n            <div class="row">\r\n                <div class="name">特批号:</div>\r\n                <div class="value">\r\n                    <input readonly="readonly" id="spec_audit_action_specialNum" type="text">\r\n                </div>\r\n            </div>\r\n\r\n            <div class="row">\r\n                <div class="name">特批名称:</div>\r\n                <div class="value">\r\n                    <input readonly="readonly" id="spec_audit_action_specialName" type="text">\r\n                </div>\r\n            </div>\r\n\r\n\r\n            <div class="row">\r\n                <div class="name">创建人:</div>\r\n                <div class="value">\r\n                    <input readonly="readonly" id="spec_audit_action_createName" type="text">\r\n                </div>\r\n            </div>\r\n\r\n\r\n            <div class="row " id="pnlNextUsers">\r\n                <div class="name">下步审核人:</div>\r\n                <div class="value">\r\n                    <select id="spec_audit_action_nextUserId" name="NextUserId"></select>\r\n                </div>\r\n            </div>\r\n\r\n            <div class="row">\r\n                <div class="name">处理状态:</div>\r\n                <div class="value">\r\n                    <div class="radioPanel" id="pnlAuditOptions">\r\n                        <span class="chkBox" data-value="1">确认</span>\r\n                        <span class="chkBox" data-value="0" id="chkBack">退回</span>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class="row ">\r\n                <div class="name"> 产品类型:</div>\r\n                <div class="value">\r\n                    <select id="spec_audit_action_productType"></select>\r\n                </div>\r\n            </div>\r\n\r\n            <div class="row ">\r\n                <div class="name"> 毛利分摊部门:</div>\r\n                <div class="value">\r\n                    <select id="spec_audit_action_apportionOrg"></select>\r\n                </div>\r\n            </div>\r\n\r\n            <div class="row">\r\n                <div class="name">备注:</div>\r\n                <div class="value">\r\n                    <input id="spec_audit_action_remark" data-modal="" placeholder="备注" type="text" maxlength="255">\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n    <div class="footer">\r\n        <div class="redButton" id="btnAudit">\r\n            确认审核\r\n        </div>\r\n    </div>\r\n</div>\r\n\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.spec_audit_action_specialNum = this.pageObject.find('#spec_audit_action_specialNum');
			this.spec_audit_action_specialName = this.pageObject.find('#spec_audit_action_specialName');
			this.spec_audit_action_createName = this.pageObject.find('#spec_audit_action_createName');
			this.pnlNextUsers = this.pageObject.find('#pnlNextUsers');
			this.spec_audit_action_nextUserId = this.pageObject.find('#spec_audit_action_nextUserId');
			this.pnlAuditOptions = this.pageObject.find('#pnlAuditOptions');
			this.chkBack = this.pageObject.find('#chkBack');
			this.spec_audit_action_productType = this.pageObject.find('#spec_audit_action_productType');
			this.spec_audit_action_apportionOrg = this.pageObject.find('#spec_audit_action_apportionOrg');
			this.spec_audit_action_remark = this.pageObject.find('#spec_audit_action_remark');
			this.btnAudit = this.pageObject.find('#btnAudit');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.spec_audit_action_specialNum)) {
				this.spec_audit_action_specialNum.unbind().off();
				this.spec_audit_action_specialNum = null;
			}
			if (ss.isValue(this.spec_audit_action_specialName)) {
				this.spec_audit_action_specialName.unbind().off();
				this.spec_audit_action_specialName = null;
			}
			if (ss.isValue(this.spec_audit_action_createName)) {
				this.spec_audit_action_createName.unbind().off();
				this.spec_audit_action_createName = null;
			}
			if (ss.isValue(this.pnlNextUsers)) {
				this.pnlNextUsers.unbind().off();
				this.pnlNextUsers = null;
			}
			if (ss.isValue(this.spec_audit_action_nextUserId)) {
				this.spec_audit_action_nextUserId.unbind().off();
				this.spec_audit_action_nextUserId = null;
			}
			if (ss.isValue(this.pnlAuditOptions)) {
				this.pnlAuditOptions.unbind().off();
				this.pnlAuditOptions = null;
			}
			if (ss.isValue(this.chkBack)) {
				this.chkBack.unbind().off();
				this.chkBack = null;
			}
			if (ss.isValue(this.spec_audit_action_productType)) {
				this.spec_audit_action_productType.unbind().off();
				this.spec_audit_action_productType = null;
			}
			if (ss.isValue(this.spec_audit_action_apportionOrg)) {
				this.spec_audit_action_apportionOrg.unbind().off();
				this.spec_audit_action_apportionOrg = null;
			}
			if (ss.isValue(this.spec_audit_action_remark)) {
				this.spec_audit_action_remark.unbind().off();
				this.spec_audit_action_remark = null;
			}
			if (ss.isValue(this.btnAudit)) {
				this.btnAudit.unbind().off();
				this.btnAudit = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Spec_SpecAuditAction$SpecAuditActionData, $asm, {});
	ss.initClass($USOProject_Pages_Spec_SpecDetail, $asm, {
		$SpecDetail_OnPageShow: function(sender, e) {
		},
		$SpecDetail_OnPageInit: function(sender, e) {
			var $state1 = 0, specID, $t1, viewData;
			var $sm1 = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state1) {
						case 0: {
							$state1 = -1;
							this.SetScrollable(this.pnlContent[0], false, true, false, null, null, null, '', false, null, true, true);
							specID = this.InitialData;
							$t1 = $USOProject_Business_BusinessAction.GetSpecDetail(specID, this);
							$state1 = 1;
							$t1.continueWith($sm1);
							return;
						}
						case 1: {
							$state1 = -1;
							viewData = $t1.getAwaitedResult();
							if (!viewData.IsSuccess) {
								JSLib.Mobile.MessageBox.Alert(viewData.ErrorMessage);
								return;
							}
							this.ModelData = viewData.Result;
							this.pnlContent.html(this.GetPageContentHtml().toString());
							//查看流程跟踪
							this.pageObject.on('click', '#li_spec_audit_proc_track', ss.mkdel(this, function(event) {
								var $state = 0, $t2, queryData, $t3, result;
								var $sm = ss.mkdel(this, function() {
									$sm1:
									for (;;) {
										switch ($state) {
											case 0: {
												$state = -1;
												//没有查看权限，并且状态不是已审核
												if (!$USOProject_Business_ToCompletion_PermissionManager.Have_ShowSpecialWorkFlowBasic() && this.ModelData.Status !== 2) {
													JSLib.Mobile.MessageBox.Alert('没有查看特批流程跟踪的权限');
													$state = -1;
													break $sm1;
												}
												else {
													$t2 = new $USOProject_Pages_Spec_SpecProcTrack$SpecProcTrackData();
													$t2.SpecialId = this.ModelData.SpecialId;
													$t2.Status = ss.unbox(this.ModelData.Status);
													queryData = $t2;
													$t3 = $USOProject_Business_BusinessAction.GetSpecialAuditProcTrack(queryData, this);
													$state = 1;
													$t3.continueWith($sm);
													return;
												}
											}
											case 1: {
												$state = -1;
												result = $t3.getAwaitedResult();
												if (!result.IsSuccess) {
													JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
													return;
												}
												JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Spec_SpecProcTrack).call(null, result.Result, null);
												$state = -1;
												break $sm1;
											}
											default: {
												break $sm1;
											}
										}
									}
								});
								$sm();
							}));
							//跳转至产品详情
							this.pageObject.on('click', 'a[data-productid]', ss.thisFix(ss.mkdel(this, function(elem, event1) {
								var productId = elem.getAttribute('data-productid');
								var index = CoreEx.ToInt(elem.getAttribute('productindex'), 0);
								var product = Enumerable.from(this.ModelData.Items).first(function(n) {
									return n.ProductId === CoreEx.ToInt(productId, 0);
								});
								var $t5 = new $USOProject_Pages_Spec_SpecProductDetail$SpecProductDetailData();
								$t5.Product = product;
								$t5.SpecialData = this.ModelData;
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Spec_SpecProductDetail).call(null, $t5, ss.mkdel(this, function(page) {
									page.OnModifyComplete = ss.mkdel(this, function(data) {
										var target = $(elem).find('span.line_right_modify');
										$(target[0]).text(data.AuditNum.toString());
										$(target[1]).text(data.AuditPrice.toFixed(2) + '元/台');
										$(target[2]).text(data.AuditCorePrice.toFixed(2) + '元/台');
										this.ModelData.Items[index].AuditNum = data.AuditNum;
										this.ModelData.Items[index].AuditPrice = data.AuditPrice;
										this.ModelData.Items[index].HaveRoyalties = data.HaveRoyalties;
										this.ModelData.Items[index].HaveGrossProfit = data.HaveGrossProfit;
										if (ss.isNullOrUndefined(product.ApplyCorePrice)) {
											this.ModelData.Items[index].AuditCorePrice = null;
										}
										else {
											this.ModelData.Items[index].AuditCorePrice = data.AuditCorePrice;
										}
									});
								}));
							})));
							this.btn_spec_audit.click(ss.mkdel(this, function(event2) {
								var $t6 = new $USOProject_Pages_Spec_SpecAuditAction$SpecAuditActionData();
								$t6.SpecId = this.ModelData.SpecialId;
								$t6.SpecItems = this.ModelData.Items;
								JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Spec_SpecAuditAction).call(null, $t6, ss.mkdel(this, function(page1) {
									page1.IsSpecAuditFinished = ss.mkdel(this, function() {
										if (!ss.staticEquals(this.IsSpecAuditFinished, null)) {
											this.IsSpecAuditFinished();
										}
									});
								}));
							}));
							//审核中状态才显示审核按钮
							jQueryObjectEx.SetVisible(this.btn_spec_audit, this.ModelData.Status === 1);
							$state1 = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm1();
		},
		GetPageContentHtml: function() {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				this.WriteLiteralTo(__razor_helper_writer, '    <ul id="ulSpecDetail" class="list inset">\n        <li class="li_detail_title divider textBadge"></li>\n        <li class="li_detail">\n            <div class="content_text">\n                <div class="content_text_left">特批编号</div>\n                <div class="content_text_right" id="spec_detail_specialNum">');
				this.WriteTo(__razor_helper_writer, this.ModelData.SpecialNum);
				this.WriteLiteralTo(__razor_helper_writer, '</div>\n            </div>\n        </li>\n        <li class="li_detail">\n            <div class="content_text">\n                <div class="content_text_left">\n                    特批名称\n                </div>\n                <div class="content_text_right">\n                    <span id="spec_detail_specialName">');
				this.WriteTo(__razor_helper_writer, this.ModelData.SpecialName);
				this.WriteLiteralTo(__razor_helper_writer, '</span>\n                    <span>/</span>\n                    <span id="spec_detail_specialTypeName">');
				this.WriteTo(__razor_helper_writer, this.ModelData.SpecialTypeName);
				this.WriteLiteralTo(__razor_helper_writer, '</span>\n                </div>\n            </div>\n            <div class="content_text">\n                <div class="content_text_left">\n                    创建人\n                </div>\n                <div class="content_text_right">\n                    <span id="spec_detail_createName">');
				this.WriteTo(__razor_helper_writer, this.ModelData.CreateName);
				this.WriteLiteralTo(__razor_helper_writer, '</span>\n                    <span>/</span>\n                    <span id="spec_detail_createOnFormart">');
				this.WriteTo(__razor_helper_writer, this.ModelData.CreateOnFormart);
				this.WriteLiteralTo(__razor_helper_writer, '</span>\n                </div>\n            </div>\n            <div class="content_text">\n                <div class="content_text_left">\n                    有效时间\n                </div>\n                <div class="content_text_right">\n                    <span id="spec_detail_vaildTimeFormmart">');
				this.WriteTo(__razor_helper_writer, this.ModelData.VaildTimeFormmart);
				this.WriteLiteralTo(__razor_helper_writer, '</span>\n                    <span>到</span>\n                    <span id="spec_detail_vaildTimeToFormart">');
				this.WriteTo(__razor_helper_writer, this.ModelData.VaildTimeToFormart);
				this.WriteLiteralTo(__razor_helper_writer, '</span>\n                </div>\n\n            </div>\n        </li>\n        <li class="li_detail_title divider textBadge"></li>\n        <li class="li_detail" id="li_spec_audit_proc_track">\n            <div class="content_text">\n                特批流程跟踪\n                <img src="img/arrow_right_gray@2x.png" style="width: 6px; height: 11px; float: right; margin-top: 4px;">\n            </div>\n        </li>\n        <li class="li_detail_title divider textBadge"></li>\n        <li class="li_detail">\n            <div class="content_text">\n                客户名称\n            </div>\n        </li>\n        <li class="li_detail">\n');
				var customerName = (!ss.isNullOrEmptyString(this.ModelData.CustomerName) ? this.ModelData.CustomerName : '无');
				this.WriteLiteralTo(__razor_helper_writer, '            <div class="content_text" id="spec_detail_customerName">');
				this.WriteTo(__razor_helper_writer, customerName);
				this.WriteLiteralTo(__razor_helper_writer, '</div>\n        </li>\n        <li class="li_detail_title divider textBadge"></li>\n        <li class="li_detail">\n            <div class="content_text">\n                <div class="content_text_left">销售信息</div>\n                <div class="content_text_right" style="color: #f35935">\n                    <span id="spec_detail_saleChannelName">');
				this.WriteTo(__razor_helper_writer, (!ss.isNullOrEmptyString(this.ModelData.SaleChannelName) ? this.ModelData.SaleChannelName : '无分销渠道'));
				this.WriteLiteralTo(__razor_helper_writer, '</span>\n                    <span>—</span>\n                    <span id="spec_detail_apportionOrgName" class="">');
				this.WriteTo(__razor_helper_writer, (!ss.isNullOrEmptyString(this.ModelData.ApportionOrgName) ? this.ModelData.ApportionOrgName : '无毛利分摊部门'));
				this.WriteLiteralTo(__razor_helper_writer, '</span>\n                </div>\n            </div>\n        </li>\n        <li class="li_detail">\n            <div class="content_text" id="spec_detail_organizationName">');
				this.WriteTo(__razor_helper_writer, (!ss.isNullOrEmptyString(this.ModelData.OrganizationName) ? this.ModelData.OrganizationName : '无销售组织'));
				this.WriteLiteralTo(__razor_helper_writer, '</div>\n        </li>\n        <li class="li_detail_title divider textBadge"></li>\n        <li class="li_detail">\n            <div class="content_text">\n                说明\n            </div>\n        </li>\n        <li class="li_detail">\n            <div class="content_text" id="spec_detail_memo">');
				this.WriteTo(__razor_helper_writer, this.ModelData.Memo);
				this.WriteLiteralTo(__razor_helper_writer, '</div>\n        </li>\n        <li class="li_detail_title divider textBadge"></li>\n    </ul>\n');
				this.WriteLiteralTo(__razor_helper_writer, '    <ul class="list inset" id="spec_detail_productlist">\n        <li class="li_detail">\n            <div class="content_text">产品列表</div>\n        </li>\n');
				var count = 0;
				this.WriteLiteralTo(__razor_helper_writer, '\n');
				for (var $t1 = 0; $t1 < this.ModelData.Items.length; $t1++) {
					var item = this.ModelData.Items[$t1];
					var applyCorePrice = (ss.isValue(item.ApplyCorePrice) ? ss.unbox(item.ApplyCorePrice).toFixed(2) : '0.00');
					var showApplyCorePriceBasic = ss.contains($App.app.permissions, 'ShowApplyCorePriceBasic');
					this.WriteLiteralTo(__razor_helper_writer, '            <li class="li_work">\n                <a name="a_specdetailproduct" productindex="');
					this.WriteTo(__razor_helper_writer, count);
					this.WriteLiteralTo(__razor_helper_writer, '" data-productid="');
					this.WriteTo(__razor_helper_writer, item.ProductId);
					this.WriteLiteralTo(__razor_helper_writer, '">\n                    <div class="spec_detail_product">\n                        <div class="line">\n                            <div class="line_left">R3物料代码：</div>\n                            <div class="line_right">');
					this.WriteTo(__razor_helper_writer, item.ProductR3Code);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\n                        </div><div class="line">\n                            <div class="line_left">物料名称：</div>\n                            <div class="line_right">');
					this.WriteTo(__razor_helper_writer, item.ProductBirefName);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\n                        </div><div class="line">\n                            <div class="line_left">申请/审核数量：</div><div class="line_right">\n                                <span class="line_right_original">');
					this.WriteTo(__razor_helper_writer, item.ApplyNum);
					this.WriteLiteralTo(__razor_helper_writer, '</span>-&gt;\n                                <span class="line_right_modify">\n                                    ');
					this.WriteTo(__razor_helper_writer, (ss.isValue(item.AgreeNum) ? ss.unbox(item.AgreeNum) : item.ApplyNum));
					this.WriteLiteralTo(__razor_helper_writer, '\n                                </span>\n                            </div>\n                        </div><div class="line">\n                            <div class="line_left">申请/审核单价：</div>\n                            <div class="line_right">\n                                <span class="line_right_original">\n                                    ');
					this.WriteTo(__razor_helper_writer, (ss.isValue(item.ApplyPrice) ? ss.unbox(item.ApplyPrice).toFixed(2) : ''));
					this.WriteLiteralTo(__razor_helper_writer, ' 元/台\n                                </span>-&gt;\n                                <span class="line_right_modify">\n                                    ');
					this.WriteTo(__razor_helper_writer, (ss.isValue(item.AgreePrice) ? ss.unbox(item.AgreePrice).toFixed(2) : ss.unbox(item.ApplyPrice).toFixed(2)));
					this.WriteLiteralTo(__razor_helper_writer, ' 元/台\n                                </span>\n                            </div>\n                        </div><div class="line">\n                            <div class="line_left">申请/特批核算单价：</div>\n                            <div class="line_right">\n                                <span class="line_right_original">\n                                    ');
					this.WriteTo(__razor_helper_writer, applyCorePrice);
					this.WriteLiteralTo(__razor_helper_writer, ' 元/台\n                                </span>-&gt;\n                                <span class="line_right_modify">\n                                    ');
					this.WriteTo(__razor_helper_writer, (showApplyCorePriceBasic ? (ss.isValue(item.AuditCorePrice) ? ss.unbox(item.AuditCorePrice).toFixed(2) : '0.00') : '0.00'));
					this.WriteLiteralTo(__razor_helper_writer, ' 元/台\n                                </span>\n                            </div>\n                        </div>\n                    </div>\n                </a>\n            </li>\n');
					count++;
				}
				this.WriteLiteralTo(__razor_helper_writer, '\n    </ul>\n');
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="SpecDetail">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">特批详情</div>\n    </div>\n    <div class="content" id="pnlContent">\n      \n\n    </div>\n    <div id="btn_spec_audit" class="redButton" style="display:none;">\n        特批审核\n    </div>\n</div>\n\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.btn_spec_audit = this.pageObject.find('#btn_spec_audit');
			this.ulSpecDetail = this.pageObject.find('#ulSpecDetail');
			this.spec_detail_specialNum = this.pageObject.find('#spec_detail_specialNum');
			this.spec_detail_specialName = this.pageObject.find('#spec_detail_specialName');
			this.spec_detail_specialTypeName = this.pageObject.find('#spec_detail_specialTypeName');
			this.spec_detail_createName = this.pageObject.find('#spec_detail_createName');
			this.spec_detail_createOnFormart = this.pageObject.find('#spec_detail_createOnFormart');
			this.spec_detail_vaildTimeFormmart = this.pageObject.find('#spec_detail_vaildTimeFormmart');
			this.spec_detail_vaildTimeToFormart = this.pageObject.find('#spec_detail_vaildTimeToFormart');
			this.li_spec_audit_proc_track = this.pageObject.find('#li_spec_audit_proc_track');
			this.spec_detail_customerName = this.pageObject.find('#spec_detail_customerName');
			this.spec_detail_saleChannelName = this.pageObject.find('#spec_detail_saleChannelName');
			this.spec_detail_apportionOrgName = this.pageObject.find('#spec_detail_apportionOrgName');
			this.spec_detail_organizationName = this.pageObject.find('#spec_detail_organizationName');
			this.spec_detail_memo = this.pageObject.find('#spec_detail_memo');
			this.spec_detail_productlist = this.pageObject.find('#spec_detail_productlist');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.btn_spec_audit)) {
				this.btn_spec_audit.unbind().off();
				this.btn_spec_audit = null;
			}
			if (ss.isValue(this.ulSpecDetail)) {
				this.ulSpecDetail.unbind().off();
				this.ulSpecDetail = null;
			}
			if (ss.isValue(this.spec_detail_specialNum)) {
				this.spec_detail_specialNum.unbind().off();
				this.spec_detail_specialNum = null;
			}
			if (ss.isValue(this.spec_detail_specialName)) {
				this.spec_detail_specialName.unbind().off();
				this.spec_detail_specialName = null;
			}
			if (ss.isValue(this.spec_detail_specialTypeName)) {
				this.spec_detail_specialTypeName.unbind().off();
				this.spec_detail_specialTypeName = null;
			}
			if (ss.isValue(this.spec_detail_createName)) {
				this.spec_detail_createName.unbind().off();
				this.spec_detail_createName = null;
			}
			if (ss.isValue(this.spec_detail_createOnFormart)) {
				this.spec_detail_createOnFormart.unbind().off();
				this.spec_detail_createOnFormart = null;
			}
			if (ss.isValue(this.spec_detail_vaildTimeFormmart)) {
				this.spec_detail_vaildTimeFormmart.unbind().off();
				this.spec_detail_vaildTimeFormmart = null;
			}
			if (ss.isValue(this.spec_detail_vaildTimeToFormart)) {
				this.spec_detail_vaildTimeToFormart.unbind().off();
				this.spec_detail_vaildTimeToFormart = null;
			}
			if (ss.isValue(this.li_spec_audit_proc_track)) {
				this.li_spec_audit_proc_track.unbind().off();
				this.li_spec_audit_proc_track = null;
			}
			if (ss.isValue(this.spec_detail_customerName)) {
				this.spec_detail_customerName.unbind().off();
				this.spec_detail_customerName = null;
			}
			if (ss.isValue(this.spec_detail_saleChannelName)) {
				this.spec_detail_saleChannelName.unbind().off();
				this.spec_detail_saleChannelName = null;
			}
			if (ss.isValue(this.spec_detail_apportionOrgName)) {
				this.spec_detail_apportionOrgName.unbind().off();
				this.spec_detail_apportionOrgName = null;
			}
			if (ss.isValue(this.spec_detail_organizationName)) {
				this.spec_detail_organizationName.unbind().off();
				this.spec_detail_organizationName = null;
			}
			if (ss.isValue(this.spec_detail_memo)) {
				this.spec_detail_memo.unbind().off();
				this.spec_detail_memo = null;
			}
			if (ss.isValue(this.spec_detail_productlist)) {
				this.spec_detail_productlist.unbind().off();
				this.spec_detail_productlist = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Spec_SpecList, $asm, {
		$SpecList_OnPageInit: function(sender, e) {
			var iscrollList = this.SetIscrollList(this.ulSpecQueryListContainer[0], 20, 100, true, false, true);
			iscrollList.set_GetPageData(ss.mkdel(this, function(index) {
				var $state = 0, $tcs = new ss.TaskCompletionSource(), queryCondition, $t1, result, $t2;
				var $sm = ss.mkdel(this, function() {
					try {
						$sm1:
						for (;;) {
							switch ($state) {
								case 0: {
									$state = -1;
									queryCondition = $USOProject_Business_SpecQueryCondtion.$ctor();
									queryCondition.CustomerName = this.$pageQuery.Customer;
									queryCondition.SpecialName = this.$pageQuery.SpecName;
									queryCondition.SpecialType = this.$pageQuery.Spectype;
									queryCondition.FromDate = this.$pageQuery.FromDate;
									queryCondition.ToDate = this.$pageQuery.ToDate;
									queryCondition.SpecialNum = this.$pageQuery.SpecId;
									queryCondition.Page = index;
									queryCondition.PageSize = 20;
									queryCondition.SpecialStatus = CoreEx.ToInt(this.pageObject.find('.spec_status_tab.selected').attr('status'), 0);
									queryCondition.CustomerWorkFlowlRangeStatus = 1;
									$t1 = $USOProject_Business_BusinessAction.QuerySpecList(queryCondition, this);
									$state = 1;
									$t1.continueWith($sm);
									return;
								}
								case 1: {
									$state = -1;
									result = $t1.getAwaitedResult();
									$t2 = new JSLib.IScrollWraper.PageData();
									$t2.PageIndex = index;
									$t2.RecordCount = result.Result.length;
									$t2.ResultElement = jQueryObjectEx.ToJqueryObject$1(this.GetSpecItemHtml(result.Result));
									$tcs.setResult($t2);
									return;
								}
								default: {
									break $sm1;
								}
							}
						}
					}
					catch ($t3) {
						$tcs.setException(ss.Exception.wrap($t3));
					}
				});
				$sm();
				return $tcs.task;
			}));
			//iscrollList.ReLoad();
			//切换审核状态
			this.spec_list_status_tab.on('click', '.spec_status_tab', ss.thisFix(function(elem, event) {
				$(elem).siblings().removeClass('selected');
				$(elem).addClass('selected');
				iscrollList.ReLoad();
			}));
			//点击第一个标签
			this.spec_list_status_tab.children().first().click();
			this.ulSpecQueryListContainer.on('click', 'li[specid]', ss.thisFix(function(elem1, event1) {
				var specid = elem1.getAttribute('specid');
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Spec_SpecDetail).call(null, specid, function(page) {
					page.IsSpecAuditFinished = function() {
						iscrollList.ReLoad();
					};
				});
			}));
			this.header_search.click(ss.mkdel(this, function(event2) {
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_Spec_SpecQuery).call(null, this.$pageQuery, ss.mkdel(this, function(page1) {
					page1.OnSearchButttonClick = ss.mkdel(this, function(condition) {
						this.$pageQuery = condition;
						iscrollList.ReLoad();
					});
				}));
			}));
		},
		GetSpecItemHtml: function(data) {
			return new System.Web.WebPages.HelperResult(ss.mkdel(this, function(__razor_helper_writer) {
				if (ss.isNullOrUndefined(data) || data.length === 0) {
					this.WriteLiteralTo(__razor_helper_writer, '        <div class="noData">暂无数据</div>\r\n');
				}
				for (var $t1 = 0; $t1 < data.length; $t1++) {
					var item = data[$t1];
					this.WriteLiteralTo(__razor_helper_writer, '        <li specid="');
					this.WriteTo(__razor_helper_writer, item.Id);
					this.WriteLiteralTo(__razor_helper_writer, '" class="li_work">\r\n            <a style="height: 64px;">\r\n                <div>\r\n                    <div class="work_title">\r\n                        <span class="special_number">');
					this.WriteTo(__razor_helper_writer, item.SpecialNum);
					this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                        <span class="special_status">');
					this.WriteTo(__razor_helper_writer, item.SpecialStatusString);
					this.WriteLiteralTo(__razor_helper_writer, '</span>\r\n                    </div>\r\n                    <div class="work_detail">');
					this.WriteTo(__razor_helper_writer, item.CustomerName);
					this.WriteLiteralTo(__razor_helper_writer, ' &nbsp;');
					this.WriteTo(__razor_helper_writer, item.SpecialName);
					this.WriteLiteralTo(__razor_helper_writer, ' &nbsp; ');
					this.WriteTo(__razor_helper_writer, item.SpecialTypeString);
					this.WriteLiteralTo(__razor_helper_writer, '</div>\r\n                </div>\r\n            </a>\r\n        </li>\r\n');
				}
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="SpecList">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">特批审核列表</div>\n        <div id="header_search" class="queryButton"></div>\n\n    </div>\n    <div class="content" id="pnlContent">\n        <div id="spec_list_status_tab">\n            <div class="spec_status_tab selected" status="');
			this.Write(1);
			this.WriteLiteral(' ">特批审核中</div>\r\n            <div class="spec_status_tab" status="');
			this.Write(2);
			this.WriteLiteral('">特批已审核</div>\n        </div>\n        <ul id="ulSpecQueryListContainer" style="width: 100%; overflow: auto;" class="list inset"></ul>\n        <a id="spec_list_more" class="button block" style="width: 100%; border: 0px; font-size: 14px; color: rgb(0, 136, 209); display: none; background-color: transparent;" afmoldstyle="block">点击查看更多</a>\n    </div>\n</div>\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.header_search = this.pageObject.find('#header_search');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.spec_list_status_tab = this.pageObject.find('#spec_list_status_tab');
			this.ulSpecQueryListContainer = this.pageObject.find('#ulSpecQueryListContainer');
			this.spec_list_more = this.pageObject.find('#spec_list_more');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.header_search)) {
				this.header_search.unbind().off();
				this.header_search = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.spec_list_status_tab)) {
				this.spec_list_status_tab.unbind().off();
				this.spec_list_status_tab = null;
			}
			if (ss.isValue(this.ulSpecQueryListContainer)) {
				this.ulSpecQueryListContainer.unbind().off();
				this.ulSpecQueryListContainer = null;
			}
			if (ss.isValue(this.spec_list_more)) {
				this.spec_list_more.unbind().off();
				this.spec_list_more = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Spec_SpecProcTrack, $asm, {
		$SpecProcTrack_OnPageShow: function(sender, e) {
			this.SetScrollable(this.pnlContent[0], false, true, false, null, null, null, '', false, null, true, true);
			//如果最后一步已通过，那么“完成”需要显示为已完成的状态（黑色，而非灰色）
			if (this.IsFinished) {
				this.pageObject.find('li.li_process div.process_timeline').first().find('i').removeClass('process_timeline_grey').addClass('process_timeline_blue');
				this.pageObject.find('li.li_process div.toprocess').first().addClass('finished').removeClass('topproess');
			}
		},
		$SpecProcTrack_OnPageInit: function(sender, e) {
		},
		PrepareData: function() {
			this.processData = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="SpecProcTrack">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">流程跟踪</div>\n    </div>\n\n    <ul class="content list inset" id="pnlContent">\n');
			//processData.WorkFlowSteps -- 审批过程
			//processData.WorkFlowAllStep -- 所有审批流程
			var lastAllStepNo = this.processData.WorkFlowAllStep[this.processData.WorkFlowAllStep.length - 2].StepNo;
			var lastStepNo = this.processData.WorkFlowSteps[this.processData.WorkFlowSteps.length - 1].StepNo;
			for (var j = this.processData.WorkFlowAllStep.length - 1; j >= 0; j--) {
				if (this.processData.WorkFlowAllStep[j].StepNo > lastStepNo) {
					this.WriteLiteral('                    <li class="li_process">\n                        <div class="process_content">\n                            <div class="process_timeline">\n                                <i class="process_timeline_grey c-icon"></i>\n                            </div>\n                            <div class="process_info">\n                                <div class="process_title toprocess">\n                                    ');
					this.Write(this.processData.WorkFlowAllStep[j].StepName);
					this.WriteLiteral('\r\n                                </div>\r\n                            </div>\r\n                        </div>\r\n                    </li>\r\n');
				}
			}
			for (var i = this.processData.WorkFlowSteps.length - 1; i >= 0; i--) {
				var processStatusClass = ((this.processData.WorkFlowSteps[i].StepStatus === '未处理') ? 'processing' : 'processed');
				//如果最后一步已通过，那么“完成”需要显示为已完成的状态（黑色，而非灰色）
				if (lastAllStepNo === this.processData.WorkFlowSteps[i].StepNo && this.processData.WorkFlowSteps[i].StepStatus === '通过') {
					this.IsFinished = true;
				}
				this.WriteLiteral('                <li class="li_process">\n                    <div class="process_content">\n                        <div class="process_timeline process_timeline_grey">\n                            <i class="process_timeline_blue c-icon"></i>\n                        </div>\n                        <div class="process_info">\n                            <div class="process_title ');
				this.Write(processStatusClass);
				this.WriteLiteral('">\r\n                                <div class="process_title_stepname">\r\n                                    [');
				this.Write(this.processData.WorkFlowSteps[i].StepName);
				this.WriteLiteral(']\r\n                                </div>\r\n                                <div class="process_title_status">\r\n                                    ');
				this.Write(this.processData.WorkFlowSteps[i].StepStatus);
				this.WriteLiteral('\r\n                                </div>\r\n                            </div>\r\n                            <div class="process_sub">\r\n');
				if (this.processData.WorkFlowSteps[i].StepStatus === '未处理') {
					this.WriteLiteral('                                    ');
					this.WriteLiteral('未处理人：');
					this.Write(this.processData.WorkFlowSteps[i].ThisPersonName);
					this.WriteLiteral('\r\n');
				}
				else {
					this.Write(this.processData.WorkFlowSteps[i].ProcessedOn);
					this.Write(this.processData.WorkFlowSteps[i].ProPersonName);
				}
				this.WriteLiteral('                            </div>\r\n                        </div>\r\n                    </div>\r\n');
				if (!ss.isNullOrEmptyString(this.processData.WorkFlowSteps[i].Note)) {
					this.WriteLiteral('                        <div class="process_nav">\r\n                            备注: ');
					this.Write(this.processData.WorkFlowSteps[i].Note);
					this.WriteLiteral('\r\n                        </div>\r\n');
				}
				this.WriteLiteral('                </li>\r\n');
			}
			this.WriteLiteral('    </ul>\r\n\r\n</div>\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Spec_SpecProcTrack$SpecProcTrackData, $asm, {});
	ss.initClass($USOProject_Pages_Spec_SpecProductDetail, $asm, {
		$SpecProductDetail_OnPageShow: function(sender, e) {
			//待审核时，三个审批项的值如果为空，则等于申请的值
			if (this.SpecialData.Status === 1) {
				if (ss.Nullable$1.gt(this.product.AuditNum, 0)) {
					this.txt_prod_detail_auditnum.val($NullableExtenion.ForamtInt(this.product.AuditNum, ''));
				}
				else {
					this.txt_prod_detail_auditnum.val($NullableExtenion.ForamtInt(this.product.AgreeNum, ''));
				}
				if (ss.Nullable$1.gt(this.product.AuditPrice, 0)) {
					this.txt_prod_detail_auditprice.val((ss.isValue(this.product.AuditPrice) ? $NullableExtenion.FormatMoney(this.product.AuditPrice, '') : ''));
				}
				else {
					this.txt_prod_detail_auditprice.val((ss.isValue(this.product.AgreePrice) ? $NullableExtenion.FormatMoney(this.product.AgreePrice, '') : ''));
				}
				if (ss.Nullable$1.gt(this.product.AuditCorePrice, 0)) {
					this.txt_prod_detail_auditcoreprice.val($NullableExtenion.FormatMoney(this.product.AuditCorePrice, '0.00'));
				}
				else {
					this.txt_prod_detail_auditcoreprice.val((ss.isValue(this.product.AgreeCorePrice) ? $NullableExtenion.FormatMoney(this.product.AgreeCorePrice, '0.00') : ''));
				}
				//价格是否能修改的逻辑,只有逐单审批不能修改价格和数量，其他都能修改
				if ($NullableExtenion.WithDefault$1(this.SpecialData.OrderId, 0) > 0 || !this.SpecialData.IsAllowModifyPrice) {
					this.txt_prod_detail_auditnum.attr('readonly', 'readonly').removeAttr('style');
					this.txt_prod_detail_auditprice.attr('readonly', 'readonly').removeAttr('style');
				}
				else {
					this.txt_prod_detail_auditnum.removeAttr('readonly').css('style', 'color: rgb(245,132,111); border:1px;border-style: solid;margin-top: 1px;');
					this.txt_prod_detail_auditprice.removeAttr('readonly').css('style', 'color: rgb(245,132,111); border:1px;border-style: solid;margin-top: 1px;');
				}
				this.txt_prod_detail_auditcoreprice.removeAttr('readonly').css('style', 'color: rgb(245,132,111); border:1px;border-style: solid;margin-top: 1px;').attr('placeholder', '请输入特批核算单价');
				this.prod_detail_HaveRoyalties.removeAttr('disabled').css('style', 'color: rgb(245,132,111); border:1px;border-style: solid;margin-top: 1px;');
				this.prod_detail_havegrossprofit.removeAttr('disabled').css('style', 'color: rgb(245,132,111); border:1px;border-style: solid;margin-top: 1px;');
			}
			else {
				this.txt_prod_detail_auditnum.val($NullableExtenion.ForamtInt(this.product.AuditNum, ''));
				this.txt_prod_detail_auditprice.val($NullableExtenion.FormatMoney(this.product.AuditPrice, '无'));
				if ($USOProject_Business_ToCompletion_PermissionManager.Have_ShowApplyCorePriceBasic()) {
					this.txt_prod_detail_auditcoreprice.val($NullableExtenion.FormatMoney(this.product.AuditCorePrice, '无'));
				}
				else {
					this.txt_prod_detail_auditcoreprice.val('');
				}
				this.txt_prod_detail_auditnum.attr('readonly', 'readonly');
				this.txt_prod_detail_auditnum.removeAttr('style');
				this.txt_prod_detail_auditprice.attr('readonly', 'readonly');
				this.txt_prod_detail_auditprice.removeAttr('style');
				this.txt_prod_detail_auditcoreprice.attr('readonly', 'readonly');
				this.txt_prod_detail_auditcoreprice.removeAttr('style');
				this.txt_prod_detail_auditcoreprice.removeAttr('placeholder');
				this.prod_detail_HaveRoyalties.attr('disabled', 'disabled').removeAttr('style');
				this.prod_detail_havegrossprofit.attr('disabled', 'disabled').removeAttr('style');
			}
			if (ss.isNullOrUndefined(this.product.ApplyCorePrice)) {
				this.txt_prod_detail_auditcoreprice.attr('readonly', 'readonly');
				this.txt_prod_detail_auditcoreprice.removeAttr('style');
				this.txt_prod_detail_auditcoreprice.removeAttr('placeholder');
			}
			else {
				this.prod_detail_applycoreprice.val(this.product.ApplyCorePrice.toString());
				if (ss.isNullOrUndefined(this.product.AuditCorePrice)) {
					this.txt_prod_detail_auditcoreprice.val(this.product.ApplyCorePrice.toString());
				}
				else {
					this.txt_prod_detail_auditcoreprice.val(this.product.AuditCorePrice.toString());
				}
			}
			this.prod_detail_HaveRoyalties.val(((ss.isValue(this.product.HaveRoyalties) && ss.unbox(this.product.HaveRoyalties) === 1) ? '1' : '0'));
			this.prod_detail_havegrossprofit.val(((ss.isValue(this.product.HaveGrossProfit) && ss.unbox(this.product.HaveGrossProfit) === 1) ? '1' : '0'));
		},
		$SpecProductDetail_OnPageInit: function(sender, e) {
			this.SetScrollable(this.pnlContent[0], false, true, false, null, null, null, '', false, null, true, true);
			this.spec_product_detail_confirm.click(ss.mkdel(this, function(event) {
				var auditNumVal = CoreEx.ToInt(this.txt_prod_detail_auditnum.val(), 0);
				var oriNum = CoreEx.ToInt(this.prod_detail_applynum.val().trim(), 0);
				var auditPriceVal = CoreEx.ToDoubleWithDefault(this.txt_prod_detail_auditprice.val().trim(), 0);
				var auditCorePriceVal = CoreEx.ToDoubleWithDefault(this.txt_prod_detail_auditcoreprice.val().trim(), -1);
				if (isNaN(auditNumVal) || auditNumVal < 1) {
					JSLib.Mobile.MessageBox.Alert('审核数量无效');
					return;
				}
				var auditNum = auditNumVal;
				if (auditNum > oriNum) {
					JSLib.Mobile.MessageBox.Alert('审核数量不能大于申请数量');
					return;
				}
				if (isNaN(auditPriceVal) || auditPriceVal <= 0) {
					JSLib.Mobile.MessageBox.Alert('审核价格无效');
					return;
				}
				if (ss.isNullOrEmptyString(this.txt_prod_detail_auditcoreprice.attr('readonly'))) {
					if (isNaN(auditCorePriceVal) || auditCorePriceVal < 0) {
						JSLib.Mobile.MessageBox.Alert('审核核算价格无效');
						return;
					}
				}
				var $t1 = new $USOProject_Pages_Spec_SpecProductDetail$ResultData();
				$t1.AuditCorePrice = auditCorePriceVal;
				$t1.AuditNum = auditNum;
				$t1.AuditPrice = auditPriceVal;
				$t1.HaveRoyalties = CoreEx.ToInt(this.prod_detail_HaveRoyalties.val(), 0);
				$t1.HaveGrossProfit = CoreEx.ToInt(this.prod_detail_havegrossprofit.val(), 0);
				var result = $t1;
				if (!ss.staticEquals(this.OnModifyComplete, null)) {
					this.OnModifyComplete(result);
				}
				JSLib.Mobile.Application.Back(1);
			}));
		},
		PrepareData: function() {
			this.product = this.InitialData.Product;
			this.SpecialData = this.InitialData.SpecialData;
			return null;
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="SpecProductDetail">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">特批产品详情</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="inputPanel">\n            <div class="InputItem">\n                <div class="title">产品编号</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_productNo" type="text" value="');
			this.Write(this.product.ProductId);
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">产品型号</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_productmode" type="text" value="');
			this.Write(StringHelper.WithDefault(this.product.ProductMode, '无'));
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">物料名称</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_productbirefname" type="text" value="');
			this.Write(StringHelper.WithDefault(this.product.ProductBirefName, '无'));
			this.WriteLiteral('">\n                </div>\n            </div>\n\n            <div class="InputItem">\n                <div class="title">R3物料代码</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_productr3code" type="text" value="');
			this.Write(StringHelper.WithDefault(this.product.ProductR3Code, '无'));
			this.WriteLiteral('">\n                </div>\n            </div>\n\n            <div class="InputItem">\n                <div class="title">申请数量</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_applynum" type="text" value="');
			this.Write($NullableExtenion.WithDefault$1(this.product.ApplyNum, 0));
			this.WriteLiteral('">\n                </div>\n            </div>\n\n            <div class="InputItem">\n                <div class="title">下级审批数量</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_agreenum" type="text" value="');
			this.Write($NullableExtenion.WithDefault$1(this.product.AgreeNum, 0));
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div id="div_agreenum_title" class="title" style="color: rgb(245,132,111)">审核数量</div>\n                <div id="div_agreenum_content" class="inputWarp">\n                    <input id="txt_prod_detail_auditnum" type="text" value="" placeholder="请输入审核数量" data-modal-number style="color: rgb(245,132,111); border:1px;border-style: solid;margin-top: 1px;">\n                    <!--<img src="img/arrow_right_gray@2x.png" style="width: 6px; height: 11px; float: right; margin-top: -23px;" />-->\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">特批申请单价</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_applyprice" type="text">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">下级审批单价</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_agreeprice" type="text" class="">\n                </div>\n            </div>\n\n            <div class="InputItem">\n                <div id="div_agreeprice_title" class="title" style="color: rgb(245,132,111)">特批审核单价</div>\n                <div id="div_agreeprice_content" class="inputWarp">\n                    <input id="txt_prod_detail_auditprice" type="text" placeholder="请输入审核单价" data-modal-number style="color: rgb(245,132,111); border:1px;border-style: solid;margin-top: 1px;">\n                    <!--<img src="img/arrow_right_gray@2x.png" style="width: 6px; height: 11px; float: right; margin-top: -23px;" />-->\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">申请核算单价</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_applycoreprice" type="text">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div id="div_agreecoreprice_title" class="title" style="color: rgb(245,132,111)">特批核算单价</div>\n                <div id="div_agreecoreprice_content" class="inputWarp">\n                    <input id="txt_prod_detail_auditcoreprice" type="text" placeholder="请输入特批核算单价" data-modal-number style="color: rgb(245,132,111);border:1px;border-style: solid;margin-top: 1px;">\n                    <!--<img src="img/arrow_right_gray@2x.png" style="width: 6px; height: 11px; float: right; margin-top: -23px;" />-->\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">客户价</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_nowprice" type="text" value="');
			this.Write($NullableExtenion.WithDefault(this.product.NowPrice, 0).toFixed(2));
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title" style="color: rgb(255,50,50);">内核价</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_internalaccountprice" type="text" style="color: rgb(255,50,50);" value="');
			this.Write($NullableExtenion.FormatMoney(this.product.InternalAccountPrice, '无'));
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title" style="color: rgb(255,50,50);">分公司红线价</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_redlinpriceofsubcompay" type="text" style="color: rgb(255,50,50);" value="');
			this.Write($NullableExtenion.FormatMoney(this.product.RedLinPriceOfSubCompay, '无'));
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">折扣</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_discountamt" type="text" value="');
			this.Write($NullableExtenion.FormatMoney(this.product.DiscountAmt, '无'));
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">有无分红</div>\n                <div class="inputWarp">\n                    <div class="submit_input ">\n                        <select id="prod_detail_HaveRoyalties" class="" style="color: rgb(245,132,111); border:1px;border-style: solid;margin-top: 1px;">\n                            <option value="0">\n                                无\n                            </option>\n                            <option value="1">\n                                有\n                            </option>\n                        </select>\n                    </div>\n                </div>\n            </div>\n\n            <div class="InputItem">\n                <div class="title">有无毛利</div>\n                <div class="inputWarp">\n                    <div class="submit_input ">\n                        <select id="prod_detail_havegrossprofit" class="" style="color: rgb(245,132,111); border:1px;border-style: solid;margin-top: 1px;">\n                            <option value="0">\n                                无\n                            </option>\n                            <option value="1">\n                                有\n                            </option>\n                        </select>\n                    </div>\n                </div>\n            </div>\n\n            <div class="InputItem">\n                <div class="title">状态</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_status" type="text" value="');
			this.Write(((this.product.Status === 1) ? '有效' : '无效'));
			this.WriteLiteral('">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">备注</div>\n                <div class="inputWarp">\n                    <input readonly="readonly" id="prod_detail_note" type="text" value="');
			this.Write((!ss.isNullOrEmptyString(this.product.Note) ? this.product.Note : '无'));
			this.WriteLiteral('">\n                </div>\n            </div>\n        </div>\n    </div>\n    <div id="spec_product_detail_confirm" class="redButton">\n        确定\n    </div>\n</div>\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.prod_detail_productNo = this.pageObject.find('#prod_detail_productNo');
			this.prod_detail_productmode = this.pageObject.find('#prod_detail_productmode');
			this.prod_detail_productbirefname = this.pageObject.find('#prod_detail_productbirefname');
			this.prod_detail_productr3code = this.pageObject.find('#prod_detail_productr3code');
			this.prod_detail_applynum = this.pageObject.find('#prod_detail_applynum');
			this.prod_detail_agreenum = this.pageObject.find('#prod_detail_agreenum');
			this.div_agreenum_title = this.pageObject.find('#div_agreenum_title');
			this.div_agreenum_content = this.pageObject.find('#div_agreenum_content');
			this.txt_prod_detail_auditnum = this.pageObject.find('#txt_prod_detail_auditnum');
			this.prod_detail_applyprice = this.pageObject.find('#prod_detail_applyprice');
			this.prod_detail_agreeprice = this.pageObject.find('#prod_detail_agreeprice');
			this.div_agreeprice_title = this.pageObject.find('#div_agreeprice_title');
			this.div_agreeprice_content = this.pageObject.find('#div_agreeprice_content');
			this.txt_prod_detail_auditprice = this.pageObject.find('#txt_prod_detail_auditprice');
			this.prod_detail_applycoreprice = this.pageObject.find('#prod_detail_applycoreprice');
			this.div_agreecoreprice_title = this.pageObject.find('#div_agreecoreprice_title');
			this.div_agreecoreprice_content = this.pageObject.find('#div_agreecoreprice_content');
			this.txt_prod_detail_auditcoreprice = this.pageObject.find('#txt_prod_detail_auditcoreprice');
			this.prod_detail_nowprice = this.pageObject.find('#prod_detail_nowprice');
			this.prod_detail_internalaccountprice = this.pageObject.find('#prod_detail_internalaccountprice');
			this.prod_detail_redlinpriceofsubcompay = this.pageObject.find('#prod_detail_redlinpriceofsubcompay');
			this.prod_detail_discountamt = this.pageObject.find('#prod_detail_discountamt');
			this.prod_detail_HaveRoyalties = this.pageObject.find('#prod_detail_HaveRoyalties');
			this.prod_detail_havegrossprofit = this.pageObject.find('#prod_detail_havegrossprofit');
			this.prod_detail_status = this.pageObject.find('#prod_detail_status');
			this.prod_detail_note = this.pageObject.find('#prod_detail_note');
			this.spec_product_detail_confirm = this.pageObject.find('#spec_product_detail_confirm');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.prod_detail_productNo)) {
				this.prod_detail_productNo.unbind().off();
				this.prod_detail_productNo = null;
			}
			if (ss.isValue(this.prod_detail_productmode)) {
				this.prod_detail_productmode.unbind().off();
				this.prod_detail_productmode = null;
			}
			if (ss.isValue(this.prod_detail_productbirefname)) {
				this.prod_detail_productbirefname.unbind().off();
				this.prod_detail_productbirefname = null;
			}
			if (ss.isValue(this.prod_detail_productr3code)) {
				this.prod_detail_productr3code.unbind().off();
				this.prod_detail_productr3code = null;
			}
			if (ss.isValue(this.prod_detail_applynum)) {
				this.prod_detail_applynum.unbind().off();
				this.prod_detail_applynum = null;
			}
			if (ss.isValue(this.prod_detail_agreenum)) {
				this.prod_detail_agreenum.unbind().off();
				this.prod_detail_agreenum = null;
			}
			if (ss.isValue(this.div_agreenum_title)) {
				this.div_agreenum_title.unbind().off();
				this.div_agreenum_title = null;
			}
			if (ss.isValue(this.div_agreenum_content)) {
				this.div_agreenum_content.unbind().off();
				this.div_agreenum_content = null;
			}
			if (ss.isValue(this.txt_prod_detail_auditnum)) {
				this.txt_prod_detail_auditnum.unbind().off();
				this.txt_prod_detail_auditnum = null;
			}
			if (ss.isValue(this.prod_detail_applyprice)) {
				this.prod_detail_applyprice.unbind().off();
				this.prod_detail_applyprice = null;
			}
			if (ss.isValue(this.prod_detail_agreeprice)) {
				this.prod_detail_agreeprice.unbind().off();
				this.prod_detail_agreeprice = null;
			}
			if (ss.isValue(this.div_agreeprice_title)) {
				this.div_agreeprice_title.unbind().off();
				this.div_agreeprice_title = null;
			}
			if (ss.isValue(this.div_agreeprice_content)) {
				this.div_agreeprice_content.unbind().off();
				this.div_agreeprice_content = null;
			}
			if (ss.isValue(this.txt_prod_detail_auditprice)) {
				this.txt_prod_detail_auditprice.unbind().off();
				this.txt_prod_detail_auditprice = null;
			}
			if (ss.isValue(this.prod_detail_applycoreprice)) {
				this.prod_detail_applycoreprice.unbind().off();
				this.prod_detail_applycoreprice = null;
			}
			if (ss.isValue(this.div_agreecoreprice_title)) {
				this.div_agreecoreprice_title.unbind().off();
				this.div_agreecoreprice_title = null;
			}
			if (ss.isValue(this.div_agreecoreprice_content)) {
				this.div_agreecoreprice_content.unbind().off();
				this.div_agreecoreprice_content = null;
			}
			if (ss.isValue(this.txt_prod_detail_auditcoreprice)) {
				this.txt_prod_detail_auditcoreprice.unbind().off();
				this.txt_prod_detail_auditcoreprice = null;
			}
			if (ss.isValue(this.prod_detail_nowprice)) {
				this.prod_detail_nowprice.unbind().off();
				this.prod_detail_nowprice = null;
			}
			if (ss.isValue(this.prod_detail_internalaccountprice)) {
				this.prod_detail_internalaccountprice.unbind().off();
				this.prod_detail_internalaccountprice = null;
			}
			if (ss.isValue(this.prod_detail_redlinpriceofsubcompay)) {
				this.prod_detail_redlinpriceofsubcompay.unbind().off();
				this.prod_detail_redlinpriceofsubcompay = null;
			}
			if (ss.isValue(this.prod_detail_discountamt)) {
				this.prod_detail_discountamt.unbind().off();
				this.prod_detail_discountamt = null;
			}
			if (ss.isValue(this.prod_detail_HaveRoyalties)) {
				this.prod_detail_HaveRoyalties.unbind().off();
				this.prod_detail_HaveRoyalties = null;
			}
			if (ss.isValue(this.prod_detail_havegrossprofit)) {
				this.prod_detail_havegrossprofit.unbind().off();
				this.prod_detail_havegrossprofit = null;
			}
			if (ss.isValue(this.prod_detail_status)) {
				this.prod_detail_status.unbind().off();
				this.prod_detail_status = null;
			}
			if (ss.isValue(this.prod_detail_note)) {
				this.prod_detail_note.unbind().off();
				this.prod_detail_note = null;
			}
			if (ss.isValue(this.spec_product_detail_confirm)) {
				this.spec_product_detail_confirm.unbind().off();
				this.spec_product_detail_confirm = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Spec_SpecProductDetail$ResultData, $asm, {});
	ss.initClass($USOProject_Pages_Spec_SpecProductDetail$SpecProductDetailData, $asm, {});
	ss.initClass($USOProject_Pages_Spec_SpecQuery, $asm, {
		$SpecQuery_OnPageInit: function(sender, e) {
			JSLib.Widget.Common.DateTimeSelector.BindTo(this.spec_search_date_beginDate[0]);
			JSLib.Widget.Common.DateTimeSelector.BindTo(this.spec_search_date_endDate[0]);
			if (!ss.isNullOrEmptyString(this.queryCondition.Spectype)) {
				this.spec_sel_spectypesearch.val(this.queryCondition.Spectype);
			}
			this.spec_a_dosearch.click(ss.mkdel(this, function(event) {
				this.queryCondition.SpecId = this.spec_txt_specid.val();
				this.queryCondition.SpecName = this.spec_txt_specname.val();
				this.queryCondition.Spectype = this.spec_sel_spectypesearch.val();
				if (this.queryCondition.Spectype === '-1') {
					this.queryCondition.Spectype = '';
				}
				this.queryCondition.FromDate = this.spec_search_date_beginDate.val();
				this.queryCondition.ToDate = this.spec_search_date_endDate.val();
				if (!ss.staticEquals(this.OnSearchButttonClick, null)) {
					this.OnSearchButttonClick(this.queryCondition);
				}
				JSLib.Mobile.Application.Back(1);
			}));
		},
		PrepareData: function() {
			this.queryCondition = this.InitialData;
			return Phone.RazorMobilePage.prototype.PrepareData.call(this);
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="SpecQuery">\r\n    <div class="head">\r\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\r\n        <div id="lblHeadText" class="headText">特批查询</div>\r\n    </div>\r\n    <div class="content" id="pnlContent">\r\n        <div class="submit_all">\r\n            <div class="inputPanel">\r\n                <div class="inputItem">\r\n                    <div class="title">特批号:</div>\r\n                    <div class="inputWarp">\r\n                        <input id="spec_txt_specid" type="search" placeholder="特批号" value="');
			this.Write(this.queryCondition.SpecId);
			this.WriteLiteral('">\r\n                    </div>\r\n                </div>\r\n\r\n                <div class="inputItem">\r\n                    <div class="title">特批名称:</div>\r\n                    <div class="inputWarp">\r\n                        <input id="spec_txt_specname" type="search" placeholder="特批名称" value="');
			this.Write(this.queryCondition.SpecName);
			this.WriteLiteral('">\r\n                    </div>\r\n                </div>\r\n                <div class="inputItem">\r\n                    <div class="title">客户名称:</div>\r\n                    <div class="inputWarp">\r\n                        <input id="spec_txt_customer" type="search" placeholder="客户名称" value="');
			this.Write(this.queryCondition.Customer);
			this.WriteLiteral('">\n                    </div>\n                </div>\n                <div class="inputItem">\n                    <div class="title">审批类型:</div>\n                    <div class="inputWarp">\n                        <select id="spec_sel_spectypesearch">\n                            <option value="-1">----所有审批类型----</option>\n                            <option value="0">普通特批</option>\n                            <option value="1">工程特批</option>\n                            <option value="2">多媒体退货特批</option>\n                            <option value="3">空调常规提货订单</option>\n                            <option value="4">空调常规退货订单</option>\n                            <option value="5">空调售中提货订单</option>\n                            <option value="6">空调售中退货订单</option>\n                            <option value="7">美菱常规特批</option>\n                            <option value="8">美菱等级品特批</option>\n                            <option value="9">美菱样机特批</option>\n                            <option value="10">美菱寄售特批</option>\n                            <option value="11">美菱工程特批</option>\n                            <option value="12">美菱退货特批</option>\n                            <option value="13">白皮机特批</option>\n                            <option value="14">智易家特批</option>\n                            <option value="15">智易家退货特批</option>\n                            <option value="16">多媒体关系购机特批</option>\n                            <option value="17">空调工程特批</option>\n                            <option value="18">空调关系购机特批</option>\n                            <option value="19">多媒体售中机特批</option>\n                            <option value="20">欧宝丽关系购机特批</option>\n                            <option value="21">欧宝丽工程特批</option>\n                            <option value="22">欧宝丽退货特批</option>\n                            <option value="23">多媒体屏裂机标准－特批</option>\n                            <option value="25">空调常规提货</option>\n                            <option value="26">美菱样机场外销售特批</option>\n                            <option value="27">美菱关系户购机特批</option>\n                        </select>\n                    </div>\n                </div>\n                <div class="inputItem">\n                    <div class="title">开始日期:</div>\n                    <div class="inputWarp">\n                        <input id="spec_search_date_beginDate"  type="text" placeholder="开始日期" value="');
			this.Write(this.queryCondition.FromDate);
			this.WriteLiteral('">\r\n                    </div>\r\n                </div>\r\n                <div class="inputItem">\r\n                    <div class="title">结束日期:</div>\r\n                    <div class="inputWarp">\r\n                        <input id="spec_search_date_endDate" type="text" placeholder="结束日期" class="" value="');
			this.Write(this.queryCondition.ToDate);
			this.WriteLiteral('">\n                    </div>\n                </div>\n\n            </div>\n        </div>\n    </div>\n    <div id="spec_a_dosearch" class="redButton">\n        提交查询\n    </div>\n</div>\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.spec_txt_specid = this.pageObject.find('#spec_txt_specid');
			this.spec_txt_specname = this.pageObject.find('#spec_txt_specname');
			this.spec_txt_customer = this.pageObject.find('#spec_txt_customer');
			this.spec_sel_spectypesearch = this.pageObject.find('#spec_sel_spectypesearch');
			this.spec_search_date_beginDate = this.pageObject.find('#spec_search_date_beginDate');
			this.spec_search_date_endDate = this.pageObject.find('#spec_search_date_endDate');
			this.spec_a_dosearch = this.pageObject.find('#spec_a_dosearch');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.spec_txt_specid)) {
				this.spec_txt_specid.unbind().off();
				this.spec_txt_specid = null;
			}
			if (ss.isValue(this.spec_txt_specname)) {
				this.spec_txt_specname.unbind().off();
				this.spec_txt_specname = null;
			}
			if (ss.isValue(this.spec_txt_customer)) {
				this.spec_txt_customer.unbind().off();
				this.spec_txt_customer = null;
			}
			if (ss.isValue(this.spec_sel_spectypesearch)) {
				this.spec_sel_spectypesearch.unbind().off();
				this.spec_sel_spectypesearch = null;
			}
			if (ss.isValue(this.spec_search_date_beginDate)) {
				this.spec_search_date_beginDate.unbind().off();
				this.spec_search_date_beginDate = null;
			}
			if (ss.isValue(this.spec_search_date_endDate)) {
				this.spec_search_date_endDate.unbind().off();
				this.spec_search_date_endDate = null;
			}
			if (ss.isValue(this.spec_a_dosearch)) {
				this.spec_a_dosearch.unbind().off();
				this.spec_a_dosearch = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Spec_SpecQuery$QueryCondition, $asm, {});
	ss.initClass($USOProject_Pages_SystemModule_ModifyPassword, $asm, {
		$ModifyPassword_OnPageInit: function(sender, e) {
			this.btnSubmit.click(ss.mkdel(this, function(event) {
				var $state = 0, oldPwd, newPwd, confirmPwd, $t1, result;
				var $sm = ss.mkdel(this, function() {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								oldPwd = this.txtCurPassword.val();
								newPwd = this.txtNewPassword.val();
								confirmPwd = this.txtReNewPassword.val();
								if (ss.isNullOrEmptyString(oldPwd)) {
									JSLib.Mobile.MessageBox.Alert('当前密码不能为空!');
									return;
								}
								if (ss.isNullOrEmptyString(newPwd)) {
									JSLib.Mobile.MessageBox.Alert('新密码不能为空!');
									return;
								}
								if (!ss.referenceEquals(newPwd, confirmPwd)) {
									JSLib.Mobile.MessageBox.Alert('新密码和确认密码不匹配!');
									this.txtNewPassword.val('');
									this.txtReNewPassword.val('');
									return;
								}
								$t1 = $USOProject_Business_BusinessAction.ModifyPassword(oldPwd, newPwd);
								$state = 1;
								$t1.continueWith($sm);
								return;
							}
							case 1: {
								$state = -1;
								result = $t1.getAwaitedResult();
								if (!result.IsSuccess) {
									JSLib.Mobile.MessageBox.Alert(result.ErrorMessage);
									return;
								}
								//移除保存的登陆信息
								$USOProject_SecurityLayerJS.RemovePersistentToken();
								JSLib.Mobile.MessageBox.Alert('修改密码成功！');
								JSLib.Mobile.Application.Back(1);
								$state = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				});
				$sm();
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="ModifyPassword">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">修改密码</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div class="inputPanel">\n            <div class="InputItem">\n                <div class="title">\n                    当前密码：\n                </div>\n                <div class="inputWarp">\n                    <input type="text" id="txtCurPassword" class="" style="-webkit-text-security: disc;">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">\n                    新密码：\n                </div>\n                <div class="inputWarp">\n                    <input type="text" id="txtNewPassword" class="" style="-webkit-text-security: disc;">\n                </div>\n            </div>\n            <div class="InputItem">\n                <div class="title">\n                    确认新密码：\n                </div>\n                <div class="inputWarp">\n                    <input type="text" id="txtReNewPassword" class="" style="-webkit-text-security: disc;">\n                </div>\n            </div>\n        </div>\n        <div id="btnSubmit" class="redButton">提交</div>\n    </div>\n</div>\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.txtCurPassword = this.pageObject.find('#txtCurPassword');
			this.txtNewPassword = this.pageObject.find('#txtNewPassword');
			this.txtReNewPassword = this.pageObject.find('#txtReNewPassword');
			this.btnSubmit = this.pageObject.find('#btnSubmit');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.txtCurPassword)) {
				this.txtCurPassword.unbind().off();
				this.txtCurPassword = null;
			}
			if (ss.isValue(this.txtNewPassword)) {
				this.txtNewPassword.unbind().off();
				this.txtNewPassword = null;
			}
			if (ss.isValue(this.txtReNewPassword)) {
				this.txtReNewPassword.unbind().off();
				this.txtReNewPassword = null;
			}
			if (ss.isValue(this.btnSubmit)) {
				this.btnSubmit.unbind().off();
				this.btnSubmit = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_SystemModule_ModuleSettings, $asm, {
		$ModuleSettings_OnPageShow: function(sender, e) {
		},
		$ModuleSettings_OnPageInit: function(sender, e) {
			this.SetScrollable(this.pnlContent[0], false, true, false, null, null, null, '', false, null, true, true);
			this.pageObject.on('change', '.toggleButton', ss.thisFix(function(elem, event) {
				var permissionModule = UIDataEx.GetBindData$1($USOProject_Business_ToCompletion_PermmissionModule).call(null, $(elem));
				$USOProject_Business_ToCompletion_PermissionManager.SetLocalPermision(permissionModule.PermissionName, $(elem).hasClass('active'));
			}));
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="ModuleSettings">\n    <div class="head">\n        <div id="btnBack" class="backButton" data-role="BackButton"><</div>\n        <div id="lblHeadText" class="headText">模块设置</div>\n    </div>\n    <div class="content" id="pnlContent">\n        <div>\n            <div class="divider">请选择要开启的模块</div>\n            <ul id="pnlModuleItems" class="permissionContainer">\n');
			var localPermissionDefine = $USOProject_Business_ToCompletion_PermissionManager.LocalPermissionDefine;
			var localDisabledPerssmision = $USOProject_Business_ToCompletion_PermissionManager.LoadDisabledPermission();
			for (var $t1 = 0; $t1 < localPermissionDefine.length; $t1++) {
				var item = localPermissionDefine[$t1];
				//服务端没有定义此本地权限，则取消显示
				if (!ss.contains($App.app.permissions, item.PermissionName)) {
					continue;
				}
				//加载当前权限的状态
				var activeClass = '';
				if (!ss.contains(localDisabledPerssmision, item.PermissionName)) {
					activeClass = 'active';
				}
				this.WriteLiteral('                        <li ');
				this.Write(this.DataBind(item));
				this.WriteLiteral(' data-permission="');
				this.Write(item.PermissionName);
				this.WriteLiteral('" class="modulesetting_li permissionItem">\r\n                            <div class="itemLeft">\r\n                                <div class="permissionImg" style="background-image: url(');
				this.Write(item.iconUrl);
				this.WriteLiteral(')"></div>\r\n                                <label class="permissionName">');
				this.Write(item.ModuleName);
				this.WriteLiteral('</label>\r\n                            </div>\r\n                            <div class="itemRight">\r\n                                <div class="toggleButton ');
				this.Write(activeClass);
				this.WriteLiteral('" name="modulesetting" data-permission="');
				this.Write(item.PermissionName);
				this.WriteLiteral('" ');
				this.Write(this.DataBind(item));
				this.WriteLiteral('>\r\n                                    <div class="on">ON</div>\r\n                                    <div class="off">OFF</div>\r\n                                </div>\r\n                            </div>\r\n                        </li>\r\n');
			}
			this.WriteLiteral('            </ul>\r\n        </div>\r\n    </div>\r\n</div>\r\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
			this.pnlModuleItems = this.pageObject.find('#pnlModuleItems');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
			if (ss.isValue(this.pnlModuleItems)) {
				this.pnlModuleItems.unbind().off();
				this.pnlModuleItems = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	ss.initClass($USOProject_Pages_Test_TestPage, $asm, {
		$TestPage_OnPageInit: function(sender, e) {
			var $state = 0, query, $t1, result;
			var $sm = ss.mkdel(this, function() {
				$sm1:
				for (;;) {
					switch ($state) {
						case 0: {
							$state = -1;
							query = {};
							query.OrderType = -1;
							query.R3ProductGroupId = -1;
							query.Page = 1;
							query.PageSize = 20;
							$t1 = $USOProject_Business_BusinessAction.AdjustApply_SearchWaitAudit(query, this, true);
							$state = 1;
							$t1.continueWith($sm);
							return;
						}
						case 1: {
							$state = -1;
							result = $t1.getAwaitedResult();
							console.info(result);
							$state = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			});
			$sm();
		},
		Execute: function() {
			this.WriteLiteral('<div data-role="page" class="TestPage">\n    <div class="head">\n        <div id="btnBack" class="backButton"></div>\n        <div id="lblHeadText">TestPage</div>\n    </div>\n    <div class="content" id="pnlContent">\n        这是测试页面\n    </div>\n    <div class="testDiv" style="background-color:black; height:50px;"></div>\n</div>\n');
		},
		InitialComponent: function() {
			this.btnBack = this.pageObject.find('#btnBack');
			this.lblHeadText = this.pageObject.find('#lblHeadText');
			this.pnlContent = this.pageObject.find('#pnlContent');
		},
		DestoryComponent: function() {
			if (ss.isValue(this.btnBack)) {
				this.btnBack.unbind().off();
				this.btnBack = null;
			}
			if (ss.isValue(this.lblHeadText)) {
				this.lblHeadText.unbind().off();
				this.lblHeadText = null;
			}
			if (ss.isValue(this.pnlContent)) {
				this.pnlContent.unbind().off();
				this.pnlContent = null;
			}
		}
	}, Phone.RazorMobilePage, [JSLib.Mobile.IShowLoading]);
	(function() {
		$AppData.$_userData = null;
	})();
	(function() {
		$USOProject_Pages_Common_AddressSelector.$_addressData = null;
	})();
	(function() {
		$RetailStatisticsCurrentUser.OwnOrgType = 0;
		$RetailStatisticsCurrentUser.SelectedOrgTypes = null;
		$RetailStatisticsCurrentUser.CurrentOrgId = 0;
		$RetailStatisticsCurrentUser.CustomerManagerId = null;
		$RetailStatisticsCurrentUser.CustomerLegalId = null;
		$RetailStatisticsCurrentUser.CustomerStoreId = null;
		$RetailStatisticsCurrentUser.ProductSeryId = null;
	})();
	(function() {
		$USOProject_Pages_ApplyAudit_Adjust_AdjustQueryPage.OrderTypes = null;
		$USOProject_Pages_ApplyAudit_Adjust_AdjustQueryPage.SearchProductGroups = null;
	})();
	(function() {
		$App.TimeDiff = ss.getDefaultValue(ss.TimeSpan);
		$App.IsProjectOrder = false;
		$App.app = new $App();
		var $t1 = [];
		$t1.push($USOProject_SetupType.$ctor('座架安装', 184));
		$t1.push($USOProject_SetupType.$ctor('挂架安装', 185));
		$App.SetupTypes = $t1;
		var $t1 = [];
		$t1.push($USOProject_NetWorkType.$ctor('无网络', 186));
		$t1.push($USOProject_NetWorkType.$ctor('电信', 187));
		$t1.push($USOProject_NetWorkType.$ctor('联通', 188));
		$t1.push($USOProject_NetWorkType.$ctor('铁通', 189));
		$t1.push($USOProject_NetWorkType.$ctor('校园网', 190));
		$t1.push($USOProject_NetWorkType.$ctor('企业网', 191));
		$t1.push($USOProject_NetWorkType.$ctor('其它', 192));
		$App.NetWorkTypes = $t1;
		$App.LoginResult = null;
	})();
	(function() {
		$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.OrderTypes = null;
		$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.SearchProductGroups = null;
		$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.StockOrganizations = null;
		$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.R3SalesChannel = null;
		$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderQueryPage.R3ProductGroups = null;
	})();
	(function() {
		$USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderAuditAction.IsAuditComplete = false;
	})();
	(function() {
		$USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage.StockOrganizations = null;
		$USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage.R3SalesChannel = null;
		$USOProject_Pages_ApplyAudit_OrderAudit_OrderQueryPage.R3ProductGroups = null;
	})();
	(function() {
		$USOProject_Pages_ApplyAudit_Adjust_AdjustAuditAction.IsAuditComplete = false;
	})();
	(function() {
		$USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderAuditAction.IsAuditComplete = false;
	})();
	(function() {
		$USOProject_Pages_Product_CategoryMaster.AllCategory = null;
	})();
	(function() {
		$USOProject_Pages_Retail_RetailInputQuery.$CurrentOrgId = 0;
		$USOProject_Pages_Retail_RetailInputQuery.$OrgData = null;
	})();
	(function() {
		$USOProject_Pages_Retail_Add_AddFeeItem.FeeList = null;
	})();
	(function() {
		var $t1 = [];
		$t1.push(new $USOProject_Business_ToCompletion_PermmissionModule('特批审核', $USOProject_Business_ToCompletion_PermissionTypeEx.ToEnumString(8), 'img/icon_spec.png', $USOProject_Pages_Spec_SpecList));
		$t1.push(new $USOProject_Business_ToCompletion_PermmissionModule('零售录入', $USOProject_Business_ToCompletion_PermissionTypeEx.ToEnumString(3), 'img/icon_retail.png', $USOProject_Pages_Retail_RetailInput));
		$t1.push(new $USOProject_Business_ToCompletion_PermmissionModule('零售录入统计', $USOProject_Business_ToCompletion_PermissionTypeEx.ToEnumString(6), 'img/icon_retail.png', $USOProject_Pages_NewRetailInputStatistics_RetailInputStatistics_Configure));
		$t1.push(new $USOProject_Business_ToCompletion_PermmissionModule('产品中心', $USOProject_Business_ToCompletion_PermissionTypeEx.ToEnumString(2), 'img/icon_product_center.png', $USOProject_Pages_Product_CategoryMaster));
		$t1.push(new $USOProject_Business_ToCompletion_PermmissionModule('工程档案', $USOProject_Business_ToCompletion_PermissionTypeEx.ToEnumString(15), 'img/icon_mine.png', $USOProject_Pages_ApplyAudit_EngineerOrder_EngineerOrderList));
		$t1.push(new $USOProject_Business_ToCompletion_PermmissionModule('调帐审核', $USOProject_Business_ToCompletion_PermissionTypeEx.ToEnumString(14), 'img/icon_mine.png', $USOProject_Pages_ApplyAudit_Adjust_AdjustList));
		$t1.push(new $USOProject_Business_ToCompletion_PermmissionModule('订单审核', $USOProject_Business_ToCompletion_PermissionTypeEx.ToEnumString(21), 'img/icon_mine.png', $USOProject_Pages_ApplyAudit_OrderAudit_OrderList));
		$t1.push(new $USOProject_Business_ToCompletion_PermmissionModule('异地订单', $USOProject_Business_ToCompletion_PermissionTypeEx.ToEnumString(16), 'img/icon_mine.png', $USOProject_Pages_ApplyAudit_OtherOrder_OtherOrderList));
		$USOProject_Business_ToCompletion_PermissionManager.LocalPermissionDefine = $t1;
		$USOProject_Business_ToCompletion_PermissionManager.$1$OnPermissionChangedField = null;
	})();
	(function() {
		$USOProject_Pages_Control_MyWorkControl.$3$TodoWorkChangeField = null;
	})();
	(function() {
		$USOProject_SecurityChannel.tokenArray = [];
	})();
	(function() {
		$USOProject_SecurityLayerJS.xmlParams = '<RSAKeyValue><Modulus>3xtq/7hvYm482X9U2NeQA75lOlTLD5AbQgG3MXoSGYPyYRoWQGkhJ4dzn3ioSaUHzxZ4Quo08wrAXw71m9Jh3w==</Modulus><Exponent>AQAB</Exponent></RSAKeyValue>';
	})();
	(function() {
		$USOProject_Pages_TokenInitilzer.Seq = 110;
	})();
	(function() {
		//指定页面的命名空间和页面存放的路径，用于后期动态加载页面CSS文件或JS文件
		JSLib.Mobile.Application.set_BaseNameSpace('MobileMealOrder.Pages');
		JSLib.Mobile.Application.RootPath = 'Pages/';
		//自动根据页面加载页面对应的CSS文件.
		JSLib.Mobile.Application.AutoLoadCss = true;
		//应用珵序是否强制加载CSS，强制加载CSS会避免出现缓存的现像.
		JSLib.Mobile.Application.LoadCssForce = false;
		//应用程序允许的最大页面数量，当超出定义的页面数量时，使用频率最低，创建时间最早的页面将会被销毁。
		JSLib.Mobile.PageResourceManager.MaxPageCount = 10;
		//列表的分页Index值是否从0开始,IScrollList列表中使用此定义的值.
		JSLib.Mobile.Application.PageIndexFromZero = false;
		JSLib.JSLibConfig.IsUseZepto = true;
		JSLib.JSLibConfig.PageTransitionEffect = false;
		JSLib.Mobile.Application.set_BaseNameSpace('USOProject.Pages');
		JSLib.Mobile.Application.RootPath = '../Pages/';
		JSLib.Mobile.Application.CordovaJSDir = 'JS/';
		JSLib.Mobile.Application.DisableBodyMove = false;
		JSLib.Mobile.Application.IsBrowser = ss.startsWithString(window.location.href, 'http');
		//注册自定义消息提示框
		$App.RegisterShowMessage();
		//注册自定义模态输入框
		$App.RegisterInputModal();
		JSLib.Mobile.Application.BeforeBack = function() {
			var $state = 0, $tcs = new ss.TaskCompletionSource();
			var $sm = function() {
				try {
					$sm1:
					for (;;) {
						switch ($state) {
							case 0: {
								$state = -1;
								$tcs.setResult(!$App.RemoveGlobalInputModal());
								return;
							}
							default: {
								break $sm1;
							}
						}
					}
				}
				catch ($t1) {
					$tcs.setException(ss.Exception.wrap($t1));
				}
			};
			$sm();
			return $tcs.task;
		};
		//自定义确认对话框
		JSLib.Mobile.MessageBox.ConfirmHandler = function(message) {
			return JSLib.Widget.Common.CommonDialog.Confirm('确认消息', message);
		};
		JSLib.Mobile.Application.add_OnHashChange(function(sender, args) {
			var newUrl = JSLib.Util.URL.GetAllExceptHash('') + '#' + JSLib.Mobile.Application.CurrentHashString;
			window.location.replace(newUrl);
		});
		$App.RegisterGlobalEvent();
		window.setTimeout(function() {
			var $state1 = 0, $t2, $t3;
			var $sm1 = function() {
				$sm1:
				for (;;) {
					switch ($state1) {
						case 0: {
							$state1 = -1;
							JSLib.Mobile.Application.PrepareApp();
							if (!JSLib.Mobile.Application.IsBrowser) {
								//加载插件相关
								if (JSLib.Mobile.Application.DeviceType === 10) {
									//加载日期控件
									$t2 = JSLib.WebData.GetScriptTask('./JS/cordova/DatePicker.js');
									$state1 = 2;
									$t2.continueWith($sm1);
									return;
								}
								$state1 = 1;
								continue $sm1;
							}
							$state1 = -1;
							break $sm1;
						}
						case 2: {
							$state1 = -1;
							$t2.getAwaitedResult();
							$state1 = 1;
							continue $sm1;
						}
						case 1: {
							$state1 = -1;
							//加载系统插件
							//await WebData.GetScriptTask("./JS/cordova/cordova_plugins.js");
							//加载Jpush
							$t3 = JSLib.WebData.GetScriptTask('./JS/cordova/JPushPlugin.js');
							$state1 = 3;
							$t3.continueWith($sm1);
							return;
						}
						case 3: {
							$state1 = -1;
							$t3.getAwaitedResult();
							$state1 = -1;
							break $sm1;
						}
						default: {
							break $sm1;
						}
					}
				}
			};
			$sm1();
		}, 0);
		window.setInterval(function() {
			if (JSLib.Mobile.Application.NetWorkState === 2) {
				return;
			}
			var releaseTokenArray = $USOProject_SecurityChannel.GetValidateTokens();
			var tokens = releaseTokenArray.join(',');
			var service = { ServiceName: 'MobileRest.Service.ReleaseUnfinishedTokenService', MethodName: 'ReleaseTokens' };
			var callBack = function(result) {
			};
			$USOProject_Business_DataService.PostRequest(Object).call(null, function(builder) {
				var param = null;
				if (!!ss.isNullOrUndefined({ Value: tokens })) {
					param = '';
				}
				var postData = { ServiceName: service.ServiceName, MethodName: service.MethodName, Param: param };
				builder.AddString(JSON.stringify(postData));
			}, 33, true, null, true);
		}, 20000000);
		window.setTimeout(function() {
			//准备页面及进入入口页面
			//phongap准备事件
			JSLib.Mobile.Application.OnDeviceReady(function() {
				var $state3 = 0, $t8, $t7;
				var $sm3 = function() {
					$sm1:
					for (;;) {
						switch ($state3) {
							case 0: {
								$state3 = -1;
								document.addEventListener('backbutton', function(event) {
									var $state2 = 0, $t5, isExit;
									var $sm2 = function() {
										$sm1:
										for (;;) {
											switch ($state2) {
												case 0: {
													$state2 = -1;
													if (JSLib.Mobile.NavigationManager.BackToRemoveModalPanel()) {
														if (ss.referenceEquals(ss.getInstanceType(JSLib.Mobile.MobilePage.CurrentPage), $USOProject_Pages_HomePage) || ss.referenceEquals(ss.getInstanceType(JSLib.Mobile.MobilePage.CurrentPage), $USOProject_Pages_LoginPage)) {
															$t5 = JSLib.Mobile.MessageBox.Confirm('你确认要退出吗？');
															$state2 = 1;
															$t5.continueWith($sm2);
															return;
														}
														else {
															JSLib.Mobile.Application.Back(1);
															$state2 = -1;
															break $sm1;
														}
													}
													$state2 = -1;
													break $sm1;
												}
												case 1: {
													$state2 = -1;
													isExit = $t5.getAwaitedResult();
													if (isExit) {
														navigator.app.exitApp();
													}
													$state2 = -1;
													break $sm1;
												}
												default: {
													break $sm1;
												}
											}
										}
									};
									$sm2();
								});
								//获取App版本号
								$t8 = $App.app;
								$t7 = $B2BProject_Business_Plugin_AppVersion.GetAppVersion();
								$state3 = 1;
								$t7.continueWith($sm3);
								return;
							}
							case 1: {
								$state3 = -1;
								$t8.AppVersion = $t7.getAwaitedResult();
								$state3 = -1;
								break $sm1;
							}
							default: {
								break $sm1;
							}
						}
					}
				};
				$sm3();
			});
			if (JSLib.Mobile.Application.IsBrowser) {
				$App.app.AppVersion = window['AppVersion'];
			}
			var mobilePageTypes = Enumerable.from(ss.getAssemblyTypes($asm)).where(function(n) {
				return n.prototype instanceof Phone.RazorMobilePage;
			}).toArray();
			var autoLoadPageFromHash = false;
			//await TokenInitilzer.TokenInit();
			//var tokenObj = SecurityChannel.GetTokenObject();
			//if (tokenObj == null)
			//{
			//    await TokenInitilzer.TokenInit();
			//}
			//var autoLoginResult = await LoginPage.AutoLogin();
			//if (autoLoginResult)
			//{
			//    autoLoadPageFromHash = true;
			//}
			if (!JSLib.Mobile.MobilePage.Prepare(mobilePageTypes, autoLoadPageFromHash, null)) {
				JSLib.Mobile.MobilePage.GotoPage($USOProject_Pages_LoginPage).call(null, null, null);
			}
		}, 100);
		JSLib.Mobile.Application.OnDeviceReady(function() {
			(new $USOProject_Business_InAppUpdater()).Do();
		});
	})();
})();
