/**
 * Phonegap DatePicker Plugin Copyright (c) Greg Allen 2011 MIT Licensed
 * Reused and ported to Android plugin by Daniel van 't Oever
 */

/**
 * Constructor
 */
var exec = cordova.require('cordova/exec');



function DatePicker() {
    //this._callback;
}

function DatePicker_iOS() {

}

/**
 * show - true to show the ad, false to hide the ad
 */
DatePicker_iOS.prototype.show = function (options, cb) {
    var padDate = function (date) {
        if (date.length == 1) {
            return ("0" + date);
        }
        return date;
    };

    var formatDate = function (date) {
        date = date.getFullYear()
              + "-"
              + padDate(date.getMonth() + 1)
              + "-"
              + padDate(date.getDate())
              + "T"
              + padDate(date.getHours())
              + ":"
              + padDate(date.getMinutes())
              + ":00Z";

        return date
    }

    if (options.date) {
        options.date = formatDate(options.date);
    }

    if (options.minDate) {
        options.minDate = formatDate(options.minDate);
    }

    if (options.maxDate) {
        options.maxDate = formatDate(options.maxDate);
    }

    var defaults = {
        mode: 'date',
        date: new Date(),
        allowOldDates: true,
        allowFutureDates: true,
        minDate: '',
        maxDate: '',
        doneButtonLabel: '',
        doneButtonColor: '#0000FF',
        cancelButtonLabel: 'ȡ',
        cancelButtonColor: '#000000',
        x: '0',
        y: '0'
    };

    for (var key in defaults) {
        if (typeof options[key] !== "undefined")
            defaults[key] = options[key];
    }
    this._callback = cb;

    exec(null,
      null,
      "DatePicker",
      "show",
      [defaults]
    );
};


/**
 * show - true to show the ad, false to hide the ad
 */
DatePicker.prototype.show = function (options, cb) {

    if (options.date) {
        options.date = (options.date.getMonth() + 1) + "/" +
					   (options.date.getDate()) + "/" +
					   (options.date.getFullYear()) + "/" +
					   (options.date.getHours()) + "/" +
					   (options.date.getMinutes());
    }

    var defaults = {
        mode: 'date',
        date: '',
        minDate: 0,
        maxDate: 0
    };

    for (var key in defaults) {
        if (typeof options[key] !== "undefined") {
            defaults[key] = options[key];
        }
    }

    //this._callback = cb;

    var callback = function (message) {
        cb(new Date(message));
    }

    exec(callback,
		null,
		"DatePickerPlugin",
		defaults.mode,
		[defaults]
	);
};


